replace binary io by Parallel netcdf io 
============================================================================
We can check the io files using ncview now in both prep and main model stage.
Also, redundant io files are removed for clearity.


implement from single precision to double precision
===========================================================================
For slimplicity, implicit real*8 is used.
MPI related info communication and Pnetcdf io are also modified to meet real*8 requirement.


add cfc module
===========================================================================
input files needed in initial step are moved to $model/data/
input files: timcom_gasx.nc, cfc1112_new.atm

To adjust cfc content in different years, see variable: "index" @ subroutine cfcsurf

History:
=================================================
2014-11-30-23:22 musoc2.1.0 version
1) Makefile
2) Lower case including all data and code

=================================================
2014-11-31-00:42 musoc2.1.1 version
1) F77 -> F90 
2) Soft link to prepglo, opt directories in musoc2.1.0 version 
The result of musoc2.1.1 is a little bit different with that of musoc2.1.0 after one day simulation

=================================================
2014-11-31-03:38 musoc2.1.3 version
1) code aligning 
2) This version is stable for 1 year simulation

=================================================
2014-12-01-18:18 musoc2.1.4 version
1) Chang makefile (make submit) 
2) Create main.F90
3) global.F90 -> module global
4) Change some bugs in line 2723(rinv->rrinv), line 3765, lin 4759 and etc.(ib->ibegin, ie->iend, mbf->rmbf) 

=================================================
2014-12-03-01:19 musoc2.1.5 version
1) Delete unnecessary "include mpif.h" and "include resglo.h"
2) Create const.F90

=================================================
2014-12-03-02:46 musoc2.1.7 version
1) Delete numbers of unnecessary global varaibles
2) Create var.f90

=================================================
2014-12-03-03:20 musoc2.1.8 version
1) Create io.f90
2) Change temporary "nn" variable to "n_tmp" in the tempp_s computing phase, otherwise it conflicts with the "nn" in io.F90 
3) This version is stable for 1 year simulation

=================================================
2014-12-03-13:54 musoc2.1.9 version
1) Create solver.F90
2) Create util.F90
2) Create physics.F90

=================================================
2014-12-04-02:48 musoc2.2.0 version
1) Delete goto in global.F90
2) Change the loop style
3) Code aligning

=================================================
2014-12-04-17:32 musoc2.2.1 version
1) Split the initfsglo subroutine into some small subroutines
2) This version is stable for 1 year simulation

=================================================
2014-12-05-01:00 musoc2.2.2 version
1) Rewrite the init and run subroutines in main.F90 
2) Delete global_fun and initfsglo in global.F90
3) Change global.F90 to driver.F90

=================================================
2014-12-05-01:07 musoc2.2.3 version
1) Delete all log, output files, and execute files
2) This version is a complete clean package

=================================================
2014-12-05-04:43 musoc2.2.4 version
1) Split part of fsglo subroutine into small subroutines
2) Delete some local variables in fsglo subroutine

=================================================
2014-12-06-15:57 musoc2.2.5 version
1) Change part of fsglo subroutine into small subroutines further 

=================================================
2014-12-24-03:10 musoc2.2.6 version
1) Create filter.F90 .

=================================================
2015-03-15-22:47 musoc2.2.7 version
1) add cess cluster support in makefile(make cess).
2) create a new script, run.job, to execute qsub task.

=================================================
2015-08-21-13:52 musoc2.3 version
1) Build the prepreocess system, add metgen function.

2015-08-23-03:30 musoc.2.3.1 version
1) Add inmets and indata functions into preprocess module. 

=================================================
2017-06-10-15:30 musoc.2.3.2 version
1) all real variables are modified to double precision using implicit R8.
2) binary input and output files for prepglo are now modified to PNetcdf format.

2017-06-15-11:30 musoc.2.3.3 version
1) add cfc module

!********************************************************************
! Dolphine Ocean Model v1.0
! Date:	Nov 3, 2015
!********************************************************************

program main 
    
    call init
    call run 
    call finalize

    stop
end program


subroutine init()
    use driver 
    implicit real*8 (a-h,o-z)
    call init_comm
    call mpi_grid_gen
    call init_io
    call set_windmix
    call set_rundata
    call set_zkb
    call set_surfwinds
    call set_area 
    call set_ts_nudging 
    call set_lateral_mixing
    call set_extra_vertical_eddy_viscosity
    call init_solver
    call set_seasonal_data      
    call write_topo
    call eliminate_spurious_values

end subroutine 


subroutine run
    use driver
    implicit real*8 (a-h,o-z)

    if(myid.eq.0) print*,'mxit,itf,days',mxit,itf,days

    nopt=30
    it0=itf
    wopt=1./dble(nopt*itfday)
    timer=0.d0
    timer(10)=mpi_wtime()

    ! ------------------------------
    ! main time integration loop 100
    ! ------------------------------
    do itf=1,mxit
	timer(1)=timer(1)+mpi_wtime()-timer(10)
	timer(10)=mpi_wtime()

	days=itf/daodt
	n=days/360.+.0001
	tmp=days/360.
	! during year, n360 goes from 0 to 360
	n360=(tmp-n)*360.+.1
	nyr=n+1

	!call check_salinity_budget

	call mpi_barrier(m_cart,ierr)

	call fsglo

	call mpi_barrier(m_cart,ierr)

	call check_blowup

	call write_hist

	if (mod(itf,itfday).ne.0.and.itf.lt.mxit) continue 

	call restart

    enddo

    timer(1)=timer(1)+mpi_wtime()-timer(10)
    open(88,file='data/timer'//grd,form='unformatted')
    write(88)timer
    close(88)

end subroutine


subroutine finalize()
    call mpi_finalize(ierr)
end subroutine 

module driver 
    use const
    use comm
    use var 
    use io
    use util
    use solver
    use physics
    use filter
implicit real*8 (a-h,o-z)

contains

subroutine fsglo
    character fn1*7
    integer tt0,tt1,tt2

    dimension rhomin(k1)
    dimension scr1(i0,j0,k1)

    if (mod(itf,4).eq.1) call pp82glonew

    ! 30 days between climatological data sets
    ! we also use this to restore based on jan 1 climate
    nld=days/30.
    fnew=days/30.-nld
    fold=1.-fnew
    nld=mod(nld,12)+1
    new=nld+1
    if (new.eq.13) new=1

    call ts_nudging_for_watermass

    call solve_hydrostatic_equation
    ! modified pacanowski and philander vertical mixing coefficients
    ! subracting layer min rho to reduce roundoff error cannot be
    ! done before pp82glo or loop

    !       if (mod(itf,4).eq.1) call pp82glo
    !       if (mod(itf,4).eq.1) call pp82glonew

    ! smagorinsky mixing not useful or needed due to model robustness
    if (mod(itf,4).eq.1) call smagglo

    call mpi_barrier(m_cart,ierr)
    timer(9)=mpi_wtime()
    call  mpi_exch_3d_r4(u2)
    call  mpi_exch_3d_r4(v2)
    call  mpi_exch_3d_r4(t2)
    call  mpi_exch_3d_r4(s2)
    call  mpi_exch_3d_r4(u1)
    call  mpi_exch_3d_r4(v1)
    call  mpi_exch_3d_r4(t1)
    call  mpi_exch_3d_r4(s1)
    call  mpi_exch_3d_r4(ulf)
    call  mpi_exch_3d_r4(vlf)
    call  mpi_exch_3d_r4(tlf)
    call  mpi_exch_3d_r4(slf)
    call  mpi_exch_3d_r4(p)
!yc
    call  mpi_exch_3d_r4(c2)
    call  mpi_exch_3d_r4(c1)
    call  mpi_exch_3d_r4(clf)
!yc
    timer(3)=timer(3)+mpi_wtime()-timer(9)

    lb=1
    lt=2
    if (lfsrf .eq. 0) then
	do j=1,j2
	    do i=1,i2
		uz(i,j,1)=0.
		vz(i,j,1)=0.
		sz(i,j,1)=0.
		tz(i,j,1)=0.
!yc
                cfcz(i,j,1)=0.
!yc
	    enddo
	enddo
    else
	do j=1,j2
	    do i=1,i2
		uz(i,j,1)=w(i+1,j+1,1)*u2(i+1,j+1,1)
		vz(i,j,1)=w(i+1,j+1,1)*v2(i+1,j+1,1)
		sz(i,j,1)=w(i+1,j+1,1)*s2(i+1,j+1,1)
		tz(i,j,1)=w(i+1,j+1,1)*t2(i+1,j+1,1)
!yc
                cfcz(i,j,1)=w(i+1,j+1,1)*c2(i+1,j+1,1)
!yc
	    enddo
	enddo
    endif

    ! =================================================================
    !calculate all internal fluxes and substitute into conservation laws
    ! =================================================================
    ! level-by-level moving window reduces storage.
    ! note: all boundary fluxes are masked out in this loop,
    ! but are included later. this is the main computation loop.
    do k=1,k1
	l=k+1

	! variable diffusivity arrays are used for near-shore laplace filter
	do j=1,j0
	    do i=1,i1
		dhx(i,j)=dmx(i,j,k)
	    enddo
	enddo

	do j=1,j1
	    do i=1,i0
		dhy(i,j)=dmy(i,j,k)
	    enddo
	enddo

	! 4th order pressure gradient
	call compute_pressure_gradient(k)
	
	! vertical fluxes
	call compute_vertical_fluxes(k,lt)
	
	! longitudinal fluxes
	call compute_longitudinal_fluxes(k)	
	
	! latitudinal fluxes
	call compute_latitudinal_fluxes(k)
	
	! ====================
	!conservation equations
	! ====================
	! note: these are only partial updates. pressure, coriolis and boundary
	! forcings are added after statement label 500.
	do j=2,j1
	    odyj=ocs(j)*ody(j)
	    do i=2,i1
		dtin=dt*in(i,j,k)
		! longitudinal momentum
		u2(i,j,k)=u1(i,j,k)-dtin*((ux(i,j-1)-ux(i-1,j-1)+px(i,j))*odx(j)+(uy(i-1,j)-uy(i-1,j-1))*odyj+(uz(i-1,j-1,lt)-uz(i-1,j-1,lb))*odz(k))

		! latitudinal momentum
		v2(i,j,k)=v1(i,j,k)-dtin*((vx(i,j-1)-vx(i-1,j-1))*odx(j)+(vy(i-1,j)-vy(i-1,j-1))*odyj+py(i,j)*ody(j)+(vz(i-1,j-1,lt)-vz(i-1,j-1,lb))*odz(k))

		! salinity
		s2(i,j,k)=s1(i,j,k)-dtin*((sx(i,j-1)-sx(i-1,j-1))*odx(j)+(sy(i-1,j)-sy(i-1,j-1))*odyj+(sz(i-1,j-1,lt)-sz(i-1,j-1,lb))*odz(k))

		! temperature
		t2(i,j,k)=t1(i,j,k)-dtin*((tx(i,j-1)-tx(i-1,j-1))*odx(j)+(ty(i-1,j)-ty(i-1,j-1))*odyj+(tz(i-1,j-1,lt)-tz(i-1,j-1,lb))*odz(k))
!yc
                !tracer
                c2(i,j,k)=c1(i,j,k)-dtin*((cfcx(i,j-1)-cfcx(i-1,j-1))*odx(j)+(cfcy(i-1,j)-cfcy(i-1,j-1))*odyj+(cfcz(i-1,j-1,lt)-cfcz(i-1,j-1,lb))*odz(k))
!yc

	    enddo
	enddo
	i=lb
	lb=lt
	lt=i
    enddo

    ! ===============
    ! surface effect  
    ! ===============
    ! wind stress

    call windglo(u2,v2,days,dt,odz)

    !cfc surface forcing
    call cfcsurf(c2(:,:,1),t2(:,:,1),s2(:,:,1),days,dt,odz)

    ! call qsurfglo(t2,dt,odz)
    ! radiative heating
    ! call sunglo(t2,dt,odz,qprof,kb)

    if (lopen/=0) then 
	! ========================
	! open boundary conditions
	! ========================
	! these are all determined by "known" normal boundary veloctiy (nbv)
	! i.e. boundary normal flux is upwinded for both inflow and outflow.
	! for inflow, exterior "ghost zone" fields are fluxed inward. the ghost
	! zone fields can be set to climatology.
	! loop 506 below does all fluxes on lateral boundaries
	! loop 634 below determines nbv
	! upwind method based on nbv.
	! temporarily use abs() function.
	! later use boundary flag arrays if a vectorized function exists which
	! sets an integer array to the sign bit (i.e., 0 or 1)
	! skip on first time step because advection velocity divergence in
	! boundary zones has not been cleared out yet.

	! nbv update must be after loop 500 (to keep non-divergent bt mode)
	if (mylat .eq. ngy1) then
	    tmp=.5*dt
	    do k=1,k1
		! no open boundaries in periodic longitudinal direction
		do i=2,i1
		    tmpin=in(i,j1,k)*tmp*ody(j1)*csv(j1)*ocs(j1)
		    temp=abs(v(i,j1,k))
		    temp1=tmpin*(temp+v(i,j1,k))
		    temp2=tmpin*(temp-v(i,j1,k))
		    u2(i,j1,k)=u2(i,j1,k)-temp1*ulf(i,j1,k)+temp2*u2(i,j0,k)
		    v2(i,j1,k)=v2(i,j1,k)-temp1*vlf(i,j1,k)+temp2*v2(i,j0,k)
		    s2(i,j1,k)=s2(i,j1,k)-temp1*slf(i,j1,k)+temp2*s2(i,j0,k)
		    t2(i,j1,k)=t2(i,j1,k)-temp1*tlf(i,j1,k)+temp2*t2(i,j0,k)
!yc
                    c2(i,j1,k)=c2(i,j1,k)-temp1*clf(i,j1,k)+temp2*c2(i,j0,k)
!yc
                enddo
	    enddo

	endif

	!do j=2,j1
	!    do i=2,i1
	!        ! take out momentum with positive e-p, and add none for negative e-p
	!        ! this is for convenience only (minor effect, but not really realistic
	!        ! because this is based only on the net rather than actual fluxes)
	!        tmp=.5*(w(i,j,1)-abs(w(i,j,1)))*odz(1)
	!        u2(i,j,1)=u2(i,j,1)+dt*tmp*u2(i,j,1)
	!        v2(i,j,1)=v2(i,j,1)+dt*tmp*v2(i,j,1)
	!        t2(i,j,1)=t2(i,j,1)+dt*w(i,j,1)*t2(i,j,1)*odz(1)
	!    enddo
	!enddo
    endif
    
    do j=2,j1
	do i=2,i1
	    tmp1=dble(t_nudge(i,j))
	    tmp2=1.-tmp1
	    ! skli is no longer used (no salinity restoring)
	    ! tkli is climatological value interpolated to present time
	    tkli=fold*tclis(i,j,1,nld)+fnew*tclis(i,j,1,new)
	    ! qavg(watts/cm-cm)= (watts/deg/cc)*heat*dx(j)*dy*dz/(dx(j)*dy)/time
	    !    where qavg=heat/time in deg ! per time step
	    !======================================================================
	    ! add model-consistent climatology determined surface fluxes, which
	    ! are proporational to time averaged restoring rate for present month
	    ! add to all 3 time levels to get full and proper effect with fltw
	    ! method; otherwise "final" effect on t1 is only partial!
	    temp=in(i,j,1)*qavg(i-1,j-1,nld)
	    t2(i,j,1)=t2(i,j,1)+temp
	    t1(i,j,1)=t1(i,j,1)+temp
	    tlf(i,j,1)=tlf(i,j,1)+temp
!yc
!            c2(i,j,1)=c2(i,j,1)+temp
!            c1(i,j,1)=c1(i,j,1)+temp
!            clf(i,j,1)=clf(i,j,1)+temp
!yc
	    !======================================================================
	    ! surface restoring: nudge toward surface t climatology
	    ! to emulate eddy damping by atmospheri! heat flux.
	    temp=t2(i,j,1)
	    !      t2(i,j,1)=in(i,j,1)*(tmp*temp+tau*tkli)+(1-in(i,j,1))*tkli
	    t2(i,j,1)=in(i,j,1)*(tmp2*temp+tmp1*tkli)+(1-in(i,j,1))*tkli
!yc
!            c2(i,j,1)=in(i,j,1)*(tmp2*temp+tmp1*tkli)+(1-in(i,j,1))*tkli
!yc

	    ! accumulate nudgings for present month
	    tnudge(i-1,j-1)=tnudge(i-1,j-1)+t2(i,j,1)-temp
	enddo
    enddo

    ! ===========================================================
    ! new strategy for surface fluxes
    ! determine ensemble (climatological) monthly mean model-
    ! consistent surface heat and freshwater volume sources
    ! (update long term mean sources according to present month
    ! anomalous changes of surface temperature and salinity
    ! where anomalous changes are differences from observed
    ! climatological changes).
    ! ===========================================================

    ! procedure:
    ! a) calculate surface climate t anomaly at end of month
    ! b) add anomaly to tnudge to get qavg for present month
    ! c) blend with results from previous years
    i=30*itfday
    if (mod(itf,i).ne.i-1) go to 575
    ! nsombo=1 when qavg is initialized,
    ! and we include initial value in averaging process

    ! ww nsombo(nld)=nsombo(nld)+1
    if (itf.gt.i*12*10) nsombo(nld)=nsombo(nld)+1

    ens1=1./nsombo(nld)
    ens2=1.-ens1

    ! plot nudgings for present month
    !     do 535 j=2,j1
    !     do 535 i=2,i1
    !     call xyglo('r','present month net t nudging   ',scr(1,1,2),1,1)

    ! for long term average, temp=1/years/(30*itfday)
    !   where years=number of years included in average

    temp=1./(30*itfday)
    tmp1=temp*ens1
    tmp2=z(3)*odt*ens1

    qsum=0.
    do j=1,j2
	tmp=dx(j+1)*dy(j+1)
	do i=1,i2
	    ! for time consistencfcy with evap we also use unadjusted qavg here
	    qsum=qsum+in(i+1,j+1,1)*qavg(i,j,new)*tmp
	    ! evap is net surface outflow (positive for net positive e-p)
	    qavg(i,j,nld)=qavg(i,j,nld)+tmp1*(tnudge(i,j)+tclis(i+1,j+1,1,new)-t2(i+1,j+1,1))
	    scr(i+1,j+1,2)=daodt*30.*qavg(i,j,nld)
	    ! set monthly sum of nudgings to zero to initialize next month
	    tnudge(i,j)=0.
	enddo
    enddo
    
    if (days<=361.)then 
	! ======================================================================
	! first year only (gives reasonable advection estimate for next month;
	! also, avoids accumulation of advection-induced drift
	do j=1,j2
	    do i=1,i2
		qavg(i,j,new)=qavg(i,j,nld)
	    enddo
	enddo
    endif
    
    !convert qsum to mean watts/m-m and evap to m**3/sec
    tp=qsum
    call mpi_barrier(m_cart,ierr)
    timer(9)=mpi_wtime()
    call mpi_allreduce(tp,qsum,1,mpi_real8,mpi_sum,m_cart,ierr)
    timer(3)=timer(3)+mpi_wtime()-timer(9)
    qsum=watts*qsum/a(1)


    ! =============
    ! bottom stress
    ! =============
    575  tmp=dt*drag
    
    do j=2,j1
	do i=2,i1
	    k=kb(i,j)
	    ! don't exceed explicit limit
	    drg=min(.2,in(i,j,k)*tmp*odz(k)*sqrt(u1(i,j,k)**2+v1(i,j,k)**2))
	    u2(i,j,k)=u2(i,j,k)-drg*u1(i,j,k)
	    v2(i,j,k)=v2(i,j,k)-drg*v1(i,j,k)
	enddo
    enddo
    
    ! ====================
    ! trapezoidal coriolis
    ! ====================
    do k=1,k1
	do j=2,j1
	    do i=2,i1
		tmp=.5*(f(j-1)+ulf(i,j,k)*tanphi(j-1))*dt
		temp=1./(1.+tmp**2)
		qu=u2(i,j,k)+tmp*v1(i,j,k)
		qv=v2(i,j,k)-tmp*u1(i,j,k)
		u2(i,j,k)=temp*(qu+tmp*qv)
		v2(i,j,k)=temp*(qv-tmp*qu)
	    enddo
	enddo
    enddo

    call mpi_barrier(m_cart,ierr)
    timer(9)=mpi_wtime()

    call mpi_exch_3d_r4(u2)
    call mpi_exch_3d_r4(v2)

    timer(3)=timer(3)+mpi_wtime()-timer(9)
    ! =====================================================
    ! interpolate "a" grid quantities to "c" grid locations
    ! =====================================================
    ! 4th-order interpolations
    ! unnecessary masking has been removed here
    do k=1,k1
	do j=2,j1
	    do i=1,i1
		scr(i,j,k)=6.*(u2(i,j,k)+u2(i+1,j,k))
	    enddo
	    ! skip loop 612 for 2nd order scheme
	    do i=2,i2
		scr(i,j,k)=scr(i,j,k)+iu(i,j,k)*(-u2(i-1,j,k)+u2(i,j,k)+u2(i+1,j,k)-u2(i+2,j,k))
	    enddo
	enddo
    enddo

    call mpi_sendrecv(u2(i2,1,1),1,m_vlon3d,m_e,1,scr1(i0,1,1),1,m_vlon3d,m_w,1,m_cart,istat,ierr)
    call mpi_sendrecv(u2(3,1,1),1,m_vlon3d,m_w,1,scr1(i1,1,1),1,m_vlon3d,m_e,1,m_cart,istat,ierr)

    do k=1,k1
	do j=2,j1
	    scr(1,j,k)=scr(1,j,k)+iu(1,j,k)* (-scr1(i0,j,k)+u2(1,j,k)+u2(2,j,k)-u2(3,j,k))
	    scr(i1,j,k)=scr(i1,j,k)+iu(i1,j,k)*(-u2(i2,j,k)+u2(i1,j,k)+u2(i0,j,k)-scr1(i1,j,k))
	    do i=1,i1
		u(i,j,k)=o12*scr(i,j,k)*iu(i,j,k)
	    enddo
	enddo
    enddo


    do k=1,k1
	do j=js,jf
	    do i=2,i1
		scr(i,j,k)=6.*(v2(i,j,k)+v2(i,j+1,k))
	    enddo
	enddo
	do j=2,j2
	    do i=2,i1
		scr(i,j,k)=scr(i,j,k)-v2(i,j-1,k)+v2(i,j,k)+v2(i,j+1,k)-v2(i,j+2,k)
	    enddo
	enddo
    enddo

    call mpi_sendrecv(v2(1,j2,1),1,m_vlat3d,m_n,1,scr1(1,j0,1),1,m_vlat3d,m_s,1,m_cart,istat,ierr)
    call mpi_sendrecv(v2(1,3,1),1,m_vlat3d,m_s,1,scr1(1,j1,1),1,m_vlat3d,m_n,1,m_cart,istat,ierr)

    do k=1,k1
	! skip loop for 2nd order scheme
	if (mylat .ne. 0) then
	    do i=2,i1
		scr(i,1,k)=scr(i,1,k)-scr1(i,j0,k)+v2(i,1,k)+v2(i,2,k)-v2(i,3,k)
	    enddo
	endif

	if (mylat .ne. ngy1) then
	    do i=2,i1
		scr(i,j1,k)=scr(i,j1,k)-v2(i,j2,k)+v2(i,j1,k)+v2(i,j0,k)-scr1(i,j1,k)
	    enddo
	endif

	do j=js,jf
	    do i=2,i1
		v(i,j,k)=o12*scr(i,j,k)*iv(i,j,k)
	    enddo
	enddo
    enddo


    ! the following non-porous lid approach may be replaced by a good estimate
    ! of e-p, as in medina and north pacifi! codes, as per dietrich, et al.
    ! e-p may be significant when there is significant lateral water vapor
    ! transport and fallout by translating hurricanes and typhoons.

    ! non-porous lid approach:
    ! maintain top layer salinity by exchange with layer 2, and ignore
    ! possible vortex stretching implied by non-zero e-p (w(i,j,1)). this
    ! simplifies global incompressibility treatment in domain decomposed mpi
    ! code.
    ! do 627 j=2,j1
    ! do 627 i=2,i1
    ! 627 w(i,j,1)=0.
    ! maintain surface climatological s in the long run
    ! 90 day nudging time scale toward surface climatological s
    !conserves total salt material assuming all wet points > one layer deep

    !        tmp1=1./(90.*daodt)
    !        tmp2=tmp1*odz(2)/odz(1)
    !        do 628 j=2,j1
    !        do 628 i=2,i1
    !        tmp=in(i,j,1)*(sclis(i,j,1,new)-s1(i,j,1))
    !        s1(i,j,1)=s1(i,j,1)+tmp1*tmp
    !   628  s1(i,j,2)=s1(i,j,2)-tmp2*tmp

    ! ====================================================
    ! create non-divergent u,v,w for next step by
    ! "clearing out the divergence of the barotropic mode"
    ! ====================================================
    ! use scr and scr to store changes for incompressibility
    do k=1,4
	do j=1,j0
	    do i=1,i0
		scr(i,j,k)=0.
	    enddo
	enddo
    enddo
    ! ---------------------------------------------------
    ! iterate evp solver to get zero normal flow at shore
    ! and exactly non-divergent bt mode
    ! ---------------------------------------------------
    ! mxmask is maximum number of iterations allowed
    !check whether increasing from 8 to 9 eliminates noisy regions
    mxmask=9
    ! note: it would be slightly more efficient to separate out the bt mode
    ! (as per dan wright's suggestion) if more than one iteration is
    ! performed, but this has not yet been implemented with river sources
    ! and precipitation

    call mpi_barrier(m_cart,ierr)
    timer(9)=mpi_wtime()
    itmask=0
    652  itmask=itmask+1

    ! eventually, we should use wright's bt model approach
    ! for efficiencfcy, but the bt mode's non-zero divergence
    ! requires special treatment in that case.


    ! zero out advection velocity over land

    tmp=0.
    do j=2,j1
	do i=1,i1
	    u(i,j,1)=iu0(i,j)*u(i,j,1)
	enddo
    enddo

    do j=js,jf
	do i=2,i1
	    v(i,j,1)=iv0(i,j)*v(i,j,1)
	enddo
    enddo

    !      call write_rerun
    !      call mpi_finalize(ierr)
    !      stop 654

    if (lfsrf .eq. 0) then
	do k=1,k1
	    temp1=1./odz(k)
	    do j=2,j1
		temp=ocs(j)*ody(j)
		do i=2,i1
		    w(i,j,k+1)=w(i,j,k)-((u(i,j,k)-u(i-1,j,k))*odx(j)+(csv(j)*v(i,j,k)-csv(j-1)*v(i,j-1,k))*temp)*temp1
		end do
	    end do
	end do
	do j=2,j1
	    jj=j-1      !(j:cell, jj:size of s, easy to read)
	    do i=2,i1
		ii=i-1    !(i:cell, ii:size of s, easy to read)
		s(ii,jj)=w(i,j,kb(i,j)+1)
	    end do
	end do
    elseif (lfsrf .eq. 1) then
	do k=k1,1,-1
	    temp1=1./odz(k)
	    do j=2,j1
		temp=ocs(j)*ody(j)
		do i=2,i1
		    w(i,j,k)=w(i,j,k+1)+((u(i,j,k)-u(i-1,j,k))*odx(j)+(csv(j)*v(i,j,k)-csv(j-1)*v(i,j-1,k))*temp)*temp1
		end do
	    end do
	end do
	do j=2,j1
	    jj=j-1      !(j:cell, jj:size of s, easy to read)
	    do i=2,i1
		ii=i-1;    !(i:cell, ii:size of s, easy to read)
		s(ii,jj)=-w(i,j,1)
	    end do
	end do
    else
	if(myid.eq.0)write(*,*)'lfsrf is not set correctly'
	call mpi_finalize(ierr)
	stop
    endif


    ! ================================
    ! the rebirth of bir
    ! something for m.s. to chew on!!!
    ! ================================
    ! iter is the bir sweep number
    timer(7)=mpi_wtime()
	
    if (lsolver .eq. 1) then
	call rep(al,ab,ac,ar,at,rinv,rinv1,dum0,dum1,dum2,dumg,s,x,ie)
	!       call rep2(al,ab,ac,ar,at,rinv,rinv1,dum0,dum1,dum2,dumg,s,x,ie)
	elseif(lsolver .eq. 2) then
	call p_bicgstab_le(ab,al,ac,ar,at,s,x,cb,cl,cc,cr,ct,cgr,cgrh,cgp,cgv,cgs,cgt,cgph,cgsh)
    endif

    !    call rep(al,ab,ac,ar,at,rinv,rinv1,dum0,dum1,dum2,dumg,s,x,ie)

    timer(6)=mpi_wtime()-timer(7)
    ! rigid-lid pressure adjustment
    do j=1,j0
	do i=1,i0
	    p0(i,j)=p0(i,j)+odt*x(i,j)
	enddo
    enddo
    ! bt mode adjustment (from pressure gradient change)
    do j=2,j1
	do i=1,i1
	    scr(i,j,1)=-(x(i+1,j)-x(i,j))*odx(j)
	enddo
    enddo
    do j=js,jf
	do i=2,i1
	    scr(i,j,2)=-(x(i,j+1)-x(i,j))*odyv(j)
	enddo
    enddo

    ! top layer
    do j=2,j1
	do i=1,i1
	    scr(i,j,3)=scr(i,j,3)+scr(i,j,1)
	    u(i,j,1)=iu0(i,j)*u(i,j,1)+scr(i,j,1)
	enddo
    enddo
    do j=js,jf
	do i=2,i1
	    scr(i,j,4)=scr(i,j,4)+scr(i,j,2)
	    v(i,j,1)=iv0(i,j)*v(i,j,1)+scr(i,j,2)
	enddo
    enddo
    ! remaining layers
    do k=2,k1
	do j=2,j1
	    do i=1,i1
		u(i,j,k)=u(i,j,k)+scr(i,j,1)*iu(i,j,k)
	    enddo
	enddo
	do j=js,jf
	    do i=2,i1
		v(i,j,k)=v(i,j,k)+scr(i,j,2)*iv(i,j,k)
	    enddo
	enddo
    enddo
    !check convergence to zero flow over land
    tmp=0.
    do j=2,j1
	do i=2,i2
	    tmp=max(tmp,(1-iu0(i,j))*abs(u(i,j,1)))
	enddo
    enddo
    do j=2,j2
	do i=2,i1
	    tmp=max(tmp,(1-iv0(i,j))*abs(v(i,j,1)))
	enddo
    enddo
    tp=tmp
    call mpi_allreduce(tp,tmp,1,mpi_real8,mpi_max,m_cart,ierr)
    if(itf-it0.lt.itfday.or.mod(itf,itfday).eq.0) write(14,683) itf-it0,itmask,tmp,timer(6)
    !if (myid .eq. 0 .and. mod(itf,itfday).eq.0) write(*,683) itf-it0,itmask,tmp,timer(6)
    if (myid .eq. 0) write(*,683) itf-it0,itmask,tmp,timer(6)
    683  format('@itf-it0===',i8,',itmask=',i3,', vmx on land=',f8.4,' cm/s, solver time =', f8.4,'sec')

    if (tmp.gt..0002 .and. itmask.lt.mxmask) go to 652

    timer(4)=timer(4)+mpi_wtime()-timer(9)
    ! this completes the advanced time level advection velocity
    ! having exactly zero barotropic divergence and satisfying all
    ! kinematic and specified open boundary conditions
    if (lfsrf .eq. 0) then
	do k=1,k1                !(k:layer& top   face for w, k+1:bottom face for w)
	    tmp=1./odz(k)
	    do j=2,j1              !(j:cell & north face for v)
		temp=ocs(j)*ody(j)
		do i=2,i1            !(i:cell & east  face for u)
		    w(i,j,k+1)=iw(i,j,k+1)*(w(i,j,k)-((u(i,j,k)-u(i-1,j,k))*odx(j)+(csv(j)*v(i,j,k)-csv(j-1)*v(i,j-1,k))*temp)*tmp)
		end do
	    end do
	end do
    elseif (lfsrf .eq. 1) then
	do j=2,j1              !(j:cell & north face for v)
	    temp=ocs(j)*ody(j)
	    do i=2,i1            !(i:cell & east  face for u)
		do k=kb(i,j),1,-1
		    tmp=1./odz(k)
		    w(i,j,k)=(w(i,j,k+1)+((u(i,j,k)-u(i-1,j,k))*odx(j)+(csv(j)*v(i,j,k)-csv(j-1)*v(i,j-1,k))*temp)*tmp)
		end do
	    end do
	end do
    endif

    do k=1,k1
	do j=2,j1
	    do i=2,i1
		u2(i,j,k)=12.*(u(i-1,j,k)+u(i,j,k))
		v2(i,j,k)=12.*(v(i,j-1,k)+v(i,j,k))
	    enddo
	enddo
    enddo

    call mpi_sendrecv(u(i2,1,1),1,m_vlon3d,m_e,1,scr(i2,1,1),1,m_vlon3d,m_w,1,m_cart,istat,ierr)
    call mpi_sendrecv(u(2,1,1),1,m_vlon3d,m_w,1,scr(2,1,1),1,m_vlon3d,m_e,1,m_cart,istat,ierr)
    do k=1,k1
	do j=2,j1
	    u2(2,j,k)=o24*in(2,j,k)*(u2(2,j,k)-scr(i2,j,k)+u(1,j,k)+u(2,j,k)-u(3,j,k))
	    u2(i1,j,k)=o24*in(i1,j,k)*(u2(i1,j,k)-u(i0-3,j,k)+u(i2,j,k)+u(i1,j,k)-scr(2,j,k))
	enddo
    enddo
    do k=1,k1
	do j=2,j1
	    do i=3,i2
		u2(i,j,k)=o24*in(i,j,k)*(u2(i,j,k)-u(i-2,j,k)+u(i-1,j,k)+u(i,j,k)-u(i+1,j,k))
	    enddo
	enddo
    enddo
    call mpi_sendrecv(v(1,j2,1),1,m_vlat3d,m_n,1,scr(1,j2,1),1,m_vlat3d,m_s,1,m_cart,istat,ierr)
    call mpi_sendrecv(v(1,2,1),1,m_vlat3d,m_s,1,scr(1,2,1),1,m_vlat3d,m_n,1,m_cart,istat,ierr)
    do k=1,k1
	do i=2,i1
	    do j=3,j2
		v2(i,j,k)=v2(i,j,k)-v(i,j-2,k)+v(i,j-1,k)+v(i,j,k)-v(i,j+1,k)
	    enddo
	    if(mylat.ne.0) v2(i,2,k)=v2(i,2,k)-scr(i,j2,k)+v(i,1,k)+v(i,2,k)-v(i,3,k)
	    if(mylat.ne.ngy1) v2(i,j1,k)=v2(i,j1,k)-v(i,j0-3,k)+v(i,j2,k)+v(i,j1,k)-scr(i,2,k)
	enddo
    enddo
    do k=1,k1
	do j=js,j1
	    do i=2,i1
		v2(i,j,k)=in(i,j,k)*o24*v2(i,j,k)
	    enddo
	enddo
    enddo


    if (itf-it0.gt.itfday.and.mod(itf,itfday).ne.0) go to 712
	!check incompressibility
	tmp=0.
	err=0.
	do k=1,k1
	    do j=2,j1
		do i=2,i1
		    tmp1=(u(i,j,k)-u(i-1,j,k))*odx(j)
		    tmp2=(csv(j)*v(i,j,k)-csv(j-1)*v(i,j-1,k))*ocs(j)*ody(j)
		    tmp3=(w(i,j,k+1)-w(i,j,k))*odz(k)
		    tmp=tmp+max(abs(tmp1),abs(tmp2),abs(tmp3))*in(i,j,k)
		    err=err+abs(tmp1+tmp2+tmp3)*in(i,j,k)
		enddo
	    enddo
	enddo

	tep=err
	call mpi_allreduce(tep,err,1,mpi_real8,mpi_sum,m_cart,ierr)
	tep=tmp
	call mpi_allreduce(tep,tmp,1,mpi_real8,mpi_sum,m_cart,ierr)
	err=err/tmp
	write(14,711) err
	call flush(14)
	711  format(' *** normalized mean incompressibility error = ',1pe9.2)
    712  psm=0.

    do j=2,j1
	do i=2,i1
	    psm=psm+p0(i,j)
	enddo
    enddo
    tmp=psm
    call mpi_allreduce(tmp,psm,1,mpi_real8,mpi_sum,m_cart,ierr)

    psm=psm/dble(i2t*j2t)

    do j=2,j1
	do i=2,i1
	    p0(i,j)=p0(i,j)-psm
	enddo
    enddo


    call mpi_barrier(m_cart,ierr)  
    call mpi_exch_3d_r4(u2)
    call mpi_exch_3d_r4(v2)
    call mpi_exch_3d_r4(t2)
    call mpi_exch_3d_r4(s2)
!yc
    call mpi_exch_3d_r4(c2)
!yc

    if (.false.) then
	tt0=it0/daodt
	n=tt0/360.+.0001
	tmp=tt0/360.
	tt2=(tmp-n)*360.+.1
	tt1=tt0/360.+.0001+1
	write(fn1,'(i3.3,a1,i3.3)'),tt1,'_',tt2

	do i = 1,i0,2
	do j = 1,j0,2

	if (ydeg(j).ge.30.1.and.ydeg(j).le.40.1 .and.xdeg(i).ge.(360.-80.).and.xdeg(i).le.(360.-72.)) then
	    open(1005,file='ts/field1_'//fn1//'_'//grd,form='unformatted')
	    do k=1,10
	    write(1005) ulf(i,j,k),vlf(i,j,k),p(i,j,k),tlf(i,j,k)
	    enddo
	    if(itf.eq.it0) then
		print*,'field i,j,myid',myid,grd,i,j,ydeg(j),xdeg(i),ulf(i,j,4)
	    endif
	endif

	if (ydeg(j).ge.36.1.and.ydeg(j).le.42.1 .and.xdeg(i).ge.(360.-70.).and.xdeg(i).le.(360.-60.)) then
	    open(1006,file='ts/field2_'//fn1//'_'//grd,form='unformatted')
	    do k=1,10
	    write(1006) ulf(i,j,k),vlf(i,j,k),p(i,j,k),tlf(i,j,k)
	    enddo
	    if(itf.eq.it0) then
		print*,'field i,j,myid',myid,grd,i,j,ydeg(j),xdeg(i),ulf(i,j,4)
	    endif
	endif


	enddo
	enddo
    endif

    !   rawf=0.53
    !   fltw=0.1
    !   modified filter scheme
    call modified_filter
   
    ! ----------------------------------------------
    ! relax swamp layer and masked water to interior
    ! to reduce seepage effect  
    ! ----------------------------------------------
    call mpi_barrier(m_cart,ierr)
    call mpi_exch_2d_r4(t1(1,1,1))
    call mpi_exch_2d_r4(s1(1,1,1))
!yc
    call mpi_exch_2d_r4(c1(1,1,1))
!yc


    do j=2,j1
	do i=2,i1
	    tmp=.25*(1-in(i,j,1))
	    scr(i,j,1)=in(i,j,1)*t1(i,j,1)+tmp*(t1(i-1,j,1)+t1(i+1,j,1)+t1(i,j+1,1)+t1(i,j-1,1))
	    scr(i,j,2)=in(i,j,1)*s1(i,j,1)+tmp*(s1(i-1,j,1)+s1(i+1,j,1)+s1(i,j+1,1)+s1(i,j-1,1))
!yc
            scr(i,j,13)=in(i,j,1)*c1(i,j,1)+tmp*(c1(i-1,j,1)+c1(i+1,j,1)+c1(i,j+1,1)+c1(i,j-1,1))
!yc
	enddo
    enddo

    do j=2,j1
	do i=2,i1
	    t1(i,j,1)=scr(i,j,1)
	    s1(i,j,1)=scr(i,j,2)      
!yc
            c1(i,j,1)=scr(i,j,13)
!yc

	enddo
    enddo
end subroutine


subroutine set_windmix
!    open(8,file='prepglo/data/windmix'//grd,form='unformatted')
!    read(8) vbk,hbk
!    close(8)
     call rdnc_windmix
end subroutine


subroutine set_rundata 
!    open(9,file='prepglo/data/rundata'//grd,form='unformatted')
!    read(9) case,dscrib,dt,tlz,b,g,dm0,de0,dmz0,f,tanphi,rzmx, &
!    drag,fltw,daodt,odt,prn,orzmx,ofltw,y,yv,yvdeg,ydeg,cs,csv, &
!    ocs,ocsv,dx,dxv,odx,odxv,dy,dyv,ody,odyv,ktrm,lrstrt,mxit,isav, &
!    mxsav,lopen,lmovi,mvi,lfsrf,lsolver,xdeg,lprecon,rawf
!    close(9)
    call rdnc_rundata
   
    itfday=daodt+.0001
    !conversion of qavg (deg c per model time step) to watts/m-m
    ! use factors for deg ! per year and g/kg/yr
    watts=360.*24.*3600.*0.00134/(dt*odz(1))

    ! global salinity budget weighting factor             
end subroutine


subroutine set_zkb 
    ! --------------------------------------------------------------------
    ! metrics, z-levels(z) and bathymetry (logical depth array (kb)) data
    ! --------------------------------------------------------------------
!    open(60,file='prepglo/data/zkb'//grd,form='unformatted')
!    read(60) tlz,z,odz,odzw,kb,in,iu,iv,iw,iu0,iv0
    call rdnc_zkb
end subroutine


subroutine set_surfwinds
!    open(72,file='prepglo/data/winds'//grd,form='unformatted')
    call rdnc_winds
    do n=1,12
	! read wind stress (dynes/cm-cm), temperature (deg c), salinity(ppt),
	! q, wavg(mm/month)
!	read(72) ((taux(i,j,n),i=1,i2),j=1,j2),((tauy(i,j,n),i=1,i2),j=1,j2)

	! screen out land sources and convert from newtons/m-m to dynes/cm-cm
	!   intensifies the mixing le
	nocn=0
	do j=1,j2
	    do i=1,i2
		nocn=nocn+in(i+1,j+1,1)
		taux(i,j,n)=10.*in(i+1,j+1,1)*taux(i,j,n)
		tauy(i,j,n)=10.*in(i+1,j+1,1)*tauy(i,j,n)
	    enddo
	enddo
    enddo

    nt=nocn
    call mpi_allreduce(nt,nocn,1,mpi_integer,mpi_sum,m_cart,ierr)
end subroutine


subroutine set_area
    real*8 dtmp
    do k=1,k1
	a(k)=0.d0
	do j=2,j1
	    dtmp=dx(j)*dy(j)
	    do i=2,i1
		a(k)=a(k)+in(i,j,k)*dtmp
	    enddo
	enddo
	dtmp=a(k)
	call mpi_allreduce(dtmp,a(k),1,mpi_real8,mpi_sum,m_cart,ierr)
    enddo
end subroutine


subroutine set_ts_nudging 
    ! simple equatorial and high latitude sponge layers are needed because
    ! storm-generated penetrative convection in high lats and inappropriate
    ! hydrostati! equatorial dynamics that cannot emulate effe!   of stacked
    ! equatorial vortices on t,s near equator; the effe!   on momentum are
    ! addressed by new eddy viscosity formulation based on the time
    ! variability of vertical velocity which is big: near the equator (due to
    ! small coriolis parameter); in high lats and southern ocean due to small
    ! stratification there; and along fronts everywhere due to instabilities
    ! ======================================================================
    ! jacc,jeq,jar! refer to cell centers. assume southernmost and
    ! northernmost gridlines are at the same lats as used at 1/4 deg lon
    ! resolution, which is achieved by proper inputs, defined in
    ! prepglo/data/metgen.
    ! 1. keep the same southernmost gridline lat (y0deg=yv(1)=-69.9377 deg)
    !    as used with 1/4 deg resolution (dxmnut=15.)
    ! 2. set the new j2 value equal to the old one (792) multiplied by the
    !    ratio of the old "dxdeg" value to the new one,
    ! this puts a gridline exactly on the equator and puts the northernmost
    ! gridline, yv(j1), at 69.7654 deg lat; 1/4 deg res (dxmnut=15.), gives
    ! yv(398)= 0.0 deg (on the equator).
    ! ======================================================================
    ! ---------------------
    ! setting nudge matrix
    ! ---------------------
    scr=0.
    yscale=10.
    rate=(792./j2t)/yscale
    rate3=3.*rate
    
    ! s
    n_tmp=90.
    tmpp_s=max(1./(n_tmp*daodt),0.)
    ! t
    n_tmp=90.
    tmpp_t=max(1./(n_tmp*daodt),0.)
    ! s,t coast
    n_tmp=-1.
    tmpp_sc=max(1./(n_tmp*daodt),0.)
    n_tmp=90.
    tmpp_tc=max(1./(n_tmp*daodt),0.)
    ! s,t ac! arc
    n_tmp=90.
    tmpp_shs=max(1./(n_tmp*daodt),0.)
    n_tmp=90.
    tmpp_ths=max(1./(n_tmp*daodt),0.)


    ! hmean ac! arc
    n_tmp=90.
    tmpp_hi=max(1./(n_tmp*daodt),0.)
    ! hmean eq
    n_tmp=-1.
    tmpp_ei=max(1./(n_tmp*daodt),0.)
    ! hmean other
    n_tmp=-1.
    tmpp_o=max(1./(n_tmp*daodt),0.)
    ! hmean coast
    n_tmp=-1.
    tmpp_oc=max(1./(n_tmp*daodt),0.)


    acc_deg=-69.5
    acc_rag=acc_deg+2.

    arc_deg=83.
    arc_rag=arc_deg-2.

    do j=2,j1
	do i=2,i1
	    ! s & t
	    if(ydeg(j).ge.arc_deg.or.ydeg(j).le.acc_deg) then
		t_nudge(i,j)=tmpp_ths
		s_nudge(i,j)=tmpp_shs
		elseif((ydeg(j).ge.arc_rag)) then
		t_nudge(i,j)=(tmpp_ths-tmpp_t)*exp(-rate*abs((ydeg(j)-arc_deg)/(ydeg(j)-ydeg(j-1))))+tmpp_t
		s_nudge(i,j)=(tmpp_shs-tmpp_s)*exp(-rate*abs((ydeg(j)-arc_deg)/(ydeg(j)-ydeg(j-1))))+tmpp_s
		elseif((ydeg(j).le.acc_rag)) then
		t_nudge(i,j)=(tmpp_ths-tmpp_t)*exp(-rate*abs((ydeg(j)-acc_deg)/(ydeg(j)-ydeg(j-1))))+tmpp_t
		s_nudge(i,j)=(tmpp_shs-tmpp_s)*exp(-rate*abs((ydeg(j)-acc_deg)/(ydeg(j)-ydeg(j-1))))+tmpp_s
	    else
		t_nudge(i,j)=tmpp_t
		s_nudge(i,j)=tmpp_s
	    endif

	    if(kb(i,j).le.1.or.kb(i-1,j).le.1.or.kb(i+1,j).le.1.or.kb(i,j-1).le.1.or.kb(i,j+1).le.1) then
		t_nudge(i,j)=tmpp_tc
		s_nudge(i,j)=tmpp_sc
	    endif

	    ! hmean
	    do k=1,k0
		if(ydeg(j).ge.arc_deg.or.ydeg(j).le.acc_deg) then
		    hmean_nudge(i,j,k)=tmpp_hi
		    elseif((ydeg(j).ge.arc_rag)) then
		    hmean_nudge(i,j,k)=(tmpp_hi-tmpp_o)*exp(-rate*abs((ydeg(j)-arc_deg)/(ydeg(j)-ydeg(j-1))))+tmpp_o
		    elseif((ydeg(j).le.acc_rag)) then
		    hmean_nudge(i,j,k)=(tmpp_hi-tmpp_o)*exp(-rate*abs((ydeg(j)-acc_deg)/(ydeg(j)-ydeg(j-1))))+tmpp_o
		    elseif(ydeg(j).ge.-5..and.ydeg(j).le.5.) then
		    hmean_nudge(i,j,k)=(tmpp_ei-tmpp_o)*exp(-rate3*abs((ydeg(j)-0.)/(ydeg(j)-ydeg(j-1))))+tmpp_o
		else
		    hmean_nudge(i,j,k)=tmpp_o
		endif

		if(kb(i,j).le.1.or.kb(i-1,j).le.1.or.kb(i+1,j).le.1.or.kb(i,j-1).le.1.or.kb(i,j+1).le.1) then
		    hmean_nudge(i,j,k)=tmpp_oc
		endif
	    enddo
	enddo
    enddo
end subroutine


subroutine set_lateral_mixing 
    ! increase lateral mixing near equator and in high latitudes
    ! big northern latitude dissipation fixes initialization data problem
    it=mylon*i2
    jt=mylat*j2

    dxx=1.0
    dyy=1.0

    do k=1,k1
	do j=1,j0
	    do i=1,i0
		temp=1.e6*(exp(-.001*(2-j-jt)**2)+exp(-.001*(j1t-jt-j)**2))      ! north & south poles
		scr(i,j,k)=2.e6*exp(-.001*((ydeg(j)-0)/dyy)**2)+temp        &
		+.5e6*exp(-.01*(((xdeg(i)-109.5))**2+((ydeg(j)-15.5))**2)) &! warm bias
		+.5e6*exp(-.01*(((xdeg(i)-114.5))**2+((ydeg(j)+ 9.5))**2)) &! warm bias
		+2.e6*exp(-.01*(((xdeg(i)-300.9))**2+((ydeg(j)-45.11))**2))&! cold bias (west nova scotia)
		+2.e6*exp(-.01*(((xdeg(i)-298.7))**2+((ydeg(j)-43.68))**2))&! cold bias (sw nova scotia)
		+2.e6*exp(-.01*(((xdeg(i)-276.2))**2+((ydeg(j)-56.67))**2))&! cold bias (south hudson bay)
		+2.e6*exp(-.01*(((xdeg(i)-181.7))**2+((ydeg(j)-64.22))**2))&! cold bias (gulf of anadyr)
		+2.e6*exp(-.01*(((xdeg(i)-164.8))**2+((ydeg(j)-58.85))**2))&! cold bias (ne kamchatka)
		+1.e6*exp(-.01*(((xdeg(i)-142.3))**2+((ydeg(j)-56.67))**2))&! cold bias (sakhalin gulf)
		+1.e6*exp(-.01*(((xdeg(i)-143.4))**2+((ydeg(j)-45.11))**2))&! cold bias (aniva bay)
		+1.e6*exp(-.01*(((xdeg(i)-135.6))**2+((ydeg(j)-42.21))**2)) ! cold bias (east japan sea)
	    enddo
	enddo
    enddo

    ! note: the following may need some adjustment in the mpi code
    ! increase lateral eddy viscosity near wet/dry point interfaces
    do k=1,k1
	do i=1,i0
	    do j=1,j0
		dmx(i,j,k)=dm0+scr(i,j,k)
		dmy(i,j,k)=dmx(i,j,k)
	    enddo
	enddo
    enddo
end subroutine


subroutine set_extra_vertical_eddy_viscosity
    ! xtra vertical eddy viscosity
    do jj=2,j1
	j=min(jj,j2)
	j=max(j,3)
	do ii=2,i1
	    i=min(ii,i2)
	    i=max(i,3)
	    ! bottom slope
	    dzdx=(z(2*kb(i+1,j))-z(2*kb(i-1,j)))*odx(j) 
	    dzdy=(z(2*kb(i,j+1))-z(2*kb(i,j-1)))*ody(j)
	    zbot=z(2*kb(i,j)+1)
	    slope=sqrt(dzdx**2+dzdy**2)
	    do k=1,k2
		! regionally increased vertical eddy viscosity
		! locally increase add array to get 90-day time scale for 1 layer scale
		! tscale=90.*24.*3600.
		! after day 100 yr 3 confine xtra equatorial (j=398) mixing to top 1000m
		tmp=min(10.,2.e-4*z(2*kb(i,j)+1))
		!      evadd=.5*exp(-tmp-.01*(jt+j-j2t/2-2)**2)
		evadd=.5*exp(-tmp-.01*((ydeg(j)-0)/(ydeg(j+1)-ydeg(j)))**2)

		! eddy viscosity is big above steeply sloping bottom locations
		! near-bottom factor
		! temp=2.e-9*(zbot-z(2*k+1))**2
		! decrease vertical mixing scale at start of yr 3 to allow free
		! passage into caribbean
		temp=1.e-8*(zbot-z(2*k+1))**2
		! vertical mix time scale=o(dz*2/ev); for time scale=1 day and dz=10m,
		! ev=o(10**6/10**5)=10.

		tmp=min(5.,5.*exp(-temp)*slope)

		! biggest eddy viscosity in deep water having steeply sloping bottom
		! where breaking big amplitude internal waves are most likely to occur
		! due to low subthermocline stratification

		tmp=tmp+vbk(k)+evadd

		! explicit stability limit and ev normalization done in pp82glo
		add(ii-1,jj-1,k)=tmp
	    enddo 
	enddo 
    enddo 
end subroutine


subroutine set_seasonal_data 
    real*8 tmpp
!    open(70,file='prepglo/data/annualevitus'//grd,form='unformatted')
!    rewind 70
    ! seasonal boundary conditions
    tmpp=1./12.

    do nm=1,12
	if(myid.eq.0)write(*,15) nm
	15   format('month',i3,' in bounds')
	! read in monthly t,s boundary climatologies
!	read(70) sclim,tclim
        call rdnc_levitus(nm)

	do k=1,k1
	    do j=1,j0
		do i=1,i0
		    s2(i,j,k)=s2(i,j,k)+sclim(i,j,k)*tmpp
		    t2(i,j,k)=t2(i,j,k)+tclim(i,j,k)*tmpp
		    if(k.eq.1) sclim(i,j,k)=max(33.,sclim(i,j,k))
		    if(ini_clim.eq.13)then
			s1(i,j,k)=s1(i,j,k)+sclim(i,j,k)*tmpp
			t1(i,j,k)=t1(i,j,k)+tclim(i,j,k)*tmpp
		    else
			if(ini_clim.eq.nm)then
			    s1(i,j,k)=sclim(i,j,k)
			    t1(i,j,k)=tclim(i,j,k)
			endif
		    endif
		enddo
	    enddo
	enddo

	do j=1,j0
	    do i=1,i0
		do k=1,k1
		    sclis(i,j,k,nm)=sclim(i,j,k)
		    tclis(i,j,k,nm)=tclim(i,j,k)
		enddo
	    enddo
	enddo
    enddo 
!    close(70)
    
    do k=1,k1
	do j=1,j0
	    do i=1,i0
		sclim(i,j,k)=s2(i,j,k)
		tclim(i,j,k)=t2(i,j,k)
		s2(i,j,k)=0.
		t2(i,j,k)=0.
	    enddo 
	enddo 
    enddo 
 
    if (lrstrt.eq.0)then
	if(myid.eq.0)write(*,*)'write ncf initial'
	call write_init2nc(sclim,tclim)

	do k=1,k1
	    do j=1,j0
		do i=1,i0
		    slf(i,j,k)=s1(i,j,k)
		    tlf(i,j,k)=t1(i,j,k)
		    s2(i,j,k)=s1(i,j,k)
		    t2(i,j,k)=t1(i,j,k)
!yc
                    c1(i,j,k)=0. !t1(i,j,k) !assume c1 is same as temp
                    clf(i,j,k)=c1(i,j,k)
                    c2(i,j,k)=c1(i,j,k)
!yc
		enddo
	    enddo
	enddo

        write(14,1)case,dscrib,lrstrt,mxit,i0,j0,k0,ktrm,dt,fltw,tlz,g,dm0,de0,dmz0,rzmx,drag
        1    format('case ',a5,' (',a63,')'/'----------'/ &
        ' lrstrt   mxit   i0   j0   k0 ktrm'/2i9,4i5// &
        8x,'dt',6x,'fltw',7x,'tlz'/1p,3(1x,e9.2)// &
        7x,'g',7x,'dm0',7x,'de0',6x,'dmz0', &
        6x,'rzmx',6x,'drag'/1p,7(1x,e9.2))

	! initialize qavg
	n=30*daodt
	temp=z(3)/(30.*24.*3600.)
	do m=1,12
	    nsombo(m)=2
	    mp=m+1
	    if (m.eq.12) mp=1
	    evap=0.
	    do j=1,j2
		tmp=dx(j+1)*dy(j+1)
		do i=1,i2
		    ! this initialization is arbitrary and optional
		    qavg(i,j,m)=in(i+1,j+1,1)*(tclis(i+1,j+1,1,mp)-tclis(i+1,j+1,1,m))/n
		enddo	
	    enddo	
	enddo	

	! depth
!	read(60) ((scr(i,j,1),i=1,i0),j=1,j0)
!	close(60)
        call rdnc_zkb2
	do j=2,j1
	    do i=2,i1
		! convert to kilometers
		scr(i,j,1)=1.e-5*scr(i,j,1)
	    enddo
	enddo
    else
	! -----------------
	! read restart data
	! -----------------
	! av is for long term averages. avg is for nabcs 5-day averages.
	if (myid.eq.0) print*,'read rerun file',myid,itf
	call read_rerun

	call  mpi_exch_3d_r4(u)
	call  mpi_exch_3d_r4(v)
	call  mpi_exch_2d_r8(x)
	
	if(myid.eq.0)write(*,*)'read ncf initial'
	call read_initnc(sclim,tclim)

	call  mpi_exch_3d_r4(tclim)
	call  mpi_exch_3d_r4(sclim)

	n=days*daodt+.5
	daodt_new=daodt
	daodt_old=itf/days
	if (n/=itf) then 
	    ! tmp=(dtnew/dtold)
	    tmp=daodt_old/daodt_new
	    if (myid .eq. 0)then
		write(*,57) tmp
		write(14,57) tmp
		57   format('dtnew/dtold=',f6.3)
	    endif
	    do nm=1,12
		do j=1,j2
		    do i=1,i2
			qavg(i,j,nm)=tmp*qavg(i,j,nm)
		    enddo	
		enddo	
	    enddo	

	    if (myid .eq. 0)then
		write(*,59) itf,n
		write(14,59) itf,n
		59   format(/'time step # changed from',i7,' to',i7,' at restart to reflect dt change')
	    endif
	    itf=n
	    ! reset averaging arrays every 5 years
	endif
	
	if(myid.eq.0)write(*,61) itf,days,daodt_new,daodt_old
	61   format('itf,days,daodt_new,daodt_old',i8,3f8.1)

	n=days+.1

	if (mod(int(days+.01),1800).eq.0.) av=0.

	itf=days*daodt+0.5

	! 82 if (days.gt.460..and.mod(itf,360*itfday).ne.0) go to 85
	! wavg & qavg include advection effe!  
	! wavg is surface freshwater sources/sinks (e-p) consistent with model
	! and climatological data
	! nsombo(m)=number of ensemble-averaging years
	! assumed already included in qavg and wa[vg
	! however, we weight each new year equally to the previously completed
	! year's ensemble average, until year 11, thus given more weight to
	! recent results and thus acclerating convergence to a multi-year ensemble
	! average.
	if (n<=10*360) then 
	    ! keep old avg but speed convergence to new avg
	    do m=1,12
		nsombo(m)=2
	    enddo
	endif  
	
	if(myid .eq. 0)then
	    write(*,90) itf,days,nsombo
	    write(14,90) itf,days,nsombo
	    90   format(/'restart data read for time step ',i9,', day ',f8.2/'nsombo:',12i3)
	endif

    endif


    if (mylat .eq. 0) then
	do k=1,k1
	do i=1,i0
	t1(i,1,k)=tclim(i,1,k)
	t2(i,1,k)=tclim(i,1,k)
	tlf(i,1,k)=tclim(i,1,k)
	s1(i,1,k)=sclim(i,1,k)
	s2(i,1,k)=sclim(i,1,k)
	slf(i,1,k)=sclim(i,1,k)
	enddo
	enddo
    endif
    if (mylat .eq. ngy1) then
	do k=1,k1
	do i=1,i0
	t1(i,j0,k)=tclim(i,j0,k)
	t2(i,j0,k)=tclim(i,j0,k)
	tlf(i,j0,k)=tclim(i,j0,k)
	s1(i,j0,k)=sclim(i,j0,k)
	s2(i,j0,k)=sclim(i,j0,k)
	slf(i,j0,k)=sclim(i,j0,k)
	enddo
	enddo
    endif
end subroutine


subroutine eliminate_spurious_values
    if(lrstrt.eq.0)then
	! eliminate spurious values over land
	!      nit=2001
	nit=1
	do n=1,nit
	    do k=1,2
		tmin=1.e8
		tmax=-1.e8
		smin=1.e8
		smax=-1.e8
		do j=2,j1
		    do i=2,i1
			if (in(i,j,k)==0) then 
			    scr(i,j,1)=.25*(s1(i+1,j,k)+s1(i-1,j,k)+s1(i,j-1,k)+s1(i,j+1,k))
			    smin=min(smin,scr(i,j,1))
			    smax=max(smax,scr(i,j,1))
			    scr(i,j,2)=.25*(t1(i+1,j,k)+t1(i-1,j,k)+t1(i,j-1,k)+t1(i,j+1,k))
			    tmin=min(tmin,scr(i,j,2))
			    tmax=max(tmax,scr(i,j,2))
			endif	
		    enddo
		enddo
		do j=2,j1
		    do i=2,i1
			if (in(i,j,k)==0) then
			    s1(i,j,k)=scr(i,j,1)
			    t1(i,j,k)=scr(i,j,2)
			endif
		    enddo
		enddo

		call mpi_exch_2d_r4(t1(1,1,k))
		call mpi_exch_2d_r4(s1(1,1,k))

		if(myid.eq.0)then
		    if(mod(n,100).eq.1)write(*,2) n,k,tmin,tmax,smin,smax
		    2    format('n,k,tmin,tmax,smin,smax:',i5,i3,4f7.3)
		endif
	    enddo
	enddo
    endif

end subroutine


subroutine ts_nudging_for_watermass
    ! To emulate watermass transformation effects on THC, nudge toward
    ! eqatorial as well as hi and lo lat climatology. We do not directly
    ! address watermass tranformations closer to poles, because their most
    ! important effects are seen in the central ACC and Arctic Circle
    ! regions, but important wind forced dynamics are included closer to
    ! poles. This is valid for simulating present climate and model
    ! validation, but NOT for simulating climate change, which equires
    ! ocean coupling to full atmospheric and ice dynamics, and much more
    ! complex physics.

    ! NOTE: This gives internal effective heat and salt material "sources"
    ! not in the real ocean. However, this should give model climatology
    ! close to the real ocean with the "sources" magnitudes being a metric
    ! of model quality; they should decrease with increased resolution and
    ! better model physics and subgridscale mixing emulation. Thus, the time
    ! averaged source magnitudes are a good indicator of model applicability
    ! to climate research. Indeed, the following may eventually include time
    ! averaged "sources" to decrease damping of transients (analagous to the
    ! non-damping surface sources of Dietrich, et al., 2004), but are not
    ! simply surface boundary conditions needed for ocean-only modeling (may
    ! be derived by coupling "perfect" ocean and atmospheri! models). They
    ! also noted that the "sources" may be used to improve vertical mixing
    ! parameterizations needed to keep imperfect models on track with
    ! observed ocean climate.
    ! ======================================================================
    ! Later, check sensitivity to expanding nudging to bands of polar and
    ! eqatorial lats to invoke stronger watermass formation.
    ! Loop 95 replaces hardwired multi-region approach used by original
    ! coding before calling FSGLO.
    do k=2,k1
	do j=2,j1
	    do i=2,i1
		if(in(i,j,k)/=0) then
		    t1(i,j,k)=(1.-hmean_nudge(i,j,k))*t1(i,j,k)+hmean_nudge(i,j,k)*tclim(i,j,k)
		    s1(i,j,k)=(1.-hmean_nudge(i,j,k))*s1(i,j,k)+hmean_nudge(i,j,k)*sclim(i,j,k)
!yc
!                    c1(i,j,k)=(1.-hmean_nudge(i,j,k))*c1(i,j,k)+hmean_nudge(i,j,k)*tclim(i,j,k)
!yc
		endif
	    enddo
	enddo
    enddo

    do j=2,j1
	do i=2,i1
	    s1(i,j,1)=s1(i,j,1)+s_nudge(i,j)*in(i,j,1)*in(i,j,2)*&
			    (fold*sclis(i,j,1,nld)+fnew*sclis(i,j,1,new)-s1(i,j,1))
	enddo
    enddo
end subroutine


subroutine solve_hydrostatic_equation
    real*8 tmpd,sltd,pisd,p01,p02
    dimension rhomin(k1)
    ! ======================================================
    ! Hydrostatic equation with static balance subracted out
    ! ======================================================
    do k=1,k1
	temp=1.e8
	do j=2,j1
	    do i=2,i1
		tmpd=max(-1.8,t2(i,j,k))
		sltd=min(41.,s2(i,j,k))
		sltd=max(0.d0,sltd)
		pisd=.001*z(2*k)
		! =======================
		! dan wright full e.o.s.
		! rho(i,j,k)=r(tmpd,sltd,pisd)
		! function r(t,s,p)
		! =======================
		p02=1747.4508988+tmpd*(11.51588-0.046331033*tmpd)-sltd*(3.85429655+0.01353985*tmpd)
		p01=pisd+5884.81703666+tmpd*(39.803732+tmpd*(-0.3191477+tmpd*0.0004291133))+2.6126277*sltd
		rho(i,j,k)=p01/(p02+0.7028423*p01)
		! determine global min of rho in all layers
		if(in(i,j,k)/=0) then 
		    temp=min(dble(temp),rho(i,j,k))
		endif
	    enddo
	enddo
	tmp=temp
	call mpi_barrier(m_cart,ierr)
	timer(9)=mpi_wtime()
	call mpi_allreduce(tmp,temp,1,mpi_real8,mpi_min,m_cart,ierr)
	timer(3)=timer(3)+mpi_wtime()-timer(9)

	rhomin(k)=temp
    enddo

    ! Subtract off global min of rho (in all layers, but it is always
    ! in the top layer) to keep correct rho stratification for vertical eddy
    ! viscosity/diffusivity parameterization in PP82GLO. Later, to reduce
    ! pressure gradient errors associated with big mean density in underlying
    ! layers, we subtract the layer min rho from each layer.
    do k=1,k1
	do j=2,j1
	    do i=2,i1
		scr(i,j,k)=rho(i,j,k)-rhomin(k)
	    enddo
	enddo
    enddo

    ! Use deviation of density from layer min density to get hydrostatic
    ! pressure gradient (reduces roundoff error and does not affect
    ! horizontal pressure gradient in the primitive hydroatic equations)
    ! Non-centered top half layer approximation: a good approximation
    ! because D(RHO)/DZ is very small in mixed layer
    tmpd=g*z(2)
    do j=2,j1
	do i=2,i1
	    p(i,j,1)=p0(i,j)+tmpd*rho(i,j,1)
	enddo
    enddo
    
    do k=1,k2
	tmpd=.5*g/odzw(k+1)
	do j=2,j1
	    do i=2,i1
		p(i,j,k+1)=p(i,j,k)+tmpd*(rho(i,j,k)+rho(i,j,k+1))
	    enddo
	enddo
    enddo
end subroutine


subroutine compute_pressure_gradient(k)
    ! first pressure differences
    do j=2,j1
	! scratch array for 4th-order pressure gradient calculation
	! avoid misusing data from overlying levels
	! (put 0's where they are needed in xp)
	do i=1,i1
	    xp(i,j)=iu(i,j,k)*(p(i+1,j,k)-p(i,j,k))
	enddo
    enddo

    call mpi_sendrecv(xp(2,1),1,m_evlon2d,m_w,1,xp(i0,1),1,m_evlon2d,m_e,1,m_cart,istat,ierr)
    call mpi_sendrecv(xp(i2,1),1,m_evlon2d,m_e,1,xp(0,1),1,m_evlon2d,m_w,1,m_cart,istat,ierr)

    do j=js,jf
	do i=2,i1
	    yp(i,j)=iv(i,j,k)*(p(i,j+1,k)-p(i,j,k))
	enddo
    enddo

    call mpi_sendrecv(yp(1,2),1,m_evlat2d,m_s,1,yp(1,j0),1,m_evlat2d,m_n,1,m_cart,istat,ierr)
    call mpi_sendrecv(yp(1,j2),1,m_evlat2d,m_n,1,yp(1,0),1,m_evlat2d,m_s,1,m_cart,istat,ierr)

    if (k .eq. 1) then
	do j=2,j1
	    do i=0,i0
		xp(i,j)=iu0(i,j)*xp(i,j)
	    enddo
	enddo
	do j=js-1,jf+1
	    do i=2,i1
		yp(i,j)=iv0(i,j)*yp(i,j)
	    enddo
	enddo
    endif
    ! basi! second order
    do j=2,j1
	do i=2,i1
	    px(i,j)=6.*(xp(i,j)+xp(i-1,j))
	    py(i,j)=6.*(yp(i,j)+yp(i,j-1))
	enddo
    enddo
    ! fourth order correction
    do j=2,j1
	do i=2,i1
	    px(i,j)=px(i,j)+iu(i-1,j,k)*iu(i,j,k)*(xp(i,j)+xp(i-1,j)-xp(i+1,j)-xp(i-2,j))
	enddo
    enddo
    do j=js+1,jf
	do i=2,i1
	    py(i,j)=py(i,j)+iv(i,j-1,k)*iv(i,j,k)*(yp(i,j)+yp(i,j-1)-yp(i,j+1)-yp(i,j-2))
	enddo
    enddo
    do j=2,j1
	do i=2,i1
	    px(i,j)=o12*px(i,j)
	    py(i,j)=o12*py(i,j)
	enddo
    enddo
end subroutine


subroutine compute_vertical_fluxes(k,lt)
    ! ---------------
    ! vertical fluxes
    ! ---------------
    ! these are 4th-order-accurate in logical space ("stretched z-coord")
    ! which is logical when the stretching is near optimum.
    l=k+1
    if (k==k1) then 
	! set bottom fluxes to zero (drag law applied after label 500)
	do j=1,j2
	    do i=1,i2
		uz(i,j,lt)=0.
		vz(i,j,lt)=0.
		sz(i,j,lt)=0.
		tz(i,j,lt)=0.
!yc
                cfcz(i,j,lt)=0.
!yc
	    enddo
	enddo
    else	
	do j=2,j1
	    do i=2,i1
		scr(i,j,1)=6.*(u2(i,j,k)+u2(i,j,l))
		scr(i,j,2)=6.*(v2(i,j,k)+v2(i,j,l))
		scr(i,j,3)=6.*(s2(i,j,k)+s2(i,j,l))
		scr(i,j,4)=6.*(t2(i,j,k)+t2(i,j,l))
!yc
                scr(i,j,13)=6.*(c2(i,j,k)+c2(i,j,l))
!yc
	    enddo
	enddo

	if (k/=1.and.k/=k2) then 
	    do j=2,j1
		do i=2,i1
		    tmp=iw(i,j,k)*iw(i,j,k+2)
		    scr(i,j,1)=scr(i,j,1)+tmp*(-ulf(i,j,k-1)+u2(i,j,k)+u2(i,j,l)-u2(i,j,k+2))
		    scr(i,j,2)=scr(i,j,2)+tmp*(-vlf(i,j,k-1)+v2(i,j,k)+v2(i,j,l)-v2(i,j,k+2))
		    scr(i,j,3)=scr(i,j,3)+tmp*(-slf(i,j,k-1)+s2(i,j,k)+s2(i,j,l)-s2(i,j,k+2))
		    scr(i,j,4)=scr(i,j,4)+tmp*(-tlf(i,j,k-1)+t2(i,j,k)+t2(i,j,l)-t2(i,j,k+2))
!yc
                    scr(i,j,13)=scr(i,j,13)+tmp*(-clf(i,j,k-1)+c2(i,j,k)+c2(i,j,l)-c2(i,j,k+2))
!yc
		enddo
	    enddo
	endif

	do n=1,4
	    do j=2,j1
		do i=2,i1
		    scr(i,j,n)=o12*scr(i,j,n)
		enddo
	    enddo
	enddo
!yc
        do j=2,j1
            do i=2,i1
               scr(i,j,13)=o12*scr(i,j,13)
            enddo
        enddo
!yc


	do j=2,j1
	    do i=2,i1
		uz(i-1,j-1,lt)=w(i,j,l)*scr(i,j,1)-ev(i-1,j-1,k)*(u1(i,j,l)-u1(i,j,k))*iw(i,j,l)
		vz(i-1,j-1,lt)=w(i,j,l)*scr(i,j,2)-ev(i-1,j-1,k)*(v1(i,j,l)-v1(i,j,k))*iw(i,j,l)
		sz(i-1,j-1,lt)=w(i,j,l)*scr(i,j,3)-0.1*hv(i-1,j-1,k)*(s1(i,j,l)-s1(i,j,k))*iw(i,j,l)
		tz(i-1,j-1,lt)=w(i,j,l)*scr(i,j,4)-hv(i-1,j-1,k)*(t1(i,j,l)-t1(i,j,k))*iw(i,j,l)
!yc
                cfcz(i-1,j-1,lt)=w(i,j,l)*scr(i,j,13)-hv(i-1,j-1,k)*(c1(i,j,l)-c1(i,j,k))*iw(i,j,l)
!yc
	    enddo
	enddo
    endif

    ! set scr(3,j,5) to store u2(3,j,k) so as v2,s2 and t2
    call mpi_sendrecv(u2(3,1,k),1,m_vlon2d,m_w,1,scr(3,1,5),1,m_vlon2d,m_e,1,m_cart,istat,ierr)
    call mpi_sendrecv(v2(3,1,k),1,m_vlon2d,m_w,1,scr(3,1,6),1,m_vlon2d,m_e,1,m_cart,istat,ierr)
    call mpi_sendrecv(s2(3,1,k),1,m_vlon2d,m_w,1,scr(3,1,7),1,m_vlon2d,m_e,1,m_cart,istat,ierr)
    call mpi_sendrecv(t2(3,1,k),1,m_vlon2d,m_w,1,scr(3,1,8),1,m_vlon2d,m_e,1,m_cart,istat,ierr)
!yc
    call mpi_sendrecv(c2(3,1,k),1,m_vlon2d,m_w,1,scr(3,1,14),1,m_vlon2d,m_e,1,m_cart,istat,ierr)
!yc
    ! set scr(i2,j,5) to store u2(i2,j,k) so as v2,s2 and t2
    call mpi_sendrecv(u2(i2,1,k),1,m_vlon2d,m_e,1,scr(i2,1,5),1,m_vlon2d,m_w,1,m_cart,istat,ierr)
    call mpi_sendrecv(v2(i2,1,k),1,m_vlon2d,m_e,1,scr(i2,1,6),1,m_vlon2d,m_w,1,m_cart,istat,ierr)
    call mpi_sendrecv(s2(i2,1,k),1,m_vlon2d,m_e,1,scr(i2,1,7),1,m_vlon2d,m_w,1,m_cart,istat,ierr)
    call mpi_sendrecv(t2(i2,1,k),1,m_vlon2d,m_e,1,scr(i2,1,8),1,m_vlon2d,m_w,1,m_cart,istat,ierr)
!yc
    call mpi_sendrecv(c2(i2,1,k),1,m_vlon2d,m_e,1,scr(i2,1,14),1,m_vlon2d,m_w,1,m_cart,istat,ierr)
!yc
    ! set scr(i,3,9) to store u2(i,3,k) so as v2,s2 and t2
    call mpi_sendrecv(u2(1,3,k),1,m_vlat2d,m_s,1,scr(1,3,9),1,m_vlat2d,m_n,1,m_cart,istat,ierr)
    call mpi_sendrecv(v2(1,3,k),1,m_vlat2d,m_s,1,scr(1,3,10),1,m_vlat2d,m_n,1,m_cart,istat,ierr)
    call mpi_sendrecv(s2(1,3,k),1,m_vlat2d,m_s,1,scr(1,3,11),1,m_vlat2d,m_n,1,m_cart,istat,ierr)
    call mpi_sendrecv(t2(1,3,k),1,m_vlat2d,m_s,1,scr(1,3,12),1,m_vlat2d,m_n,1,m_cart,istat,ierr)
!yc
    call mpi_sendrecv(c2(1,3,k),1,m_vlat2d,m_s,1,scr(1,3,15),1,m_vlat2d,m_n,1,m_cart,istat,ierr)
!yc
    ! set scr(i,j2,9) to store u2(i,j2,k) so as v2,s2 and t2
    call mpi_sendrecv(u2(1,j2,k),1,m_vlat2d,m_n,1,scr(1,j2,9),1,m_vlat2d,m_s,1,m_cart,istat,ierr)
    call mpi_sendrecv(v2(1,j2,k),1,m_vlat2d,m_n,1,scr(1,j2,10),1,m_vlat2d,m_s,1,m_cart,istat,ierr)
    call mpi_sendrecv(s2(1,j2,k),1,m_vlat2d,m_n,1,scr(1,j2,11),1,m_vlat2d,m_s,1,m_cart,istat,ierr)
    call mpi_sendrecv(t2(1,j2,k),1,m_vlat2d,m_n,1,scr(1,j2,12),1,m_vlat2d,m_s,1,m_cart,istat,ierr)
!yc
    call mpi_sendrecv(c2(1,j2,k),1,m_vlat2d,m_n,1,scr(1,j2,15),1,m_vlat2d,m_s,1,m_cart,istat,ierr)
!yc
end subroutine


subroutine compute_longitudinal_fluxes(k)
    ! -------------------
    ! longitudinal fluxes
    ! -------------------
    do j=2,j1
	! higher order interpolations
	do i=1,i1
	    scr(i,j,1)=6.*(u2(i,j,k)+u2(i+1,j,k))
	    scr(i,j,2)=6.*(v2(i,j,k)+v2(i+1,j,k))
	    scr(i,j,3)=6.*(s2(i,j,k)+s2(i+1,j,k))
	    scr(i,j,4)=6.*(t2(i,j,k)+t2(i+1,j,k))
!yc
            scr(i,j,13)=6.*(c2(i,j,k)+c2(i+1,j,k))
!yc
	enddo

	tmp=iu(0,j,k)*iu(2,j,k)
	scr(1,j,1)=scr(1,j,1)+tmp*(-scr(i2,j,5)+u2(1,j,k)+u2(2,j,k)-u2(3,j,k))
	scr(1,j,2)=scr(1,j,2)+tmp*(-scr(i2,j,6)+v2(1,j,k)+v2(2,j,k)-v2(3,j,k))
	scr(1,j,3)=scr(1,j,3)+tmp*(-scr(i2,j,7)+s2(1,j,k)+s2(2,j,k)-s2(3,j,k))
	scr(1,j,4)=scr(1,j,4)+tmp* (-scr(i2,j,8)+t2(1,j,k)+t2(2,j,k)-t2(3,j,k))
!yc
        scr(1,j,13)=scr(1,j,13)+tmp*(-scr(i2,j,14)+c2(1,j,k)+c2(2,j,k)-c2(3,j,k))
!yc
	tmp=iu(i2,j,k)*iu(i0,j,k)
	scr(i1,j,1)=scr(i1,j,1)+tmp*(-u2(i2,j,k)+u2(i1,j,k)+u2(i0,j,k)-scr(3,j,5))
	scr(i1,j,2)=scr(i1,j,2)+tmp*(-v2(i2,j,k)+v2(i1,j,k)+v2(i0,j,k)-scr(3,j,6))
	scr(i1,j,3)=scr(i1,j,3)+tmp*(-s2(i2,j,k)+s2(i1,j,k)+s2(i0,j,k)-scr(3,j,7))
	scr(i1,j,4)=scr(i1,j,4)+tmp*(-t2(i2,j,k)+t2(i1,j,k)+t2(i0,j,k)-scr(3,j,8))
!yc
        scr(i1,j,13)=scr(i1,j,13)+tmp*(-c2(i2,j,k)+c2(i1,j,k)+c2(i0,j,k)-scr(3,j,14))
!yc

	do i=2,i2
	    tmp=iu(i-1,j,k)*iu(i+1,j,k)
	    scr(i,j,1)=scr(i,j,1)+tmp*(-u2(i-1,j,k)+u2(i,j,k)+u2(i+1,j,k)-u2(i+2,j,k))
	    scr(i,j,2)=scr(i,j,2)+tmp*(-v2(i-1,j,k)+v2(i,j,k)+v2(i+1,j,k)-v2(i+2,j,k))
	    scr(i,j,3)=scr(i,j,3)+tmp*(-s2(i-1,j,k)+s2(i,j,k)+s2(i+1,j,k)-s2(i+2,j,k))
	    scr(i,j,4)=scr(i,j,4)+tmp*(-t2(i-1,j,k)+t2(i,j,k)+t2(i+1,j,k)-t2(i+2,j,k))
!yc
            scr(i,j,13)=scr(i,j,13)+tmp*(-c2(i-1,j,k)+c2(i,j,k)+c2(i+1,j,k)-c2(i+2,j,k))
!yc
	enddo

	do n=1,4
	    do i=1,i1
		scr(i,j,n)=o12*scr(i,j,n)
	    enddo
	enddo
!yc
        do i=1,i1
            scr(i,j,13)=o12*scr(i,j,13)
        enddo
!yc

	do i=1,i1
	    am=dmx(i,j,k)*odx(j)
	    ah=dhx(i,j)*odx(j)
	    ! ux could be simply u(i,j,k)**2 + ...., but this does not conserve
	    ! energy and is unstable
	    ux(i,j-1)=(u(i,j,k)*scr(i,j,1)-am*(u1(i+1,j,k)-u1(i,j,k)))*iu(i,j,k)
	    vx(i,j-1)=(u(i,j,k)*scr(i,j,2)-am*(v1(i+1,j,k)-v1(i,j,k)))*iu(i,j,k)
	    sx(i,j-1)=(u(i,j,k)*scr(i,j,3)-ah*(s1(i+1,j,k)-s1(i,j,k)))*iu(i,j,k)
	    tx(i,j-1)=(u(i,j,k)*scr(i,j,4)-ah*(t1(i+1,j,k)-t1(i,j,k)))*iu(i,j,k)
!yc
            cfcx(i,j-1)=(u(i,j,k)*scr(i,j,13)-ah*(c1(i+1,j,k)-c1(i,j,k)))*iu(i,j,k)
!yc
	enddo
    enddo
end subroutine


subroutine compute_latitudinal_fluxes(k)
    ! ------------------
    ! latitudinal fluxes
    ! ------------------
    do j=1,jf
	do i=2,i1
	    scr(i,j,1)=6.*(u2(i,j,k)+u2(i,j+1,k))
	    scr(i,j,2)=6.*(v2(i,j,k)+v2(i,j+1,k))
	    scr(i,j,3)=6.*(s2(i,j,k)+s2(i,j+1,k))
	    scr(i,j,4)=6.*(t2(i,j,k)+t2(i,j+1,k))
!yc
            scr(i,j,13)=6.*(c2(i,j,k)+c2(i,j+1,k))
!yc
	enddo
    enddo

    do j=2,j2
	do i=2,i1
	    tmp=iv(i,j-1,k)*iv(i,j+1,k)
	    scr(i,j,1)=scr(i,j,1)+tmp*(-u2(i,j-1,k)+u2(i,j,k)+u2(i,j+1,k)-u2(i,j+2,k))
	    scr(i,j,2)=scr(i,j,2)+tmp*(-v2(i,j-1,k)+v2(i,j,k)+v2(i,j+1,k)-v2(i,j+2,k))
	    scr(i,j,3)=scr(i,j,3)+tmp*(-s2(i,j-1,k)+s2(i,j,k)+s2(i,j+1,k)-s2(i,j+2,k))
	    scr(i,j,4)=scr(i,j,4)+tmp*(-t2(i,j-1,k)+t2(i,j,k)+t2(i,j+1,k)-t2(i,j+2,k))
!yc
            scr(i,j,13)=scr(i,j,13)+tmp*(-c2(i,j-1,k)+c2(i,j,k)+c2(i,j+1,k)-c2(i,j+2,k))
!yc
	enddo
    enddo

    do i=2,i1
	tmp=iv(i,0,k)*iv(i,2,k)
	scr(i,1,1)=scr(i,1,1)+tmp*(-scr(i,j2,9)+u2(i,1,k)+u2(i,2,k)-u2(i,3,k))
	scr(i,1,2)=scr(i,1,2)+tmp*(-scr(i,j2,10)+v2(i,1,k)+v2(i,2,k)-v2(i,3,k))
	scr(i,1,3)=scr(i,1,3)+tmp*(-scr(i,j2,11)+s2(i,1,k)+s2(i,2,k)-s2(i,3,k))
	scr(i,1,4)=scr(i,1,4)+tmp*(-scr(i,j2,12)+t2(i,1,k)+t2(i,2,k)-t2(i,3,k))
!yc
        scr(i,1,13)=scr(i,1,13)+tmp*(-scr(i,j2,15)+c2(i,1,k)+c2(i,2,k)-c2(i,3,k))
!yc
    enddo

    do i=2,i1
	tmp=iv(i,j2,k)*iv(i,j0,k)
	scr(i,j1,1)=scr(i,j1,1)+tmp*(-u2(i,j2,k)+u2(i,j1,k)+u2(i,j0,k)-scr(i,3,9))
	scr(i,j1,2)=scr(i,j1,2)+tmp*(-v2(i,j2,k)+v2(i,j1,k)+v2(i,j0,k)-scr(i,3,10))
	scr(i,j1,3)=scr(i,j1,3)+tmp*(-s2(i,j2,k)+s2(i,j1,k)+s2(i,j0,k)-scr(i,3,11))
	scr(i,j1,4)=scr(i,j1,4)+tmp*(-t2(i,j2,k)+t2(i,j1,k)+t2(i,j0,k)-scr(i,3,12))
!yc
        scr(i,j1,13)=scr(i,j1,13)+tmp*(-c2(i,j2,k)+c2(i,j1,k)+c2(i,j0,k)-scr(i,3,15))
!yc
    enddo

    do j=js,jf
	do n=1,4
	    do i=2,i1
		scr(i,j,n)=o12*scr(i,j,n)
	    enddo
	enddo
    enddo
!yc
    do j=js,jf
        do i=2,i1
            scr(i,j,13)=o12*scr(i,j,13)
        enddo
    enddo
!yc

    do j=js,jf
	do i=2,i1
	    am=dmy(i,j,k)*odyv(j)
	    ah=dhy(i,j)*odyv(j)
	    !       am=dmx(i,j,k)*odyv(j)
	    !       ah=dhx(i,j)*odyv(j)
	    ! old free-slip
	    uy(i-1,j)=csv(j)*(v(i,j,k)*scr(i,j,1)-am*(u1(i,j+1,k)-u1(i,j,k)))*iv(i,j,k)
	    vy(i-1,j)=csv(j)*(v(i,j,k)*scr(i,j,2)-am*(v1(i,j+1,k)-v1(i,j,k)))*iv(i,j,k)
	    sy(i-1,j)=csv(j)*(v(i,j,k)*scr(i,j,3)-ah*(s1(i,j+1,k)-s1(i,j,k)))*iv(i,j,k)
	    ty(i-1,j)=csv(j)*(v(i,j,k)*scr(i,j,4)-ah*(t1(i,j+1,k)-t1(i,j,k)))*iv(i,j,k)
!yc
            cfcy(i-1,j)=csv(j)*(v(i,j,k)*scr(i,j,13)-ah*(c1(i,j+1,k)-c1(i,j,k)))*iv(i,j,k)
!yc
	enddo
    enddo

end subroutine


end module 

module physics
    use const
    use comm
    use var 
    use io
implicit real*8 (a-h,o-z)
contains

! ----------------------------------------------------------------------
subroutine windglo(u,v,days,dt,odz)
    integer nld
    dimension u(i0,j0),v(i0,j0),odz(*)
    common/klimatglo/fnew,fold,new,nld
    common/windsglo/taux(i2,j2,12),tauy(i2,j2,12)
    ! the velocity arrays u,v have a perimeter "ghost zone".
    ! thus, we set wind forcing only in the interior zones.
    ! taux,tauy are surface wind stress components.
    ! taux,tauy units are force per unit area (i.e., energy per unit volume).
    ! tmp=odz(1)/rho
    ! all units are cgs, so we use rho=1.
if(myid.eq.0) write(*,*) 'days = ',days
    tmp=dt*odz(1)
    do j=2,j1
	do i=2,i1
	    u(i,j)=u(i,j)+tmp*(fold*taux(i-1,j-1,nld)+fnew*taux(i-1,j-1,new))
	    v(i,j)=v(i,j)+tmp*(fold*tauy(i-1,j-1,nld)+fnew*tauy(i-1,j-1,new))
	enddo
    enddo
end subroutine

! ----------------------------------------------------------------------
subroutine cfcsurf(c,t,s,days,dt,odz)
    dimension c(i0,j0),t(i0,j0),s(i0,j0),odz(*)

!local
    logical,save :: first_call=.true.

    integer, parameter :: cfc_nt = 2
    integer, parameter :: nyrbeg = 31
    integer, parameter :: nyrend = 99
    integer,parameter :: imt=i2
    integer,parameter :: jmt=j2
    real*8,save :: year(nyrend),p11(nyrend,cfc_nt),p12(nyrend,cfc_nt)

    real*8,save :: fice(i2,j2,12),xkw(i2,j2,12),patm(i2,j2,12)

    real*8,save :: ratio,day0,nday
    real*8,save :: p11_new(cfc_nt),p12_new(cfc_nt)
    real*8,save :: pnorth(cfc_nt),psouth(cfc_nt)
    real*8 :: rlon(imt,jmt),rlat(imt,jmt),CFCatm(imt,jmt,cfc_nt)

    real*8 :: Kw,CFCsat
    real*8 :: cfc_sc,cfc_alpha

    real*8, save :: CMAX,CMIN,STMAX,STMIN,SSMAX,SSMIN
    real*8, save :: KwMAX,scMAX,CFCMAX,alphaMAX,xkwMAX
    real*8, save :: KwMIN,scMIN,CFCMIN,alphaMIN,xkwMIN
    real*8 :: tmp1,tmp2,tmp3,tmp4,tmp5,tmp6,tmp7,tmp8,tmp9
    real*8 :: tmp10,tmp11,tmp12,tmp13,tmp14,tmp15,tmp16

    INTEGER :: I,J,K,kn
    integer,save :: indx1,indx2,month

!local
    if(first_call) then

!      if(myid.eq.0)write(*,*)'days,dt=',days,dt
      if(myid.eq.0)write(*,*)'first call Read CFC gas and atm!'
      if(myid.eq.0)write(*,*)'i0,i1,i2=',i0,i1,i2
      if(myid.eq.0)write(*,*)'j0,j1,j2=',j0,j1,j2

      call read_gas(fice,xkw,patm)
      call read_cfcatm(cfc_nt,nyrbeg,nyrend,year,p11,p12)

      !Initial year in file
      indx1 = 90 !90 !31 !45 !1 !90 !we can use 29 =>spin up 2 yrs and run 37yrs
      indx2 = indx1+1
      month=1
      day0 = 0. !10800.

      if(myid.eq.0)write(*,*)'initial year,month:',1900+indx1,month

        STMAX = -9999.0
        SSMAX = -9999.0
        CMAX = -9999.0
        KwMAX = -9999.0
        scMAX = -9999.0
        CFCMAX = -9999.0
        alphaMAX = -9999.0
        xkwMAX = -9999.0

        STMIN = 9999.0
        SSMIN = 9999.0
        CMIN = 9999.0
        KwMIN = 9999.0
        scMIN = 9999.0
        CFCMIN = 9999.0
        alphaMIN = 9999.0
        xkwMIN = 9999.0

      do j=1,j2
          do i=1,i2
            rlon(i,j) = xdeg(i+1)
            rlat(i,j) = ydeg(j+1)
!            if(myid.eq.0) write(99,*)rlon(i,j),rlat(i,j),xkw(i,j,12)
!            if(myid.eq.1) write(98,*)rlon(i,j),rlat(i,j),xkw(i,j,12)
!            if(myid.eq.2) write(97,*)rlon(i,j),rlat(i,j),xkw(i,j,12)
!            if(myid.eq.3) write(96,*)rlon(i,j),rlat(i,j),xkw(i,j,12)
!            if(myid.eq.4) write(95,*)rlon(i,j),rlat(i,j),xkw(i,j,12)
!            if(myid.eq.5) write(94,*)rlon(i,j),rlat(i,j),xkw(i,j,12)
!            if(myid.eq.6) write(93,*)rlon(i,j),rlat(i,j),xkw(i,j,12)
!            if(myid.eq.7) write(92,*)rlon(i,j),rlat(i,j),xkw(i,j,12)
!            if(myid.eq.8) write(91,*)rlon(i,j),rlat(i,j),xkw(i,j,12)
!            if(myid.eq.9) write(90,*)rlon(i,j),rlat(i,j),xkw(i,j,12)
!            if(myid.eq.10) write(89,*)rlon(i,j),rlat(i,j),xkw(i,j,12)
!            if(myid.eq.11) write(88,*)rlon(i,j),rlat(i,j),xkw(i,j,12)
!            if(myid.eq.12) write(87,*)rlon(i,j),rlat(i,j),xkw(i,j,12)
!            if(myid.eq.13) write(86,*)rlon(i,j),rlat(i,j),xkw(i,j,12)
!            if(myid.eq.14) write(85,*)rlon(i,j),rlat(i,j),xkw(i,j,12)
!            if(myid.eq.15) write(84,*)rlon(i,j),rlat(i,j),xkw(i,j,12)
          enddo
      enddo

      first_call=.false.
    endif !first call

    nday = days-day0;

    if (mod(days,30.).eq.0.) then
      month = month +1
      month = min(month,12)
      if(myid.eq.0)write(*,*)'month=',month
    end if

    if (mod(days,360.).eq.0.) then
      month = 1
      day0 = days
      indx1 = indx2
      indx2 = indx1+1
      if(myid.eq.0)write(*,*)'New year: month,year1,year2=',month,indx1,indx2
    end if

    ratio = nday/360. !360.!360.0
    p11_new(1) = p11(indx1,1)*(1-ratio)+p11(indx2,1)*ratio
    p11_new(2) = p11(indx1,2)*(1-ratio)+p11(indx2,2)*ratio
    p12_new(1) = p11(indx1,1)*(1-ratio)+p11(indx2,1)*ratio
    p12_new(2) = p11(indx1,2)*(1-ratio)+p11(indx2,2)*ratio

    pnorth(1)=p11_new(1)
    pnorth(2)=p12_new(1)
    psouth(1)=p11_new(2)
    psouth(2)=p12_new(2)
    call cfc_interp(cfc_nt,pnorth, psouth, rlat, imt, jmt, CFCatm)
!    if(mod(days,1.).eq.0) then
!    do j=1,J2
!        do i=1,I2
!          if(myid.eq.0)write(99,*)rlon(i,j),rlat(i,j),CFCatm(i,j,1)
!          if(myid.eq.1)write(98,*)rlon(i,j),rlat(i,j),CFCatm(i,j,1)
!          if(myid.eq.2)write(97,*)rlon(i,j),rlat(i,j),CFCatm(i,j,1)
!          if(myid.eq.3)write(96,*)rlon(i,j),rlat(i,j),CFCatm(i,j,1)
!        end do
!     end do
!    endif

    kn = 11 !11: CFC-11 12:CFC-12

!       if(myid.eq.0) write(*,*)'T,S=',T(70,60),S(70,60)
!       if(myid.eq.0) call sc_cfc(T(70,60),kn,cfc_sc)
!       if(myid.eq.0) call sol_cfc(T(70,60),S(70,60),kn,cfc_alpha)
!       if(myid.eq.0)write(*,*)'alpha=',cfc_sc,cfc_alpha

    do j=1,j2
      do i=1,i2

        call sc_cfc(t(I+1,J+1),kn,cfc_sc)
        call sol_cfc(t(I+1,J+1),s(I+1,J+1),kn,cfc_alpha)

        CFCsat = cfc_alpha*CFCatm(I,J,1) !1=CFC-11
        ! convert to pmol/kg for comparison with GLODAP data set
        CFCsat = CFCsat*1e12/1030. !pmol/kg
        Kw = (1-fice(I,J,month))*xkw(I,J,month)*(cfc_sc/660.0)**(-0.5) !m/s
        Kw = Kw*ODZ(1)*100. !the latter *100 because ODZ is in 1/cm rather than 1/m
        Kw = Kw*dt

!        if(myid.eq.0) then
!          if(i.eq.50.and.j.eq.50) then
!          write(*,*)'check kw',myid,month,xkw(I+1,J+1,month)
!          endif
!        endif

        c(I+1,J+1) = c(I+1,J+1) + Kw*(CFCsat-c(I+1,J+1))*IN(I+1,J+1,1)
        STMAX=MAX(STMAX,T(I+1,J+1))
        SSMAX=MAX(SSMAX,S(I+1,J+1))
        CMAX=MAX(CMAX,C(I+1,J+1))
        KwMAX=MAX(KwMAX,Kw)
        scMAX=MAX(scMAX,cfc_sc)
        CFCMAX=MAX(CFCMAX,CFCsat)
        alphaMAX=MAX(alphaMAX,cfc_alpha)
        xkwMAX=MAX(xkwMAX,xkw(I,J,month))

        STMIN=MIN(STMIN,T(I+1,J+1))
        SSMIN=MIN(SSMIN,S(I+1,J+1))
        CMIN=MIN(CMIN,C(I+1,J+1))
        KwMIN=MIN(KwMIN,Kw)
        scMIN=MIN(scMIN,cfc_sc)
        CFCMIN=MIN(CFCMIN,CFCsat)
        alphaMIN=MIN(alphaMIN,cfc_alpha)
        xkwMIN=MIN(xkwMIN,xkw(I,J,month))

      end do
    end do
      tmp1=cmax
      tmp2=cmin
      tmp3=cfcmax
      tmp4=cfcmin
      tmp5=kwmax
      tmp6=kwmin
      tmp7=scmax
      tmp8=scmin
      tmp9=alphamax
      tmp10=alphamin
      tmp11=stmax
      tmp12=stmin
      tmp13=ssmax
      tmp14=ssmin
      tmp15=xkwmax
      tmp16=xkwmin


      CALL MPI_BARRIER(M_CART,IERR)
      CALL MPI_ALLREDUCE(tmp1,cmax,1,MPI_REAL8,MPI_MAX,M_CART,IERR)
      CALL MPI_BARRIER(M_CART,IERR)
      CALL MPI_ALLREDUCE(tmp2,cmin,1,MPI_REAL8,MPI_MIN,M_CART,IERR)
      CALL MPI_BARRIER(M_CART,IERR)
      CALL MPI_ALLREDUCE(tmp3,cfcmax,1,MPI_REAL8,MPI_MAX,M_CART,IERR)
      CALL MPI_BARRIER(M_CART,IERR)
      CALL MPI_ALLREDUCE(tmp4,cfcmin,1,MPI_REAL8,MPI_MIN,M_CART,IERR)
      CALL MPI_BARRIER(M_CART,IERR)
      CALL MPI_ALLREDUCE(tmp5,kwmax,1,MPI_REAL8,MPI_MAX,M_CART,IERR)
      CALL MPI_BARRIER(M_CART,IERR)
      CALL MPI_ALLREDUCE(tmp6,kwmin,1,MPI_REAL8,MPI_MIN,M_CART,IERR)
      CALL MPI_BARRIER(M_CART,IERR)
      CALL MPI_ALLREDUCE(tmp7,scmax,1,MPI_REAL8,MPI_MAX,M_CART,IERR)
      CALL MPI_BARRIER(M_CART,IERR)
      CALL MPI_ALLREDUCE(tmp8,scmin,1,MPI_REAL8,MPI_MIN,M_CART,IERR)
      CALL MPI_BARRIER(M_CART,IERR)
      CALL MPI_ALLREDUCE(tmp9,alphamax,1,MPI_REAL8,MPI_MAX,M_CART,IERR)
      CALL MPI_BARRIER(M_CART,IERR)
      CALL MPI_ALLREDUCE(tmp10,alphamin,1,MPI_REAL8,MPI_MIN,M_CART,IERR)
      CALL MPI_BARRIER(M_CART,IERR)
      CALL MPI_ALLREDUCE(tmp11,stmax,1,MPI_REAL8,MPI_MAX,M_CART,IERR)
      CALL MPI_BARRIER(M_CART,IERR)
      CALL MPI_ALLREDUCE(tmp12,stmin,1,MPI_REAL8,MPI_MIN,M_CART,IERR)
      CALL MPI_BARRIER(M_CART,IERR)
      CALL MPI_ALLREDUCE(tmp13,ssmax,1,MPI_REAL8,MPI_MAX,M_CART,IERR)
      CALL MPI_BARRIER(M_CART,IERR)
      CALL MPI_ALLREDUCE(tmp14,ssmin,1,MPI_REAL8,MPI_MIN,M_CART,IERR)
      CALL MPI_BARRIER(M_CART,IERR)
      CALL MPI_ALLREDUCE(tmp15,xkwmax,1,MPI_REAL8,MPI_MAX,M_CART,IERR)
      CALL MPI_BARRIER(M_CART,IERR)
      CALL MPI_ALLREDUCE(tmp16,xkwmin,1,MPI_REAL8,MPI_MIN,M_CART,IERR)

      if(myid.eq.0) then
        if (mod(days,1.0).eq.0.) then
          write(*,*)'CFC check! DT=',DT
          write(*,*)days,month,nday,day0,ratio,indx1,indx2
          write(*,*)stmax,ssmax,cmax,cfcmax,kwmax,scmax,alphamax
          write(*,*)stmin,ssmin,cmin,cfcmin,kwmin,scmin,alphamin
          write(*,*)xkwmax,xkwmin,odz(1),odz(1)*100.0*dt
        end if
      endif

end subroutine

subroutine sc_cfc(t,kn,cfc_sc)
!---------------------------------------------------
!     CFC 11 and 12 schmidt number
!     as a fonction of temperature.
!
!     ref: Zheng et al (1998), JGR, vol 103,No C1
!
!     t: temperature (degree Celcius)
!     kn: = 11 for CFC-11,  12 for CFC-12
!
!     J-C Dutay - LSCE
!---------------------------------------------------
!      use cfc_glbl, only: rkind
      implicit none
      integer, intent(in) :: kn
      real*8 ::  a1( 11: 12), a2( 11: 12), a3( 11: 12), a4( 11: 12)
      real*8,intent(in) :: t
      real*8,intent(out) :: cfc_sc
!
!   coefficients with t in degre Celcius
!   ------------------------------------
      a1(11) = 3501.8
      a2(11) = -210.31
      a3(11) =  6.1851
      a4(11) = -0.07513
!
      a1(12) = 3845.4
      a2(12) = -228.95
      a3(12) =  6.1908
      a4(12) = -0.067430
!
      cfc_sc = a1(kn)+a2(kn)*t+a3(kn)*t*t+a4(kn)*t*t*t
end subroutine

subroutine sol_cfc(pt,ps,kn,cfc_alpha)
      implicit none

      real*8,intent(in) ::  pt, ps
      real*8,intent(out) :: cfc_alpha
      real*8 :: ta,d
      real*8 :: a1 ( 11: 12), a2 ( 11: 12), a3 ( 11: 12), a4 ( 11: 12)
      real*8 :: b1 ( 11: 12), b2 ( 11: 12), b3 ( 11: 12)

      integer, intent(in) ::  kn
!!
!! coefficient for solubility in  mol/l/atm
!! ----------------------------------------
!
!     for CFC 11
!     ----------
      a1 ( 11) = -229.9261
      a2 ( 11) =  319.6552
      a3 ( 11) =  119.4471
      a4 ( 11) =   -1.39165
      b1 ( 11) =   -0.142382
      b2 ( 11) =    0.091459
      b3 ( 11) =   -0.0157274
!
!     for CFC/12
!     ----------
      a1 ( 12) = -218.0971
      a2 ( 12) =  298.9702
      a3 ( 12) =  113.8049
      a4 ( 12) =   -1.39165
      b1 ( 12) =   -0.143566
      b2 ( 12) =    0.091015
      b3 ( 12) =   -0.0153924
!

      ta       = ( pt + 273.16)* 0.01
      d    = ( b3 ( kn)* ta + b2 ( kn))* ta + b1 ( kn)
!
!
      cfc_alpha = exp ( a1 ( kn) + a2 ( kn)/ ta + a3 ( kn)* log ( ta ) + & 
                                a4 (kn)* ta * ta  + ps* d )

!
!     conversion from mol/(l * atm) to mol/(m^3 * atm)
!     ------------------------------------------------
      cfc_alpha = 1000. * cfc_alpha
!
!     conversion from mol/(m^3 * atm) to mol/(m3 * pptv)
!     --------------------------------------------------
      cfc_alpha = 1.0e-12 * cfc_alpha
end subroutine

! ----------------------------------------------------------------------
subroutine cfc_interp(cfc_nt,pnorth,psouth,rlat,imt,jmt,CFCatm)
      integer, parameter :: ijmax=200*200

      integer, intent(in) :: cfc_nt, imt, jmt
      integer,save :: ientry
      integer :: i, j, ij, n

      real*8,save ::  ys, yn

      real*8,save :: xintp(ijmax)
      real*8, intent(in) :: Pnorth(cfc_nt), Psouth(cfc_nt)
      real*8, intent(in) :: rlat(imt,jmt)

      real*8, intent(out) :: CFCatm(imt,jmt,cfc_nt)


      DATA ys, yn / -10., 10./
      DATA ientry /0/


      ientry = ientry + 1

!     Test to see if ijmax is large enough
      if (ijmax .lt. imt*jmt) then
          print *," cfc_interp: ERROR -> ijmax must be at least",imt*jmt
          stop
      endif

!     IF Block to be executed ONLY on first call to this routine
      if (ientry .eq. 1) then
          do j = 1,jmt
            do i = 1,imt
              ij = (j-1)*imt + i
              if (rlat(i,j) .ge. yn) then
                  xintp(ij) = 1.
              else if (rlat(i,j) .le. ys) then
                  xintp(ij) = 0.
              else
                  xintp(ij) =  (rlat(i,j) - ys)/(yn-ys)
              endif
            end do
          end do
      endif

!     Block to be executed every pass
      do n=1,cfc_nt
        do j=1,jmt
          do i=1,imt
            ij = (j-1)*imt + i
            CFCatm(i,j,n) = xintp(ij) * Pnorth(n) + & 
                                 (1.0 - xintp(ij)) * Psouth(n)
          end do
        end do
      end do

end subroutine

! ----------------------------------------------------------------------
subroutine read_cfcatm(cfc_nt,nyrbeg,nyrend,year,p11,p12)
! needs modification to dbl
      !local
      integer :: i, n
      integer, parameter :: iu = 10
      integer,intent(in)  :: nyrbeg,nyrend,cfc_nt
      real*8,intent(out) :: year(nyrend), p11(nyrend,cfc_nt), p12(nyrend,cfc_nt)

      character(len=80) :: filen

      year = 0.
      p11 = 0.
      p12 = 0.

!
!     OPEN FILE
!     ---------
      filen='data/cfc1112_new.atm'
      open(UNIT=iu,FILE=filen,STATUS='old')
!
!     Skip over 1st six descriptor lines
!     ----------------------------------
      do i=1,6
        read(iu,99)
      end do

!
!     READ FILE
!     ---------
      do n = nyrbeg, nyrend
        READ(iu,*)year(n), p11(n,1), p12(n,1), p11(n,2), p12(n,2)
        year(n) = year(n) - 0.5
        if(myid.eq.0) then
         write(*,*) 'read cfcatm file', year(n),p11(n,1), p12(n,1), p11(n,2), p12(n,2)
        endif
      end do

      close(iu)

 99   FORMAT(1x)
 100  FORMAT(f7.2, 4f8.2)

end subroutine

! ----------------------------------------------------------------------
subroutine pp82glo
    ! ----------------------------------------------------------------------
    ! vertical mixing coefficients

    ! approach:
    ! set background vertical diffusivities to dmz0 (o(0.1) cm-cm/sec) and
    ! add richardson number based vertical diffusivity plus numerical
    ! contribution according to vertical cell reynolds number.

    ! vertical cell re is o(100), except during winter cooling conditions
    ! and in wind-blown surface mixed layer, because internal waves, which
    ! dominate w below the sml in the model results during summer, do not
    ! mix t or s in nature.

    ! note: one cannot depend on diffusive closure by itself if one wants to
    ! model possible contra-diffusive effe!  
    parameter(i01=i0+1)

    common/windmxglo/vbk(k2),hbk(k2)
    common/tauglo/add(i2,j2,k2)

    do k=1,k2
	l=k+1
	dzwl=orzmx/odzw(l)
	! stability limit
	emax=.4/(dt*odzw(l)**2)
	do j=2,j1
	    do i=2,i1
		! pacanowski and philander (1981): evisc=a*(1/(1+b*ri))**n
		! evisc=turbulent eddy viscosity; diffuse=turbulent diffusivity
		! ri=max(0.,980.*(rho(i,j,l)-rho(i,j,k))*odzw(l)/(odzw(l)**2*
		ri=max(-0.02d0,980.*(rho(i,j,l)-rho(i,j,k))*odzw(l)/(odzw(l)**2*(0.001+(u2(i,j,l)-u2(i,j,k))**2+(v2(i,j,l)-v2(i,j,k))**2)))
		rrinv=1./(1.+5.*ri)
		tmp=rrinv**2
		! ri- and cell re- dependent vertical mixing
		! numerically kosher because, for large ri, laminar flow dominates
		! and time mean overshoot effe!   are limited by time mean w being small
		temp=tmp*abs(w(i,j,l))*dzwl
		evisc=5.*tmp
		diffuse=evisc*rrinv
		! add parameterizes extra momentum dissipation along steep slopes,
		! high and low latitudes, and equatorial regions due to breaking of
		! waves that were generated by big storm events that are missing when
		! using climatological winds. add includes vbk(k) term.
		ev(i-1,j-1,k)=evisc+add(i-1,j-1,k)+temp
		hv(i-1,j-1,k)=diffuse+hbk(k)+temp
		! apply stability limit and odzw factor
		tmp=odzw(l)*iw(i,j,l)
		ev(i-1,j-1,k)=tmp*min(emax,ev(i-1,j-1,k))
		hv(i-1,j-1,k)=tmp*min(emax,hv(i-1,j-1,k))
	    enddo
	enddo
    enddo
end subroutine


! ----------------------------------------------------------------------
subroutine pp82glonew
    ! ----------------------------------------------------------------------
    ! vertical mixing coefficients

    ! approach:
    ! set background vertical diffusivities to dmz0 (o(0.1) cm-cm/sec) and
    ! add richardson number based vertical diffusivity plus numerical
    ! contribution according to vertical cell reynolds number.

    ! vertical cell re is o(100), except during winter cooling conditions
    ! and in wind-blown surface mixed layer, because internal waves, which
    ! dominate w below the sml in the model results during summer, do not
    ! mix t or s in nature.

    ! note: one cannot depend on diffusive closure by itself if one wants to
    ! model possible contra-diffusive effe!  
    parameter(i01=i0+1)

    common/windmxglo/vbk(k2),hbk(k2)

    rate=-.05
    jt=mylat*j2
    do k=1,k2
	l=k+1
	dzwl=orzmx/odzw(l)
	! deepen and augment mixing in high lats to emulate big storms
	tmpk=10.*exp(-.0001*z(2*k+1))
	! stability limit
	emax=.4/(dt*odzw(l)**2)
	elim=min(200.,emax)
	do j=2,j1
	    ! decrease background mixing except in high lats to emulate big
	    ! storms within 20 grid intervals (~2 deg lat) of lat boundaries
	    tmp=tmpk*(exp(rate*abs(2-j-jt)))+exp(rate*abs(j1t-j-jt))
	    vb=vbk(k)+tmp
	    hb=hbk(k)+tmp
	    do i=2,i1
		! pacanowski and philander (1981): evisc=a*(1/(1+b*ri))**n
		! evisc=turbulent eddy viscosity; diffuse=turbulent diffusivity
		tmp=odzw(l)
		! starting at day 0 of yr 16, decrease ri-based vertical mixing
		! gap in izu ridge is also deepened to emulate unresolved deep kuroshio paths
		! thus allowing it to pass over the ridgeline with less anomalous vortex
		! squashing and thus taking a non-meander path when appropriate.
		oldfact=980.*(rho(i,j,l)-rho(i,j,k))*tmp/(tmp**2*(0.001+(u2(i,j,l)-u2(i,j,k))**2+(v2(i,j,l)-v2(i,j,k))**2))
		! big ri decreases vertical mixing
		ri=max(-0.19,5.*oldfact)

		rrinv=1./(1.+5.*ri)
		tmp=rrinv**2
		! ri- and cell re- dependent vertical mixing
		! numerically kosher because, for large ri, laminar flow dominates
		! and time mean overshoot effe!   are limited by time mean w being small
		temp=.01*tmp*abs(w(i,j,l))*dzwl
		evisc=tmp
		diffuse=evisc*rrinv
		! evisc, diffuse, hb and vb units are cm-cm/sec
		ev(i-1,j-1,k)=evisc+vb+temp
		hv(i-1,j-1,k)=diffuse+hb+0.1*temp
		! apply stability limit and odzw factor
		tmp=odzw(l)*iw(i,j,l)
		ev(i-1,j-1,k)=tmp*min(elim,ev(i-1,j-1,k))
		hv(i-1,j-1,k)=tmp*min(elim,hv(i-1,j-1,k))
	    enddo
	enddo
    enddo
    ! ======================================================================
    ! add vertical mixing to emulate effect of equatorial vortices and
    ! penetrative convection in acc.
    ! ======================================================================
    ! stacked vortices in 10-point equator band (hardwired to 1/4 deg res)
    ! strong velocity oscillations having ~20-day time scale are observed
    ! within a few deg of equator
    ! 33-point equatorial and acc bands

    ! 
    !      do 770 i=1,i2
    !      do 770 j=1,j2
    !      do 770 k=1,k2
    ! 770  scr(i+1,j+1,k)=ev(i,j,k)

    sc1=.01
    sc2=.01
    do k=1,k2
	l=k+1
	! 100m scale height of added vertical mixing
	tmp=exp(-.0001*z(2*k+1))
	do j=1,j2
	    tmp1=10./(1.+sc1*((0-ydeg(j))/(ydeg(j+1)-ydeg(j)))**2)
	    addd=tmp1*odzw(l)*tmp

	    do i=1,i2
		! insulated bottom, nonlinear drag invoked in fs
		ad=addd*iw(i+1,j+1,l)
		hv(i,j,k)=hv(i,j,k)+ad
		ev(i,j,k)=ev(i,j,k)+ad
	    enddo
	enddo
    enddo
end subroutine

!--------------------------------------------------------------------------
subroutine kppglo
end subroutine kppglo
!--------------------------------------------------------------------------


! ----------------------------------------------------------------------
subroutine smagglo
    ! ----------------------------------------------------------------------
    ! horizontal mixing coefficients
    ! approach:smagorinsky, j. general circulation experiments with the
    ! primitive equations, i. the basi! experiment. monthly weather rev. 1963,
    ! 91, 99-164.
    parameter(i01=i0+1)
    
    do k=1,k1
	do j=2,j1
	    temp=ocs(j)*ody(j)
	    do i=2,i1
		scr(i,j,k)=0.12*dx(j)*dy(j)*in(i,j,k)*sqrt(((u(i,j,k)-u(i-1,j,k))*odx(j))**2+((csv(j)*v(i,j,k)-csv(j-1)*v(i,j-1,k))*temp)**2)
	    enddo
	enddo
    enddo


    call mpi_sendrecv(scr(2,1,1),1,m_vlon,m_w,1,scr(i0,1,1),1,m_vlon,m_e,1,m_cart,istat,ierr)
    call mpi_sendrecv(scr(i1,1,1),1,m_vlon,m_e,1,scr(1,1,1),1,m_vlon,m_w,1,m_cart,istat,ierr)
    call mpi_sendrecv(scr(1,2,1),1,m_vlat,m_s,1,scr(1,j0,1),1,m_vlat,m_n,1,m_cart,istat,ierr)
    call mpi_sendrecv(scr(1,j1,1),1,m_vlat,m_n,1,scr(1,1,1),1,m_vlat,m_s,1,m_cart,istat,ierr)

    do k=1,k1
	do j=1,j0
	    do i=1,i1
		dmx(i,j,k)=dm0+.5*(scr(i,j,k)+scr(i+1,j,k))
	    enddo
	enddo
	do i=1,i0
	    dmy(i,1,k)=dm0+scr(i,2,k)
	    dmy(i,j1,k)=dm0+scr(i,j2,k)
	    do j=1,jf
		! note: except in hi lats, dmy slightly violates ang. mom. conservation
		dmy(i,j,k)=dm0+.5*(scr(i,j,k)+scr(i,j+1,k))
	    enddo
	enddo
    enddo
end subroutine


! ----------------------------------------------------------------------
subroutine qsurfglo(t,dt,odz)
    dimension t(i0,j0),odz(*)
    ! the temperature array t has a permiter "ghost zone".
    ! thus, we set atmospheri! heat exchange only in the interior zones.
    ! typical latitudinal range: -50 to 50 watts per square meter.
    ! 1 watt per square meter = 1 erg per second per equare cm.
    ! example: surface heating qdot = 50 watts per square meter
    qdot=50.
    ! tmp is conversion factor from watts per square meter
    ! to deg ! per time step in top model layer.
    ! tmp=dt*odz(1)/rho/cp
    ! all units are cgs, so we use rho=1.
    ! cp for water is 2.5e4 ergs/gram/deg c.
    !check this cp value!!!
    tmp=dt*odz(1)/2.5e4
    dtemp=tmp*qdot
    do j=1,j2
	do i=1,i2
	    t(i+1,j+1)=t(i+1,j+1)+dtemp
	enddo
    enddo
end subroutine

! ----------------------------------------------------------------------
subroutine sunglo(t,dt,odz,qprof,kb)
    integer*2 kb
    dimension t(i0,j0,k1),odz(k1),qprof(k1),kb(i0,j0)
    ! this is like subroutine qsurf except
    ! we use predetermined input array qprof to vertically distribute qdot.
    ! qprof(k) is the cumulative fraction of total heat absorbed to depth
    ! of bottom of layer k for a pure water column.
    ! example: surface radiation flux of 10 watts per square meter
    qdot=10.
    fract=qprof(1)
    do k=1,k1
	dtemp=fract*qdot*dt/2.5e4
	! odz(k) is not the correct factor for layers deeper than the local bottom.
	! thus, odz factor must be added inside loop 99.
	! this quickly programmed logi! must be checked.
	do j=1,j2
	    do i=1,i2
		kk=min(kb(i+1,j+1),k)
		t(i+1,j+1,kk)=t(i+1,j+1,kk)+dtemp*odz(kk)
	    enddo
	enddo
	if (k.lt.k1) fract=qprof(k+1)-fract
    enddo
end subroutine


end module

module comm
    use const
    use var
    use mpi
implicit real*8 (a-h,o-z)
    common/mpicomm/m_cart,m_comm_2d,m_comm_lon,m_comm_lat,myid,mylon,mylat,m_n,m_e, &
    m_s,m_w,m_vlon,m_vlat,m_v8lon,m_v8lat,js,jf,ierr, &
    npx(14),npy(14),istat(mpi_status_size)
    common/mpi_vtype/m_vlon2d,m_vlat2d,m_vlon3d,m_vlat3d,m_v8lonx2d,m_v8latx2d,m_evlon2d,m_evlat2d

contains


subroutine init_comm
    ! mpi initialization
    call mpi_init(ierr)
    call mpi_comm_size(mpi_comm_world, nproc, ierr)
    call mpi_comm_rank(mpi_comm_world, myid, ierr)

    if (nproc .ne. ng0) then
	print*,'ng0=', ng0,' is not equal to nproc=',nproc
	call mpi_finalize(ierr)
	stop
    endif

end subroutine


subroutine mpi_grid2d_gen
    logical peri,rdim1,rdim2
    dimension ndim(2),mycrd(2),peri(2),rdim1(2),rdim2(2)

    ndim(1)=ngx0
    ndim(2)=ngy0
    peri(1)=.true.
    peri(2)=.false.
    rdim1(1)=.true.
    rdim1(2)=.false.
    rdim2(1)=.false.
    rdim2(2)=.true.
    call mpi_cart_create(mpi_comm_world,2,ndim,peri,.true.,m_comm_2d,ierr)
    call mpi_cart_shift(m_comm_2d,0,1,m_w,m_e,ierr)
    call mpi_cart_shift(m_comm_2d,1,1,m_s,m_n,ierr)
    call mpi_cart_sub(m_comm_2d,rdim1,m_comm_lon,ierr)
    call mpi_cart_sub(m_comm_2d,rdim2,m_comm_lat,ierr)
    call mpi_comm_rank(m_comm_lon,mylon,ierr)
    call mpi_comm_rank(m_comm_lat,mylat,ierr)

    write(grd,'(i3.3,a1,i3.3)')mylon,'_',mylat
end subroutine

!-----------------------------------------
subroutine mpi_grid_gen
    parameter(nbg0=nb0*ngy0,nbg1=nbg0-1,i01=i0+1,ig0=i2*ngx0+2,ig1=ig0-1,ig2=ig0-2,ibir=ig2/ngy0,j01=j0+1)

    dimension ndim(3),mycrd(3),mycor(3)
    logical peri(3),rdim1(3),rdim2(3)
    data ndim / 1,ngy0,ngx0/
    data peri / .false., .false., .true./
    data rdim1 / .false., .false., .true./
    data rdim2 / .false., .true., .false./

    integer(kind=mpi_offset_kind) nn,ns_kji,nc_kji,ns_tji,nc_tji,ns_ji,nc_ji,ns_1,nc_1

    common/pnetcdf/nn(6),ns_kji(3),nc_kji(3),ns_tji(3),nc_tji(3),ns_ji(2),nc_ji(2),ns_1,nc_1,nf_kji(3)

    integer(kind=mpi_offset_kind) ns_kji2,nc_kji2,ns_tji2,nc_tji2,ns_ji2,nc_ji2,nf_kji2

    common/pnetcdf2/ns_kji2(3),nc_kji2(3),ns_tji2(3),nc_tji2(3),ns_ji2(2),nc_ji2(2),nf_kji2(3)


    call mpi_dims_create(ng0,3,ndim,ierr)
    call mpi_cart_create(mpi_comm_world,3,ndim,peri,.true.,m_cart,ierr)
    call mpi_cart_shift(m_cart,2,1,m_w,m_e,ierr)
    call mpi_cart_shift(m_cart,1,1,m_s,m_n,ierr)
    call mpi_cart_sub(m_cart,rdim1,m_comm_lon,ierr)
    call mpi_cart_sub(m_cart,rdim2,m_comm_lat,ierr)
    call mpi_comm_rank(m_comm_lon,mylon,ierr)
    call mpi_comm_rank(m_comm_lat,mylat,ierr)
    call mpi_cart_coords (m_cart, myid, 3, mycor, ierr)

    write(grd,'(i3.3,a1,i3.3)')mylon,'_',mylat
    
    ! cartisean remark
    ! -------------------------------
    ! | 2 | 5 | 8 | 11 |
    ! | (0,2) | (1,2) | (2,2) | (3,2) |
    ! |-------|-------|-------|-------|
    ! | 1 | 4 | 7 | 10 |
    ! | (0,1) | (1,1) | (2,1) | (3,1) |
    ! |-------|-------|-------|-------|
    ! | 0 | 3 | 6 | 9 |
    ! | (0,0) | (1,0) | (2,0) | (3,0) |
    ! -------------------------------
    
    call mpi_type_vector(j0,1,i0,mpi_real8,m_vlon2d,ierr)
    call mpi_type_vector(1,i0,j0,mpi_real8,m_vlat2d,ierr)
    call mpi_type_commit(m_vlon2d,ierr)
    call mpi_type_commit(m_vlat2d,ierr)
    call mpi_type_vector(k1*j0,1,i0,mpi_real8,m_vlon3d,ierr)
    call mpi_type_vector(k1,i0,i0*j0,mpi_real8,m_vlat3d,ierr)
    call mpi_type_commit(m_vlon3d,ierr)
    call mpi_type_commit(m_vlat3d,ierr)
    call mpi_type_vector(j0,1,i0,mpi_real8,m_v8lonx2d,ierr)
    call mpi_type_vector(1,i0,i0*j0,mpi_real8,m_v8latx2d,ierr)
    call mpi_type_commit(m_v8lonx2d,ierr)
    call mpi_type_commit(m_v8latx2d,ierr)
    call mpi_type_vector(j0,1,i0+1,mpi_real8,m_evlon2d,ierr)
    call mpi_type_vector(1,i0,i0*(j0+1),mpi_real8,m_evlat2d,ierr)
    call mpi_type_commit(m_evlon2d,ierr)
    call mpi_type_commit(m_evlat2d,ierr)


    ! write(grd,'(i3.3,a1,i3.3)')mylon,'_',mylat
    call mpi_type_vector(k1*j0,1,i0,mpi_real8,m_vlon,ierr)
    call mpi_type_vector(k1,i0,i0*j0,mpi_real8,m_vlat,ierr)
    call mpi_type_commit(m_vlon,ierr)
    call mpi_type_commit(m_vlat,ierr)
    call mpi_type_vector(j0,1,i0,mpi_real8,m_v8lon,ierr)
    call mpi_type_vector(1,i0,i0*j0,mpi_real8,m_v8lat,ierr)
    call mpi_type_commit(m_v8lon,ierr)
    call mpi_type_commit(m_v8lat,ierr)


    do i=1,14
	npx(i)=(i-1)*j0*k1+1
	npy(i)=(i-1)*i0*k1+1
    enddo

    js=1
    jf=j0-1
    if (mylat .eq. 0) js=2
    if (mylat .eq. ngy0-1) jf=j0-2

    nn(1)=k1
    nn(2)=j2t
    nn(3)=i2t
    nn(4)=12
    nn(5)=k0
    nn(6)=1
    ns_kji(1)=1
    ns_kji(2)=mylat*j2+1
    ns_kji(3)=mylon*i2+1
    nc_kji(1)=k1
    nc_kji(2)=j2
    nc_kji(3)=i2
    ns_tji(1)=1
    ns_tji(2)=mylat*j2+1
    ns_tji(3)=mylon*i2+1
    nc_tji(1)=12
    nc_tji(2)=j2
    nc_tji(3)=i2
    nf_kji(1)=k0
    nf_kji(2)=j2
    nf_kji(3)=i2
    ns_ji(1)=mylat*j2+1
    ns_ji(2)=mylon*i2+1
    nc_ji(1)=j2
    nc_ji(2)=i2
    ns_1=1
    nc_1=1


    ns_kji2(3)=1
    ns_kji2(2)=mylat*j2+1
    ns_kji2(1)=mylon*i2+1
    nc_kji2(3)=k1
    nc_kji2(2)=j2
    nc_kji2(1)=i2
    ns_tji2(3)=1
    ns_tji2(2)=mylat*j2+1
    ns_tji2(1)=mylon*i2+1
    nc_tji2(3)=12
    nc_tji2(2)=j2
    nc_tji2(1)=i2
    nf_kji2(3)=k0
    nf_kji2(2)=j2
    nf_kji2(1)=i2
    ns_ji2(2)=mylat*j2+1
    ns_ji2(1)=mylon*i2+1
    nc_ji2(2)=j2
    nc_ji2(1)=i2
end subroutine


! ----------------------------------------------------------------------
subroutine mpi_exch_3d_r4(scr)
    dimension scr(i0,j0,k1)

    call mpi_sendrecv(scr(2,1,1),1,m_vlon3d,m_w,1,scr(i0,1,1),1,m_vlon3d,m_e,1,m_cart,istat,ierr1)
    call mpi_sendrecv(scr(i1,1,1),1,m_vlon3d,m_e,1,scr(1,1,1),1,m_vlon3d,m_w,1,m_cart,istat,ierr2)
    call mpi_sendrecv(scr(1,2,1),1,m_vlat3d,m_s,1,scr(1,j0,1),1,m_vlat3d,m_n,1,m_cart,istat,ierr3)
    call mpi_sendrecv(scr(1,j1,1),1,m_vlat3d,m_n,1,scr(1,1,1),1,m_vlat3d,m_s,1,m_cart,istat,ierr4)
    if(ierr1+ierr2+ierr3+ierr4.ne.0)write(*,'(a)')'mpi_exch_3d error'
end subroutine


! ----------------------------------------------------------------------
subroutine mpi_exch_2d_r4(scr)
    dimension scr(i0,j0)
    call mpi_sendrecv(scr(2,1),1,m_vlon2d,m_w,1,scr(i0,1),1,m_vlon2d,m_e,1,m_cart,istat,ierr1)
    call mpi_sendrecv(scr(i1,1),1,m_vlon2d,m_e,1,scr(1,1),1,m_vlon2d,m_w,1,m_cart,istat,ierr2)
    call mpi_sendrecv(scr(1,2),1,m_vlat2d,m_s,1,scr(1,j0),1,m_vlat2d,m_n,1,m_cart,istat,ierr3)
    call mpi_sendrecv(scr(1,j1),1,m_vlat2d,m_n,1,scr(1,1),1,m_vlat2d,m_s,1,m_cart,istat,ierr4)

    if(ierr1+ierr2+ierr3+ierr4.ne.0)write(*,'(a)')'mpi_exch_2d error'
end subroutine


! ----------------------------------------------------------------------
subroutine mpi_exch_2d_r8(scr)
    real*8 scr(i0,j0)

    call mpi_sendrecv(scr(2,1),1,m_v8lonx2d,m_w,1,scr(i0,1),1,m_v8lonx2d,m_e,1,m_cart,istat,ierr1)
    call mpi_sendrecv(scr(i1,1),1,m_v8lonx2d,m_e,1,scr(1,1),1,m_v8lonx2d,m_w,1,m_cart,istat,ierr2)
    call mpi_sendrecv(scr(1,2),1,m_v8latx2d,m_s,1,scr(1,j0),1,m_v8latx2d,m_n,1,m_cart,istat,ierr3)
    call mpi_sendrecv(scr(1,j1),1,m_v8latx2d,m_n,1,scr(1,1),1,m_v8latx2d,m_s,1,m_cart,istat,ierr4)
    if(ierr1+ierr2+ierr3+ierr4.ne.0)write(*,'(a)')'mpi_exch_2d error'
end subroutine


! ----------------------------------------------------------------------
subroutine mpi_peri_all(u2,v2,t2,s2,u1,v1,t1,s1,p,ub,vb,tb,sb,pb)
    parameter(nlat=14*i0*k1,nlon=14*j0*k1)
    dimension u2(i0,j0,k1),v2(i0,j0,k1),t2(i0,j0,k1),s2(i0,j0,k1),u1(i0,j0,k1),v1(i0,j0,k1),t1(i0,j0,k1),s1(i0,j0,k1),p(i0,j0,k1),ub(i0,j0,k1),vb(i0,j0,k1),tb(i0,j0,k1),sb(i0,j0,k1),pb(j0,j0,k1)
    dimension rbe(nlon),rbw(nlon),sbe(nlon),sbw(nlon),rbn(nlat),rbs(nlat),sbn(nlat),sbs(nlat)

    call combosend(p,i0,j0,k1,sbw(npx(1)),2,sbe(npx(1)),i1,ngy1,mylat,sbn(npy(1)),j1,sbs(npy(1)),2)
    call combosend(t2,i0,j0,k1,sbw(npx(2)),2,sbe(npx(2)),i1,ngy1,mylat,sbn(npy(2)),j1,sbs(npy(2)),2)
    call combosend(s2,i0,j0,k1,sbw(npx(3)),2,sbe(npx(3)),i1,ngy1,mylat,sbn(npy(3)),j1,sbs(npy(3)),2)
    call combosend(u2,i0,j0,k1,sbw(npx(4)),2,sbe(npx(4)),i1,ngy1,mylat,sbn(npy(4)),j1,sbs(npy(4)),2)
    call combosend(v2,i0,j0,k1,sbw(npx(5)),2,sbe(npx(5)),i1,ngy1,mylat,sbn(npy(5)),j1,sbs(npy(5)),2)
    call combosend(p,i0,j0,k1,sbw(npx(6)),3,sbe(npx(6)),i2,ngy1,mylat,sbn(npy(6)),j2,sbs(npy(6)),3)
    call combosend(t2,i0,j0,k1,sbw(npx(7)),3,sbe(npx(7)),i2,ngy1,mylat,sbn(npy(7)),j2,sbs(npy(7)),3)
    call combosend(s2,i0,j0,k1,sbw(npx(8)),3,sbe(npx(8)),i2,ngy1,mylat,sbn(npy(8)),j2,sbs(npy(8)),3)
    call combosend(u2,i0,j0,k1,sbw(npx(9)),3,sbe(npx(9)),i2,ngy1,mylat,sbn(npy(9)),j2,sbs(npy(9)),3)
    call combosend(v2,i0,j0,k1,sbw(npx(10)),3,sbe(npx(10)),i2,ngy1,mylat,sbn(npy(10)),j2,sbs(npy(10)),3)
    call combosend(t1,i0,j0,k1,sbw(npx(11)),2,sbe(npx(11)),i1,ngy1,mylat,sbn(npy(11)),j1,sbs(npy(11)),2)
    call combosend(s1,i0,j0,k1,sbw(npx(12)),2,sbe(npx(12)),i1,ngy1,mylat,sbn(npy(12)),j1,sbs(npy(12)),2)
    call combosend(u1,i0,j0,k1,sbw(npx(13)),2,sbe(npx(13)),i1,ngy1,mylat,sbn(npy(13)),j1,sbs(npy(13)),2)
    call combosend(v1,i0,j0,k1,sbw(npx(14)),2,sbe(npx(14)),i1,ngy1,mylat,sbn(npy(14)),j1,sbs(npy(14)),2)
    call mpi_sendrecv(sbw(1),nlon,mpi_real8,m_w,1,rbe(1),nlon,mpi_real8,m_e,1,m_cart,istat,ierr)
    call mpi_sendrecv(sbe(1),nlon,mpi_real8,m_e,1,rbw(1),nlon,mpi_real8,m_w,1,m_cart,istat,ierr)
    call mpi_sendrecv(sbs(1),nlat,mpi_real8,m_s,1,rbn(1),nlat,mpi_real8,m_n,1,m_cart,istat,ierr)
    call mpi_sendrecv(sbn(1),nlat,mpi_real8,m_n,1,rbs(1),nlat,mpi_real8,m_s,1,m_cart,istat,ierr)
    call comborecv(p,i0,j0,k1,rbw(npx(1)),1,rbe(npx(1)),i0,ngy1,mylat,rbn(npy(1)),j0,rbs(npy(1)),1)
    call comborecv(t2,i0,j0,k1,rbw(npx(2)),1,rbe(npx(2)),i0,ngy1,mylat,rbn(npy(2)),j0,rbs(npy(2)),1)
    call comborecv(s2,i0,j0,k1,rbw(npx(3)),1,rbe(npx(3)),i0,ngy1,mylat,rbn(npy(3)),j0,rbs(npy(3)),1)
    call comborecv(u2,i0,j0,k1,rbw(npx(4)),1,rbe(npx(4)),i0,ngy1,mylat,rbn(npy(4)),j0,rbs(npy(4)),1)
    call comborecv(v2,i0,j0,k1,rbw(npx(5)),1,rbe(npx(5)),i0,ngy1,mylat,rbn(npy(5)),j0,rbs(npy(5)),1)
    call comborecv(pb,i0,j0,k1,rbw(npx(6)),1,rbe(npx(6)),i0,ngy1,mylat,rbn(npy(6)),j0,rbs(npy(6)),1)
    call comborecv(tb,i0,j0,k1,rbw(npx(7)),1,rbe(npx(7)),i0,ngy1,mylat,rbn(npy(7)),j0,rbs(npy(7)),1)
    call comborecv(sb,i0,j0,k1,rbw(npx(8)),1,rbe(npx(8)),i0,ngy1,mylat,rbn(npy(8)),j0,rbs(npy(8)),1)
    call comborecv(ub,i0,j0,k1,rbw(npx(9)),1,rbe(npx(9)),i0,ngy1,mylat,rbn(npy(9)),j0,rbs(npy(9)),1)
    call comborecv(vb,i0,j0,k1,rbw(npx(10)),1,rbe(npx(10)),i0,ngy1,mylat,rbn(npy(10)),j0,rbs(npy(10)),1)
    call comborecv(t1,i0,j0,k1,rbw(npx(11)),1,rbe(npx(11)),i0,ngy1,mylat,rbn(npy(11)),j0,rbs(npy(11)),1)
    call comborecv(s1,i0,j0,k1,rbw(npx(12)),1,rbe(npx(12)),i0,ngy1,mylat,rbn(npy(12)),j0,rbs(npy(12)),1)
    call comborecv(u1,i0,j0,k1,rbw(npx(13)),1,rbe(npx(13)),i0,ngy1,mylat,rbn(npy(13)),j0,rbs(npy(13)),1)
    call comborecv(v1,i0,j0,k1,rbw(npx(14)),1,rbe(npx(14)),i0,ngy1,mylat,rbn(npy(14)),j0,rbs(npy(14)),1)
end subroutine


! ----------------------------------------------------------------------
subroutine mpi_peri_scr(scr1,scr2,ubf,vbf)
    parameter(nlt=2*i0,nln=2*j0)
    dimension scr1(i0,j0),scr2(i0,j0),ubf(i0,j0),vbf(i0,j0)
    dimension rbe(nln),rbw(nln),sbe(nln),sbw(nln),rbn(nlt),rbs(nlt),sbn(nlt),sbs(nlt)

    call combosend(scr1,i0,j0,1,sbw(1),2,sbe(1),i2,ngy1,mylat,sbn(1),j2,sbs(1),2)
    call combosend(scr2,i0,j0,1,sbw(j0+1),2,sbe(j0+1),i2,ngy1,mylat,sbn(i0+1),j2,sbs(i0+1),2)
    call mpi_sendrecv(sbw(1),nln,mpi_real8,m_w,1,rbe(1),nln,mpi_real8,m_e,1,m_cart,istat,ierr)
    call mpi_sendrecv(sbe(1),nln,mpi_real8,m_e,1,rbw(1),nln,mpi_real8,m_w,1,m_cart,istat,ierr)
    call mpi_sendrecv(sbs(1),nlt,mpi_real8,m_s,1,rbn(1),nlt,mpi_real8,m_n,1,m_cart,istat,ierr)
    call mpi_sendrecv(sbn(1),nlt,mpi_real8,m_n,1,rbs(1),nlt,mpi_real8,m_s,1,m_cart,istat,ierr)
    call comborecv(ubf,i0,j0,1,rbw(1),1,rbe(1),i0,ngy1,mylat,rbn(1),j0,rbs(1),1)
    call comborecv(vbf,i0,j0,1,rbw(j0+1),1,rbe(j0+1),i0,ngy1,mylat,rbn(i0+1),j0,rbs(i0+1),1)
end subroutine


! ----------------------------------------------------------------------
subroutine mpi_peri_uv(u2,v2,ub,vb)
    parameter(nlat=4*i0*k1,nlon=4*j0*k1)
    dimension u2(i0,j0,k1),v2(i0,j0,k1),ub(i0,j0,k1),vb(i0,j0,k1)
    dimension rbe(nlon),rbw(nlon),sbe(nlon),sbw(nlon),rbn(nlat),rbs(nlat),sbn(nlat),sbs(nlat)

    call combosend(u2,i0,j0,k1,sbw(npx(1)),2,sbe(npx(1)),i1,ngy1,mylat,sbn(npy(1)),j1,sbs(npy(1)),2)
    call combosend(v2,i0,j0,k1,sbw(npx(2)),2,sbe(npx(2)),i1,ngy1,mylat,sbn(npy(2)),j1,sbs(npy(2)),2)
    call combosend(u2,i0,j0,k1,sbw(npx(3)),3,sbe(npx(3)),i2,ngy1,mylat,sbn(npy(3)),j2,sbs(npy(3)),3)
    call combosend(v2,i0,j0,k1,sbw(npx(4)),3,sbe(npx(4)),i2,ngy1,mylat,sbn(npy(4)),j2,sbs(npy(4)),3)
    call mpi_sendrecv(sbw(1),nlon,mpi_real8,m_w,1,rbe(1),nlon,mpi_real8,m_e,1,m_cart,istat,ierr)
    call mpi_sendrecv(sbe(1),nlon,mpi_real8,m_e,1,rbw(1),nlon,mpi_real8,m_w,1,m_cart,istat,ierr)
    call mpi_sendrecv(sbs(1),nlat,mpi_real8,m_s,1,rbn(1),nlat,mpi_real8,m_n,1,m_cart,istat,ierr)
    call mpi_sendrecv(sbn(1),nlat,mpi_real8,m_n,1,rbs(1),nlat,mpi_real8,m_s,1,m_cart,istat,ierr)
    call comborecv(u2,i0,j0,k1,rbw(npx(1)),1,rbe(npx(1)),i0,ngy1,mylat,rbn(npy(1)),j0,rbs(npy(1)),1)
    call comborecv(v2,i0,j0,k1,rbw(npx(2)),1,rbe(npx(2)),i0,ngy1,mylat,rbn(npy(2)),j0,rbs(npy(2)),1)
    call comborecv(ub,i0,j0,k1,rbw(npx(3)),1,rbe(npx(3)),i0,ngy1,mylat,rbn(npy(3)),j0,rbs(npy(3)),1)
    call comborecv(vb,i0,j0,k1,rbw(npx(4)),1,rbe(npx(4)),i0,ngy1,mylat,rbn(npy(4)),j0,rbs(npy(4)),1)
end subroutine

! ----------------------------------------------------------------------
subroutine mpi_peri_ts(t1,s1)
    parameter(nlat=2*i0*k1,nlon=2*j0*k1)
    dimension t1(i0,j0,k1),s1(i0,j0,k1)
    dimension rbe(nlon),rbw(nlon),sbe(nlon),sbw(nlon),rbn(nlat),rbs(nlat),sbn(nlat),sbs(nlat)

    call combosend(t1,i0,j0,k1,sbw(npx(1)),2,sbe(npx(1)),i1,ngy1,mylat,sbn(npy(1)),j1,sbs(npy(1)),2)
    call combosend(s1,i0,j0,k1,sbw(npx(2)),2,sbe(npx(2)),i1,ngy1,mylat,sbn(npy(2)),j1,sbs(npy(2)),2)
    call mpi_sendrecv(sbw(1),nlon,mpi_real8,m_w,1,rbe(1),nlon,mpi_real8,m_e,1,m_cart,istat,ierr)
    call mpi_sendrecv(sbe(1),nlon,mpi_real8,m_e,1,rbw(1),nlon,mpi_real8,m_w,1,m_cart,istat,ierr)
    call mpi_sendrecv(sbs(1),nlat,mpi_real8,m_s,1,rbn(1),nlat,mpi_real8,m_n,1,m_cart,istat,ierr)
    call mpi_sendrecv(sbn(1),nlat,mpi_real8,m_n,1,rbs(1),nlat,mpi_real8,m_s,1,m_cart,istat,ierr)
    call comborecv(t1,i0,j0,k1,rbw(npx(1)),1,rbe(npx(1)),i0,ngy1,mylat,rbn(npy(1)),j0,rbs(npy(1)),1)
    call comborecv(s1,i0,j0,k1,rbw(npx(2)),1,rbe(npx(2)),i0,ngy1,mylat,rbn(npy(2)),j0,rbs(npy(2)),1)
end subroutine


! ----------------------------------------------------------------------
subroutine combosend(sbuf,ni0,nj0,nk0,sbw,iw,sbe,ie,ngy0,mylat,sbn,jn,sbs,js)
    dimension sbuf(ni0,nj0,nk0),sbw(nj0*nk0),sbe(nj0*nk0),sbn(ni0*nk0),sbs(ni0*nk0)

    do 10 k=1,nk0
    jt=k*nj0-nj0
    do 10 j=1,nj0
    sbe(jt+j)=sbuf(ie,j,k)
    10   sbw(jt+j)=sbuf(iw,j,k)

    if (mylat .ne. 0) then
	do 20 k=1,nk0
	it=k*ni0-ni0
	do 20 i=1,ni0
	20   sbs(it+i)=sbuf(i,js,k)
    endif
    if (mylat .ne. ngy0) then
	do 30 k=1,nk0
	it=k*ni0-ni0
	do 30 i=1,ni0
	30   sbn(it+i)=sbuf(i,jn,k)
    endif
end subroutine


! ----------------------------------------------------------------------
subroutine comborecv(rbuf,ni0,nj0,nk0,rbw,iw,rbe,ie,ngy0,mylat,rbn,jn,rbs,js)
    dimension rbuf(ni0,nj0,nk0),rbw(nj0*nk0),rbe(nj0*nk0),rbn(ni0*nk0),rbs(ni0*nk0)
    do 10 k=1,nk0
    jt=k*nj0-nj0
    do 10 j=1,nj0
    rbuf(ie,j,k)=rbe(jt+j)
    10   rbuf(iw,j,k)=rbw(jt+j)

    if (mylat .ne. 0) then
	do 20 k=1,nk0
	it=k*ni0-ni0
	do 20 i=1,ni0
	20   rbuf(i,js,k)=rbs(it+i)
    endif
    if (mylat .ne. ngy0) then
	do 30 k=1,nk0
	it=k*ni0-ni0
	do 30 i=1,ni0
	30   rbuf(i,jn,k)=rbn(it+i)
    endif
end subroutine


subroutine finalize_comm

end subroutine


end module

module presolver  
    use const
    use comm
    use var
implicit real*8 (a-h,o-z)
#   include "pnetcdf.inc"
    
    ! preprocessor for 1/2 deg res global model                   july, 2007
    !!cyclic longitudinal b.c.'s (i.e., global or periodic)
    ! ----------------------------------------------------------------------
    !      block data nishal
    ! ----------------------------------------------------------------------
    real*8 hh,d1
    common/contro/r0
    common/lpi/mvfreq
    common/boyanc/d1(i0,j0,k1)
    common/bathy/hh(i0,j0),rmets(i0,j0)
    common/bcs/tsurf(i2,j2,12),ssurf(i2,j2,12),snsp(i2,10,k2,12),sssp(i2,10,k2,12),tnsp(i2,10,k2,12),tssp(i2,10,k2,12)

! lsolver solver control
! lsolver:0 no solver setting
! lsolver:1 evp
! lsolver:2 bi-cgstab
! ie(nb0)=j1
! we initialize ie in do loop 250 of subroutine initfs
!     data ie/6,11,16,...,j1/

! ----------------------------
! explanation of parameters
! ----------------------------
! i0,j0: horizontal dimension parameters (includes ghost zones around
! entire model domain; climatological boundary values are stored in
! ghost zones)
! k0: vertical dimension parameter (number of layer interfaces, equal
! the number of layers or pressure levels plus 1, does not include ghost
! zone)
! nb0: number of evp ellipti! solver restart vectors, used to control
! solver roundoff error (decreases with increasing nb0)
! case=5-character case name
! dscrib=63-character case descriptor
! r0=earth radius
! daodt=number of time steps per day
! b=thermal expansion coefficient when linear equation of state is used
! g=gravity
! dm0,de0 are horizontal heat and momentum diffusivities (cm-cm/sec)
! rzmx=vertical cell reynolds number limit
! drag=drag coefficient (standard value is .002)
! fltw=time filter coefficient on time filtered leapfrog method
! ktrm=thermocline level (used only for animation graphics)
! lrstrt=flag to initialize from restart file; if lrstrt=0, initial vel
!         is zero (but not necessarily boundary values)
! mxit=last time step number of current run (last time step of previous
!      run is saved on restart file)
! lopen=flag for open lateral boundaries (derive geostrophi! inflows)
! lmovi=flag to save data for animation of the results
! lsolver=flag for this program to initialize ellipti! solver data for the
! lprecon=flag for precodition of bi-cgstab(lsolver=2)
!  given geometry and also to generate initial temperature and salinity
! ie=array for evp ellipti! solver (controls roundoff error); ie(nb0)=j1

contains
! ----------------------------------------------------------------------
subroutine solvergen
! ----------------------------------------------------------------------
! input data: etopo5, levitus (t and s)
! the model now reads input wind data directly
! output data:
! input data translated to model variable latitudinal resolution grid

    integer*2 intmp(i2,j2),ing(i0t,j0t),inbuf(i2t*j2t)
    integer*2 isw(j0*k1),ise(j0*k1),isn(i0*k1),iss(i0*k1),irw(j0*k1),ire(j0*k1),irn(i0*k1),irs(i0*k1)
    real*8 scr_tmp(i0,j0) 

    daodt=576
    r0=6.4e8
    b=2.05e-4
    g=980.6
    dm0=5.e6
    de0=25.e5
    dmz0=.01
    rzmx=50
    drag=.001
    fltw=.1
    rawf=.53

    ! this may be unstable
    !data ktrm,lrstrt,mxit,isav,mxsav/5,0,0,5400,5400/
   
    ktrm=5
    lrstrt=0
    mxit=0
    isav=5400
    mxsav=5400
    
    !data lopen,lmovi,mvfreq,lfsrf,lsolver,lprecon/0,1,5,1,2,1/
    lopen=0
    lmovi=1
    mvfreq=5
    lfsrf=1
    lsolver=2
    lprecon=1
    case="GLOBO"
    dscrib="global model (.5 deg longitudinal resolution)                  "
    
    if (myid .eq. 0) then
	open(79,file='namelist.txt',form='formatted')
	read(79,*)lrstrt
	read(79,*)daodt
	read(79,*)irun
	close(79)
	mxit=irun*daodt*360
    endif
    call mpi_bcast(lrstrt,1,mpi_integer,0,mpi_comm_world,ierr)
    call mpi_bcast(daodt,1,mpi_real8,0,mpi_comm_world,ierr)
    call mpi_bcast(mxit,1,mpi_integer,0,mpi_comm_world,ierr)

    ! output data
!    open(10,file='data/yzgrid'//grd,form='unformatted')
!    open(11,file='data/depth'//grd,form='unformatted')
!    open(70,file='data/annualevitus'//grd,form='unformatted')
    ! output data
!    open(7,file='data/vbk_ascii'//grd)
!    open(8,file='data/windmix'//grd,form='unformatted')
!    open(9,file='data/rundata'//grd,form='unformatted')
!    open(17,file='data/kbview'//grd)
!    open(60,file='data/zkb'//grd,form='unformatted')
!    open(62,file='data/boundaries'//grd,form='unformatted')
    ! check solver 
    if(lsolver.eq.1 .or. lsolver.eq.2) then
!	open(99,file='data/evp'//grd,form='unformatted')
!	rewind 99
    elseif(lsolver.eq.0) then
	if(myid.eq.0) print*,'no solver setting'
    else
	if(myid.eq.0) print*,'lsolver=',lsolver,' err'
	stop 0
    endif

!    rewind 10
!    rewind 11
!    rewind 70
!    rewind 7 
!    rewind 8 
!    rewind 9 
!    rewind 17 
!    rewind 60 
!    rewind 62

    call rdnc_yzgrid2(j,k,dxmnut) !dog
!    read(10) j,k
    if (j0.ne.j.and.k0.ne.k) then
    write(*,6)
6   format('stop due to resolution mismatch. set i0,k0 to values from metgen.f.')
    stop 0
    endif
!   continue   

!9   read(10) tlz,z,odz,odzw,dxmnut,xdeg,y,yv,yvdeg,ydeg,cs,csv,ocs,ocsv,dx,dxv,odx,odxv,dy,dyv,ody,odyv

    !k01=k0+k1
    !write(21,10) (.01*z(k),k=1,k01,2)
    !10   format('z-levels(m)'/(10f8.2))
!coriolis parameter array
      omega2=3.141592654/21600.
! degrees to radians
      pi_180=3.141592654/180.
      do 12 j=2,j1
! spherical curvature parameter
      tanphi(j-1)=tan(pi_180*ydeg(j))/r0
 12   f(j-1)=omega2*sin(pi_180*ydeg(j))

     ! write(21,14) i0,j0
 !14   format('longitude(x) grid dimension:',i4/'latitude(y) grid dimension:',i4/)

! rmets data
! rmets(i,1) corresponds to southern most internal grid point
!      stop
      call rdnc_depth(rmets)
!      read(11) rmets


      write(*,*) '==============',maxval(rmets),minval(rmets)
      write(*,*) 'rmets filtered'
      write(*,*) '=============='
      call mpi_type_vector(j0,1,i0,mpi_real8,m_vlon_2d,ierr) !dog
      call mpi_type_vector(1,i0,j0,mpi_real8,m_vlat_2d,ierr)
      call mpi_type_commit(m_vlon_2d,ierr)
      call mpi_type_commit(m_vlat_2d,ierr)

      call mpi_sendrecv(rmets(2,1),1,m_vlon_2d,m_w,1,rmets(i0,1),1,m_vlon_2d,m_e,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(rmets(i1,1),1,m_vlon_2d,m_e,1,rmets(1,1),1,m_vlon_2d,m_w,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(rmets(1,2),1,m_vlat_2d,m_s,1,rmets(1,j0),1,m_vlat_2d,m_n,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(rmets(1,j1),1,m_vlat_2d,m_n,1,rmets(1,1),1,m_vlat_2d,m_s,1,mpi_comm_world,istat,ierr)


!cts change from mxpas=2 to 4
      mxpas=4
      do n=1,mxpas
      do 15 j=2,j1
      do 15 i=2,i1

! don't filter izu ridge and se honshu coastal region
      if(xdeg(i).gt.134.5.and.xdeg(i).lt.147..and.ydeg(j).gt.-62.5.and.ydeg(j).lt.-51.5) goto 15
! don't filter gs window region      
      if(xdeg(i).gt.284.5.and.xdeg(i).lt.320..and.ydeg(j).gt.-54.5.and.ydeg(j).lt.-29.) goto 15

! don't filter regions near land (they are adequately known)
! filter only points farther than nwet grid intervals from land

      if (rmets(i,j).lt. 300.) goto 15
      scr_tmp(i,j)=.25*(rmets(i,j-1)+rmets(i,j+1)+rmets(i-1,j)+rmets(i+1,j))
 15   continue

      do 16 j=2,j1
      do 16 i=2,i1

! don't filter izu ridge and se honshu coastal region
      if(xdeg(i).gt.134.5.and.xdeg(i).lt.147..and.ydeg(j).gt.-62.5.and.ydeg(j).lt.-51.5) goto 16
! don't filter gs window region
      if(xdeg(i).gt.284.5.and.xdeg(i).lt.320..and.ydeg(j).gt.-54.5.and.ydeg(j).lt.-29.) goto 16

      if (rmets(i,j).lt. 300.) goto 16
      rmets(i,j)=scr_tmp(i,j)
 16   continue
     
      call mpi_sendrecv(rmets(2,1),1,m_vlon_2d,m_w,1,rmets(i0,1),1,m_vlon_2d,m_e,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(rmets(i1,1),1,m_vlon_2d,m_e,1,rmets(1,1),1,m_vlon_2d,m_w,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(rmets(1,2),1,m_vlat_2d,m_s,1,rmets(1,j0),1,m_vlat_2d,m_n,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(rmets(1,j1),1,m_vlat_2d,m_n,1,rmets(1,1),1,m_vlat_2d,m_s,1,mpi_comm_world,istat,ierr)
      enddo


!cts20150921
      if(.false.)then
! 555 510  64  53
! make izu ridge into a narrow ridge at sill level
!cw      do 18 j=547,527,-1
!cw      jloc=j-mylat*j2
      do 18 j=2,j1
      do 18 i=3,i2
! rmets is in meters
! 15   write(*,16) j,(int(.1*rmets(i,j)),i=555,565)
! 16   format(i3,1x,11i4)
! find shallowest sill level in longitudinal range i=555-565
      kmn=10000
!cw      do 17 i=556,564
!cw      iloc=i-mylon*i2
      
!      if(iloc.le.2.or.iloc.ge.i1.or.jloc.le.2.and.jloc.ge.j1)
!cw      if(iloc.lt.2.or.iloc.gt.i1.or.jloc.lt.2.or.jloc.gt.j1)
!cw     1  goto 18
       if(xdeg(i).gt.138..and.xdeg(i).lt.142..and.ydeg(j).gt.30..and.ydeg(j).lt.35.) then
!      k=kmn
!      kmn=min(kmn,int(.1*rmets(i,j)))
! 17   if (kmn.ne.k) imn=i
! make narrow ridge
!      tmp=max(rmets(imn-1,j),rmets(imn-2,j))
!      rmets(imn-2,j)=tmp
!      rmets(imn-1,j)=tmp
!      tmp=max(rmets(imn+1,j),rmets(imn+2,j))
!      rmets(imn+2,j)=tmp
!      rmets(imn+1,j)=tmp
!     write(*,*) imn,kmn

      k=kmn
!cw      kmn=min(kmn,int(.1*rmets(iloc,jloc)))
      kmn=min(kmn,int(.1*rmets(i,j)))
!cw 17   if (kmn.ne.k) imn=iloc
 17   if (kmn.ne.k) imn=i
! make narrow ridge
      tmp=max(rmets(imn-1,j),rmets(imn-2,j))
      rmets(imn-2,j)=tmp
      rmets(imn-1,j)=tmp
      tmp=max(rmets(imn+1,j),rmets(imn+2,j))
      rmets(imn+2,j)=tmp
      rmets(imn+1,j)=tmp
!cw      tmp=max(rmets(imn-1,jloc),rmets(imn-2,jloc))
!cw      rmets(imn-2,jloc)=tmp
!cw      rmets(imn-1,jloc)=tmp
!cw      tmp=max(rmets(imn+1,jloc),rmets(imn+2,jloc))
!cw      rmets(imn+2,jloc)=tmp
!cw      rmets(imn+1,jloc)=tmp
!     write(*,*) imn,kmn
      endif
 18   continue


      do i=2,i1
      do j=2,j1
! smoother coastline near cozumel
       if(xdeg(i).gt.273.2.and.xdeg(i).lt.273.5.and.ydeg(j).gt.21.1.and.ydeg(j).lt.21.5) then
       rmets(i,j)=0.
       endif

! eliminate shallow water northwest of easternmost florida point
! rmets(1118:1120,516:530)=0.
       if(xdeg(i).gt.279.1.and.xdeg(i).lt.279.9.and.ydeg(j).gt.28.1.and.ydeg(j).lt.31.6) then
       rmets(i,j)=0.
       endif
! rmets(1121,516:530)=28.
       if(xdeg(i).gt.280.0.and.xdeg(i).lt.280.3.and.ydeg(j).gt.28.1.and.ydeg(j).lt.31.6) then
       rmets(i,j)=28.
       endif
! rmets(1121,521:525)=45.
       if(xdeg(i).gt.280.0.and.xdeg(i).lt.280.3.and.ydeg(j).gt.29.2.and.ydeg(j).lt.30.5) then
       rmets(i,j)=45.
       endif
! rmets(1120,522:523)=28.
       if(xdeg(i).gt.279.5.and.xdeg(i).lt.280.0.and.ydeg(j).gt.29.5.and.ydeg(j).lt.30.0) then
       rmets(i,j)=28.
       endif         
       if(ydeg(j).gt.85.0)then
       rmets(i,j)=0.
       endif
       enddo
       enddo

!      stop
! artificial high latitude shelves (shortcircuits arcti! ocean,
! truncates antarcti! seas and bays, and avoids artificial excessive bt
! mode vortex stretching at latitudinal boundaries)

!cw new shallowing scheme
      jtt=min(j2t/60,k2)
!cw      jtt=min(j2t/30,k2)
      kinv=int(dble(k2)/dble(jtt)+.5)
      kzl=int(70.*dble(k1)/60.)
      if(myid.eq.0) print*,'kzl=',kzl

      do 23 j=2,j1

      if(mylat*j2+j-1.le.jtt) then
      jin=mylat*j2+j-2      
      kin=1+kinv*jin
!cw      kk=min(k0+k1,2*kin+3)
      kk=min(k0+k1,2*kin+kzl+1)
      tmp=.01*z(kk)
      do 21 i=1,i0
 21   rmets(i,j)=min(rmets(i,j),tmp)  
      endif

      if(mylat*j2+j.ge.j0t-jtt) then
      jin=j0t-mylat*j2-j-1
      kin=1+kinv*jin
!cw      kk=min(k0+k1,2*kin+3)
      kk=min(k0+k1,2*kin+kzl+1)

      tmp=.01*z(kk)
      do 22 i=1,i0
 22   rmets(i,j)=min(rmets(i,j),tmp)
      endif
 23   continue   


!cts20150921 if(.false.)then
      endif

!      if (mylat .eq. 0) then
!      n=0
!      do 22 k=1,k1
!      n=n+1
!      kk=min(k0+k1,2*k+3)
!      tmp=.01*z(kk)
!      do 22 i=1,i0
! 22   rmets(i,n+1)=min(rmets(i,n+1),tmp)
!      endif
!      
!      if (mylat .eq. ngy1) then
!      n=0
!      do 23 k=1,k1
!      n=n+1
!      kk=min(k0+k1,2*k+3)
!      tmp=.01*z(kk)
!      do 23 i=1,i0
! 23   rmets(i,j0-n)=min(rmets(i,j0-n),tmp)
!      endif

      

! bad point is (39,401) starting at step 91100
!      write(*,24) (j,(int(rmets(i,j)),i=31,47),j=j1,j1-50,-1)
! 24   format(i3,4x,17i4)

!     write(*,24) (j,(int(rmets(i,j)),i=261,300),j=206,167,-1)
!c24   format(/(i3,1x,40i1))

! make all water least 2 layers deep
! to allow baroclini! ventillation all the way to coast
      tmp=.01*z(5)
!convert 1-layer deep water to 2-layer-deep water
! alternatively, !convert water less than 2 layers deep to land

!cw20150910
!cw      tmp1=.01*(z(3)+z(5))/2.
      tmp1=.01*(z(5)+z(7))/2. 

      do 25 j=2,j1
      do 25 i=2,i1
!convert land to water
! 25   if (rmets(i,j).gt.tmp1) rmets(i,j)=max(rmets(i,j),tmp)
!convert water to land
 25   if (rmets(i,j).lt.tmp1) rmets(i,j)=0.

! periodic
      call mpi_sendrecv(rmets(2,1),1,m_vlon_2d,m_w,1,rmets(i0,1),1,m_vlon_2d,m_e,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(rmets(i1,1),1,m_vlon_2d,m_e,1,rmets(1,1),1,m_vlon_2d,m_w,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(rmets(1,2),1,m_vlat_2d,m_s,1,rmets(1,j0),1,m_vlat_2d,m_n,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(rmets(1,j1),1,m_vlat_2d,m_n,1,rmets(1,1),1,m_vlat_2d,m_s,1,mpi_comm_world,istat,ierr)

      do 33 j=1,j0
      do 33 i=1,i0
 33   rmets(i,j)=min(tlz,100.*rmets(i,j))
  
! determine "logical grid" rmets array kb(i,j)
! kb(i,j)=number of layers at pressure point (i,j)
      do 34 k=1,k1
      zz=.5*(z(2*k-1)+z(2*k+1))
      do 34 j=1,j0
      do 34 i=1,i0
! if rmets is deeper than mid-layer (zz), increment kb by 1
      l=rmets(i,j)/zz
 34   kb(i,j)=kb(i,j)+min(1,l)

! widen northern izu gap to allow more flow through to entrain more
! oyashio water. this was added at day 90 of year 6. before that the
! kuroshio extension was good, but a small southward loop downstream from
! the gap is decreased by this change.
! deepen widened gap at start of year 14
!     n=1
! further deepen gap at start of year 16
      n=2
      do i=2,i1
      do j=2,j1

      if(.false.)then
!cts 20150911 remove new york bight singularity
       if(xdeg(i).gt.289.5.and.xdeg(i).lt.293.5.and.ydeg(j).gt.42.2.and.ydeg(j).lt.45.2) then
       kb(i,j)=min(kb(i,j),3)
       endif
       if(xdeg(i).gt.289.5.and.xdeg(i).lt.293.5.and.ydeg(j).gt.41.5.and.ydeg(j).lt.45.2) then
       kb(i,j)=min(kb(i,j),7)
       endif
      endif
!cts seamounts around 44.7n, 321e

      if(xdeg(i).gt.319.and.xdeg(i).lt.322.and.ydeg(j).gt.44.8.and.ydeg(j).lt.45.2) then
       kb(i,j)=min(kb(i,j),32)
      endif

      if(.false.)then
!cts kuroshio seperation-japan coast should be sahllower
      if(xdeg(i).gt.138.8.and.xdeg(i).lt.141.4.and.ydeg(j).gt.34.5.and.ydeg(j).lt.35.) then
       kb(i,j)=min(kb(i,j),18)
      endif
      if(xdeg(i).gt.140.9.and.xdeg(i).lt.141.8.and.ydeg(j).gt.35..and.ydeg(j).lt.36.) then
       kb(i,j)=min(kb(i,j),15)
      endif
      if(xdeg(i).gt.140.9.and.xdeg(i).lt.141.8.and.ydeg(j).gt.36.and.ydeg(j).lt.37.) then
       kb(i,j)=min(kb(i,j),11)
      endif
      if(xdeg(i).gt.141.8.and.xdeg(i).lt.142.8.and.ydeg(j).gt.35.1.and.ydeg(j).lt.39.4) then
       kb(i,j)=kb(i,j)-5
      endif
      endif
!cw 20150910
      if(.false.) then

!cw      do j=539,541  i=561,563
!cw      kb(iloc,jloc)=13+n
       if(xdeg(i).gt.140.0.and.xdeg(i).lt.140.8.and.ydeg(j).gt.33.2.and.ydeg(j).lt.34.0) then
       kb(i,j)=13+n
       endif
!cw      iloc=561-mylon*i2    jloc=539-mylat*j2
!cw      kb(iloc,jloc)=13+n
       if(xdeg(i).gt.140.0.and.xdeg(i).lt.140.3.and.ydeg(j).gt.33.2.and.ydeg(j).lt.33.6) then
       kb(i,j)=13+n
       endif
!cw      iloc=562-mylon*i2    jloc=539-mylat*j2
!cw      kb(iloc,jloc)=13+n
       if(xdeg(i).gt.140.3.and.xdeg(i).lt.140.5.and.ydeg(j).gt.33.2.and.ydeg(j).lt.33.6) then
       kb(i,j)=13+n
       endif
!cw      iloc=561-mylon*i2    jloc=540-mylat*j2
!cw      kb(iloc,jloc)=13+n
       if(xdeg(i).gt.140.0.and.xdeg(i).lt.140.3.and.ydeg(j).gt.33.5.and.ydeg(j).lt.33.7) then
       kb(i,j)=13+n
       endif
!cw      iloc=562-mylon*i2    jloc=540-mylat*j2
!cw      kb(iloc,jloc)=13+n
       if(xdeg(i).gt.140.3.and.xdeg(i).lt.140.5.and.ydeg(j).gt.33.5.and.ydeg(j).lt.33.7) then
       kb(i,j)=13+n
       endif
!cw      iloc=562-mylon*i2    jloc=541-mylat*j2
!cw      kb(iloc,jloc)=13+n
       if(xdeg(i).gt.140.3.and.xdeg(i).lt.140.5.and.ydeg(j).gt.33.7.and.ydeg(j).lt.33.9) then
       kb(i,j)=13+n
       endif

! eliminate anomalous ny bight island
!cw      iloc=1142-mylon*i2   jloc=557-mylat*j2
!cw      kb(iloc,jloc)=2
       if(xdeg(i).gt.285.3.and.xdeg(i).lt.285.5.and.ydeg(j).gt.36.9.and.ydeg(j).lt.37.1) then
       kb(i,j)=2
       endif
!cw      iloc=1142-mylon*i2   jloc=558-mylat*j2
!cw      kb(iloc,jloc)=2
       if(xdeg(i).gt.285.3.and.xdeg(i).lt.285.5.and.ydeg(j).gt.37.1.and.ydeg(j).lt.37.3) then
       kb(i,j)=2
       endif
!cw      iloc=1142-mylon*i2   jloc=559-mylat*j2
!cw      kb(iloc,jloc)=2
       if(xdeg(i).gt.285.3.and.xdeg(i).lt.285.5.and.ydeg(j).gt.37.3.and.ydeg(j).lt.37.5) then
       kb(i,j)=2
       endif
!cw      iloc=1144-mylon*i2   jloc=561-mylat*j2
!cw      kb(iloc,jloc)=2
       if(xdeg(i).gt.285.8.and.xdeg(i).lt.290.1.and.ydeg(j).gt.37.7.and.ydeg(j).lt.37.9) then
       kb(i,j)=2
       endif
!cts no above modification
       endif



!cts new check and topographical modification
       if(xdeg(i).gt.140.5.and.xdeg(i).lt.141.5.and.ydeg(j).gt.41.0.and.ydeg(j).lt.42.) then
       kb(i,j)=10
       endif
!cw20150902
       if(xdeg(i).gt.120.5.and.xdeg(i).lt.121.5.and.ydeg(j).gt.24.5.and.ydeg(j).lt.25.0) then
       kb(i,j)=9
       endif
  
       if(xdeg(i).gt.121.5.and.xdeg(i).lt.122.5.and.ydeg(j).gt.25.5.and.ydeg(j).lt.26.0) then
       kb(i,j)=13
       endif

!cw indonesia throughflow
       if(xdeg(i).gt.119.5.and.xdeg(i).lt.120.5.and.ydeg(j).gt.-6..and.ydeg(j).lt.0.25) then
       kb(i,j)=23
       endif

       if(xdeg(i).gt.119.5.and.xdeg(i).lt.121.5.and.ydeg(j).gt.0.5.and.ydeg(j).lt.0.75) then
       kb(i,j)=20
       endif

       if(xdeg(i).gt.119.5.and.xdeg(i).lt.121.5.and.ydeg(j).gt.0.75.and.ydeg(j).lt.1.) then
       kb(i,j)=24
       endif

       if(xdeg(i).gt.119.5.and.xdeg(i).lt.121.5.and.ydeg(j).gt.1..and.ydeg(j).lt.1.5) then
       kb(i,j)=26
       endif

!cw allow lombok
       if(xdeg(i).gt.118.5.and.xdeg(i).lt.119.5.and.ydeg(j).gt.-12.5.and.ydeg(j).lt.-11.75) then
       kb(i,j)=26
       endif

       if(xdeg(i).gt.118.5.and.xdeg(i).lt.119.5.and.ydeg(j).gt.-10.75.and.ydeg(j).lt.-10.25) then
       kb(i,j)=28
       endif

!cw allow ombai
       if(xdeg(i).gt.122.5.and.xdeg(i).lt.123.5.and.ydeg(j).gt.-8.5.and.ydeg(j).lt.-8.) then
       kb(i,j)=26
       endif

       if(xdeg(i).gt.123.5.and.xdeg(i).lt.124.5.and.ydeg(j).gt.-8.5.and.ydeg(j).lt.-8.) then
       kb(i,j)=25
       endif

       if(xdeg(i).gt.126.5.and.xdeg(i).lt.127.5.and.ydeg(j).gt.-9.and.ydeg(j).lt.-8.5) then
       kb(i,j)=24
       endif

       if(xdeg(i).gt.129.5.and.xdeg(i).lt.131.5.and.ydeg(j).gt.-3.75.and.ydeg(j).lt.0.75) then
       kb(i,j)=24
       endif


       enddo
       enddo

       do j=2,j1
       do i=2,i1
       if(ydeg(j).ge.34..and.ydeg(j).le.36.5.and.xdeg(i).ge.352.5.and.xdeg(i).le.356)then
        kb(i,j)=max(kb(i,j),19)
       endif
       enddo
       enddo

       do j=2,j1
       do i=2,i1
       if(ydeg(j).ge.36..and.ydeg(j).le.36.5.and.xdeg(i).ge.354.and.xdeg(i).le.356)then
        write(*,*)'topo1',i,j

        do jj=j+6,j-8,-1
        write(*,'(a,11i4)')'topo1',kb(i-5:i+5,jj)
        enddo
       endif
       enddo
       enddo


!cw check
!       do i=2,i1
!       do j=2,j1
!       it=i+mylon*i2-1
!       jt=j+mylat*j2-1
!       if(it.eq.107.and.jt.eq.144) print*,'1 kb 107 144=',kb(i,j)
!     1 ,xdeg(i),ydeg(j)
!       if(it.eq.116.and.jt.eq.144) print*,'1 kb 116 144=',kb(i,j)
!     1 ,xdeg(i),ydeg(j)
!       if(it.eq.117.and.jt.eq.144) print*,'1 kb 117 144=',kb(i,j)
!       enddo
!       enddo

! derive land/sea mask array
      do 52 j=1,j0
      do 52 i=1,i0
      it=kb(i,j)
      if (it.ne.0) go to 50
      kb(i,j)=1
      go to 52
 50   do 51 k=1,it
 51   in(i,j,k)=1
 52   continue

      do 53 j=2,j1
      do 53 i=2,i1
 53   intmp(i-1,j-1)=in(i,j,1)

       do j=2,j1
       do i=2,i1
       if(ydeg(j).ge.36..and.ydeg(j).le.36.5.and.xdeg(i).ge.354.and.xdeg(i).le.356)then
        write(*,*)'topo1',i,j
        do jj=j+6,j-8,-1
        write(*,'(a,11i4)')'topo1',in(i-5:i+5,jj,1)
        enddo
       endif
       enddo
       enddo

      nsend=i2*j2

      call mpi_gather(intmp,nsend,mpi_integer2,inbuf,nsend,mpi_integer2,0,mpi_comm_world,ierr)

      if (myid .eq. 0) then
      do 57 nx=1,ngx0
      ngxt=(nx-1)*ngy0
      do 57 ny=1,ngy0
      ngt=((ny-1)+ngxt)*i2*j2
      do 57 j=1,j2
      nt=ngt+(j-1)*i2
      jt=j+(ny-1)*j2
      do 57 i=1,i2
!      it=mod(i+(nx-1)*i2+i2t/2,i2t)
      it=i+(nx-1)*i2
 57   ing(it+1,jt+1)=inbuf(nt+i)
      
! in and ing is the same with in in global_serial1


!remark that boundary condition is computed in value of ghost cell.
! ------------------------------------------------------
! start with single point in central equatorial pacific
! check pt
      n=0
!      ing(i2t/6,j0t/2)=2


      ing(2*i0t/3,j0t/2)=2


! ------------------------------------------------------
! due to periodi! logical grid boundary at 0 deg longitude
! we need a second point in the arcti! ocean
! rmk: i=2 alway lies in processor 0.

!cw20140604      ing(2,j1t)=2

 153  n=n+1
      nsum=0
      do 155 j=2,j1t
      do 154 i=2,i1t
      nn=ing(i+1,j)
      if (ing(i+1,j).eq.1.and.ing(i,j).eq.2) ing(i+1,j)=2
      nsum=nsum+ing(i+1,j)-nn
      nn=ing(i-1,j)
      if (ing(i-1,j).eq.1.and.ing(i,j).eq.2) ing(i-1,j)=2
      nsum=nsum+ing(i-1,j)-nn
      nn=ing(i,j+1)
      if (ing(i,j+1).eq.1.and.ing(i,j).eq.2) ing(i,j+1)=2
      nsum=nsum+ing(i,j+1)-nn
      nn=ing(i,j-1)
      if (ing(i,j-1).eq.1.and.ing(i,j).eq.2) ing(i,j-1)=2
 154  nsum=nsum+ing(i,j-1)-nn
      do 155 i=i1t,2,-1
      nn=ing(i+1,j)
      if (ing(i+1,j).eq.1.and.ing(i,j).eq.2) ing(i+1,j)=2
      nsum=nsum+ing(i+1,j)-nn
      nn=ing(i-1,j)
      if (ing(i-1,j).eq.1.and.ing(i,j).eq.2) ing(i-1,j)=2
      nsum=nsum+ing(i-1,j)-nn
      nn=ing(i,j+1)
      if (ing(i,j+1).eq.1.and.ing(i,j).eq.2) ing(i,j+1)=2
      nsum=nsum+ing(i,j+1)-nn
      nn=ing(i,j-1)
      if (ing(i,j-1).eq.1.and.ing(i,j).eq.2) ing(i,j-1)=2
 155  nsum=nsum+ing(i,j-1)-nn

      write(*,156) nsum,n
 156  format(i8,'changes during iteration',i4)
      if (nsum.ne.0) go to 153


      do 157 j=1,j0t
      ing(i0t,j)=ing(2,j)
 157  ing(1,j)=ing(i1t,j)
      endif
      call mpi_bcast(ing,i0t*j0t,mpi_integer2,0,mpi_comm_world,ierr)

! widen northern izu gap to allow more flow through to entrain more
! oyashio water. this was added at day 90 of year 6. before that the
! kuroshio extension was good, but a small southward loop downstream from
! the gap is decreased by this change.

!cw      iloc=561-mylon*i2
!cw      jloc=539-mylat*j2
!cw      if(iloc.ge.2.and.iloc.le.i1.and.jloc.ge.2.and.jloc.le.j1)
!cw     1 kb(iloc,jloc)=13
!cw      iloc=562-mylon*i2
!cw      jloc=539-mylat*j2
!cw      if(iloc.ge.2.and.iloc.le.i1.and.jloc.ge.2.and.jloc.le.j1)
!cw     1 kb(iloc,jloc)=13
!cw      iloc=561-mylon*i2
!cw      jloc=540-mylat*j2
!cw      if(iloc.ge.2.and.iloc.le.i1.and.jloc.ge.2.and.jloc.le.j1)
!cw     1 kb(iloc,jloc)=13
!cw      iloc=562-mylon*i2
!cw      jloc=540-mylat*j2
!cw      if(iloc.ge.2.and.iloc.le.i1.and.jloc.ge.2.and.jloc.le.j1)
!cw     1 kb(iloc,jloc)=13
!cw      iloc=562-mylon*i2
!cw      jloc=541-mylat*j2
!cw      if(iloc.ge.2.and.iloc.le.i1.and.jloc.ge.2.and.jloc.le.j1)
!cw     1 kb(iloc,jloc)=13


      it=mylon*i2
      jt=mylat*j2
      do 158 j=1,j0
      do 158 i=1,i0
      in(i,j,1)=ing(it+i,jt+j)
      n=in(i,j,1)
 158  if (in(i,j,1).ne.2) kb(i,j)=0
       do j=2,j1
       do i=2,i1
       if(ydeg(j).ge.36..and.ydeg(j).le.36.5.and.xdeg(i).ge.354.and.xdeg(i).le.356)then
        write(*,*)'topo2',i,j
        do jj=j+6,j-8,-1
         write(*,'(a,11i4)')'toin2',in(i-5:i+5,jj,1)
        enddo
       endif
       enddo
       enddo

      do 159 k=1,k1
      do 159 j=1,j0
      do 159 i=1,i0
 159  in(i,j,k)=0

       do j=2,j1
       do i=2,i1
       if(ydeg(j).ge.36..and.ydeg(j).le.36.5.and.xdeg(i).ge.354.and.xdeg(i).le.356)then
        write(*,*)'topo2',i,j
        do jj=j+6,j-8,-1
         write(*,'(a,11i4)')'topo2',kb(i-5:i+5,jj)
        enddo
       endif
       enddo
       enddo

!     do 8886 j=j1,2,-1
!8886 write(*,8887) j,(kb(i,j),i=1,122)
!8887 format(i3,1x,122i1)
!     do 8888 j=j1,2,-1
!8888 write(*,8887) j,(kb(i,j),i=121,242)
!     do 8889 j=j1,2,-1
!8889 write(*,8887) j,(kb(i,j),i=241,362)

! redefine in with exterraneous pools eliminated

      do 162 j=2,j1
      do 162 i=1,i0
      it=kb(i,j)
      if (it.ne.0) go to 160
      kb(i,j)=1
      go to 162
 160  do 161 k=1,it
 161  in(i,j,k)=1
 162  continue


       do j=2,j1
       do i=2,i1
       if(ydeg(j).ge.36..and.ydeg(j).le.36.5.and.xdeg(i).ge.354.and.xdeg(i).le.356)then
        write(*,*)'topo3',i,j
        do jj=j+6,j-8,-1
        write(*,'(a,11i4)')'topo3',kb(i-5:i+5,jj)
        enddo
       endif
       enddo
       enddo

! periodic
      call mpi_type_vector(1,i0,j0,mpi_integer2,m_vlat_2di,ierr)
      call mpi_type_commit(m_vlat_2di,ierr)
      call mpi_sendrecv(kb(1,2),1,m_vlat_2di,m_s,1,kb(1,j0),1,m_vlat_2di,m_n,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(kb(1,j1),1,m_vlat_2di,m_n,1,kb(1,1),1,m_vlat_2di,m_s,1,mpi_comm_world,istat,ierr)

      call mpi_type_vector(k1,i0,i0*j0,mpi_integer2, m_vlat_2di,ierr)
      call mpi_type_commit(m_vlat_2di,ierr)
      call mpi_sendrecv(in(1,2,1),1,m_vlat_2di,m_s,1,in(1,j0,1),1,m_vlat_2di,m_n,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(in(1,j1,1),1,m_vlat_2di,m_n,1,in(1,1,1),1,m_vlat_2di,m_s,1,mpi_comm_world,istat,ierr)


!cw check
!       do i=2,i1
!       do j=2,j1
!       it=i+(mylon)*i2-1
!       jt=j+(mylat)*j2-1
!       if(it.eq.107.and.jt.eq.144) print*,'2 kb 107 144=',kb(i,j)
!       if(it.eq.116.and.jt.eq.144) print*,'2 kb 116 144=',kb(i,j)
!       if(it.eq.117.and.jt.eq.144) print*,'2 kb 117 144=',kb(i,j)
!       enddo
!       enddo






! mask out points having no lateral ventillation
 69   n=0
      do 70 k=2,k1
      do 70 j=2,j1
      do 70 i=2,i1
      if (in(i-1,j,k)+in(i+1,j,k)+in(i,j-1,k)+in(i,j+1,k).ne.0) go to 70
      if (in(i,j,k).ne.0) n=n+1
      in(i,j,k)=0
 70   continue
      write(*,71) n
 71   format('mask out',i4,' points having no lateral ventillation')
      if (n.ne.0) go to 69
! redefine kb based on modified in
      do 72 k=2,k1
      do 72 j=2,j1
      do 72 i=2,i1
      if (in(i,j,k).eq.1) go to 72
      if (in(i,j,k-1).eq.1) kb(i,j)=k-1
! this may be redundant
      kb(i,j)=max(1,kb(i,j))
 72   continue

       do j=2,j1
       do i=2,i1
       if(ydeg(j).ge.36..and.ydeg(j).le.36.5.and.xdeg(i).ge.354.and.xdeg(i).le.356)then
        write(*,*)'topo4',i,j
        do jj=j+6,j-8,-1
        write(*,'(a,11i4)')'topo4',kb(i-5:i+5,jj)
        enddo
       endif
       enddo
       enddo

! periodic
      call mpi_barrier(mpi_comm_world,ierr)
      call mpi_type_vector(1,i0,j0,mpi_integer2,m_vlat_2di,ierr)
      call mpi_type_commit(m_vlat_2di,ierr)
      call mpi_type_vector(j0,1,i0,mpi_integer2,m_vlon_2di,ierr)
      call mpi_type_commit(m_vlon_2di,ierr)
      call mpi_sendrecv(kb(1,2),1,m_vlat_2di,m_s,1,kb(1,j0),1,m_vlat_2di,m_n,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(kb(1,j1),1,m_vlat_2di,m_n,1,kb(1,1),1,m_vlat_2di,m_s,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(kb(2,1),1,m_vlon_2di,m_w,1,kb(i0,1),1,m_vlon_2di,m_e,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(kb(i1,1),1,m_vlon_2di,m_e,1,kb(1,1),1,m_vlon_2di,m_w,1,mpi_comm_world,istat,ierr)


      call mpi_barrier(mpi_comm_world,ierr)
      call mpi_type_vector(k1,i0,i0*j0,mpi_integer2,m_vlat_2di,ierr)
      call mpi_type_commit(m_vlat_2di,ierr)
      call mpi_type_vector(k1*j0,1,i0,mpi_integer2,m_vlon_2di,ierr)
      call mpi_type_commit(m_vlon_2di,ierr)
      call mpi_sendrecv(in(1,2,1),1,m_vlat_2di,m_s,1,in(1,j0,1),1,m_vlat_2di,m_n,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(in(1,j1,1),1,m_vlat_2di,m_n,1,in(1,1,1),1,m_vlat_2di,m_s,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(in(2,1,1),1,m_vlon_2di,m_w,1,in(i0,1,1),1,m_vlon_2di,m_e,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(in(i1,1,1),1,m_vlon_2di,m_e,1,in(1,1,1),1,m_vlon_2di,m_w,1,mpi_comm_world,istat,ierr)
      call mpi_barrier(mpi_comm_world,ierr)



!cw check
!       do i=2,i1
!       do j=2,j1
!       it=i+(mylon)*i2-1
!       jt=j+(mylat)*j2-1
!       if(it.eq.107.and.jt.eq.144) print*,'3 kb 107 144=',kb(i,j)
!       if(it.eq.116.and.jt.eq.144) print*,'3 kb 116 144=',kb(i,j)
!       if(it.eq.117.and.jt.eq.144) print*,'3 kb 117 144=',kb(i,j)
!       enddo
!       enddo


! other mask arrays

      do 64 k=1,k1
      do 64 j=1,j0
      do 64 i=1,i1
 64   iu(i,j,k)=in(i,j,k)*in(i+1,j,k)

      do 65 k=1,k1
      do 65 j=1,j1
      do 65 i=1,i0
 65   iv(i,j,k)=in(i,j,k)*in(i,j+1,k)

      do 66 k=1,k2
      do 66 j=1,j0
      do 66 i=1,i0
 66   iw(i,j,k+1)=in(i,j,k)*in(i,j,k+1)


      do k=1,k1
       jt=(k-1)*j0
       do j=1,j0
        ise(jt+j)=iu(i1,j,k)
        isw(jt+j)=iu(2,j,k)
       enddo
      enddo
      do k=1,k1
       it=(k-1)*i0
       do i=1,i0
        isn(it+i)=iv(i,j2,k)
        iss(it+i)=iv(i,2,k)
       enddo
      enddo

      nlon=j0*k1
      nlat=i0*k1

      call mpi_barrier(mpi_comm_world,ierr)
      call mpi_sendrecv(isw,nlon,mpi_integer2,m_w,1,ire,nlon,mpi_integer2,m_e,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(ise,nlon,mpi_integer2,m_e,1,irw,nlon,mpi_integer2,m_w,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(iss,nlat,mpi_integer2,m_s,1,irn,nlat,mpi_integer2,m_n,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(isn,nlat,mpi_integer2,m_n,1,irs,nlat,mpi_integer2,m_s,1,mpi_comm_world,istat,ierr)

      do k=1,k1
       jt=(k-1)*j0
        do j=1,j0
         ise(jt+j)=iu(i2,j,k)
         isw(jt+j)=iu(3,j,k)
         iu(i0,j,k)=ire(jt+j)
         iu(1,j,k)=irw(jt+j)
       enddo
      enddo
      if (mylat .ne.ngy1) then
      do k=1,k1
       it=(k-1)*i0
       do i=1,i0
        iv(i,j0,k)=irn(it+i)
       enddo
      enddo
      endif

      if (mylat .ne. 0) then
      do k=1,k1
       it=(k-1)*i0
       do i=1,i0
        iv(i,0,k)=irs(it+i)
       enddo
      enddo
      endif

      call mpi_barrier(mpi_comm_world,ierr)
      call mpi_sendrecv(isw,nlon,mpi_integer2,m_w,1,ire,nlon,mpi_integer2,m_e,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(ise,nlon,mpi_integer2,m_e,1,irw,nlon,mpi_integer2,m_w,1,mpi_comm_world,istat,ierr)

      do k=1,k1
       jt=(k-1)*j0
       do j=1,j0
        iu(i0+1,j,k)=ire(jt+j)
        iu(0,j,k)=irw(jt+j)
       enddo
      enddo
      do j=2,j1
       do i=0,i0+1
        iu0(i,j)=iu(i,j,1)
        iu(i,j,1)=1
       enddo
      enddo
      do j=0,j0
      do i=2,i1
        iv0(i,j)=iv(i,j,1)
        iv(i,j,1)=1
       enddo
      enddo

      if(mylat.eq.0)then
        do i=1,i0
         iv(i,0,1)=0
         iv(i,1,1)=0
        enddo    
      endif
      if(mylat.eq.ngy1)then
        do i=1,i0
         iv(i,j0,1)=0
         iv(i,j1,1)=0
        enddo
      endif                    

!      write(60) tlz,z,odz,odzw,kb,in,iu,iv,iw,iu0,iv0
!      write(60) rmets
      call wr8nc_zkb  !dog
! ===================================================================
! coupling to 1/8 deg resolution tai and gom grids; one may still run
! entire medina model with coupling to global model, because it uses
! no equatorial shelf.
! this global model, the medina model and norpa! tai grid all fit in
! the memory of a single "fast" processor, but may run less than a
! day per hour of cpu. with one way coupling and separate processors
! for each model, the speed will be almost as fast as the full norpac
! duo grid model.
! ===================================================================
! write rmets data for tai grid (at 150 deg e)
! this covers coupling region with tai grid (j0=488 in tai grid)
! from equator northward
!      open(80,file='tai_kbe')
!      write(80,80) (kb(601,j),kb(601,j),j=399,642)
! 80   format(40i3)
!      open(81,file='gom_kbe')
! write rmets data for gom grid (at 300 deg e)
! this covers coupling region with gom grid (j0=336 in gom grid)
! from 10 deg latitude to 46 deg n
!      write(81,80) (kb(1201,j),kb(1201,j),j=439,606)
!      write(*,99) (j,(in(i,j,1),i=1,140),j=j0,1,-1)
! 99   format(i3,1x,140i1)

      call initfs

end subroutine
! ****************
! initialization *
! ****************
! ----------------------------------------------------------------------
subroutine pre(ax,ay,bb,cx,cy,rinv,rinv1,hh,ie)
! ----------------------------------------------------------------------
      real*8 rinv,rinv1,hh,run,rtp,rtemp,rp
      dimension ax(i2,j2),ay(i2,j2),bb(i2,j2),cx(i2,j2),cy(i2,0:j2),rinv(ibir,i0,nbg0),rinv1(ibir,i0,nbg1),hh(i0,j0),ie(nb0),rp(i0t*i0t),rtemp(i2t,i0t),rtp(i2t,i2t),ipvt(i2t)
      dimension axt(i2,j2),ayt(i2,j2),bbt(i2,j2),cxt(i2,j2),cyt(i2,j2),ct(i2)

      do 100 ng=1,ngy0
      jl=1
      if (mylat .eq. ng-1) then
      do 99 j=1,j2
      do 99 i=1,i2
      axt(i,j)=ax(i,j)
      ayt(i,j)=ay(i,j)
      bbt(i,j)=bb(i,j)
      cxt(i,j)=cx(i,j)
 99   cyt(i,j)=cy(i,j)
      endif
      if (mylat .eq. ng-2) then
      do 98 i=1,i2
 98   ct(i)=cy(i,j2)
      endif
      nsd=i2*j2
      call mpi_bcast(axt,nsd,mpi_real8,ng-1,m_comm_lat,ierr)
      call mpi_bcast(ayt,nsd,mpi_real8,ng-1,m_comm_lat,ierr)
      call mpi_bcast(bbt,nsd,mpi_real8,ng-1,m_comm_lat,ierr)
      call mpi_bcast(cxt,nsd,mpi_real8,ng-1,m_comm_lat,ierr)
      call mpi_bcast(cyt,nsd,mpi_real8,ng-1,m_comm_lat,ierr)
      if (ng .ne. 1)call mpi_bcast(ct,i2,mpi_real8,ng-2,m_comm_lat,ierr)

      if (mylat .eq. ng-1) then
      do 97 i=1,i2
 97   cy(i,0)=ct(i)
      endif
      do 100 nb=1,nb0
      nbg=(ng-1)*nb0+nb
      write(*,111) nbg,nbg0
 111  format ('processing block #',i3,' out of ',i3,' total evp solver')
      jh=ie(nb)
      jhp=jh+1
      jhm=jh-2
      jg=jl+1
      do 250 ii=1,ibir
      ig=mylat*ibir+ii
      idxy=(ig-1)/i2
      do 210 j=jl,jhp
      do 210 i=1,i0
 210  hh(i,j)=0.d0
      if (idxy .eq. mylon) then
      if (mod(ig,i2) .eq. 0) then
      hh(i1,jg)=1.d0
      else
      hh(mod(ig,i2)+1,jg)=1.d0
      endif
      endif
      call mpi_sendrecv(hh(2,jg),1,mpi_real8,m_w,1,hh(i0,jg),1,mpi_real8,m_e,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(hh(i1,jg),1,mpi_real8,m_e,1,hh(1,jg),1,mpi_real8,m_w,1,mpi_comm_world,istat,ierr)
      if (nbg .eq. 1) go to 220
      if (idxy .eq. mylon) then
      if (nb .ne. 1) then
       if (mod(ig,i2) .eq. 0) then
       ctemp=cyt(i2,jg-2)
       else
       ctemp=cyt(mod(ig,i2),jg-2)
       endif
      else
       if (mod(ig,i2) .eq. 0) then
       ctemp=ct(i2)
       else
       ctemp=ct(mod(ig,i2))
       endif
      endif
      endif
      call mpi_bcast(ctemp,1,mpi_real8,idxy,m_comm_lon,ierr)
      do 218 n=1,i0
 218  hh(n,jl)=rinv1(ii,n,nbg-1)*ctemp
 220  continue
      do 226 j=jl,jhm
      do 225 i=1,i2
 225  hh(i+1,j+2)=-(axt(i,j)*hh(i,j+1)+ayt(i,j)*hh(i+1,j)+bbt(i,j)*hh(i+1,j+1)+cxt(i,j)*hh(i+2,j+1))/cyt(i,j)
      call mpi_sendrecv(hh(2,j+2),1,mpi_real8,m_w,1,hh(i0,j+2),1,mpi_real8,m_e,1,mpi_comm_world,istat,ierr)
 226  call mpi_sendrecv(hh(i1,j+2),1,mpi_real8,m_e,1,hh(1,j+2),1,mpi_real8,m_w,1,mpi_comm_world,istat,ierr)
      j=jh-1
      do 230 i=1,i2
 230  rinv(ii,i+1,nbg)=axt(i,j)*hh(i,j+1)+ayt(i,j)*hh(i+1,j)+bbt(i,j)*hh(i+1,j+1)+cxt(i,j)*hh(i+2,j+1)

      if (nbg.eq.nbg0) go to 250
      j=ie(nb)
      do 240 n=1,i0
 240  rinv(ii,n,nbg0)=hh(n,j)
      if (idxy .eq. mylon) then
      if (mod(ig,i2) .eq. 0) then
      hh(i1,jg)=0.d0
      else
      hh(mod(ig,i2)+1,jg)=0.d0
      endif
      endif
 250  continue

      nsend=i2*ibir

      call mpi_gather(rinv(1,2,nbg),nsend,mpi_real8,rp(1),nsend,mpi_real8,0,mpi_comm_world,ierr)
      if (myid .eq. 0) then
      do 497 nx=1,ngx0
      ngxt=(nx-1)*ngy0
      do 497 ny=1,ngy0
      ngt=((ny-1)+ngxt)*ibir*i2
      do 497 j=1,i2
      nt=ngt+(j-1)*ibir
      jt=j+(nx-1)*i2
      do 497 i=1,ibir
      it=i+(ny-1)*ibir
 497  rtemp(it,jt)=rp(nt+i)

      do 498 i=1,i2t
      do 498 j=1,i2t
 498  rtp(j,i)=0.d0
      do 499 i=1,i2t
 499  rtp(i,i)=1.d0
      call dgesv(i2t,i2t,rtemp,i2t,ipvt,rtp,i2t,info)
      do 500 i=1,i2t
      do 500 j=1,i2t
 500  rtemp(j,i)=rtp(i,j)
      endif

      call mpi_bcast(info,1,mpi_integer,0,mpi_comm_world,ierr)
      if (info .ne. 0) then
      print*,'preporcessor failed because rinv is singular at nbg =',nbg
      stop
      endif
      nsend=i2t*i2t
      call mpi_bcast(rtp,nsend,mpi_real8,0,mpi_comm_world,ierr)
      it=mylon*i2
      jt=mylat*ibir

      jss=1
      jff=i0
      if (mylon .eq.0) then
      do 501 i=1,ibir
 501  rinv(i,1,nbg)=rtp(jt+i,i2t)
      jss=2
      endif
      if (mylon .eq. ngx1) then
      do 502 i=1,ibir
 502  rinv(i,i0,nbg)=rtp(jt+i,1)
      jff=i1
      endif
      do 503 j=jss,jff
      do 503 i=1,ibir
 503  rinv(i,j,nbg)=rtp(jt+i,it+j-1)

      if (nbg.eq.nbg0) return
      nsend=i0*ibir
      call mpi_allgather(rinv(1,1,nbg0),nsend,mpi_real8,rp,nsend,mpi_real8,m_comm_lat,ierr)
      do 504 ny=1,ngy0
      ngt=(ny-1)*ibir*i0
      do 504 j=1,i0
      nt=ngt+(j-1)*ibir
      do 504 i=1,ibir
      it=i+(ny-1)*ibir
 504  rtemp(it,j)=rp(nt+i)

      it=ibir*mylat
      do 300 i=1,ibir
      do 300 j=1,i0
      rinv1(i,j,nbg)=0.d0
      do 300 k=1,i2t
 300  rinv1(i,j,nbg)=rinv1(i,j,nbg)-rtp(it+i,k)*rtemp(k,j)
      jl=jh

 100  call mpi_barrier(mpi_comm_world,ierr)

end subroutine

! ----------------------------------------------------------------------
subroutine pre2(ax,ay,bb,cx,cy,rinv,rinv1,hh,ie)
! ----------------------------------------------------------------------
      real*8 rinv,rinv1,h,run,rtp,rtemp,rp
      dimension ax(i2,j2),ay(i2,j2),bb(i2,j2),cx(i2,j2),cy(i2,0:j2),rinv(ibir,i0,nbg0),rinv1(ibir,i0,nbg1),hh(i0,j0),ie(nb0),rp(ig0*ig0),rtemp(ig2,ig0),rtp(ig2,ig2),ipvt(ig2)
      dimension axt(i2,j2),ayt(i2,j2),bbt(i2,j2),cxt(i2,j2),cyt(i2,j2),ct(i2)

!      if (myid .eq. 0)
      do 100 ng=1,ngy0
      jl=1
      if (mylat .eq. ng-1) then
      do 99 j=1,j2
      do 99 i=1,i2
      axt(i,j)=ax(i,j)
      ayt(i,j)=ay(i,j)
      bbt(i,j)=bb(i,j)
      cxt(i,j)=cx(i,j)
 99   cyt(i,j)=cy(i,j)
      endif
      if (mylat .eq. ng-2) then
      do 98 i=1,i2
 98   ct(i)=cy(i,j2)
      endif
      nsd=i2*j2
      call mpi_bcast(axt,nsd,mpi_real8,ng-1,m_comm_lat,ierr)
      call mpi_bcast(ayt,nsd,mpi_real8,ng-1,m_comm_lat,ierr)
      call mpi_bcast(bbt,nsd,mpi_real8,ng-1,m_comm_lat,ierr)
      call mpi_bcast(cxt,nsd,mpi_real8,ng-1,m_comm_lat,ierr)
      call mpi_bcast(cyt,nsd,mpi_real8,ng-1,m_comm_lat,ierr)
      if (ng .ne. 1) call mpi_bcast(ct,i2,mpi_real8,ng-2,m_comm_lat,ierr)

      if (mylat .eq. ng-1) then
      do 97 i=1,i2
 97   cy(i,0)=ct(i)
      endif
      do 100 nb=1,nb0
      nbg=(ng-1)*nb0+nb
      write(*,111) nbg,nbg0
 111  format ('processing block #',i3,' out of ',i3,' total evp solver')
      jh=ie(nb)
      jhp=jh+1
      jhm=jh-2
      jg=jl+1
      do 250 ii=1,ibir
      ig=mylat*ibir+ii
      idxy=(ig-1)/i2
      do 210 j=jl,jhp
      do 210 i=1,i0
 210  hh(i,j)=0.d0
      if (idxy .eq. mylon) then
      if (mod(ig,i2) .eq. 0) then
      hh(i1,jg)=1.d0
      else
      hh(mod(ig,i2)+1,jg)=1.d0
      endif
      endif
      call mpi_sendrecv(hh(2,jg),1,mpi_real8,m_w,1,hh(i0,jg),1,mpi_real8,m_e,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(hh(i1,jg),1,mpi_real8,m_e,1,hh(1,jg),1,mpi_real8,m_w,1,mpi_comm_world,istat,ierr)
      if (nbg .eq. 1) go to 220
      if (idxy .eq. mylon) then
      if (nb .ne. 1) then
       if (mod(ig,i2) .eq. 0) then
       ctemp=cyt(i2,jg-2)
       else
       ctemp=cyt(mod(ig,i2),jg-2)
       endif
      else
       if (mod(ig,i2) .eq. 0) then
       ctemp=ct(i2)
       else
       ctemp=ct(mod(ig,i2))
       endif
      endif
      endif
      call mpi_bcast(ctemp,1,mpi_real8,idxy,m_comm_lon,ierr)
      do 218 n=1,i0
 218  hh(n,jl)=rinv1(ii,n,nbg-1)*ctemp
 220  continue
      do 226 j=jl,jhm
      do 225 i=1,i2
 225  hh(i+1,j+2)=-(axt(i,j)*hh(i,j+1)+ayt(i,j)*hh(i+1,j)+bbt(i,j)*hh(i+1,j+1)+cxt(i,j)*hh(i+2,j+1))/cyt(i,j)
      call mpi_sendrecv(hh(2,j+2),1,mpi_real8,m_w,1,hh(i0,j+2),1,mpi_real8,m_e,1,mpi_comm_world,istat,ierr)
 226  call mpi_sendrecv(hh(i1,j+2),1,mpi_real8,m_e,1,hh(1,j+2),1,mpi_real8,m_w,1,mpi_comm_world,istat,ierr)
      j=jh-1
      do 230 i=1,i2
 230  rinv(ii,i+1,nbg)=axt(i,j)*hh(i,j+1)+ayt(i,j)*hh(i+1,j)+bbt(i,j)*hh(i+1,j+1)+cxt(i,j)*hh(i+2,j+1)

      if (nbg.eq.nbg0) go to 250
      j=ie(nb)
      do 240 n=1,i0
 240  rinv(ii,n,nbg0)=hh(n,j)
      if (idxy .eq. mylon) then
      if (mod(ig,i2) .eq. 0) then
      hh(i1,jg)=0.d0
      else
      hh(mod(ig,i2)+1,jg)=0.d0
      endif
      endif
 250  continue

      nsend=i2*ibir

      call mpi_gather(rinv(1,2,nbg),nsend,mpi_real8,rp(1),nsend,mpi_real8,0,mpi_comm_world,ierr)
      if (myid .eq. 0) then
      do 497 nx=1,ngx0
      ngxt=(nx-1)*ngy0
      do 497 ny=1,ngy0
      ngt=((ny-1)+ngxt)*ibir*i2
      do 497 j=1,i2
      nt=ngt+(j-1)*ibir
      jt=j+(nx-1)*i2
      do 497 i=1,ibir
      it=i+(ny-1)*ibir
 497  rtemp(it,jt)=rp(nt+i)

      do 498 i=1,ig2
      do 498 j=1,ig2
 498  rtp(j,i)=0.d0
      do 499 i=1,ig2
 499  rtp(i,i)=1.d0
!      write(1233)rtemp
      call dgesv(ig2,ig2,rtemp,ig2,ipvt,rtp,ig2,info)
      do 500 i=1,ig2
      do 500 j=1,ig2
 500  rtemp(j,i)=rtp(i,j)
      endif

      call mpi_bcast(info,1,mpi_integer,0,mpi_comm_world,ierr)
      if (info .ne. 0) then
      print*,'preporcessor failed because rinv is singular at nbg =',nbg
      stop
      endif
      nsend=ig2*ig2
      call mpi_bcast(rtp,nsend,mpi_real8,0,mpi_comm_world,ierr)
      it=mylon*i2
      jt=mylat*ibir

      jss=1
      jff=i0
      if (mylon .eq.0) then
      do 501 i=1,ibir
 501  rinv(i,1,nbg)=rtp(jt+i,ig2)
      jss=2
      endif
      if (mylon .eq. ngx1) then
      do 502 i=1,ibir
 502  rinv(i,i0,nbg)=rtp(jt+i,1)
      jff=i1
      endif
      do 503 j=jss,jff
      do 503 i=1,ibir
 503  rinv(i,j,nbg)=rtp(jt+i,it+j-1)

      if (nbg.eq.nbg0) return
      nsend=i0*ibir
      call mpi_allgather(rinv(1,1,nbg0),nsend,mpi_real8,rp,nsend,mpi_real8,m_comm_lat,ierr)
      do 504 ny=1,ngy0
      ngt=(ny-1)*ibir*i0
      do 504 j=1,i0
      nt=ngt+(j-1)*ibir
      do 504 i=1,ibir
      it=i+(ny-1)*ibir
 504  rtemp(it,j)=rp(nt+i)

      it=ibir*mylat
      do 300 i=1,ibir
      do 300 j=1,i0
      rinv1(i,j,nbg)=0.d0
      do 300 k=1,ig2
 300  rinv1(i,j,nbg)=rinv1(i,j,nbg)-rtp(it+i,k)*rtemp(k,j)
      jl=jh

 100  call mpi_barrier(mpi_comm_world,ierr)

end subroutine

! ----------------------------------------------------------------------
subroutine sipinc(al,ab,ac,ar,at,cl,cb,cc,cr,ct,alpha)
! ----------------------------------------------------------------------
      dimension al(i2,j2),ar(i2,j2),ab(i2,j2),ac(i2,j2),at(i2,0:j2),cl(i2,j2),cr(i2,j2),cb(i2,j2),cc(i2,j2),ct(i2,j2),act(i2,j2)

      do 50 j=1,j2
      do 50 i=1,i2
 50   act(i,j)=ac(i,j)

      cl(1,1)=al(1,1)
      cb(1,1)=ab(1,1)
      cc(1,1)=1/ac(1,1)
      ct(1,1)=at(1,1)*cc(1,1)
      cr(1,1)=ar(1,1)*cc(1,1)
      do 100 i=2,i2
      cl(i,1)=al(i,1)
      cb(i,1)=ab(i,1)/(1+alpha*cr(i-1,1))
      cc(i,1)=1/(act(i,1)+alpha*(cb(i,1)*cr(i-1,1))-cb(i,1)*ct(i-1,1))
      ct(i,1)=at(i,1)*cc(i,1)
 100  cr(i,1)=(ar(i,1)-alpha*cb(i,1)*ar(i-1,1))*cc(i,1)

      do 200 j=2,j2
      cl(1,j)=al(1,j)/(1+alpha*ct(1,j-1))
      cb(1,j)=ab(1,j)
      cc(1,j)=1/(act(1,j)+alpha*(cl(1,j)*ct(1,j-1))-cl(1,j)*cr(1,j-1))
      ct(1,j)=(at(1,j)-alpha*cl(1,j)*ct(1,j-1))*cc(1,j)
      cr(1,j)=ar(1,j)*cc(1,j)
      do 200 i=2,i2
      cl(i,j)=al(i,j)/(1+alpha*ct(i,j-1))
      cb(i,j)=ab(i,j)/(1+alpha*cr(i-1,j))
      cc(i,j)=1/(act(i,j)+alpha*(cl(i,j)*ct(i,j-1)+cb(i,j)*cr(i-1,j))-cl(i,j)*cr(i,j-1)-cb(i,j)*ct(i-1,j))
      ct(i,j)=(at(i,j)-alpha*cl(i,j)*ct(i,j-1))*cc(i,j)
 200  cr(i,j)=(ar(i,j)-alpha*cb(i,j)*cr(i-1,j))*cc(i,j)
end subroutine

! ----------------------------------------------------------------------
subroutine cholinc(al,ab,ac,ar,at,cl,cb,cc,cr,ct)
! ----------------------------------------------------------------------
      dimension al(i2,j2),ar(i2,j2),ab(i2,j2),ac(i2,j2),at(i2,0:j2),cl(i2,j2),cr(i2,j2),cb(i2,j2),cc(i2,j2),ct(i2,j2),act(i2,j2)

      do 50 j=1,j2
      do 50 i=1,i2
 50   act(i,j)=ac(i,j)

      do 100 j=1,j0-3
      do 150 i=1,i0-3
      cc(i,j)=1/sqrt(act(i,j))
      cr(i,j)=ar(i,j)*cc(i,j)
      cl(i,j)=cr(i,j)
      ct(i,j)=at(i,j)*cc(i,j)
      cb(i,j)=ct(i,j)
      act(i+1,j)=act(i+1,j)-ar(i,j)*ar(i,j)*cc(i,j)*cc(i,j)
 150  act(i,j+1)=act(i,j+1)-at(i,j)*at(i,j)*cc(i,j)*cc(i,j)
      cc(i2,j)=1/sqrt(act(i2,j))
      ct(i2,j)=at(i2,j)*cc(i2,j)
      cb(i2,j)=ct(i2,j)
 100  act(i2,j+1)=act(i2,j+1)-at(i2,j)*at(i2,j)*cc(i2,j)*cc(i2,j)

      j=j2
      do 200 i=1,i3
      cc(i,j)=1/sqrt(act(i,j))
      cr(i,j)=ar(i,j)*cc(i,j)
      cl(i,j)=cr(i,j)
 200  act(i+1,j)=act(i+1,j)-ar(i,j)*ar(i,j)*cc(i,j)*cc(i,j)

      cc(i2,j2)=1/sqrt(ac(i2,j2))


end subroutine

! ----------------------------------------------------------------------
subroutine luinc(al,ab,ac,ar,at,cl,cb,cc,cr,ct)
! ----------------------------------------------------------------------
      dimension al(i2,j2),ar(i2,j2),ab(i2,j2),ac(i2,j2),at(i2,0:j2),cl(i2,j2),cr(i2,j2),cb(i2,j2),cc(i2,j2),ct(i2,j2),act(i2,j2)

      do 50 j=1,j2
      do 50 i=1,i2
 50   act(i,j)=ac(i,j)

      do 100 j=1,j0-3
      do 150 i=1,i0-3
      cc(i,j)=1/act(i,j)
      cl(i,j)=al(i,j)*cc(i,j)
      cr(i,j)=ar(i,j)
      cb(i,j)=ab(i,j)*cc(i,j)
      ct(i,j)=at(i,j)
      act(i+1,j)=act(i+1,j)-ar(i,j)*ar(i,j)*cc(i,j)
 150  act(i,j+1)=act(i,j+1)-at(i,j)*at(i,j)*cc(i,j)
      cc(i2,j)=1/act(i2,j)
      cb(i2,j)=ab(i2,j)*cc(i2,j)
      ct(i2,j)=at(i2,j)
 100  act(i2,j+1)=act(i2,j+1)-at(i2,j)*at(i2,j)*cc(i2,j)
      j=j2
      do 200 i=1,i3
      cc(i,j)=1/act(i,j)
      cl(i,j)=al(i,j)*cc(i,j)
      cr(i,j)=ar(i,j)
 200  act(i+1,j)=act(i+1,j)-ar(i,j)*ar(i,j)*cc(i,j)

      cc(i2,j2)=1/ac(i2,j2)
end subroutine

! ---------------------------------------------------------------------
subroutine bounds
! ----------------------------------------------------------------------
      real*8 mpd,sltd,pisd,p01,p02,sb8,rb8,dg
      dimension ttemp(i0,j0,k1),stemp(i0,j0,k1)

      call mpi_type_vector(k1*j0,1,i0,mpi_real8,m_vlon,ierr) !dog
      call mpi_type_vector(k1,i0,i0*j0,mpi_real8,m_vlat,ierr)
      call mpi_type_commit(m_vlon,ierr)
      call mpi_type_commit(m_vlat,ierr)
      
      call rdnc_levitus(1)   !dog
!      read(70) s1,t1


      do 32 n=1,50

      write(*,20) n
 20   format('iteration #',i3)


      do 31 k=1,k1
      smin=100.
      smax=0.
      tmin=100.
      tmax=0.
      do 30 j=2,j1
      do 30 i=2,i1
      m=in(i-1,j,k)+in(i+1,j,k)+in(i,j-1,k)+in(i,j+1,k)
      if (m*in(i,j,k).eq.0) go to 30
      tmp=1./m
      ttemp(i,j,k)=tmp*(in(i+1,j,k)*t1(i+1,j,k)+in(i-1,j,k)*t1(i-1,j,k)+in(i,j+1,k)*t1(i,j+1,k)+in(i,j-1,k)*t1(i,j-1,k))
      stemp(i,j,k)=tmp*(in(i+1,j,k)*s1(i+1,j,k)+in(i-1,j,k)*s1(i-1,j,k)+in(i,j+1,k)*s1(i,j+1,k)+in(i,j-1,k)*s1(i,j-1,k))
      smin=min(smin,stemp(i,j,k))
      smax=max(smax,stemp(i,j,k))
      tmin=min(tmin,ttemp(i,j,k))
      tmax=max(tmax,ttemp(i,j,k))
 30   continue
 31   continue
      do 33 k=1,k1
      do 33 j=2,j1
      do 33 i=2,i1
      t1(i,j,k)=ttemp(i,j,k)
      s1(i,j,k)=stemp(i,j,k)
 33   continue      
      call mpi_sendrecv(s1(2,1,1),1,m_vlon,m_w,1,s1(i0,1,1),1,m_vlon,m_e,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(s1(i1,1,1),1,m_vlon,m_e,1,s1(1,1,1),1,m_vlon,m_w,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(s1(1,2,1),1,m_vlat,m_s,1,s1(1,j0,1),1,m_vlat,m_n,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(s1(1,j1,1),1,m_vlat,m_n,1,s1(1,1,1),1,m_vlat,m_s,1,mpi_comm_world,istat,ierr)

      call mpi_sendrecv(t1(2,1,1),1,m_vlon,m_w,1,t1(i0,1,1),1,m_vlon,m_e,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(t1(i1,1,1),1,m_vlon,m_e,1,t1(1,1,1),1,m_vlon,m_w,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(t1(1,2,1),1,m_vlat,m_s,1,t1(1,j0,1),1,m_vlat,m_n,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(t1(1,j1,1),1,m_vlat,m_n,1,t1(1,1,1),1,m_vlat,m_s,1,mpi_comm_world,istat,ierr)
      call mpi_barrier(mpi_comm_world,ierr)
 32   continue
! levitus initial conditions have been modified
! now, we check for statically unstable points that may exist
 50   do 55 k=1,k1
      do 55 j=2,j1
      do 55 i=2,i1
      tmpd=t1(i,j,k)
      sltd=s1(i,j,k)
      pisd=.001*z(2*k)
! dan wright's full e.o.s.
!     rho(i,j,k)=r(tmp,slt,pis)
!     function r(t,s,p)
      p02=1747.4508988+tmpd*(11.51588-0.046331033*tmpd)-sltd*(3.85429655+0.01353985*tmpd)
      p01=pisd+5884.81703666+tmpd*(39.803732+tmpd*(-0.3191477+tmpd*0.0004291133))+2.6126277*sltd
 55   d1(i,j,k)=p01/(p02+0.7028423*p01)

      do 57 k=2,k1
      n=0
      do 56 j=2,j1
      do 56 i=2,i1
      if (in(i,j,k).eq.0.or.d1(i,j,k).ge.d1(i,j,k-1)) go to 56
      n=n+1
      t1(i,j,k)=t1(i,j,k-1)
      s1(i,j,k)=s1(i,j,k-1)
      tmpd=t1(i,j,k)
      sltd=s1(i,j,k)
      pisd=.001*z(2*k)
      p02=1747.4508988+tmpd*(11.51588-0.046331033*tmpd)-sltd*(3.85429655+0.01353985*tmpd)
      p01=pisd+5884.81703666+tmpd*(39.803732+tmpd*(-0.3191477+tmpd*0.0004291133))+2.6126277*sltd
      d1(i,j,k)=p01/(p02+0.7028423*p01)
 56   continue
 57   write(*,58) n,k
 58   format(i6,' unstable points at level',i3)

! periodic
! remark that there doesn't not exchange the b.c. the b! will be exchange in fsglo

! write climatology based initial conditions
! climatology is modified in prep program

! wenien
!      open(69,file='data/initial'//grd,form='unformatted')
!      write(69) s1,t1
!      close(69)
      call wr8nc_preini  !dog

! 199  rewind 70

!      if (.false.) then
! seasonal boundary conditions


      do 7000 nm=1,12
      write(*,238) nm
 238  format('month',i3,' in bounds')

! read in monthly t,s boundary climatologies
      call rdnc_levitus(nm) !dog
!      read(70) s1,t1

      smin=100.
      smax=0.
      tmin=100.
      tmax=0.

      do 2400 k=1,k1
      do 2400 j=2,j1
      do 2400 i=2,i1
      s1(i,j,k)=min(max(s1(i,j,k),smax),smin)
 2400 t1(i,j,k)=min(max(t1(i,j,k),tmax),tmin)

      do 240 j=2,j1
      do 240 i=2,i1
      tsurf(i-1,j-1,nm)=t1(i,j,1)
 240  ssurf(i-1,j-1,nm)=s1(i,j,1)


      do 260 k=1,k1
      avg1=0.
      avg2=0.
      areaxy=0.
      smax=0.
      smin=100.
      do 250 j=2,j1
      tmp=dx(j)*dy(j)

      do 250 i=2,i1
      temp=s1(i,j,k)
      s1(i,j,k)=max(s1(i,j,k),25.)
      if (in(i,j,k).eq.0) go to 250
      smax=max(smax,s1(i,j,k))
      smin=min(smin,s1(i,j,k))

      if (s1(i,j,k).eq.25.) write(*,29) i,j,k,temp,s1(i,j,k)
 29   format('fixed bad point i,j,k,s1bad,s1fix=',3i5,2f5.1)

      areaxy=areaxy+tmp
      avg1=avg1+tmp*t1(i,j,k)
      avg2=avg2+tmp*s1(i,j,k)
 250  continue

      tp=avg1
      call mpi_allreduce(tp,avg1,1,mpi_real8,mpi_sum,mpi_comm_world,ierr)
      tp=avg2
      call mpi_allreduce(tp,avg2,1,mpi_real8,mpi_sum,mpi_comm_world,ierr)
      tp=areaxy
      call mpi_allreduce(tp,areaxy,1,mpi_real8,mpi_sum,mpi_comm_world,ierr)


      write(*,251) nm,k,smin,smax,avg2/areaxy
 251  format('nm,k,smin,smax,savg=',2i3,1x,3f5.1)

!      if(areaxy.eq.0.) print*,mylon,'_',mylat,'k=',k,'areaxy=',areaxy

      txycli(k,nm)=avg1/areaxy
 260  sxycli(k,nm)=avg2/areaxy

      write(*,261) nm,(sxycli(k,nm),k=1,k1)
 261  format(i2/(21f5.1))

! sponge layer climatology
! k=1 is included in ssurf, tssurf
! le
! generally, j0 will not less than 10, so there requires to fix tssp etc.,
! if j0 is less than 10.
      if (mylat .eq. 0) then
!      do 270 k=1,k1
!      do 270 j=1,j2t/18
      do 270 k=2,k1
      do 270 j=1,10
      do 270 i=2,i1
!      tssp(i-1,j,k,nm)=t1(i,j+1,k)
! 270  sssp(i-1,j,k,nm)=s1(i,j+1,k)
      tssp(i-1,j,k-1,nm)=t1(i,j+1,k)
 270  sssp(i-1,j,k-1,nm)=s1(i,j+1,k) 
      endif

      if (mylat .eq. ngy0-1) then
!      do 280 k=1,k1
!      do 280 j=1,j2t/18
      do 280 k=2,k1
      do 280 j=1,10
      do 280 i=2,i1
!      tnsp(i-1,j,k,nm)=t1(i,j0-j,k)
! 280  snsp(i-1,j,k,nm)=s1(i,j0-j,k)
      tnsp(i-1,j,k-1,nm)=t1(i,j0-j,k)
 280  snsp(i-1,j,k-1,nm)=s1(i,j0-j,k)
      endif

 7000 continue


! although the following is superfluous when using seasonal climatology,
! (because the model uses linear interpolations anyway),
! we will need 12-month arrays when we use the monthly climatology

! interpolate tsurf, ssurf in time
      tmp=1./3.
      tem=2./3.
      do 600 n=1,10,3
      nm=n+3
      if (nm.eq.13) nm=1
      do 600 j=1,j2
      do 600 i=1,i2
      tsurf(i,j,n+1)=tsurf(i,j,n)+tmp*(tsurf(i,j,nm)-tsurf(i,j,n))
      tsurf(i,j,n+2)=tsurf(i,j,n)+tem*(tsurf(i,j,nm)-tsurf(i,j,n))
      ssurf(i,j,n+1)=ssurf(i,j,n)+tmp*(ssurf(i,j,nm)-ssurf(i,j,n))
 600  ssurf(i,j,n+2)=ssurf(i,j,n)+tem*(ssurf(i,j,nm)-ssurf(i,j,n))

! interpolate seasonal sponge climatologies
      do 650 n=1,10,3
      nm=n+3
      if (nm.eq.13) nm=1
      do 648 k=1,k1
      txycli(k,n+1)=txycli(k,n)+tmp*(txycli(k,nm)-txycli(k,n))
      txycli(k,n+2)=txycli(k,n)+tem*(txycli(k,nm)-txycli(k,n))
      sxycli(k,n+1)=sxycli(k,n)+tmp*(sxycli(k,nm)-sxycli(k,n))
 648  sxycli(k,n+2)=sxycli(k,n)+tem*(sxycli(k,nm)-sxycli(k,n))
!      do 650 k=1,k1
!      do 650 j=1,j2t/18
      do 650 k=1,k2
      do 650 j=1,10
      do 650 i=1,i2
      tssp(i,j,k,n+1)=tssp(i,j,k,n)+tmp*(tssp(i,j,k,nm)-tssp(i,j,k,n))
      tssp(i,j,k,n+2)=tssp(i,j,k,n)+tem*(tssp(i,j,k,nm)-tssp(i,j,k,n))
      tnsp(i,j,k,n+1)=tnsp(i,j,k,n)+tmp*(tnsp(i,j,k,nm)-tnsp(i,j,k,n))
      tnsp(i,j,k,n+2)=tnsp(i,j,k,n)+tem*(tnsp(i,j,k,nm)-tnsp(i,j,k,n))
      sssp(i,j,k,n+1)=sssp(i,j,k,n)+tmp*(sssp(i,j,k,nm)-sssp(i,j,k,n))
      sssp(i,j,k,n+2)=sssp(i,j,k,n)+tem*(sssp(i,j,k,nm)-sssp(i,j,k,n))
      snsp(i,j,k,n+1)=snsp(i,j,k,n)+tmp*(snsp(i,j,k,nm)-snsp(i,j,k,n))
 650  snsp(i,j,k,n+2)=snsp(i,j,k,n)+tem*(snsp(i,j,k,nm)-snsp(i,j,k,n))

! write surface climatology t,s and specified inflow velocities
!      write(62) ssurf,tsurf,sssp,snsp,tssp,tnsp
!      write(62) sxycli,txycli
      call wr8nc_boundaries !dog
end subroutine
! ----------------------------------------------------------------------

subroutine initfs
! initfs initializes all controlling arrays and derived scalars
!(scalar control parameters are set in block data at start of this file)
! ----------------------------------------------------------------------

      dt=172800./daodt
      odt=1./dt
      orzmx=1./rzmx
      ofltw=1.-2.*fltw

      mvi=mvfreq*daodt
      prn=dm0/de0

! ====================================================
! set background vertical eddy viscosity & diffusivity
! ====================================================
      do 90 k=1,k2
! augment molecular viscosity & diffusivity by parameterized synopti! wind
! events, and by breaking (u,v,t,s, near surface only) and non-breaking
! (u,v only, at all rmetss) internal waves.
! synopti! wind forced mixing having 20m e-folding scale.
! bigger momentum mixing due to pressure-xfers
! associated with internal waves that have no counterpart in t,s xfers.
! after yr 7
! 10m scale height for t,s mixing due to breaking internal waves
       tmpts=exp(-.001*(z(2*k+1)-z(3)))
!
! deeper tmpuv enhancement is motivated by findings of hurlburt & hogan
! that deep bathymetry and deep transient eddies influences gs path.
! tmpts is not enhanced (layer model has none across layer interface!)
! 1000m scale height for u,v mixing (due to pressure-xfers even without
! internal wave breaking). this enhances deep bathymetry effe!cts on
! upper level flow (e.g., gs separation, kuroshio meanders)
       tmpuv=exp(-.00001*(z(2*k+1)-z(3)))
      vbk(k)=.01+.05*tmpuv
 90   hbk(k)=.002+.02*tmpts
!      write(8) vbk,hbk
!      close(8)
      call wr8nc_winmx    !dog

      if(myid.eq.0)then
      write(*,91) (k,int(.01*z(2*k+1)),vbk(k),hbk(k),k=1,k2)
!      write(7,91) (k,int(.01*z(2*k+1)),vbk(k),hbk(k),k=1,k2)
 91   format(' K    Z    VBK    HBK'/(i2,i5,2f7.3))
      endif

! wenien
!      write(9) case,dscrib,dt,tlz,b,g,dm0,de0,dmz0,f,tanphi,rzmx,drag,fltw,daodt,odt,prn,orzmx,ofltw,y,yv,yvdeg,ydeg,cs,csv,ocs,ocsv,dx,dxv,odx,odxv,dy,dyv,ody,odyv,ktrm,lrstrt,mxit,isav,mxsav,lopen,lmovi,mvi,lfsrf,lsolver,xdeg,lprecon,rawf

!      close(9)
      call wr8nc_rundata !dog
      call mpi_barrier(mpi_comm_world,ierr)

      call bounds

      if (lsolver.eq.0) then
      print*,'preprocessor running without solver setting has finished.'
      stop 0
      endif

      do 250 n=1,nb0
 250  ie(n)=min(1+n0*n,j1)
!      write(*,251) ie
! 251  format('ie'/(20i4))
      if (ie(nb0).gt.ie(nb1).and.j1.lt.ie(nb1)+9) go to 260
!      write(17,252) ie(nb1),j1
      write(*,252) ie(nb1),j1
 252  format('ie(nb1),j1=',2i5,' not properly defined. Fix above do 250 loop and restart.')

 260  ie(nb0)=j1


! preprocessor for ellipti! solver used to maintain
! incompressibility for rigid-lid hydrostati! flows
! first, do top layer (all water to regularize evp domain)
      tmp=1./odz(1)
      do 280 j=1,j2
      dzx=odx(j+1)**2*tmp
      dzyb=csv(j)*ocs(j+1)*odyv(j)*ody(j+1)*tmp
      dzyt=csv(j+1)*ocs(j+1)*odyv(j+1)*ody(j+1)*tmp
      do 280 i=1,i2
      al(i,j)=dzx
      ar(i,j)=dzx
      ab(i,j)=dzyb
 280  at(i,j)=dzyt
! remaining layers
      do 282 k=2,k1
      tmp=1./odz(k)
      do 282 j=1,j2
      dzx=odx(j+1)**2*tmp
      dzyb=csv(j)*ocs(j+1)*odyv(j)*ody(j+1)*tmp
      dzyt=csv(j+1)*ocs(j+1)*odyv(j+1)*ody(j+1)*tmp
      do 282 i=1,i2
      al(i,j)=al(i,j)+dzx*iu(i,j+1,k)
      ar(i,j)=ar(i,j)+dzx*iu(i+1,j+1,k)
      ab(i,j)=ab(i,j)+dzyb*iv(i+1,j,k)
 282  at(i,j)=at(i,j)+dzyt*iv(i+1,j+1,k)

      if (mylat .eq. 0) then
      do 285 i=1,i2
 285  ab(i,1)=0.
      endif
      if (mylat .eq. ngy1) then
      do 286 i=1,i2
 286  at(i,j2)=0.
      endif

      gamma_tmp=0.
      if (lfsrf .eq. 1) gamma_tmp=1./(0.5*dt**2)
      do 287 j=1,j2
      do 287 i=1,i2
      al(i,j)=-al(i,j)
      ar(i,j)=-ar(i,j)
      ab(i,j)=-ab(i,j)
      at(i,j)=-at(i,j)
 287  ac(i,j)=(-al(i,j)-ar(i,j)-ab(i,j)-at(i,j))+gamma_tmp

      call mpi_barrier(mpi_comm_world,ierr)

      if(lsolver .eq.1) then
        if(myid.eq.0) print*,'enter evp preprocessor',myid
        call pre(al,ab,ac,ar,at,rinv,rinv1,hh,ie)
!        write(99) al,ar,ab,at,ac,rinv,rinv1,ie
!        close(99)
        call wr8nc_evp1 !dog
        if(myid.eq.0) print*,'finished evp preprocessor',myid
      elseif(lsolver .eq.2) then
        if(myid.eq.0) print*,'enter preconditioner',myid
        if(lprecon .le. 1) then
          if(myid.eq.0) print*,'sip precondition'
          alpha=.5d0
	  call sipinc(al,ab,ac,ar,at,cl,cb,cc,cr,ct,alpha)
        elseif(lprecon .eq. 2) then
          if(myid.eq.0) print*,'lu precondition'
          call luinc(al,ab,ac,ar,at,cl,cb,cc,cr,ct)
        elseif(lprecon .eq. 3) then
          if(myid.eq.0) print*,'chol precondition'
          call cholinc(al,ab,ac,ar,at,cl,cb,cc,cr,ct)
        else
          if(myid.eq.0) print*,'lprecon=',lprecon,' err'
          stop 0
        endif
!	write(99) al,ar,ab,at,ac,cl,cb,cc,cr,ct
!        close(99)
        call wr8nc_evp2 !dog
      endif    
  
      print*,'finished preconditioner',myid

end subroutine

subroutine wr8nc_evp1
use const, only: i2t,j2t,i0t,ibir,ngy0,nbg0,nbg1,nb0
use comm,  only: myid,mylon,mylat,m_cart
implicit none
!declare pnetcdf var
character :: fn*11,desp*30
integer :: ierr,ncid,nt(3),nd(2),ns(1)
integer :: i2id,j2id,i0id,ibid,ibg0,ibg1,j2idd,inb0
integer :: ial,iar,iab,iac,iat,irin,irin1,ieid
integer(kind=mpi_offset_kind) :: dim_nn(7),leng
integer(kind=mpi_offset_kind) :: ns_ijk(3),nc_ijk(3),ns_ij(2),nc_ij(2),ns_i,nc_i
      !derive the size of each mpiid task,320,288

      !output file name
      fn = 'data/evp.nc'
      !create ncfile and id
      ierr=nfmpi_create(m_cart,fn,nf_64bit_offset,mpi_info_null,ncid)
      !define dimension and assign dimID
      dim_nn(1) = i2*ngx0
      dim_nn(2) = j2*ngy0
      dim_nn(3) = i0*ngx0
      dim_nn(4) = ibir*ngy0
      dim_nn(5) = nbg0
      dim_nn(6) = nbg1
      dim_nn(7) = nb0
      ierr=nfmpi_def_dim(ncid,"i2_global",dim_nn(1),i2id)
      ierr=nfmpi_def_dim(ncid,"j2_global",dim_nn(2),j2id)
      ierr=nfmpi_def_dim(ncid,"i0_global",dim_nn(3),i0id)
      ierr=nfmpi_def_dim(ncid,"j2+1_global",dim_nn(2)+ngy0,j2idd)
      ierr=nfmpi_def_dim(ncid,"ibir_global",dim_nn(4),ibid)
      ierr=nfmpi_def_dim(ncid,"nbg0",dim_nn(5),ibg0)
      ierr=nfmpi_def_dim(ncid,"nbg1",dim_nn(6),ibg1)
      ierr=nfmpi_def_dim(ncid,"nb0",dim_nn(7),inb0)

      !define variables and assign varID
      nd(1) = j2id
      nd(2) = i2id
      ierr=nfmpi_def_var(ncid,"al",nf_double,2,nd,ial)
      ierr=nfmpi_def_var(ncid,"ar",nf_double,2,nd,iar)
      ierr=nfmpi_def_var(ncid,"ab",nf_double,2,nd,iab)
      ierr=nfmpi_def_var(ncid,"ac",nf_double,2,nd,iac)

      nd(1) = i2id
      nd(2) = j2idd
      ierr=nfmpi_def_var(ncid,"at",nf_double,2,nd,iat)

      nt(1) = ibid
      nt(2) = i0id
      nt(3) = ibg0
      ierr=nfmpi_def_var(ncid,"rinv",nf_double,3,nt,irin)

      nt(1) = ibid
      nt(2) = i0id
      nt(3) = ibg1
      ierr=nfmpi_def_var(ncid,"rinv1",nf_double,3,nt,irin1)

      ns(1) = inb0
      ierr=nfmpi_def_var(ncid,"ie",nf_int,1,ns,ieid)

      desp='input files for lsolver = 1'
      leng=len(trim(desp))
      ierr=nfmpi_put_att_text(ncid,NF_GLOBAL,'desp',leng,trim(desp))
      ierr=nfmpi_enddef(ncid)

      !put variables
      ns_ij(1) = mylon*i2+1
      ns_ij(2) = mylat*j2+1
      nc_ij(1) = i2
      nc_ij(2) = j2
      ierr=nfmpi_put_vara_double_all(ncid,ial,ns_ij,nc_ij,al)
      ierr=nfmpi_put_vara_double_all(ncid,iar,ns_ij,nc_ij,ar)
      ierr=nfmpi_put_vara_double_all(ncid,iab,ns_ij,nc_ij,ab)
      ierr=nfmpi_put_vara_double_all(ncid,iac,ns_ij,nc_ij,ac)
      ns_ij(1) = mylon*j2+1
      ns_ij(2) = mylat*(j2+1)+1
      nc_ij(1) = i2
      nc_ij(2) = j2+1
      ierr=nfmpi_put_vara_double_all(ncid,iat,ns_ij,nc_ij,at)

      ns_ijk(1) = mylat*ibir+1
      ns_ijk(2) = mylon*i0+1
      ns_ijk(3) = 1
      nc_ijk(1) = ibir
      nc_ijk(2) = i0
      nc_ijk(3) = nbg0
      ierr=nfmpi_put_vara_double_all(ncid,irin,ns_ijk,nc_ijk,rinv)
      ns_ijk(1) = mylat*ibir+1
      ns_ijk(2) = mylon*i0+1
      ns_ijk(3) = 1
      nc_ijk(1) = ibir
      nc_ijk(2) = i0
      nc_ijk(3) = nbg1
      ierr=nfmpi_put_vara_double_all(ncid,irin1,ns_ijk,nc_ijk,rinv1)

      ns_i = 1
      nc_i = nb0
      ierr=nfmpi_put_vara_int_all(ncid,ieid,ns_i,nc_i,ie)
      ierr=nfmpi_close(ncid)
end subroutine wr8nc_evp1

subroutine wr8nc_evp2
use const, only: i2,j2,ngy0,ngx0
use comm,  only: myid,mylon,mylat,m_cart
use var,   only: grd
implicit none
!declare pnetcdf var
character :: fn*11,desp*120
integer :: ierr,ncid,nd(2)
integer :: i2id,j2id,j2idd
integer :: ial,iar,iab,iac,iat,icl,icb,icc,icr,ict
integer(kind=mpi_offset_kind) :: dim_nn(3),leng
integer(kind=mpi_offset_kind) :: ns_ij(2),nc_ij(2)
      !derive the size of each mpiid task

      !output file name
      fn = 'data/evp.nc'
      !create ncfile and id
      ierr=nfmpi_create(m_cart,fn,nf_64bit_offset,mpi_info_null,ncid)
      !define dimension and assign dimID
      dim_nn(1) = i2*ngx0
      dim_nn(2) = j2*ngy0
      dim_nn(3) = (j2+1)*ngy0
      ierr=nfmpi_def_dim(ncid,"i2_global",dim_nn(1),i2id)
      ierr=nfmpi_def_dim(ncid,"j2_global",dim_nn(2),j2id)
      ierr=nfmpi_def_dim(ncid,"j2+1_global",dim_nn(3),j2idd)
      !define variables and assign varID
      nd(1) = i2id
      nd(2) = j2id
      ierr=nfmpi_def_var(ncid,"al",nf_double,2,nd,ial)
      ierr=nfmpi_def_var(ncid,"ar",nf_double,2,nd,iar)
      ierr=nfmpi_def_var(ncid,"ab",nf_double,2,nd,iab)
      ierr=nfmpi_def_var(ncid,"ac",nf_double,2,nd,iac)

      nd(2) = j2idd
      ierr=nfmpi_def_var(ncid,"at",nf_double,2,nd,iat)

      nd(2) = j2id
      ierr=nfmpi_def_var(ncid,"cl",nf_double,2,nd,icl)
      ierr=nfmpi_def_var(ncid,"cb",nf_double,2,nd,icb)
      ierr=nfmpi_def_var(ncid,"cc",nf_double,2,nd,icc)
      ierr=nfmpi_def_var(ncid,"cr",nf_double,2,nd,icr)
      ierr=nfmpi_def_var(ncid,"ct",nf_double,2,nd,ict)

      desp='input files for lsolver = 2, note that the global domain &
            is decomposed into ngx0*ngy0 subdomains'
      leng=len(trim(desp))
      ierr=nfmpi_put_att_text(ncid,NF_GLOBAL,'desp',leng,trim(desp))
      ierr=nfmpi_enddef(ncid)

      !put variables
      ns_ij(1) = mylon*i2+1
      ns_ij(2) = mylat*j2+1
      nc_ij(1) = i2
      nc_ij(2) = j2
      ierr=nfmpi_put_vara_double_all(ncid,ial,ns_ij,nc_ij,al)
      ierr=nfmpi_put_vara_double_all(ncid,iar,ns_ij,nc_ij,ar)
      ierr=nfmpi_put_vara_double_all(ncid,iab,ns_ij,nc_ij,ab)
      ierr=nfmpi_put_vara_double_all(ncid,iac,ns_ij,nc_ij,ac)
      ns_ij(1) = mylon*i2+1
      ns_ij(2) = mylat*(j2+1)+1
      nc_ij(1) = i2
      nc_ij(2) = j2+1
      ierr=nfmpi_put_vara_double_all(ncid,iat,ns_ij,nc_ij,at)

      ns_ij(1) = mylon*i2+1
      ns_ij(2) = mylat*j2+1
      nc_ij(1) = i2
      nc_ij(2) = j2
      ierr=nfmpi_put_vara_double_all(ncid,icl,ns_ij,nc_ij,cl)
      ierr=nfmpi_put_vara_double_all(ncid,icb,ns_ij,nc_ij,cb)
      ierr=nfmpi_put_vara_double_all(ncid,icc,ns_ij,nc_ij,cc)
      ierr=nfmpi_put_vara_double_all(ncid,icr,ns_ij,nc_ij,cr)
      ierr=nfmpi_put_vara_double_all(ncid,ict,ns_ij,nc_ij,ct)

      ierr=nfmpi_close(ncid)
end subroutine wr8nc_evp2

subroutine wr8nc_winmx
use const,  only: k2
use var,    only: z
use comm,  only: m_cart
implicit none

!declare pnetcdf var
character :: fn*15,desp*100
integer :: ierr,ncid,ns
integer :: k2id,i
integer :: ivbk,ihbk,idep
integer(kind=mpi_offset_kind) :: dim_nn(1),leng
integer(kind=mpi_offset_kind) :: sns,cns
integer :: dep(k2)
      !derive the size of each mpiid task
      sns = 1
      cns = k2

      do i = 1,k2
      dep(i) = int(.01*z(2*i+1))
      end do

      !output file name
      fn = 'data/windmix.nc'
      !create ncfile and id
      ierr=nfmpi_create(m_cart,fn,nf_64bit_offset,mpi_info_null,ncid)

      !define dimension and assign dimID
      dim_nn(1) = k2
      ierr=nfmpi_def_dim(ncid,"k2",dim_nn(1),k2id)

      !define variables and assign varID
      ns = k2id
      ierr=nfmpi_def_var(ncid,"depth",nf_int,1,ns,idep)
      ierr=nfmpi_def_var(ncid,"vbk",nf_double,1,ns,ivbk)
      ierr=nfmpi_def_var(ncid,"hbk",nf_double,1,ns,ihbk)

      desp='input files for vertical eddy viscosity and diffusivity '
      leng=len(trim(desp))
      ierr=nfmpi_put_att_text(ncid,NF_GLOBAL,'desp',leng,trim(desp))

      ierr=nfmpi_enddef(ncid)

      !put variables
      ierr=nfmpi_put_vara_int_all(ncid,idep,sns,cns,dep)
      ierr=nfmpi_put_vara_double_all(ncid,ivbk,sns,cns,vbk)
      ierr=nfmpi_put_vara_double_all(ncid,ihbk,sns,cns,hbk)

      ierr=nfmpi_close(ncid)
end subroutine wr8nc_winmx

subroutine wr8nc_rundata
use const, only: j2,j1,j0,i0,j2t,j1t,j0t,i0t,ngx0,ngy0
use comm,  only: myid,mylat,mylon,m_cart
implicit none

!declare pnetcdf var
character :: fn*15
integer :: ncid,ierr,ns
integer :: siid,i0id,j0id,j1id,j2id,cid,dsid
integer :: icase,idsp,idt,itlz,ib,ig,idm0,ide0,idmz0
integer :: irzmx,idrag,ifltw,idadt,iodt,iprn,iorz,ioflt,irawf
integer :: iktrm,irst,imxit,isv,imxsv,ilop,ilmov,imvi,ilfs,ilsol,ilpre
integer :: ixdeg,ifcol,iphi,icsv,iocs,idxv,iodx,idyv,iody,iydeg
integer :: iy,iyv,iyvd,ics,iocs2,idx,iodxx,idy,iodyy
integer(kind=mpi_offset_kind) :: dim_nn(5),leng
integer(kind=mpi_offset_kind) :: ns_i,nc_i
      !output file name
      fn = "data/rundata.nc"

      !create ncfile and id
      ierr=nfmpi_create(m_cart,fn,nf_64bit_offset,mpi_info_null,ncid)

      !define dimension and assign dimID
      dim_nn(1) = 1
      dim_nn(2) = i0*ngx0
      dim_nn(3) = j0*ngy0
      dim_nn(4) = j1*ngy0
      dim_nn(5) = j2*ngy0
      ierr=nfmpi_def_dim(ncid,"char_case",dim_nn(1)*5,cid)
      ierr=nfmpi_def_dim(ncid,"char_desp",dim_nn(1)*63,dsid)
      ierr=nfmpi_def_dim(ncid,"pt_val",dim_nn(1),siid)
      ierr=nfmpi_def_dim(ncid,"i0_global",dim_nn(2),i0id)
      ierr=nfmpi_def_dim(ncid,"j0_global",dim_nn(3),j0id)
      ierr=nfmpi_def_dim(ncid,"j1_global",dim_nn(4),j1id)
      ierr=nfmpi_def_dim(ncid,"j2_global",dim_nn(5),j2id)
      !define variables and assign varID
      ns = cid
      ierr=nfmpi_def_var(ncid,"case",nf_char,1,ns,icase)
      ns = dsid
      ierr=nfmpi_def_var(ncid,"describ",nf_char,1,ns,idsp)
      ns = siid
      ierr=nfmpi_def_var(ncid,"dt",nf_double,1,ns,idt)
      ierr=nfmpi_def_var(ncid,"tlz",nf_double,1,ns,itlz)
      ierr=nfmpi_def_var(ncid,"b",nf_double,1,ns,ib)
      ierr=nfmpi_def_var(ncid,"g",nf_double,1,ns,ig)
      ierr=nfmpi_def_var(ncid,"dm0",nf_double,1,ns,idm0)
      ierr=nfmpi_def_var(ncid,"de0",nf_double,1,ns,ide0)
      ierr=nfmpi_def_var(ncid,"dmz0",nf_double,1,ns,idmz0)
      ierr=nfmpi_def_var(ncid,"rzmx",nf_double,1,ns,irzmx)
      ierr=nfmpi_def_var(ncid,"drag",nf_double,1,ns,idrag)
      ierr=nfmpi_def_var(ncid,"fltw",nf_double,1,ns,ifltw)
      ierr=nfmpi_def_var(ncid,"daodt",nf_double,1,ns,idadt)
      ierr=nfmpi_def_var(ncid,"odt",nf_double,1,ns,iodt)
      ierr=nfmpi_def_var(ncid,"prn",nf_double,1,ns,iprn)
      ierr=nfmpi_def_var(ncid,"orzmx",nf_double,1,ns,iorz)
      ierr=nfmpi_def_var(ncid,"ofltw",nf_double,1,ns,ioflt)
      ierr=nfmpi_def_var(ncid,"rawf",nf_double,1,ns,irawf)
      ierr=nfmpi_def_var(ncid,"ktrm",nf_int,1,ns,iktrm)
      ierr=nfmpi_def_var(ncid,"lrstrt",nf_int,1,ns,irst)
      ierr=nfmpi_def_var(ncid,"mxit",nf_int,1,ns,imxit)
      ierr=nfmpi_def_var(ncid,"isav",nf_int,1,ns,isv)
      ierr=nfmpi_def_var(ncid,"mxsav",nf_int,1,ns,imxsv)
      ierr=nfmpi_def_var(ncid,"lopen",nf_int,1,ns,ilop)
      ierr=nfmpi_def_var(ncid,"lmovi",nf_int,1,ns,ilmov)
      ierr=nfmpi_def_var(ncid,"mvi",nf_int,1,ns,imvi)
      ierr=nfmpi_def_var(ncid,"lfsrf",nf_int,1,ns,ilfs)
      ierr=nfmpi_def_var(ncid,"lsolver",nf_int,1,ns,ilsol)
      ierr=nfmpi_def_var(ncid,"lprecon",nf_int,1,ns,ilpre)

      ns = j2id
      ierr=nfmpi_def_var(ncid,"f",nf_double,1,ns,ifcol)
      ierr=nfmpi_def_var(ncid,"tanphi",nf_double,1,ns,iphi)
      ns = j1id ! csv,ocsv,dxv,odxv,dyv,odyv
      ierr=nfmpi_def_var(ncid,"csv",nf_double,1,ns,icsv)
      ierr=nfmpi_def_var(ncid,"ocsv",nf_double,1,ns,iocs)
      ierr=nfmpi_def_var(ncid,"dxv",nf_double,1,ns,idxv)
      ierr=nfmpi_def_var(ncid,"odxv",nf_double,1,ns,iodx)
      ierr=nfmpi_def_var(ncid,"dyv",nf_double,1,ns,idyv)
      ierr=nfmpi_def_var(ncid,"odyv",nf_double,1,ns,iody)
      ns = j0id ! y,yv,yvdeg,cs,ocs,dx,odx,dy,ody
      ierr=nfmpi_def_var(ncid,"y",nf_double,1,ns,iy)
      ierr=nfmpi_def_var(ncid,"yv",nf_double,1,ns,iyv)
      ierr=nfmpi_def_var(ncid,"yvdeg",nf_double,1,ns,iyvd)
      ierr=nfmpi_def_var(ncid,"ydeg",nf_double,1,ns,iydeg)
      ierr=nfmpi_def_var(ncid,"cs",nf_double,1,ns,ics)
      ierr=nfmpi_def_var(ncid,"ocs",nf_double,1,ns,iocs2)
      ierr=nfmpi_def_var(ncid,"dx",nf_double,1,ns,idx)
      ierr=nfmpi_def_var(ncid,"odx",nf_double,1,ns,iodxx)
      ierr=nfmpi_def_var(ncid,"dy",nf_double,1,ns,idy)
      ierr=nfmpi_def_var(ncid,"ody",nf_double,1,ns,iodyy)
      ns = i0id
      ierr=nfmpi_def_var(ncid,"xdeg",nf_double,1,ns,ixdeg)
      ierr=nfmpi_enddef(ncid)
      !put variables in collective data mode
      ns_i = mylat*j2+1
      nc_i = j2
      ierr=nfmpi_put_vara_double_all(ncid,ifcol,ns_i,nc_i,f)
      ierr=nfmpi_put_vara_double_all(ncid,iphi,ns_i,nc_i,tanphi)
      ns_i = mylat*j1+1
      nc_i = j1
      ierr=nfmpi_put_vara_double_all(ncid,icsv,ns_i,nc_i,csv)
      ierr=nfmpi_put_vara_double_all(ncid,iocs,ns_i,nc_i,ocsv)
      ierr=nfmpi_put_vara_double_all(ncid,idxv,ns_i,nc_i,dxv)
      ierr=nfmpi_put_vara_double_all(ncid,iodx,ns_i,nc_i,odxv)
      ierr=nfmpi_put_vara_double_all(ncid,idyv,ns_i,nc_i,dyv)
      ierr=nfmpi_put_vara_double_all(ncid,iody,ns_i,nc_i,odyv)
      ns_i = mylat*j0+1
      nc_i = j0
      ierr=nfmpi_put_vara_double_all(ncid,iy,ns_i,nc_i,y)
      ierr=nfmpi_put_vara_double_all(ncid,iyv,ns_i,nc_i,yv)
      ierr=nfmpi_put_vara_double_all(ncid,iydeg,ns_i,nc_i,ydeg)
      ierr=nfmpi_put_vara_double_all(ncid,iyvd,ns_i,nc_i,yvdeg)
      ierr=nfmpi_put_vara_double_all(ncid,ics,ns_i,nc_i,cs)
      ierr=nfmpi_put_vara_double_all(ncid,iocs2,ns_i,nc_i,ocs)
      ierr=nfmpi_put_vara_double_all(ncid,idx,ns_i,nc_i,dx)
      ierr=nfmpi_put_vara_double_all(ncid,iodxx,ns_i,nc_i,odx)
      ierr=nfmpi_put_vara_double_all(ncid,idy,ns_i,nc_i,dy)
      ierr=nfmpi_put_vara_double_all(ncid,iodyy,ns_i,nc_i,ody)
      ns_i = mylon*i0+1
      nc_i = i0
      ierr=nfmpi_put_vara_double_all(ncid,ixdeg,ns_i,nc_i,xdeg)
      !put variables in independent data mode
      ierr=nfmpi_begin_indep_data(ncid)
      ierr=nfmpi_put_var_text(ncid,icase,case)
      ierr=nfmpi_put_var_text(ncid,idsp,dscrib)
      ierr=nfmpi_put_var_double(ncid,idt,dt)
      ierr=nfmpi_put_var_double(ncid,itlz,tlz)
      ierr=nfmpi_put_var_double(ncid,ib,b)
      ierr=nfmpi_put_var_double(ncid,ig,g)
      ierr=nfmpi_put_var_double(ncid,idm0,dm0)
      ierr=nfmpi_put_var_double(ncid,ide0,de0)
      ierr=nfmpi_put_var_double(ncid,idmz0,dmz0)
      ierr=nfmpi_put_var_double(ncid,irzmx,rzmx)
      ierr=nfmpi_put_var_double(ncid,idrag,drag)
      ierr=nfmpi_put_var_double(ncid,ifltw,fltw)
      ierr=nfmpi_put_var_double(ncid,idadt,daodt)
      ierr=nfmpi_put_var_double(ncid,iodt,odt)
      ierr=nfmpi_put_var_double(ncid,iprn,prn)
      ierr=nfmpi_put_var_double(ncid,iorz,orzmx)
      ierr=nfmpi_put_var_double(ncid,ioflt,ofltw)
      ierr=nfmpi_put_var_double(ncid,irawf,rawf)
      ierr=nfmpi_put_var_int(ncid,iktrm,ktrm)
      ierr=nfmpi_put_var_int(ncid,irst,lrstrt)
      ierr=nfmpi_put_var_int(ncid,imxit,mxit)
      ierr=nfmpi_put_var_int(ncid,isv,isav)
      ierr=nfmpi_put_var_int(ncid,imxsv,mxsav)
      ierr=nfmpi_put_var_int(ncid,ilop,lopen)
      ierr=nfmpi_put_var_int(ncid,ilmov,lmovi)
      ierr=nfmpi_put_var_int(ncid,imvi,mvi)
      ierr=nfmpi_put_var_int(ncid,ilfs,lfsrf)
      ierr=nfmpi_put_var_int(ncid,ilsol,lsolver)
      ierr=nfmpi_put_var_int(ncid,ilpre,lprecon)
      ierr=nfmpi_end_indep_data(ncid)

      ierr=nfmpi_close(ncid)
end subroutine wr8nc_rundata

subroutine wr8nc_zkb
use comm, only: myid,mylat,mylon,m_cart
use const, only: i0,j0,k0,i01,k0,k1,ngx0,ngy0
implicit none
!declare pnetcdf var
character :: fn*11
integer :: ncid,ierr,ns,nd(2),nt(3)
integer :: siid,k0id,k1id,kkid,i01id,i0id,j0id,i11id,j11id
integer :: itlz,iz,iodz,iodzw,ikb,irmt,iiv0,iiu0
integer :: iiu,iiv,iiw,iin
integer(kind=mpi_offset_kind) :: dim_nn(9),ns_ijk(3),nc_ijk(3),ns_ij(2),nc_ij(2)
integer(kind=mpi_offset_kind) :: ns_i,nc_i

      !output file name
      fn = 'data/zkb.nc'
      !create ncfile and id
      ierr=nfmpi_create(m_cart,fn,nf_64bit_offset,mpi_info_null,ncid)
      !define dimension and assign dimID
      dim_nn(1) = 1
      dim_nn(2) = k0
      dim_nn(3) = k1
      dim_nn(4) = k0+k1
      dim_nn(5) = i01*ngx0
      dim_nn(6) = i0*ngx0
      dim_nn(7) = j0*ngy0
      dim_nn(8) = (i01+1)*ngx0
      dim_nn(9) = (j0+1)*ngy0
      ierr=nfmpi_def_dim(ncid,"pt_val",dim_nn(1),siid)
      ierr=nfmpi_def_dim(ncid,"k0",dim_nn(2),k0id)
      ierr=nfmpi_def_dim(ncid,"k1",dim_nn(3),k1id)
      ierr=nfmpi_def_dim(ncid,"k0+k1",dim_nn(4),kkid)
      ierr=nfmpi_def_dim(ncid,"i01_global",dim_nn(5),i01id)
      ierr=nfmpi_def_dim(ncid,"i0_global",dim_nn(6),i0id)
      ierr=nfmpi_def_dim(ncid,"j0_global",dim_nn(7),j0id)
      ierr=nfmpi_def_dim(ncid,"i01+1_global",dim_nn(8),i11id)
      ierr=nfmpi_def_dim(ncid,"j0+1_global",dim_nn(9),j11id)
      !define variables and assign varID
      ns = siid
      ierr=nfmpi_def_var(ncid,"tlz",nf_double,1,ns,itlz)
      ns = kkid
      ierr=nfmpi_def_var(ncid,"z",nf_double,1,ns,iz)
      ns = k1id
      ierr=nfmpi_def_var(ncid,"odz",nf_double,1,ns,iodz)
      ns = k0id
      ierr=nfmpi_def_var(ncid,"odzw",nf_double,1,ns,iodzw)
      nd(1) = i0id
      nd(2) = j0id
      ierr=nfmpi_def_var(ncid,"kb",nf_short,2,nd,ikb)
      ierr=nfmpi_def_var(ncid,"rmets",nf_double,2,nd,irmt)
      nd(1) = i0id
      nd(2) = j11id
      ierr=nfmpi_def_var(ncid,"iv0",nf_short,2,nd,iiv0)
      nd(1) = i11id
      nd(2) = j0id
      ierr=nfmpi_def_var(ncid,"iu0",nf_short,2,nd,iiu0)
      nt(1) = i0id
      nt(2) = j0id
      nt(3) = k0id
      ierr=nfmpi_def_var(ncid,"iw",nf_short,3,nt,iiw)! (i0,j0,k0)
      nt(3) = k1id
      ierr=nfmpi_def_var(ncid,"in",nf_short,3,nt,iin)! (i0,j0,k1)
      nt(2) = j11id
      ierr=nfmpi_def_var(ncid,"iv",nf_short,3,nt,iiv)! (i0,0:j0,k1)
      nt(1) = i11id
      nt(2) = j0id
      ierr=nfmpi_def_var(ncid,"iu",nf_short,3,nt,iiu)
      ierr=nfmpi_enddef(ncid)

      !put variables
      ns_i = 1
      nc_i = 1
      ierr=nfmpi_put_vara_double_all(ncid,itlz,ns_i,nc_i,tlz)
      nc_i = k0+k1
      ierr=nfmpi_put_vara_double_all(ncid,iz,ns_i,nc_i,z)
      nc_i = k1
      ierr=nfmpi_put_vara_double_all(ncid,iodz,ns_i,nc_i,odz)
      nc_i = k0
      ierr=nfmpi_put_vara_double_all(ncid,iodzw,ns_i,nc_i,odzw)

      ns_ij(1) = mylon*i0+1
      ns_ij(2) = mylat*j0+1
      nc_ij(1) = i0
      nc_ij(2) = j0
      ierr=nfmpi_put_vara_int2_all(ncid,ikb,ns_ij,nc_ij,kb)
      ierr=nfmpi_put_vara_double_all(ncid,irmt,ns_ij,nc_ij,rmets)
      ns_ij(2) = mylat*(j0+1)+1
      nc_ij(2) = j0+1
      ierr=nfmpi_put_vara_int2_all(ncid,iiv0,ns_ij,nc_ij,iv0)
      ns_ij(1) = mylon*(i01+1)+1
      ns_ij(2) = mylat*j0+1
      nc_ij(1) = i01+1
      nc_ij(2) = j0
      ierr=nfmpi_put_vara_int2_all(ncid,iiu0,ns_ij,nc_ij,iu0)
      ns_ijk(1) = mylon*i0+1
      ns_ijk(2) = mylat*j0+1
      ns_ijk(3) = 1
      nc_ijk(1) = i0
      nc_ijk(2) = j0
      nc_ijk(3) = k0
      ierr=nfmpi_put_vara_int2_all(ncid,iiw,ns_ijk,nc_ijk,iw)
      nc_ijk(3) = k1
      ierr=nfmpi_put_vara_int2_all(ncid,iin,ns_ijk,nc_ijk,in)
      ns_ijk(2) = mylat*(j0+1)+1
      nc_ijk(2) = j0+1
      ierr=nfmpi_put_vara_int2_all(ncid,iiv,ns_ijk,nc_ijk,iv)
      ns_ijk(1) = mylon*(i01+1)+1
      ns_ijk(2) = mylat*j0+1
      nc_ijk(1) = i01+1
      nc_ijk(2) = j0
      ierr=nfmpi_put_vara_int2_all(ncid,iiu,ns_ijk,nc_ijk,iu)


      ierr=nfmpi_close(ncid)
end subroutine wr8nc_zkb

subroutine wr8nc_boundaries
use const,  only: i2,j2,ngx0,ngy0,k1,k2
use comm,  only: m_cart,mylat,mylon
implicit none

!declare pnetcdf var
character :: fn*18
integer :: ierr,ncid,nd(2),nt(3),nf(4)
integer :: i2id,j2id,spid,moid,k1id,k2id
integer :: isxy,itxy,itsu,issu,isnp,issp,itnp,itsp
integer(kind=mpi_offset_kind) :: dim_nn(6)
integer(kind=mpi_offset_kind) :: ns_ijkt(4),nc_ijkt(4),ns_ijk(3),nc_ijk(3)
integer(kind=mpi_offset_kind) :: ns_ij(2),nc_ij(2)

      !output file name
      fn = 'data/boundaries.nc'
      !create ncfile and id
      ierr=nfmpi_create(m_cart,fn,nf_64bit_offset,mpi_info_null,ncid)

      !define dimension and assign dimID
      dim_nn(1) = i2*ngx0
      dim_nn(2) = j2*ngy0
      dim_nn(3) = 10*ngy0
      dim_nn(4) = 12
      dim_nn(5) = k1
      dim_nn(6) = k2
      ierr=nfmpi_def_dim(ncid,"i2_global",dim_nn(1),i2id)
      ierr=nfmpi_def_dim(ncid,"j2_global",dim_nn(2),j2id)
      ierr=nfmpi_def_dim(ncid,"j0-sponge_global",dim_nn(3),spid)
      ierr=nfmpi_def_dim(ncid,"month",dim_nn(4),moid)
      ierr=nfmpi_def_dim(ncid,"k1",dim_nn(5),k1id)
      ierr=nfmpi_def_dim(ncid,"k2",dim_nn(6),k2id)

      !define variables and assign varID
      nd(1) = k1id
      nd(2) = moid
      ierr=nfmpi_def_var(ncid,"sxycli",nf_double,2,nd,isxy)
      ierr=nfmpi_def_var(ncid,"txycli",nf_double,2,nd,itxy)
      nt(1) = i2id
      nt(2) = j2id
      nt(3) = moid
      ierr=nfmpi_def_var(ncid,"tsurf",nf_double,3,nt,itsu)
      ierr=nfmpi_def_var(ncid,"ssurf",nf_double,3,nt,issu)
      nf(1) = i2id
      nf(2) = spid
      nf(3) = k2id
      nf(4) = moid
      ierr=nfmpi_def_var(ncid,"snsp",nf_double,4,nf,isnp)
      ierr=nfmpi_def_var(ncid,"sssp",nf_double,4,nf,issp)
      ierr=nfmpi_def_var(ncid,"tnsp",nf_double,4,nf,itnp)
      ierr=nfmpi_def_var(ncid,"tssp",nf_double,4,nf,itsp)
      ierr=nfmpi_enddef(ncid)

      !put variables
      ns_ij(1) = 1
      ns_ij(2) = 1
      nc_ij(1) = k1
      nc_ij(2) = 12
      ierr=nfmpi_put_vara_double_all(ncid,isxy,ns_ij,nc_ij,sxycli)
      ierr=nfmpi_put_vara_double_all(ncid,itxy,ns_ij,nc_ij,txycli)
      ns_ijk(1) = mylon*i2+1
      ns_ijk(2) = mylat*j2+1
      ns_ijk(3) = 1
      nc_ijk(1) = i2
      nc_ijk(2) = j2
      nc_ijk(3) = 12
      ierr=nfmpi_put_vara_double_all(ncid,issu,ns_ijk,nc_ijk,ssurf)
      ierr=nfmpi_put_vara_double_all(ncid,itsu,ns_ijk,nc_ijk,tsurf)
      ns_ijkt(1) = mylon*i2+1
      ns_ijkt(2) = mylat*10+1
      ns_ijkt(3) = 1
      ns_ijkt(4) = 1
      nc_ijkt(1) = i2
      nc_ijkt(2) = 10
      nc_ijkt(3) = k2
      nc_ijkt(4) = 12
      ierr=nfmpi_put_vara_double_all(ncid,isnp,ns_ijkt,nc_ijkt,snsp)
      ierr=nfmpi_put_vara_double_all(ncid,issp,ns_ijkt,nc_ijkt,sssp)
      ierr=nfmpi_put_vara_double_all(ncid,itnp,ns_ijkt,nc_ijkt,tnsp)
      ierr=nfmpi_put_vara_double_all(ncid,itnp,ns_ijkt,nc_ijkt,tssp)
      ierr=nfmpi_close(ncid)
end subroutine wr8nc_boundaries

subroutine wr8nc_preini
use const, only: i0,j0,k1,ngx0,ngy0
use comm, only: m_cart,mylat,mylon
implicit none
!declare pnetcdf var
character :: fn*14
integer :: ierr,ncid,nt(3)
integer :: i0id,j0id,k1id
integer :: isd,itd
integer(kind=mpi_offset_kind) :: dim_nn(3)
integer(kind=mpi_offset_kind) :: ns_ijk(3),nc_ijk(3)

      !output file name
      fn = 'data/preini.nc'
      !create ncfile and id
      ierr=nfmpi_create(m_cart,fn,nf_64bit_offset,mpi_info_null,ncid)

      !define dimension and assign dimID
      dim_nn(1) = i0*ngx0
      dim_nn(2) = j0*ngy0
      dim_nn(3) = k1
      ierr=nfmpi_def_dim(ncid,"i0_global",dim_nn(1),i0id)
      ierr=nfmpi_def_dim(ncid,"j0_global",dim_nn(2),j0id)
      ierr=nfmpi_def_dim(ncid,"k1",dim_nn(3),k1id)

      !define variables and assign varID
      nt(1) = i0id
      nt(2) = j0id
      nt(3) = k1id
      ierr=nfmpi_def_var(ncid,"s1",nf_double,3,nt,isd)
      ierr=nfmpi_def_var(ncid,"t1",nf_double,3,nt,itd)
      ierr=nfmpi_enddef(ncid)

      !put variables
      ns_ijk(1) = mylon*i0+1
      ns_ijk(2) = mylat*j0+1
      ns_ijk(3) = 1
      nc_ijk(1) = i0
      nc_ijk(2) = j0
      nc_ijk(3) = k1
      ierr=nfmpi_put_vara_double_all(ncid,isd,ns_ijk,nc_ijk,s1)
      ierr=nfmpi_put_vara_double_all(ncid,itd,ns_ijk,nc_ijk,t1)

      ierr=nfmpi_close(ncid)
end subroutine wr8nc_preini

subroutine rdnc_levitus(nm)
use comm, only: m_cart,myid,mylat,mylon
use const, only: i0,j0,k1,ngy0,ngx0
implicit none
character :: fn*20
integer :: ncid,ierr,itmp
integer(kind=mpi_offset_kind) :: ns_ijkt(4),nc_ijkt(4)
integer,intent(in) :: nm
      fn = 'data/annualevitus.nc'
      ierr=nfmpi_open(m_cart,fn,nf_nowrite,mpi_info_null,ncid)

      ns_ijkt(1) = mylon*i0+1
      ns_ijkt(2) = mylat*j0+1
      ns_ijkt(3) = 1
      ns_ijkt(4) = nm
      nc_ijkt(1) = i0
      nc_ijkt(2) = j0
      nc_ijkt(3) = k1
      nc_ijkt(4) = 1
      ierr=nfmpi_inq_varid(ncid,'s1_data',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ijkt,nc_ijkt,s1)
      ierr=nfmpi_inq_varid(ncid,'t1_data',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ijkt,nc_ijkt,t1)
      ierr=nfmpi_close(ncid)
endsubroutine rdnc_levitus

subroutine rdnc_depth(rmets)
use comm, only: m_cart,myid,mylat,mylon
use const, only: i0,j0
implicit none
character :: fn*14
integer :: ncid,ierr,itmp
integer(kind=mpi_offset_kind) :: ns_ij(2),nc_ij(2)
real*8,intent(inout) :: rmets(i0,j0)
      fn = 'data/depth.nc'
      ierr=nfmpi_open(m_cart,fn,nf_nowrite,mpi_info_null,ncid)
      ierr=nfmpi_inq_varid(ncid,'rmets',itmp)
      ns_ij(1) = mylon*i0+1
      ns_ij(2) = mylat*j0+1
      nc_ij(1) = i0
      nc_ij(2) = j0
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ij,nc_ij,rmets)
      ierr=nfmpi_close(ncid)
endsubroutine rdnc_depth

subroutine rdnc_yzgrid2(j,k,dxmnut)
use comm, only: m_cart,myid,mylat,mylon
use const, only: j0,j1
implicit none
character :: fn*14
integer :: ncid,ierr,itmp
integer(kind=mpi_offset_kind) :: ns_i,nc_i
integer,intent(inout) :: j,k
real*8,intent(inout) :: dxmnut
      fn = 'data/yzgrid.nc'
      ierr=nfmpi_open(m_cart,fn,nf_nowrite,mpi_info_null,ncid)

      ierr=nfmpi_inq_varid(ncid,'j0',itmp)
      ierr=nfmpi_get_var_int_all(ncid,itmp,j)
      ierr=nfmpi_inq_varid(ncid,'k0',itmp)
      ierr=nfmpi_get_var_int_all(ncid,itmp,k)
      ierr=nfmpi_inq_varid(ncid,'dxmnut',itmp)
      ierr=nfmpi_get_var_double_all(ncid,itmp,dxmnut)
      ierr=nfmpi_inq_varid(ncid,'tlz_depth',itmp)
      ierr=nfmpi_get_var_double_all(ncid,itmp,tlz)
      ierr=nfmpi_inq_varid(ncid,'z',itmp)
      ierr=nfmpi_get_var_double_all(ncid,itmp,z)
      ierr=nfmpi_inq_varid(ncid,'odz',itmp)
      ierr=nfmpi_get_var_double_all(ncid,itmp,odz)
      ierr=nfmpi_inq_varid(ncid,'odzw',itmp)
      ierr=nfmpi_get_var_double_all(ncid,itmp,odzw)

      ns_i=mylon*i0+1
      nc_i=i0
      ierr=nfmpi_inq_varid(ncid,'xdeg',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,xdeg)
      ns_i=mylat*j0+1
      nc_i=j0
      ierr=nfmpi_inq_varid(ncid,'y',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,y)
      ierr=nfmpi_inq_varid(ncid,'yv',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,yv)
      ierr=nfmpi_inq_varid(ncid,'yvdeg',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,yvdeg)
      ierr=nfmpi_inq_varid(ncid,'ydeg',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,ydeg)
      ierr=nfmpi_inq_varid(ncid,'cs',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,cs)
      ierr=nfmpi_inq_varid(ncid,'ocs',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,ocs)
      ierr=nfmpi_inq_varid(ncid,'dx',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,dx)
      ierr=nfmpi_inq_varid(ncid,'odx',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,odx)
      ierr=nfmpi_inq_varid(ncid,'dy',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,dy)
      ierr=nfmpi_inq_varid(ncid,'ody',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,ody)

      ns_i=mylat*j1+1
      nc_i=j1
      ierr=nfmpi_inq_varid(ncid,'csv',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,csv)
      ierr=nfmpi_inq_varid(ncid,'ocsv',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,ocsv)
      ierr=nfmpi_inq_varid(ncid,'dxv',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,dxv)
      ierr=nfmpi_inq_varid(ncid,'odxv',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,odxv)
      ierr=nfmpi_inq_varid(ncid,'dyv',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,dyv)
      ierr=nfmpi_inq_varid(ncid,'odyv',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,odyv)
      ierr=nfmpi_close(ncid)

end subroutine rdnc_yzgrid2

end module

module solver
    use const
    use var
    use comm
    use io
implicit real*8 (a-h,o-z)

contains

subroutine init_solver
    ! -------------------------
    ! evp elliptic solver data
    ! used for surface pressure
    ! -------------------------
!    open(99,file='prepglo/data/evp'//grd,form='unformatted')
    if(lsolver.eq.1) then
	if(myid.eq.0) write(*,*)'evp solver'
!	read(99) al,ar,ab,at,ac,rinv,rinv1,ie
!	close(99)
	elseif(lsolver.eq.2) then
	if(myid.eq.0) write(*,*)'bi-cgstab solver'
        call rdnc_evp
!	read(99) al,ar,ab,at,ac,cl,cb,cc,cr,ct
!	close(99)
    else
	if(myid.eq.0)write(*,*)'lsolver=',lsolver,' (incorrect solver)'
	call mpi_finalize(ierr)
	stop
    endif
end subroutine



! *****************
! elliptic solver *
! *****************
! ----------------------------------------------------------------------
subroutine p_bicgstab_le(ab,al,ac,ar,at,b,x,cb,cl,cc,cr,ct,r,rh,p,v,s,t,ph,sh)
    parameter(i0j0=i0*j0)
    real*8 x,r,rh,p,v,s,t,ph,sh
    real*8 rho,rhn,alpha,beta,w,res,tmp,tp,tol
    dimension ab(i2,j2),al(i2,j2),ac(i2,j2),ar(i2,j2),at(i2,0:j2), &
    b(i2,j2),x(i0,j0),r(i0,j0),rh(i0,j0),p(i0,j0),v(i0,j0),  &
    s(i0,j0),t(i0,j0),ph(i0,j0),sh(i0,j0), &
    cb(i2,j2),cl(i2,j2),cc(i2,j2),cr(i2,j2),ct(i2,j2)

    iter=0
    10   rho=1.d0
    alpha=1.d0
    w=1.d0
    call p_sqprod(ab,al,ac,ar,at,x,r)

    do 50 j=2,j1
    do 50 i=2,i1
    50   r(i,j)=b(i-1,j-1)-r(i,j)

    call dcopy(i0j0,r,1,rh,1)
    call p_inprod(r,r,tp)

    res=sqrt(tp)
    if (res .lt. 1e-7) then
	call mpi_sendrecv(x(2,1),1,m_v8lon,m_w,1,x(i0,1),1,m_v8lon,m_e,1,m_cart,istat,ierr)
	call mpi_sendrecv(x(i1,1),1,m_v8lon,m_e,1,x(1,1),1,m_v8lon,m_w,1,m_cart,istat,ierr)
	call mpi_sendrecv(x(1,2),1,m_v8lat,m_s,1,x(1,j0),1,m_v8lat,m_n,1,m_cart,istat,ierr)
	call mpi_sendrecv(x(1,j1),1,m_v8lat,m_n,1,x(1,1),1,m_v8lat,m_s,1,m_cart,istat,ierr)
	return
    endif

    100  iter=iter+1
    call p_inprod(r,rh,rhn)
    beta=(rhn/rho)*(alpha/w)

    ! print*,iter,'beta=',beta

    call daxpy(i0j0,-1.d0*w,v,1,p,1)
    call dscal(i0j0,beta,p,1)
    call daxpy(i0j0,1.d0,r,1,p,1)

    ! do 200 j=2,j1
    ! do 200 i=2,i1
    ! 200 ph(i,j)=p(i,j)

    ! call p_sqelim(cb,cl,cc,cr,ct,p,ph)
    ! call p_lusqelim(cb,cl,cc,cr,ct,p,ph)
    call p_sipsqelim(cb,cl,cc,cr,ct,p,ph)
    call p_sqprod(ab,al,ac,ar,at,ph,v)
    call p_inprod(rh,v,tmp)
    alpha=rhn/tmp

    ! print*,iter,'alpha=', alpha

    call dcopy(i0j0,r,1,s,1)
    call daxpy(i0j0,-1.d0*alpha,v,1,s,1)
    ! call dcopy(i0j0,s,1,sh,1)

    ! do 300 j=2,j1
    ! do 300 i=2,i1
    ! 300 sh(i,j)=s(i,j)

    call p_sipsqelim(cb,cl,cc,cr,ct,s,sh)
    ! call p_lusqelim(cb,cl,cc,cr,ct,s,sh)
    ! call p_sqelim(cb,cl,cc,cr,ct,s,sh)
    call p_sqprod(ab,al,ac,ar,at,sh,t)
    call p_inprod(t,t,tmp)
    call p_inprod(t,s,w)
    w=w/tmp

    ! print*,iter,'wn=',w

    tmp=0.d0

    call daxpy(i0j0,alpha,ph,1,x,1)
    call daxpy(i0j0,w,sh,1,x,1)
    call dcopy(i0j0,s,1,r,1)
    call daxpy(i0j0,-1.d0*w,t,1,r,1)

    call p_inprod(r,r,tp)

    rho=rhn
    ! if (myid .eq. 0) print*,iter,sqrt(tp)
    ! if (sqrt(tp)/res .gt. 1e-3 .and. mod(iter,100) .ne. 0) goto 100
    ! if (myid .eq. 0) print*, iter,sqrt(tp)
    !if (sqrt(tp) .gt. 1e-7 .and. iter .lt. 10000) goto 10
    if (sqrt(tp).gt.1.e-9.or.sqrt(tp)/res .gt. 1e-3.and. mod(iter,1000) .ne. 0) goto 100
    call mpi_barrier(m_cart,ierr)
    call mpi_sendrecv(x(2,1),1,m_v8lon,m_w,1,x(i0,1),1,m_v8lon,m_e,1,m_cart,istat,ierr)
    call mpi_sendrecv(x(i1,1),1,m_v8lon,m_e,1,x(1,1),1,m_v8lon,m_w,1,m_cart,istat,ierr)
    call mpi_sendrecv(x(1,2),1,m_v8lat,m_s,1,x(1,j0),1,m_v8lat,m_n,1,m_cart,istat,ierr)
    call mpi_sendrecv(x(1,j1),1,m_v8lat,m_n,1,x(1,1),1,m_v8lat,m_s,1,m_cart,istat,ierr)

    continue
end subroutine


! ----------------------------------------------------------------------
subroutine p_sqprod(ab,al,ac,ar,at,x,b)
    ! real*8 ab,al,ac,ar,at,x,b
    real*8 x,b
    dimension ab(i2,j2),al(i2,j2),ac(i2,j2),ar(i2,j2),at(i2,0:j2),x(i0,j0),b(i0,j0)

    call mpi_barrier(m_cart,ierr)
    call mpi_sendrecv(x(2,1),1,m_v8lon,m_w,1,x(i0,1),1,m_v8lon,m_e,1,m_cart,istat,ierr)
    call mpi_sendrecv(x(i1,1),1,m_v8lon,m_e,1,x(1,1),1,m_v8lon,m_w,1,m_cart,istat,ierr)
    call mpi_sendrecv(x(1,2),1,m_v8lat,m_s,1,x(1,j0),1,m_v8lat,m_n,1,m_cart,istat,ierr)
    call mpi_sendrecv(x(1,j1),1,m_v8lat,m_n,1,x(1,1),1,m_v8lat,m_s,1,m_cart,istat,ierr)

    do 100 j=2,j1
    do 100 i=2,i1
    it=i-1
    jt=j-1
    100  b(i,j)=ab(it,jt)*x(i,jt)+al(it,jt)*x(it,j)+ac(it,jt)*x(i,j)+ar(it,jt)*x(i+1,j)+at(it,jt)*x(i,j+1)
end subroutine


! ----------------------------------------------------------------------
subroutine p_inprod(a1,a2,pd)
    real*8 a1,a2,tmp,pd
    dimension a1(i0,j0),a2(i0,j0)

    tmp=0.d0
    do 100 j=2,j1
    do 100 i=2,i1
    100  tmp=tmp+a1(i,j)*a2(i,j)
    call mpi_barrier(m_cart,ierr)
    call mpi_allreduce(tmp,pd,1,mpi_real8,mpi_sum,m_cart,ierr)

    return
end subroutine


! --------------------------
subroutine p_sqelim(cb,cl,cc,cr,ct,b,bh)
    parameter(i3=i2-1,j3=j2-1,i0j0=i0*j0)
    ! real*8 cb,cl,cc,cr,ct,
    real*8 b,bh
    dimension cb(i2,j2),cl(i2,j2),cc(i2,j2),cr(i2,j2),ct(i2,j2),b(i0,j0),bh(i0,j0)

    call dcopy(i0j0,b,1,bh,1)
    do 100 j=2,j2
    jt=j-1
    do 150 i=2,i2
    it=i-1
    bh(i,j)=bh(i,j)*cc(it,jt)
    bh(i+1,j)=bh(i+1,j)-cr(it,jt)*bh(i,j)
    150  bh(i,j+1)=bh(i,j+1)-ct(it,jt)*bh(i,j)
    bh(i1,j)=bh(i1,j)*cc(i2,jt)
    100  bh(i1,j+1)=bh(i1,j+1)-ct(i2,j)*bh(i1,j)

    do 200 i=2,i2
    it=i-1
    bh(i,j1)=bh(i,j1)*cc(it,j2)
    200  bh(i+1,j1)=bh(i+1,j1)-cr(it,j2)*bh(i,j1)
    bh(i1,j1)=bh(i1,j1)*cc(i2,j2)

    do 300 j=j1,3,-1
    jt=j-1
    do 350 i=i1,3,-1
    it=i-1
    bh(i,j)=bh(i,j)*cc(it,jt)
    bh(i-1,j)=bh(i-1,j)-cr(it,jt)*bh(i,j)
    350  bh(i,j-1)=bh(i,j-1)-ct(it,jt)*bh(i,j)
    bh(2,j)=bh(2,j)*cc(1,jt)
    300  bh(2,j-1)=bh(2,j-1)-ct(1,jt)*bh(2,j)

    do 400 i=i1,3,-1
    it=i-1
    bh(i,2)=bh(i,2)*cc(it,1)
    400  bh(i-1,2)=bh(i-1,2)-cr(it,1)*bh(i,2)
    bh(2,2)=bh(2,2)*cc(1,1)
end subroutine


! ---------------------------------------------------------------------
subroutine p_lusqelim(cb,cl,cc,cr,ct,b,bh)
    parameter(i3=i2-1,j3=j2-1,i0j0=i0*j0)
    ! real*8 cb,cl,cc,cr,ct,b,bh
    real*8 b,bh
    dimension cb(i2,j2),cl(i2,j2),cc(i2,j2),cr(i2,j2),ct(i2,j2),b(i0,j0),bh(i0,j0)

    call dcopy(i0j0,b,1,bh,1)
    do 100 j=2,j2
    jt=j-1
    do 150 i=2,i2
    it=i-1
    bh(i+1,j)=bh(i+1,j)-cl(it,jt)*bh(i,j)
    150  bh(i,j+1)=bh(i,j+1)-cb(it,jt)*bh(i,j)
    100  bh(i1,j+1)=bh(i1,j+1)-cb(i2,j)*bh(i1,j)

    do 200 i=2,i2
    it=i-1
    200  bh(i+1,j1)=bh(i+1,j1)-cl(it,j2)*bh(i,j1)
    bh(i1,j1)=bh(i1,j1)

    do 300 j=j1,3,-1
    jt=j-1
    do 350 i=i1,3,-1
    it=i-1
    bh(i,j)=bh(i,j)*cc(it,jt)
    bh(i-1,j)=bh(i-1,j)-cr(it,jt)*bh(i,j)
    350  bh(i,j-1)=bh(i,j-1)-ct(it,jt)*bh(i,j)
    bh(2,j)=bh(2,j)*cc(1,jt)
    300  bh(2,j-1)=bh(2,j-1)-ct(1,jt)*bh(2,j)

    do 400 i=i1,3,-1
    it=i-1
    bh(i,2)=bh(i,2)*cc(it,1)
    400  bh(i-1,2)=bh(i-1,2)-cr(it,1)*bh(i,2)
    bh(2,2)=bh(2,2)*cc(1,1)
end subroutine

! ---------------------------------------------------------------------
subroutine p_sipsqelim(cb,cl,cc,cr,ct,b,bh)
    parameter(i3=i2-1,j3=j2-1,i0j0=i0*j0)
    ! real*8 cb,cl,cc,cr,ct,b,bh
    real*8 b,bh
    dimension cb(i2,j2),cl(i2,j2),cc(i2,j2),cr(i2,j2),ct(i2,j2),b(i0,j0),bh(i0,j0)

    call dcopy(i0j0,b,1,bh,1)
    do 100 j=2,j2
    jt=j-1
    do 150 i=2,i2
    it=i-1
    bh(i,j)=bh(i,j)*cc(it,jt)
    bh(i+1,j)=bh(i+1,j)-cl(it,jt)*bh(i,j)
    150  bh(i,j+1)=bh(i,j+1)-cb(it,jt)*bh(i,j)
    bh(i1,j)=bh(i1,j)*cc(i2,jt)
    100  bh(i1,j+1)=bh(i1,j+1)-cb(i2,jt)*bh(i1,j)

    do 200 i=2,i2
    it=i-1
    bh(i,j1)=bh(i,j1)*cc(it,j2)
    200  bh(i+1,j1)=bh(i+1,j1)-cl(it,j2)*bh(i,j1)
    bh(i1,j1)=bh(i1,j1)*cc(i2,j2)

    do 300 j=j1,3,-1
    jt=j-1
    do 350 i=i1,3,-1
    it=i-1
    bh(i-1,j)=bh(i-1,j)-cr(it,jt)*bh(i,j)
    350  bh(i,j-1)=bh(i,j-1)-ct(it,jt)*bh(i,j)
    300  bh(2,j-1)=bh(2,j-1)-ct(1,jt)*bh(2,j)

    do 400 i=i1,3,-1
    400  bh(i-1,2)=bh(i-1,2)-cr(i-1,1)*bh(i,2)
end subroutine

! ----------------------------------------------------------------------
subroutine rep2(ax,ay,bb,cx,cy,rinv,rinv1,dum0,dum1,dum2,dumg,f,x,ie)
    ! ----------------------------------------------------------------------
    !ibm  real*8 rinv,rinv1,dum0,dum1,dum2,x,h,row
    parameter(nbg0=nb0*ngy0,nbg1=nbg0-1,ibir=i2t/ngy0)
    real*8 x,rinv,rinv1,dum1,dum2,dum0,dumg,dd
    dimension ax(i2,j2),ay(i2,j2),bb(i2,j2),cx(i2,j2),cy(i2,0:j2),f(i2,j2),rinv(ibir,i0,nbg0),rinv1(ibir,i0,nbg1),ie(nb0),dum0(i0,nb0),dum1(ibir),dum2(i0),x(i0,j0),dumg(i2t)

    character grd*7
    common/grd/grd


    do 160 ng=0,ngy0-1
    jsp=1
    do 150 nb=1,nb0
    nbg=ng*nb0+nb
    if (mylat .eq. ng) then
	jfp=ie(nb)-2
	do 106 j=jsp,jfp
	do 105 i=1,i2
	105  x(i+1,j+2)=(f(i,j)-ax(i,j)*x(i,j+1)-ay(i,j)*x(i+1,j)-bb(i,j)*x(i+1,j+1)-cx(i,j)*x(i+2,j+1))/cy(i,j)
	call mpi_sendrecv(x(2,j+2),1,mpi_real8,m_w,1,x(i0,j+2),1,mpi_real8,m_e,1,m_cart,istat,ierr)
	call mpi_sendrecv(x(i1,j+2),1,mpi_real8,m_e,1,x(1,j+2),1,mpi_real8,m_w,1,m_cart,istat,ierr)
	106  continue
	if (nbg.eq.nbg0) go to 160
	j=ie(nb)-1
	do 115 i=1,i2
	115  dum2(i)=f(i,j)-ax(i,j)*x(i,j+1)-ay(i,j)*x(i+1,j)-bb(i,j)*x(i+1,j+1)-cx(i,j)*x(i+2,j+1)-cy(i,j)*x(i+1,j+2)
	j=ie(nb)
	call mpi_allgather(dum2,i2,mpi_real8,dumg,i2,mpi_real8,m_comm_lon,ierr)
	do 116 n=1,i0
	dum2(n)=x(n,j)
	116  dum0(n,nb)=x(n,j)
	dd=1.d0
    else
	if (nbg .eq. nbg0) go to 160
	dd=0.d0
    endif
    call mpi_scatter(dumg,ibir,mpi_real8,dum1,ibir,mpi_real8,ng,m_comm_lat,ierr)
    call dgemv('t',ibir,i0,-1.d0,rinv1(1,1,nbg),ibir,dum1,1,dd,dum2,1)
    if (nb .eq. nb0) go to 150
    call mpi_reduce(dum2,x(1,ie(nb)),i0,mpi_real8,mpi_sum,ng,m_comm_lat,ierr)
    jsp=ie(nb)

    150  continue
    call mpi_reduce(dum2,x(1,1),i0,mpi_real8,mpi_sum,ng+1,m_comm_lat,ierr)
    160  continue

    !  wenien
    !       open(160,file='opt/rep160'//grd,form='unformatted')
    !       write(160) x,f
    !       close(160)


    do 300 ng=ngy0-1,0,-1
    do 250 nbs=1,nb0
    nb=nb0-nbs+1
    nbg=nb0*ng+nb

    jsp=1
    if (nb.ne.1) jsp=ie(nb-1)
    if (mylat .eq. ng) then
	if (nbg.eq.nbg0) go to 201
	j=ie(nb)
	do 200 n=1,i0
	200  x(n,j)=dum0(n,nb)
	201  j=ie(nb)-1
	do 210 i=1,i2
	210  dum2(i)=f(i,j)-ax(i,j)*x(i,j+1)-ay(i,j)*x(i+1,j)-bb(i,j)*x(i+1,j+1)-cx(i,j)*x(i+2,j+1)-cy(i,j)*x(i+1,j+2)
	call mpi_allgather(dum2,i2,mpi_real8,dumg,i2,mpi_real8,m_comm_lon,ierr)
    endif

    call mpi_scatter(dumg,ibir,mpi_real8,dum1,ibir,mpi_real8,ng,m_comm_lat,ierr)
    call dgemv('t',ibir,i0,1.d0,rinv(1,1,nbg),ibir,dum1,1,0.d0,dum2,1)
    call mpi_reduce(dum2,dum0(1,nb),i0,mpi_real8,mpi_sum,ng,m_comm_lat,ierr)

    if (mylat .eq. ng) then
	do 220 n=1,i0
	220  x(n,jsp+1)=x(n,jsp+1)+dum0(n,nb)
    endif
    if (nbg.eq.1) go to 300
    if (mylat .eq. ng) then
	do 230 m=1,i2
	230  dum2(m)=dum0(m+1,nb)*cy(m,jsp-1)
	call mpi_allgather(dum2,i2,mpi_real8,dumg,i2,mpi_real8,m_comm_lon,ierr)
    endif
    call mpi_scatter(dumg,ibir,mpi_real8,dum1,ibir,mpi_real8,ng,m_comm_lat,ierr)
    call dgemv('t',ibir,i0,1.d0,rinv1(1,1,nbg-1),ibir,dum1,1,0.d0,dum2,1)
    call mpi_reduce(dum2,dum0(1,nb),i0,mpi_real8,mpi_sum,ng,m_comm_lat,ierr)
    if (mylat .eq. ng) then
	do 245 n=1,i0
	245  dum0(n,nb)=x(n,jsp)+dum0(n,nb)
    endif
    250  continue
    if (mylat .eq. ng) call mpi_send(x(1,2),i0,mpi_real8,m_s,1,m_cart,ierr)
    if (mylat .eq. ng-1) call mpi_recv(x(1,j0),i0,mpi_real8,m_n,1,m_cart,istat,ierr)
    300  continue
    if (mylat .eq. 0) then
	do 350 i=1,i0
	350  dum0(i,1)=0.d0
    endif

    jsp=1
    do 400 nb=1,nb0
    jfp=ie(nb)-2
    if (nb.eq.nb0) jfp=ie(nb)-2
    do 410 i=1,i0
    410  x(i,jsp)=dum0(i,nb)
    do 420 j=jsp,jfp
    do 430 i=1,i2
    430  x(i+1,j+2)=(f(i,j)-ax(i,j)*x(i,j+1)-ay(i,j)*x(i+1,j)-bb(i,j)*x(i+1,j+1)-cx(i,j)*x(i+2,j+1))/cy(i,j)
    call mpi_sendrecv(x(2,j+2),1,mpi_real8,m_w,1,x(i0,j+2),1,mpi_real8,m_e,1,m_cart,istat,ierr)
    call mpi_sendrecv(x(i1,j+2),1,mpi_real8,m_e,1,x(1,j+2),1,mpi_real8,m_w,1,m_cart,istat,ierr)
    420  continue
    400  jsp=ie(nb)
end subroutine


! ----------------------------------------------------------------------
subroutine rep(ax,ay,bb,cx,cy,rinv,rinv1,dum0,dum1,dum2,dumg,f,x,ie)
    parameter(nbg0=nb0*ngy0,nbg1=nbg0-1,ig0=i2*ngx0+2,ig2=ig0-2,ib=ig2/ngy0)
    real*8 x,rinv,rinv1,dum1,dum2,dum0,dumg,dd
    ! real*8 ax,ay,bb,cx,cy,f
    dimension ax(i2,j2),ay(i2,j2),bb(i2,j2),cx(i2,j2),cy(i2,0:j2),f(i2,j2),rinv(ib,i0,nbg0),rinv1(ib,i0,nbg1),ie(nb0),dum0(i0,nb0),dum1(ib),dum2(i0),x(i0,j0),dumg(i2t)

    real*8 timer
    common/timer/timer(10)

    timer(7)=mpi_wtime()

    do 160 ng=0,ngy0-1
    jsp=1
    do 150 nb=1,nb0
    nbg=ng*nb0+nb
    if (mylat .eq. ng) then
	jfp=ie(nb)-2
	do 106 j=jsp,jfp
	do 105 i=1,i2
	105  x(i+1,j+2)=(f(i,j)-ax(i,j)*x(i,j+1)-ay(i,j)*x(i+1,j)-bb(i,j)*x(i+1,j+1)-cx(i,j)*x(i+2,j+1))/cy(i,j)
	timer(8)=mpi_wtime()
	call mpi_sendrecv(x(2,j+2),1,mpi_real8,m_w,1,x(i0,j+2),1,mpi_real8,m_e,1,m_cart,istat,ierr)
	call mpi_sendrecv(x(i1,j+2),1,mpi_real8,m_e,1,x(1,j+2),1,mpi_real8,m_w,1,m_cart,istat,ierr)

	106  timer(5)=timer(5)+mpi_wtime()-timer(8)
	if (nbg.eq.nbg0) go to 160
	j=ie(nb)-1
	do 115 i=1,i2
	115  dum2(i)=f(i,j)-ax(i,j)*x(i,j+1)-ay(i,j)*x(i+1,j)-bb(i,j)*x(i+1,j+1)-cx(i,j)*x(i+2,j+1)-cy(i,j)*x(i+1,j+2)
	j=ie(nb)
	timer(8)=mpi_wtime()
	call mpi_allgather(dum2,i2,mpi_real8,dumg,i2,mpi_real8,m_comm_lon,ierr)
	timer(5)=timer(5)+mpi_wtime()-timer(8)
	do 116 n=1,i0
	dum2(n)=x(n,j)
	116  dum0(n,nb)=x(n,j)
	dd=1.d0
    else
	if (nbg .eq. nbg0) go to 160
	dd=0.d0
    endif
    timer(8)=mpi_wtime()
    call mpi_scatter(dumg,ib,mpi_real8,dum1,ib,mpi_real8,ng,m_comm_lat,ierr)
    timer(5)=timer(5)+mpi_wtime()-timer(8)
    call dgemv('t',ib,i0,-1.d0,rinv1(1,1,nbg),ib,dum1,1,dd,dum2,1)
    if (nb .eq. nb0) go to 150
    timer(8)=mpi_wtime()
    call mpi_reduce(dum2,x(1,ie(nb)),i0,mpi_real8,mpi_sum,ng,m_comm_lat,ierr)
    timer(5)=timer(5)+mpi_wtime()-timer(8)
    jsp=ie(nb)

    150  continue
    timer(8)=mpi_wtime()
    call mpi_reduce(dum2,x(1,1),i0,mpi_real8,mpi_sum,ng+1,m_comm_lat,ierr)
    timer(5)=timer(5)+mpi_wtime()-timer(8)
    160  continue

    do 300 ng=ngy0-1,0,-1
    do 250 nbs=1,nb0
    nb=nb0-nbs+1
    nbg=nb0*ng+nb

    jsp=1
    if (nb.ne.1) jsp=ie(nb-1)
    if (mylat .eq. ng) then
	if (nbg.eq.nbg0) go to 201
	j=ie(nb)
	do 200 n=1,i0
	200  x(n,j)=dum0(n,nb)
	201  j=ie(nb)-1
	do 210 i=1,i2
	210  dum2(i)=f(i,j)-ax(i,j)*x(i,j+1)-ay(i,j)*x(i+1,j)-bb(i,j)*x(i+1,j+1)-cx(i,j)*x(i+2,j+1)-cy(i,j)*x(i+1,j+2)
	timer(8)=mpi_wtime()
	call mpi_allgather(dum2,i2,mpi_real8,dumg,i2,mpi_real8,m_comm_lon,ierr)
	timer(5)=timer(5)+mpi_wtime()-timer(8)
    endif

    timer(8)=mpi_wtime()
    call mpi_scatter(dumg,ib,mpi_real8,dum1,ib,mpi_real8,ng,m_comm_lat,ierr)
    timer(5)=timer(5)+mpi_wtime()-timer(8)
    call dgemv('t',ib,i0,1.d0,rinv(1,1,nbg),ib,dum1,1,0.d0,dum2,1)
    timer(8)=mpi_wtime()
    call mpi_reduce(dum2,dum0(1,nb),i0,mpi_real8,mpi_sum,ng,m_comm_lat,ierr)
    timer(5)=timer(5)+mpi_wtime()-timer(8)

    if (mylat .eq. ng) then
	do 220 n=1,i0
	220  x(n,jsp+1)=x(n,jsp+1)+dum0(n,nb)
    endif
    if (nbg.eq.1) go to 300
    if (mylat .eq. ng) then
	do 230 m=1,i2
	230  dum2(m)=dum0(m+1,nb)*cy(m,jsp-1)
	timer(8)=mpi_wtime()
	call mpi_allgather(dum2,i2,mpi_real8,dumg,i2,mpi_real8,m_comm_lon,ierr)
	timer(5)=timer(5)+mpi_wtime()-timer(8)
    endif
    timer(8)=mpi_wtime()
    call mpi_scatter(dumg,ib,mpi_real8,dum1,ib,mpi_real8,ng,m_comm_lat,ierr)
    timer(5)=timer(5)+mpi_wtime()-timer(8)
    call dgemv('t',ib,i0,1.d0,rinv1(1,1,nbg-1),ib,dum1,1,0.d0,dum2,1)
    timer(8)=mpi_wtime()
    call mpi_reduce(dum2,dum0(1,nb),i0,mpi_real8,mpi_sum,ng,m_comm_lat,ierr)
    timer(5)=timer(5)+mpi_wtime()-timer(8)
    if (mylat .eq. ng) then
	do 245 n=1,i0
	245  dum0(n,nb)=x(n,jsp)+dum0(n,nb)
    endif
    250  continue
    if (mylat .eq. ng) call mpi_send(x(1,2),i0,mpi_real8,m_s,1,m_cart,ierr)
    if (mylat .eq. ng-1) call mpi_recv(x(1,j0),i0,mpi_real8,m_n,1,m_cart,istat,ierr)
    300  continue
    if (mylat .eq. 0) then
	do 350 i=1,i0
	350  dum0(i,1)=0.d0
    endif

    jsp=1
    do 400 nb=1,nb0
    jfp=ie(nb)-2
    if (nb.eq.nb0) jfp=ie(nb)-2
    do 410 i=1,i0
    410  x(i,jsp)=dum0(i,nb)
    do 420 j=jsp,jfp
    do 430 i=1,i2
    430  x(i+1,j+2)=(f(i,j)-ax(i,j)*x(i,j+1)-ay(i,j)*x(i+1,j)-bb(i,j)*x(i+1,j+1)-cx(i,j)*x(i+2,j+1))/cy(i,j)
    timer(8)=mpi_wtime()
    call mpi_sendrecv(x(2,j+2),1,mpi_real8,m_w,1,x(i0,j+2),1,mpi_real8,m_e,1,m_cart,istat,ierr)
    call mpi_sendrecv(x(i1,j+2),1,mpi_real8,m_e,1,x(1,j+2),1,mpi_real8,m_w,1,m_cart,istat,ierr)
    420  timer(5)=timer(5)+mpi_wtime()-timer(8)
    400  jsp=ie(nb)
end subroutine


end module

module const
    integer, parameter::    i2t=320
    integer, parameter::    j2t=288
    integer, parameter::    k0=41

    integer, parameter::    i0t=i2t+2
    integer, parameter::    j0t=j2t+2
    integer, parameter::    i1t=i0t-1
    integer, parameter::    j1t=j0t-1 

    integer, parameter::    ngx0=4
    integer, parameter::    ngy0=6
    integer, parameter::    n0=4
    integer, parameter::    ng0=ngx0*ngy0 
    integer, parameter::    ngx1=ngx0-1
    integer, parameter::    ngy1=ngy0-1
    integer, parameter::    nb0=j2t/ngy0/n0
    integer, parameter::    nb1=nb0-1 
    integer, parameter::    i0=i2t/ngx0+2
    integer, parameter::    i1=i0-1
    integer, parameter::    i2=i0-2 
    integer, parameter::    j0=j2t/ngy0+2
    integer, parameter::    j1=j0-1
    integer, parameter::    j2=j0-2 
    integer, parameter::    k1=k0-1
    integer, parameter::    k2=k0-2

    integer, parameter::    ncopt=30
    integer, parameter::    ini_clim=1

    integer, parameter::   nbg0=nb0*ngy0
    integer, parameter::   nbg1=nbg0-1
    integer, parameter::   i01=i0+1
    integer, parameter::   ibir=i2t/ngy0
    integer, parameter::   jg0=j2*ngy0+2
    integer, parameter::   j01=j0+1
    integer, parameter::   jg1=jg0-1
    integer, parameter::   jg2=jg0-2
    integer, parameter::   ig0=i2*ngx0+2
    integer, parameter::   ig1=ig0-1
    integer, parameter::   ig2=ig0-2

    real*8,    parameter::   o12=1./12.
    real*8,    parameter::   o24=1./24.
    
   
end module

module met 
    use const
    use comm
    use var
implicit real*8 (a-h,o-z)
#   include "pnetcdf.inc"

contains

subroutine metgen
    dimension fg(j2t),tanphig(j2t),		  &
     yg(j0t),yvg(j0t),yvdegg(j0t),ydegg(j0t),     &
     csg(j0t),csvg(j1t),ocsg(j0t),ocsvg(j1t),     &
     dxg(j0t),dxvg(j1t),odxg(j0t),odxvg(j1t),     &
     dyg(j0t),dyvg(j1t),odyg(j0t),odyvg(j1t)      


    real*8 dd,ddv,flag  !! kilmer

    ! tlz= depth of bottom z-level
    ! ztop= depth of interface between top two layers
    ! dydx= ratio of dy to dx at each latitude (constant)
    ! dxmnut= longitude resolution (minutes)
    ! r0= earth's radius (cm)
    ! dxdeg= longitudinal resolution (degrees)
    data tlz_depth,d,ztop,dydx,dxmnut,y0deg,r0/ &
      5800.E2,.04, 20.E2,  1.,   60.,-86.7,6.4E8/  ! kilmer

    dxmnut=360.*60./dble(i2t)
    dxdeg=dxmnut/60.
    !dydx=dydx/dxdeg


    westdeg=360./dble(ngx0)
    westdeg=westdeg*dble(mylon)
    if (westdeg .ge. 360.) westdeg=westdeg-360.

!    open(9,file='data/westdeg'//grd)
!    rewind 9
!    write(9,'(f9.4)') westdeg
!    close(9)
    call wr8nc_westdeg !dog
!    open(18,file='data/latitudes'//grd,form='unformatted')
!    open(10,file='data/yzgrid'//grd,form='unformatted')
!    rewind 10
!    rewind 18

    tmp=.01*tlz_depth
    dzz=tmp/(2.*dble(k1))
    coeff_c=.001
    coeff_d=d
    coeff_a=tmp*(1.-coeff_d)/(1.-exp(coeff_c*tmp))
    coeff_b=-coeff_a
    zz=0.
    do k=1,k0+k1
	z(k)=100.*(coeff_a+coeff_b*exp(coeff_c*zz)+coeff_d*zz)
	zz=zz+dzz
    enddo	     
    if(myid.eq.0)write(*,'(10f8.0)') z

    ! calculate vertical metrics
    do k=1,k1
	odz(k)=1./(z(2*k+1)-z(2*k-1))
    enddo	     
    ! odzw(1,i,j) and odzw(k0,i,j) are not used
    do k=2,k1
	odzw(k)=1./(z(2*k)-z(2*k-2))
    enddo	     


    it=mylon*i2
    jt=mylat*j2

    ! degrees to radians
    pi_180=3.141592654/180.
    yvdegg(1)=y0deg
    ydegg(1)=y0deg
    yvg(1)=0.
    dyg(1)=0.
    odyg(1)=0.
    ! equatorial dx
    dx0=r0*dxdeg*pi_180
    ! kilmer
    !dd=21.0/100.0
    !ddv=dd/100.0
    !flag=1.0
    ! kilmer end
    do j=2,j0t
	! initial guess
	!      yvdegg(j)=yvdegg(j-1)+dxdeg*dydx*cos(yvdegg(j-1)*pi_180)
	yvdegg(j)=yvdegg(j-1)+1.476-dxdeg*dydx*cos(yvdegg(j-1)*pi_180) ! kilmer
	!      print*,j,yvdegg(j)
	dxg(j)=dx0*cos(.5*(yvdegg(j-1)+yvdegg(j))*pi_180)

	tmp=yvdegg(j)
	!      yvdegg(j)=yvdegg(j-1)+dydx*dxg(j)/(r0*pi_180)
	yvdegg(j)=yvdegg(j-1)+1.476-dydx*dxg(j)/(r0*pi_180) ! kilmer
	ydegg(j)=.5*(yvdegg(j-1)+yvdegg(j))
	csg(j)=cos(ydegg(j)*pi_180)
	dxrad=dxdeg*pi_180*csg(j)
	dxg(j)=dxrad*r0
	dyrad=(yvdegg(j)-yvdegg(j-1))*pi_180
	temp=dyrad/dxrad
	dydeg=yvdegg(j)-yvdegg(j-1)

	dyg(j)=dydeg*r0*pi_180
	dyvg(j-1)=(ydegg(j)-ydegg(j-1))*r0*pi_180
	odyg(j)=1./dyg(j)
	odyvg(j-1)=1./dyvg(j-1)
	yvg(j)=yvg(j-1)+dyg(j)
	yg(j)=.5*(yvg(j)+yvg(j-1))
	ocsg(j)=1./csg(j)
	odxg(j)=1./dxg(j)
	csvg(j-1)=cos(pi_180*yvdegg(j-1))
	ocsvg(j-1)=1./csvg(j-1)
	dxvg(j-1)=dx0*csvg(j-1)
	odxvg(j-1)=1./dxvg(j-1)
	! kilmer
	!odxvg(j-1)=1./dxvg(j-1)
	!if (j>j0t-100) then
	!    dd=dd+ddv
	!    flag=0.0
	!endif
	!if (flag==1.0) dd=dd-ddv
	!if (dd<0.0) dd=0.0
    enddo
    ! kilmer end
    y1deg=yvdegg(j1)


    jt=mylat*j2
    do j=1,j1
	csv(j)=csvg(jt+j)
	ocsv(j)=ocsvg(jt+j)
	dxv(j)=dxvg(jt+j)
	odxv(j)=odxvg(jt+j)
	dyv(j)=dyvg(jt+j)
	odyv(j)=odyvg(jt+j)
    enddo
    do j=1,j0
	y(j)=yg(jt+j)
	yv(j)=yvg(jt+j)
	yvdeg(j)=yvdegg(jt+j)
	ydeg(j)=ydegg(jt+j)
	cs(j)=csg(jt+j)
	ocs(j)=ocsg(jt+j)
	dx(j)=dxg(jt+j)
	odx(j)=odxg(jt+j)
	dy(j)=dyg(jt+j)
	ody(j)=odyg(jt+j)
    enddo
!    open(16,file='data/cell_centers'//grd)
     if (myid ==0) write(*,16) (j,ydeg(j),j=2,j1)
    16   format(' j ','cell center latitude'/(i3,f11.4))
!    write(18) ydeg

    ! ----------------------------
    ! set coriolis parameter array
    ! ----------------------------
    omega2=3.141592654/21600.
    do j=2,j1
	! spherical curvature parameter
	tanphi(j-1)=tan(pi_180*ydeg(j))/r0
	f(j-1)=omega2*sin(pi_180*ydeg(j))
    enddo
    do i=1,i0
	xdeg(i)=westdeg+(i-1.5)*(dxmnut/60.)
	!w         xdeg(i)=(i-1.5)*(dxmnut/60.)
	if(xdeg(i).ge.360.)then
	    xdeg(i)=xdeg(i)-360.
	    elseif(xdeg(i).lt.0.)then
	    xdeg(i)=xdeg(i)+360.
	endif
    enddo
    write(*,'(10f9.4)') (xdeg(i),i=2,i1)

!    write(10)  j0,k0
    write(*,*) j0,k0

!    write(10) tlz_depth,z,odz,odzw,dxmnut,xdeg,y,yv,yvdeg,ydeg,cs,csv,ocs,ocsv,dx,dxv,odx,odxv,dy,dyv,ody,odyv
    call wr8nc_yzgrid(tlz_depth,dxmnut) !dog
!    open(11,file='data/ydeg'//grd,form='unformatted')
!    write(11) ydeg
    call wr8nc_ydeg !dog
    ! kilmer
    !if (myid==0) then
    !	open(3333,file='data/global_ydegg.log',form='formatted')
    !	write(3333,322) (ydegg(j),j=1,j0t)
    !	close(3333)
    !endif
    !322  format(/'global ydegg'/(10f10.4))
    ! kilmer end
    if(mylon.eq.0)then
	write(*,20) (yvdeg(j),j=1,j1)
	20   format(/'model latitude grid lines'/(10f8.4))
	write(*,21) f
	21   format('coriolis parameter'/(1p,10e9.2))
	write(*,99) (j,yvdeg(j),j=1,j1)
	99   format('j,yvdeg(j)=',i3,f9.4)
    endif
end subroutine

subroutine wr8nc_westdeg
use const, only:ngx0,ngy0
use comm, only: mylon,myid,m_cart
 implicit none
integer :: rank,ncid,ierr,nout
 INTEGER(KIND=MPI_OFFSET_KIND) :: start(1),count(1),bufcount=1,dimm
 integer :: x_dim
 integer :: dims=1,dimids(1),varid
 real*8 :: mydata(1)

dimm = ngx0*ngy0
    mydata(1)=360./real(ngx0)
    mydata(1)=mydata(1)*real(mylon)
    if (mydata(1) > 360.) mydata(1)=mydata(1)-360.

 ierr=nfmpi_create(m_cart,'data/westdeg.nc',nf_64bit_offset,mpi_info_null,ncid)
 nout = nfmpi_def_dim(ncid,"myid+1",dimm,x_dim)
 dimids = (/x_dim/)
 nout = nfmpi_def_var(ncid,"westdeg",NF_DOUBLE,dims,dimids,varid)
 nout = nfmpi_enddef(ncid)
 start = (/myid+1/)
 count = (/1/)
 nout = nfmpi_put_vara_all(ncid,varid,start,count,mydata,bufcount,MPI_DOUBLE)
 nout = nfmpi_close(ncid)

end subroutine wr8nc_westdeg

subroutine wr8nc_ydeg
use const, only: ngy0,j0
use comm, only: myid,m_cart
implicit none
character :: fn*12
integer :: ncid,ierr,ns
integer :: j0id
integer :: iydeg
integer(kind=mpi_offset_kind) :: dim_nn
integer(kind=mpi_offset_kind) :: ns_i,nc_i
      !output file name
      fn = 'data/ydeg.nc'
      !create ncfile and id
      ierr=nfmpi_create(m_cart,fn,nf_64bit_offset,mpi_info_null,ncid)
      !define dimension and assign dimID
      dim_nn = j0*ngy0
      ierr=nfmpi_def_dim(ncid,"j0_global",dim_nn,j0id)

      !define variable
      ns = j0id
      ierr=nfmpi_def_var(ncid,"ydeg",nf_double,1,ns,iydeg)
      ierr=nfmpi_enddef(ncid)
      !put variable
      ns_i = mylat*j0+1
      nc_i = j0
      ierr=nfmpi_put_vara_double_all(ncid,iydeg,ns_i,nc_i,ydeg)

      ierr=nfmpi_close(ncid)

end subroutine wr8nc_ydeg

subroutine wr8nc_yzgrid(tlz_depth,dxmnut)
use const, only: i0,j0,j1,k0,k1,ngx0,ngy0
use comm, only: m_cart,mylat,mylon
implicit none

!declare pnetcdf var
character :: fn*14
integer :: ierr,ncid,ns
integer :: siid,k0id,k1id,kkid,i0id,j0id,j1id
integer :: itlz,idxm,iz,iodz,iodzw,ixdeg,iij,iik
integer :: iy,iyv,iyvd,iydeg,ics,iocs,icsv,iocsv,idx,iodx
integer :: idxv,iodxv,idy,idyv,iody,iodyv
integer(kind=mpi_offset_kind) :: dim_nn(7)
integer(kind=mpi_offset_kind) :: ns_i,nc_i
real*8 :: tlz_depth,dxmnut
integer :: tmp(1)
      !output file name
      fn = 'data/yzgrid.nc'
      !create ncfile and id
      ierr=nfmpi_create(m_cart,fn,nf_64bit_offset,mpi_info_null,ncid)

      !define dimension and assign dimID
      dim_nn(1) = 1
      dim_nn(2) = k0
      dim_nn(3) = k1
      dim_nn(4) = k0+k1
      dim_nn(5) = i0*ngx0
      dim_nn(6) = j0*ngy0
      dim_nn(7) = j1*ngy0
      ierr=nfmpi_def_dim(ncid,"pt_val",dim_nn(1),siid)
      ierr=nfmpi_def_dim(ncid,"k0",dim_nn(2),k0id)
      ierr=nfmpi_def_dim(ncid,"k1",dim_nn(3),k1id)
      ierr=nfmpi_def_dim(ncid,"k0+k1",dim_nn(4),kkid)
      ierr=nfmpi_def_dim(ncid,"i0_global",dim_nn(5),i0id)
      ierr=nfmpi_def_dim(ncid,"j0_global",dim_nn(6),j0id)
      ierr=nfmpi_def_dim(ncid,"j1_global",dim_nn(7),j1id)

      !define variables and assign varID
      ns = siid
      ierr=nfmpi_def_var(ncid,"j0",nf_int,1,ns,iij)
      ierr=nfmpi_def_var(ncid,"k0",nf_int,1,ns,iik)
      ierr=nfmpi_def_var(ncid,"tlz_depth",nf_double,1,ns,itlz)
      ierr=nfmpi_def_var(ncid,"dxmnut",nf_double,1,ns,idxm)
      ns = kkid
      ierr=nfmpi_def_var(ncid,"z",nf_double,1,ns,iz)
      ns = k1id
      ierr=nfmpi_def_var(ncid,"odz",nf_double,1,ns,iodz)
      ns = k0id
      ierr=nfmpi_def_var(ncid,"odzw",nf_double,1,ns,iodzw)
      ns = i0id
      ierr=nfmpi_def_var(ncid,"xdeg",nf_double,1,ns,ixdeg)
      ns = j0id
      ierr=nfmpi_def_var(ncid,"y",nf_double,1,ns,iy)
      ierr=nfmpi_def_var(ncid,"yv",nf_double,1,ns,iyv)
      ierr=nfmpi_def_var(ncid,"yvdeg",nf_double,1,ns,iyvd)
      ierr=nfmpi_def_var(ncid,"ydeg",nf_double,1,ns,iydeg)
      ierr=nfmpi_def_var(ncid,"cs",nf_double,1,ns,ics)
      ierr=nfmpi_def_var(ncid,"ocs",nf_double,1,ns,iocs)
      ierr=nfmpi_def_var(ncid,"dx",nf_double,1,ns,idx)
      ierr=nfmpi_def_var(ncid,"odx",nf_double,1,ns,iodx)
      ierr=nfmpi_def_var(ncid,"dy",nf_double,1,ns,idy)
      ierr=nfmpi_def_var(ncid,"ody",nf_double,1,ns,iody)
      ns = j1id
      ierr=nfmpi_def_var(ncid,"csv",nf_double,1,ns,icsv)
      ierr=nfmpi_def_var(ncid,"ocsv",nf_double,1,ns,iocsv)
      ierr=nfmpi_def_var(ncid,"dxv",nf_double,1,ns,idxv)
      ierr=nfmpi_def_var(ncid,"odxv",nf_double,1,ns,iodxv)
      ierr=nfmpi_def_var(ncid,"dyv",nf_double,1,ns,idyv)
      ierr=nfmpi_def_var(ncid,"odyv",nf_double,1,ns,iodyv)
      ierr=nfmpi_enddef(ncid)

      !put variables
      ns_i = 1
      nc_i = 1
      ierr=nfmpi_begin_indep_data(ncid)
      tmp(1) = j0
      ierr=nfmpi_put_var_int(ncid,iij,tmp)
      tmp(1) = k0
      ierr=nfmpi_put_var_int(ncid,iik,tmp)
      ierr=nfmpi_put_var_double(ncid,itlz,tlz_depth)
      ierr=nfmpi_put_var_double(ncid,idxm,dxmnut)
      nc_i = k0+k1
      ierr=nfmpi_put_var_double(ncid,iz,z)
      nc_i = k1
      ierr=nfmpi_put_var_double(ncid,iodz,odz)
      nc_i = k0
      ierr=nfmpi_put_var_double(ncid,iodzw,odzw)
      ierr=nfmpi_end_indep_data(ncid)

      ns_i = mylon*i0+1
      nc_i = i0
      ierr=nfmpi_put_vara_double_all(ncid,ixdeg,ns_i,nc_i,xdeg)
      ns_i = mylat*j0+1
      nc_i = j0
      ierr=nfmpi_put_vara_double_all(ncid,iy,ns_i,nc_i,y)
      ierr=nfmpi_put_vara_double_all(ncid,iyv,ns_i,nc_i,yv)
      ierr=nfmpi_put_vara_double_all(ncid,iyvd,ns_i,nc_i,yvdeg)
      ierr=nfmpi_put_vara_double_all(ncid,iydeg,ns_i,nc_i,ydeg)
      ierr=nfmpi_put_vara_double_all(ncid,ics,ns_i,nc_i,cs)
      ierr=nfmpi_put_vara_double_all(ncid,iocs,ns_i,nc_i,ocs)
      ierr=nfmpi_put_vara_double_all(ncid,idx,ns_i,nc_i,dx)
      ierr=nfmpi_put_vara_double_all(ncid,iodx,ns_i,nc_i,odx)
      ierr=nfmpi_put_vara_double_all(ncid,idy,ns_i,nc_i,dy)
      ierr=nfmpi_put_vara_double_all(ncid,iody,ns_i,nc_i,ody)
      ns_i = mylat*j1+1
      nc_i = j1
      ierr=nfmpi_put_vara_double_all(ncid,icsv,ns_i,nc_i,csv)
      ierr=nfmpi_put_vara_double_all(ncid,iocsv,ns_i,nc_i,ocsv)
      ierr=nfmpi_put_vara_double_all(ncid,idxv,ns_i,nc_i,dxv)
      ierr=nfmpi_put_vara_double_all(ncid,iodxv,ns_i,nc_i,odxv)
      ierr=nfmpi_put_vara_double_all(ncid,idyv,ns_i,nc_i,dyv)
      ierr=nfmpi_put_vara_double_all(ncid,iodyv,ns_i,nc_i,odyv)

      ierr=nfmpi_close(ncid)

end subroutine wr8nc_yzgrid



end module

module io
    use const
    use var
    use comm 
implicit real*8 (a-h,o-z)
#   include "pnetcdf.inc"

    integer(kind=mpi_offset_kind) nn,ns_kji,nc_kji,ns_tji,nc_tji,ns_ji,nc_ji,ns_1,nc_1,nf_kji
    common/pnetcdf/nn(6),ns_kji(3),nc_kji(3),ns_tji(3),nc_tji(3),ns_ji(2),nc_ji(2),ns_1,nc_1,nf_kji(3)
    integer(kind=mpi_offset_kind) ns_kji2,nc_kji2,ns_tji2,nc_tji2,ns_ji2,nc_ji2,nf_kji2
    common/pnetcdf2/ns_kji2(3),nc_kji2(3),ns_tji2(3),nc_tji2(3),ns_ji2(2),nc_ji2(2),nf_kji2(3)


contains


subroutine init_io
    open(14,file='data/glo'//grd,form='formatted')
end subroutine


! ----------------------------------------------------------------------
subroutine write_hist
    parameter(i01=i0+1,j01=j0+1,nbg0=nb0*ngy0,nbg1=nbg0-1,ibir=i2t/ngy0)

    character fn*22
    integer*2 nbf

    real*8 rhoavg

    common/histavg/pavg(i0,j0,k1),uavg(i0,j0,k1), &
    vavg(i0,j0,k1),tavg(i0,j0,k1),cavg(i0,j0,k1), &
    savg(i0,j0,k1),wcavg(i0,j0,k0), &
    evavg(i0,j0,k0),hvavg(i0,j0,k0), &
    dmxavg(i0,j0,k1),dmyavg(i0,j0,k1),rhoavg(i0,j0,k1)

    dimension nbf(i2*j2*k1),nda(3),ndc(3),rbf(i2*j2*k1),rbfw(i2*j2*k0),rmbf(i2*j2*12)
    real*8 drbf(i2*j2*k1)
    call timeavg(p,pavg,k1,wopt)
    call timeavg(u2,uavg,k1,wopt)
    call timeavg(v2,vavg,k1,wopt)
    call timeavg(t2,tavg,k1,wopt)
    call timeavg(s2,savg,k1,wopt)
    call timeavg(dmx,dmxavg,k1,wopt)
    call timeavg(dmy,dmyavg,k1,wopt)
    call timeavgd(rho,rhoavg,k1,wopt)
!yc
    call timeavg(c2,cavg,k1,wopt)
!yc
    do 100 k=1,k0
    do 100 j=2,j1
    do 100 i=2,i1
    100  wcavg(i,j,k)=wcavg(i,j,k)+wopt*w(i,j,k)

    do 101 k=2,k1
    do 101 j=2,j1
    do 101 i=2,i1
    evavg(i,j,k)=evavg(i,j,k)+wopt*ev(i-1,j-1,k-1)
    101  hvavg(i,j,k)=hvavg(i,j,k)+wopt*hv(i-1,j-1,k-1)

    if (mod(itf,nopt*itfday) .ne. 0) return
    if(myid.eq.0) print*,'write output'

    ! wenien
    !      open(1111,file='data/his_check'//grd,form='unformatted')
    !      write(1111) uavg,vavg,tavg,savg,t2,s2
    !      close(1111)
    !      call mpi_finalize(ierr)
    !      stop 666

    write(fn,'(a11,i3.3,a1,i3.3,a3)'),'../output/data',nyr,'_',n360,'.nc'

    ierr=nfmpi_create(m_cart,fn,nf_64bit_offset,mpi_info_null,ncid)
    ierr=nfmpi_def_dim(ncid, "level-center", nn(1), kcid)
    ierr=nfmpi_def_dim(ncid, "level-face", nn(5), kfid)
    ierr=nfmpi_def_dim(ncid, "latitude", nn(2), jid)
    ierr=nfmpi_def_dim(ncid, "longitude", nn(3), iid)
    ierr=nfmpi_def_dim(ncid, "month", nn(4), mid)

    nda(3) = kcid
    nda(2) = jid
    nda(1) = iid
    ierr=nfmpi_def_var(ncid, "pressure", nf_double, 3, nda, idp)
    ierr=nfmpi_def_var(ncid, "u-velocity", nf_double, 3, nda, idu)
    ierr=nfmpi_def_var(ncid, "v-velocity", nf_double, 3, nda, idv)
    ierr=nfmpi_def_var(ncid, "temperature", nf_double, 3, nda, idt)
    ierr=nfmpi_def_var(ncid, "salinity", nf_double, 3, nda, ids)
    ierr=nfmpi_def_var(ncid, "dmx", nf_double, 3, nda, idmx)
    ierr=nfmpi_def_var(ncid, "dmy", nf_double, 3, nda, idmy)
    ierr=nfmpi_def_var(ncid, "rho", nf_double, 3, nda, irho)
!yc
    ierr=nfmpi_def_var(ncid, "cfc11", nf_double, 3, nda, idc)
!yc
    ndc(3) = kfid
    ndc(2) = jid
    ndc(1) = iid
    ierr=nfmpi_def_var(ncid, "w-velocity", nf_double, 3, ndc, idw)
    ierr=nfmpi_def_var(ncid, "hv", nf_double, 3, ndc, ihv)
    ierr=nfmpi_def_var(ncid, "ev", nf_double, 3, ndc, iev)
    ndc(3) = mid
    ndc(2) = jid
    ndc(1) = iid
    ierr=nfmpi_def_var(ncid, "qavg", nf_double, 3, ndc, iqavg)

    ierr=nfmpi_enddef(ncid)

    call mtx2vec_c(pavg,in,rbf)
    ierr=nfmpi_put_vara_double_all(ncid, idp, ns_kji2, nc_kji2, rbf)

    call mtx2vec_c(uavg,in,rbf)
    ierr=nfmpi_put_vara_double_all(ncid, idu, ns_kji2, nc_kji2, rbf)

    call mtx2vec_c(vavg,in,rbf)
    ierr=nfmpi_put_vara_double_all(ncid, idv, ns_kji2, nc_kji2, rbf)

    call mtx2vec_c(tavg,in,rbf)
    ierr=nfmpi_put_vara_double_all(ncid, idt, ns_kji2, nc_kji2, rbf)

    call mtx2vec_c(savg,in,rbf)
    ierr=nfmpi_put_vara_double_all(ncid, ids, ns_kji2, nc_kji2, rbf)
!yc
    call mtx2vec_c(cavg,in,rbf)
    ierr=nfmpi_put_vara_double_all(ncid, idc, ns_kji2, nc_kji2, rbf)
!yc
    call mtx2vec_c(dmxavg,in,rbf)
    ierr=nfmpi_put_vara_double_all(ncid, idmx, ns_kji2, nc_kji2, rbf)

    call mtx2vec_c(dmyavg,in,rbf)
    ierr=nfmpi_put_vara_double_all(ncid, idmy, ns_kji2, nc_kji2, rbf)

    call mtx2dec_c(rhoavg,in,drbf)
    ierr=nfmpi_put_vara_double_all(ncid,irho,ns_kji2,nc_kji2,drbf)

    call mtx2vec_f(wcavg,iw,rbfw)
    ierr=nfmpi_put_vara_double_all(ncid, idw, ns_kji2, nf_kji2, rbfw)

    call mtx2vec_f(hvavg,iw,rbfw)
    ierr=nfmpi_put_vara_double_all(ncid, ihv, ns_kji2, nf_kji2, rbfw)

    call mtx2vec_f(evavg,iw,rbfw)
    ierr=nfmpi_put_vara_double_all(ncid, iev, ns_kji2, nf_kji2, rbfw)

    call mtx2rvec2(qavg,rmbf,i2,j2,i2,j2,12,0,0)
    ierr=nfmpi_put_vara_double_all(ncid, iqavg, ns_tji2, nc_tji2, rmbf)

    call pnetcdferrck(ierr)

    ierr=nfmpi_close(ncid)

    pavg  = 0.
    uavg  = 0.
    vavg  = 0.
    tavg  = 0.
    savg  = 0.
!yc
    cavg  = 0.
!yc
    wcavg = 0.
    hvavg = 0.
    evavg = 0.
    dmxavg= 0.
    dmyavg= 0.
    rhoavg= 0.
end subroutine

! ----------------------------------------------------------------------
subroutine write_topo
    parameter(i01=i0+1,j01=j0+1,nbg0=nb0*ngy0,nbg1=nbg0-1,ibir=i2t/ngy0)

    character fn*17
    integer*2 nbf

    common/windsglo/taux(i2,j2,12),tauy(i2,j2,12)

    dimension z_c(k1),z_f(k0),nda(3),ndb(3),ndc(3),ndd(4),ndw(3)

    integer(kind=mpi_offset_kind) st_z,ct_z,nss(4),nee(4),nws(3),nwe(3),nks(2),nke(2)

    dimension xlon(i2),ylat(j2)

    dimension wbf(i2*j2),sbf(i2*j2*k1),rbf(i2*j2*12),vbf(i2*j2*k1*12)

    dimension inf(i2*j2*k1),iwf(i2*j2*k0),kbf(i2*j2)


    fn='../output/topo.nc'

    do 999 j=1,j2
    999 ylat(j)=ydeg(j+1)
    do 1000 i=1,i2
    1000 xlon(i)=xdeg(i+1)
    do 1001 k=1,k1
    1001 z_c(k)=z(2*k)
    do 1002 k=1,k0
    1002 z_f(k)=z(1+2*(k-1))


    ierr=nfmpi_create(m_cart,fn,nf_64bit_offset,mpi_info_null,ncid)
    ierr=nfmpi_def_dim(ncid, "level-center", nn(1), kcid)
    ierr=nfmpi_def_dim(ncid, "level-face", nn(5), kfid)
    ierr=nfmpi_def_dim(ncid, "latitude", nn(2), jid)
    ierr=nfmpi_def_dim(ncid, "longitude", nn(3), iid)
    ierr=nfmpi_def_dim(ncid, "month", nn(4), mid)


    ierr=nfmpi_def_var(ncid, "lev_c", nf_double, 1, kcid, izc)
    ierr=nfmpi_def_var(ncid, "lev_f", nf_double, 1, kfid, izf)
    ierr=nfmpi_def_var(ncid, "lat", nf_double, 1, jid, iyd)
    ierr=nfmpi_def_var(ncid, "lon", nf_double, 1, iid, ixd)

    nda(1)=iid
    nda(2)=jid
    ierr=nfmpi_def_var(ncid, "s_nudge", nf_double, 2, nda, isn)
    ierr=nfmpi_def_var(ncid, "t_nudge", nf_double, 2, nda, itn)

    ndb(1)=iid
    ndb(2)=jid
    ndb(3)=kcid
    ierr=nfmpi_def_var(ncid, "hmean_nudge", nf_double, 3, ndb, ihn)

    ndc(1)=iid
    ndc(2)=jid
    ndc(3)=mid
    ierr=nfmpi_def_var(ncid, "taux", nf_double, 3, ndc, itx)
    ierr=nfmpi_def_var(ncid, "tauy", nf_double, 3, ndc, ity)

    ndd(1)=iid
    ndd(2)=jid
    ndd(3)=kcid
    ndd(4)=mid
    ierr=nfmpi_def_var(ncid, "sclis", nf_double, 4, ndd, isc)
    ierr=nfmpi_def_var(ncid, "tclis", nf_double, 4, ndd, itc)

    ierr=nfmpi_def_var(ncid, "kb", nf_int, 2, ndb, iik)
    ierr=nfmpi_def_var(ncid, "mask", nf_int,3, ndb, iin)

    ndw(1)=iid
    ndw(2)=jid
    ndw(3)=kfid
    ierr=nfmpi_def_var(ncid, "mask_w", nf_int,3, ndw, iiw)

    ierr=nfmpi_enddef(ncid)

    ! z! zf ydeg xdeg
    st_z=1
    ct_z = k1
    ierr=nfmpi_put_vara_double_all(ncid,izc,st_z,ct_z,z_c)
    ct_z = k0
    ierr=nfmpi_put_vara_double_all(ncid,izf,st_z,ct_z,z_f)
    ierr=nfmpi_put_vara_double_all(ncid,iyd,ns_kji(2),nc_kji(2),ylat)
    ierr=nfmpi_put_vara_double_all(ncid,ixd,ns_kji(3),nc_kji(3),xlon)
    ! s_nudge t_nudge hmean_nudge
    call mtx2rvec2(s_nudge,wbf,i0,j0,i2,j2,1,1,1)
    ierr=nfmpi_put_vara_double_all(ncid, isn, ns_ji2,nc_ji2,wbf)
    call mtx2rvec2(t_nudge,wbf,i0,j0,i2,j2,1,1,1)
    ierr=nfmpi_put_vara_double_all(ncid, itn, ns_ji2, nc_ji2,wbf)
    call mtx2rvec2(hmean_nudge,sbf,i0,j0,i2,j2,k1,1,1)
    ierr=nfmpi_put_vara_double_all(ncid, ihn, ns_kji2, nc_kji2,sbf)
    ! taux tauy
    call mtx2rvec2(taux,rbf,i2,j2,i2,j2,12,0,0)
    ierr=nfmpi_put_vara_double_all(ncid, itx, ns_tji2, nc_tji2, rbf) 
    call mtx2rvec2(tauy,rbf,i2,j2,i2,j2,12,0,0)
    ierr=nfmpi_put_vara_double_all(ncid, ity, ns_tji2, nc_tji2, rbf)

    ! sclis tclis
    nss(4)=ns_tji(1)
    nss(3)=ns_kji(1)
    nss(2)=ns_tji(2)
    nss(1)=ns_tji(3)
    nee(4)=nc_tji(1)
    nee(3)=nc_kji(1)
    nee(2)=nc_tji(2)
    nee(1)=nc_tji(3)
    call mtx2rvec_m(sclis,vbf,i0,j0,k1,i2,j2,k1,12,1,1)
    ierr=nfmpi_put_vara_double_all(ncid,isc,nss,nee,vbf)    
    call mtx2rvec_m(tclis,vbf,i0,j0,k1,i2,j2,k1,12,1,1)  
    ierr=nfmpi_put_vara_double_all(ncid,itc,nss,nee,vbf)


    ! kb in iw
    nks(1)=ns_kji2(1)
    nks(2)=ns_kji2(2)
    nke(1)=nc_kji2(1)
    nke(2)=nc_kji2(2)
    call mtx2ivec(kb,kbf,i0,j0,i2,j2,1,1,1)
    ierr=nfmpi_put_vara_int_all(ncid,iik,ns_kji2,nc_kji2,kbf)

    call mtx2ivec(in,inf,i0,j0,i2,j2,k1,1,1)
    ierr=nfmpi_put_vara_int_all(ncid,iin,ns_kji2,nc_kji2,inf)

    nws(3)=ns_kji(1)
    nws(2)=ns_kji(2)
    nws(1)=ns_kji(3)
    nwe(3)=nn(5)
    nwe(2)=nc_kji(2)
    nwe(1)=nc_kji(3)
    call mtx2ivec(iw,iwf,i0,j0,i2,j2,k0,1,1)
    ierr=nfmpi_put_vara_int_all(ncid,iiw,nws,nwe,iwf)


    ierr=nfmpi_close(ncid)
end subroutine


! ----------------------------------------------------------------------
subroutine write_rerun
    parameter(nbg0=nb0*ngy0,nbg1=nbg0-1,i01=i0+1,ibir=i2t/ngy0,j01=j0+1)

    character fn*17
    integer*2 nbf
    real*8 dbf

    dimension dbf(i2*j2)
    dimension wbf(i2*j2*k0)

    dimension nd(4)


    !      write(*,'(a20,12i3)') 'kilmer:nsombo=', nsombo
    ierr=nfmpi_create(m_cart,'data/rerun.nc',nf_64bit_offset,mpi_info_null,ncid)
    call pnetcdferrck(ierr)
    ierr=nfmpi_def_dim(ncid, "latitude", nn(2), idj)
    ierr=nfmpi_def_dim(ncid, "longitude", nn(3), idi)
    ierr=nfmpi_def_dim(ncid, "month", nn(4), idt)
    ierr=nfmpi_def_dim(ncid, "global" , nn(6), id1)
    call pnetcdferrck(ierr)
    nd(1)=id1
    ierr=nfmpi_def_var(ncid, "itf", nf_int, 1, nd, i_itf)
    ierr=nfmpi_def_var(ncid, "days", nf_double, 1, nd, i_days)
    ierr=nfmpi_def_var(ncid, "evap", nf_double, 1, nd, i_evap)
    ierr=nfmpi_def_var(ncid, "qsum", nf_double, 1, nd, i_qsum)
    ierr=nfmpi_def_var(ncid, "olde", nf_double, 1, nd, i_olde)
    ierr=nfmpi_def_var(ncid, "oldq", nf_double, 1, nd, i_oldq)
    nd(1)=idt
    ierr=nfmpi_def_var(ncid, "nsombo", nf_int, 1, nd, i_nsombo)
    nd(1)=idj
    nd(2)=idi
    ierr=nfmpi_def_var(ncid, "x", nf_double, 2, nd, ix)
    !       ierr=nfmpi_def_var(ncid, "fsf", nf_double, 2, nd, ifsf)
    ierr=nfmpi_def_var(ncid, "p0", nf_double, 2, nd, ip0)
    nd(1)=idt
    nd(2)=idj
    nd(3)=idi
    ierr=nfmpi_def_var(ncid, "qvag", nf_double, 3, nd, iqavg)
    nd(1)=idj
    nd(2)=idi
    ierr=nfmpi_def_var(ncid, "tnudge", nf_double, 2, nd, itnudge)
    ierr=nfmpi_def_var(ncid, "pbar", nf_double, 2, nd, ipbar)
    ierr=nfmpi_def_var(ncid, "pvar", nf_double, 2, nd, ipvar)
    ierr=nfmpi_def_var(ncid, "xbar", nf_double, 2, nd, ixbar)
    ierr=nfmpi_def_var(ncid, "ucli", nf_double, 2, nd, iucli)
    ierr=nfmpi_def_var(ncid, "vcli", nf_double, 2, nd, ivcli)
    ierr=nfmpi_def_var(ncid, "rmsv", nf_double, 2, nd, irmsv)
    ierr=nfmpi_enddef(ncid)
    ierr=nfmpi_put_vara_int_all(ncid, i_itf, ns_1, nc_1, itf)
    ierr=nfmpi_put_vara_double_all(ncid, i_days, ns_1, nc_1, days)
    ierr=nfmpi_put_vara_double_all(ncid, i_evap, ns_1, nc_1, evap)
    ierr=nfmpi_put_vara_double_all(ncid, i_qsum, ns_1, nc_1, qsum)
    ierr=nfmpi_put_vara_double_all(ncid, i_olde, ns_1, nc_1, olde)
    ierr=nfmpi_put_vara_double_all(ncid, i_oldq, ns_1, nc_1, oldq)
    ierr=nfmpi_put_vara_int_all(ncid, i_nsombo, ns_tji(1), nc_tji(1), nsombo)
    call mtx2dvec(x,dbf)
    ierr=nfmpi_put_vara_double_all(ncid,ix,ns_ji,nc_ji,dbf)
    !       call mtx2rvec(fsf,wbf,i0,j0,i2,j2,1,1,1)
    !       ierr=nfmpi_put_vara_double_all(ncid, ifsf, ns_ji, nc_ji, wbf)
    call mtx2rvec(p0,wbf,i0,j0,i2,j2,1,1,1)
    ierr=nfmpi_put_vara_double_all(ncid, ip0, ns_ji, nc_ji, wbf)
    call mtx2rvec(qavg,wbf,i2,j2,i2,j2,12,0,0)
    ierr=nfmpi_put_vara_double_all(ncid, iqavg, ns_tji, nc_tji, wbf)
    call mtx2rvec(tnudge,wbf,i2,j2,i2,j2,1,0,0)
    ierr=nfmpi_put_vara_double_all(ncid, itnudge, ns_ji, nc_ji, wbf)
    call mtx2rvec(pbar,wbf,i0,j0,i2,j2,1,1,1)
    ierr=nfmpi_put_vara_double_all(ncid, ipbar, ns_ji, nc_ji, wbf)
    call mtx2rvec(pvar,wbf,i0,j0,i2,j2,1,1,1)
    ierr=nfmpi_put_vara_double_all(ncid, ipvar, ns_ji, nc_ji, wbf)
    call mtx2rvec(xbar,wbf,i0,j0,i2,j2,1,1,1)
    ierr=nfmpi_put_vara_double_all(ncid, ixbar, ns_ji, nc_ji, wbf)
    call mtx2rvec(ucli,wbf,i0,j0,i2,j2,1,1,1)
    ierr=nfmpi_put_vara_double_all(ncid, iucli, ns_ji, nc_ji, wbf)
    call mtx2rvec(vcli,wbf,i0,j0,i2,j2,1,1,1)
    ierr=nfmpi_put_vara_double_all(ncid, ivcli, ns_ji, nc_ji, wbf)
    call mtx2rvec(rmsv,wbf,i0,j0,i2,j2,1,1,1)
    ierr=nfmpi_put_vara_double_all(ncid, irmsv, ns_ji, nc_ji, wbf)
    ierr=nfmpi_close(ncid)

    call write2nc('u1','u1',u1,k1,1)
    call write2nc('u2','u2',u2,k1,1)
    call write2nc('ul','ulf',ulf,k1,1)
    call write2nc('v1','v1',v1,k1,1)
    call write2nc('v2','v2',v2,k1,1)
    call write2nc('vl','vlf',vlf,k1,1)
    call write2nc('t1','t1',t1,k1,1)
    call write2nc('t2','t2',t2,k1,1)
    call write2nc('tl','tlf',tlf,k1,1)
    call write2nc('s1','s1',s1,k1,1)
    call write2nc('s2','s2',s2,k1,1)
    call write2nc('sl','slf',slf,k1,1)
    call write2nc('pp','p',p,k1,1)
    call write2nc('uc','u',u,k1,1)
    call write2nc('wc','w',w,k0,5)
    call write2nc('vc','v',v,k1,1)
!yc
    call write2nc('c1','c1',c1,k1,1)
    call write2nc('c2','c2',c2,k1,1)
    call write2nc('cl','clf',clf,k1,1)
!yc
end subroutine

! ----------------------------------------------------------------------
subroutine read_gas(fice,xkw,patm)
!
    dimension fice(i2,j2,12),xkw(i2,j2,12),patm(i2,j2,12)
    parameter(nbg0=nb0*ngy0,nbg1=nbg0-1,i01=i0+1,ibir=i2t/ngy0,j01=j0+1)
    dimension rrbf(i2*j2*12)
    real*8 :: rrbf
!
    ierr=nfmpi_open(m_cart,'data/timcom_gasx.nc',nf_nowrite,mpi_info_null,ncid)
    call pnetcdferrck(ierr)
!
    ierr=nfmpi_inq_varid(ncid, "fice", itmp)
    ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_tji,nc_tji,rrbf)

    call pnetcdferrck(ierr)
    call rvec2mtx(fice,rrbf,i2,j2,i2,j2,12,0,0)
!
    ierr=nfmpi_inq_varid(ncid, "xkw", itmp)
    ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_tji,nc_tji,rrbf)
    call pnetcdferrck(ierr)
    call rvec2mtx(xkw,rrbf,i2,j2,i2,j2,12,0,0)
!
    ierr=nfmpi_inq_varid(ncid, "patm", itmp)
    ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_tji,nc_tji,rrbf)
    call pnetcdferrck(ierr)
    call rvec2mtx(patm,rrbf,i2,j2,i2,j2,12,0,0)
!
end subroutine

! ----------------------------------------------------------------------


! ----------------------------------------------------------------------
subroutine read_rerun
    parameter(nbg0=nb0*ngy0,nbg1=nbg0-1,i01=i0+1,ibir=i2t/ngy0,j01=j0+1)
    character fn*17
    integer*2 nbf

    real*8 dbf

    dimension dbf(i2*j2)
    dimension rbf(i2*j2*k0),rrbf(i2*j2*12)
    dimension nd(4)

    ierr=nfmpi_open(m_cart,'data/rerun.nc',nf_nowrite,mpi_info_null,ncid)
    call pnetcdferrck(ierr)

    ierr=nfmpi_inq_varid(ncid, "itf", itmp)
    ierr=nfmpi_get_var_int_all(ncid, itmp, itf)
    call pnetcdferrck(ierr)
    ierr=nfmpi_inq_varid(ncid, "days", itmp)
    ierr=nfmpi_get_var_double_all(ncid, itmp, days)
    call pnetcdferrck(ierr)
    ierr=nfmpi_inq_varid(ncid, "evap", itmp)
    ierr=nfmpi_get_var_double_all(ncid, itmp, evap)
    call pnetcdferrck(ierr)
    ierr=nfmpi_inq_varid(ncid, "qsum", itmp)
    ierr=nfmpi_get_var_double_all(ncid, itmp, qsum)
    call pnetcdferrck(ierr)
    ierr=nfmpi_inq_varid(ncid, "olde", itmp)
    ierr=nfmpi_get_var_double_all(ncid, itmp, olde)
    call pnetcdferrck(ierr)
    ierr=nfmpi_inq_varid(ncid, "oldq", itmp)
    ierr=nfmpi_get_var_double_all(ncid, itmp, oldq)
    call pnetcdferrck(ierr)
    ierr=nfmpi_inq_varid(ncid, "nsombo", itmp)
    ierr=nfmpi_get_vara_int_all(ncid,itmp,ns_tji(1),nc_tji(1),nsombo)
    call pnetcdferrck(ierr)
    ierr=nfmpi_inq_varid(ncid, "x", itmp)
    ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ji,nc_ji,dbf)
    call pnetcdferrck(ierr)
    call dvec2mtx(x,dbf)
    !       ierr=nfmpi_inq_varid(ncid, "fsf", itmp)
    !       ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ji,nc_ji,rbf)
    !       call rvec2mtx(fsf,rbf,i0,j0,i2,j2,1,1,1)
    ierr=nfmpi_inq_varid(ncid, "p0", itmp)
    ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ji,nc_ji,rbf)
    call pnetcdferrck(ierr)
    call rvec2mtx(p0,rbf,i0,j0,i2,j2,1,1,1)
    ierr=nfmpi_inq_varid(ncid, "qvag", itmp)
    ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_tji,nc_tji,rrbf)
    call pnetcdferrck(ierr)
    call rvec2mtx(qavg,rrbf,i2,j2,i2,j2,12,0,0)
    ierr=nfmpi_inq_varid(ncid, "tnudge", itmp)
    ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ji,nc_ji,rbf)
    call pnetcdferrck(ierr)
    call rvec2mtx(tnudge,rbf,i2,j2,i2,j2,1,0,0)
    ierr=nfmpi_inq_varid(ncid, "pbar", itmp)
    ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ji,nc_ji,rbf)
    call pnetcdferrck(ierr)
    call rvec2mtx(pbar,rbf,i0,j0,i2,j2,1,1,1)
    ierr=nfmpi_inq_varid(ncid, "pvar", itmp)
    ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ji,nc_ji,rbf)
    call pnetcdferrck(ierr)
    call rvec2mtx(pvar,rbf,i0,j0,i2,j2,1,1,1)
    ierr=nfmpi_inq_varid(ncid, "xbar", itmp)
    ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ji,nc_ji,rbf)
    call pnetcdferrck(ierr)
    call rvec2mtx(xbar,rbf,i0,j0,i2,j2,1,1,1)
    ierr=nfmpi_inq_varid(ncid, "ucli", itmp)

    ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ji,nc_ji,rbf)
    call pnetcdferrck(ierr)
    call rvec2mtx(ucli,rbf,i0,j0,i2,j2,1,1,1)
    ierr=nfmpi_inq_varid(ncid, "vcli", itmp)
    ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ji,nc_ji,rbf)
    call pnetcdferrck(ierr)
    call rvec2mtx(vcli,rbf,i0,j0,i2,j2,1,1,1)
    ierr=nfmpi_inq_varid(ncid, "rmsv", itmp)
    ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ji,nc_ji,rbf)
    call pnetcdferrck(ierr)
    call rvec2mtx(rmsv,rbf,i0,j0,i2,j2,1,1,1)
    ierr=nfmpi_close(ncid)
    call pnetcdferrck(ierr)

    call readnc('u1','u1',u1,k1)
    call readnc('u2','u2',u2,k1)
    call readnc('ul','ulf',ulf,k1)
    call readnc('v1','v1',v1,k1)
    call readnc('v2','v2',v2,k1)
    call readnc('vl','vlf',vlf,k1)
    call readnc('t1','t1',t1,k1)
    call readnc('t2','t2',t2,k1)
    call readnc('tl','tlf',tlf,k1)
    call readnc('s1','s1',s1,k1)
    call readnc('s2','s2',s2,k1)
    call readnc('sl','slf',slf,k1)
    call readnc('pp','p',p,k1)
    call readnc('uc','u',u,k1)
    call readnc('wc','w',w,k0)
    call readnc('vc','v',v,k1)
!yc
    call readnc('c1','c1',c1,k1)
    call readnc('c2','c2',c2,k1)
    call readnc('cl','clf',clf,k1)   
!yc
    call mpi_sendrecv(u(i1,1,1),1,m_vlon,m_e,1,u(1,1,1),1,m_vlon,m_w,1,m_cart,istat,ierr)
    call mpi_sendrecv(v(1,j1,1),1,m_vlat,m_n,1,v(1,1,1),1,m_vlat,m_s,1,m_cart,istat,ierr)
end subroutine


! -------------------------------------------------------------
subroutine write_init2nc(stm,ttm)
    dimension stm(i0,j0,k1),ttm(i0,j0,k1),wbf(i2*j2*k1),nd(3)

    ierr=nfmpi_create(m_cart,'data/initial.nc',nf_64bit_offset,mpi_info_null,ncid)

    call pnetcdferrck(ierr)
    ierr=nfmpi_def_dim(ncid, "level", nn(1), idk)
    ierr=nfmpi_def_dim(ncid, "latitude", nn(2), idj)
    ierr=nfmpi_def_dim(ncid, "longitude", nn(3), idi)
    call pnetcdferrck(ierr)
    nd(1)=idk
    nd(2)=idj
    nd(3)=idi
    ierr=nfmpi_def_var(ncid, 'ti', nf_double, 3, nd, itmp)
    ierr=nfmpi_def_var(ncid, 'si', nf_double, 3, nd, ismp)
    ierr=nfmpi_enddef(ncid)

    ! for temperature
    l=1
    do 100 i=2,i1
    do 100 j=2,j1
    do 100 k=1,k1
    wbf(l)=ttm(i,j,k)
    100  l=l+1
    nc_kji(1)=k1
    ierr=nfmpi_put_vara_double_all(ncid, itmp, ns_kji, nc_kji, wbf)
    call pnetcdferrck(ierr)
    ! for salinity
    l=1
    do 101 i=2,i1
    do 101 j=2,j1
    do 101 k=1,k1
    wbf(l)=stm(i,j,k)
    101  l=l+1
    ierr=nfmpi_put_vara_double_all(ncid, ismp, ns_kji, nc_kji, wbf)
    ierr=nfmpi_close(ncid)
end subroutine


! ----------------------------------------------------------------------
subroutine initbred
    parameter(nbg0=nb0*ngy0,nbg1=nbg0-1,i01=i0+1,ibir=i2t/ngy0,j01=j0+1)

    character fn*17,filename*30

    real*8 dbf

    dimension dbf(i2*j2)
    dimension rbf(i2*j2*k0),rrbf(i2*j2*12)
    dimension nd(4)


    dimension ub(i0,j0,k1),vb(i0,j0,k1)

    jt=mylat*j2
    it=mylon*i2
    do 50 j=1,j2
    do 50 i=1,i2
    ibred(i,j)=0
    50   if (((it+i.ge.540).and.(it+i).le.720).and.((jt+j.ge.524).and.(jt+j).le.572))ibred(i,j)=1




    do 100 k=1,30
    do 100 j=2,j1
    do 100 i=2,i1
    ub(i,j,k)=u1(i,j,k)
    100  vb(i,j,k)=v1(i,j,k)

    call readnc('u1','u1',u1,k1)
    call readnc('v1','v1',v1,k1)
    call readnc('t1','t1',t1,k1)
    call readnc('s1','s1',s1,k1)

    bf=0.
    eke=0.
    tmp=0.
    do 150 k=1,30
    do 150 j=2,j1
    do 150 i=2,i1
    ub(i,j,k)=ibred(i-1,j-1)*(ub(i,j,k)-u1(i,j,k))
    vb(i,j,k)=ibred(i-1,j-1)*(vb(i,j,k)-v1(i,j,k))
    temp=in(i,j,k)*(ub(i,j,k)*ub(i,j,k)+vb(i,j,k)*vb(i,j,k))
    150  tmp=tmp+temp
    call mpi_allreduce(tmp,temp,1,mpi_real8,mpi_sum,m_cart,ierr)
    bf1=sqrt(temp)

    if (myid .eq. 0) print*,'bred ke1 factor =',bf1,'bred ke1 = ',temp

    do 200 k=1,30
    do 200 j=2,j1
    do 200 i=2,i1
    ub(i,j,k)=u2(i,j,k)
    200  vb(i,j,k)=v2(i,j,k)

    call readnc('u2','u2',u2,k1)
    call readnc('v2','v2',v2,k1)
    call readnc('t2','t2',t2,k1)
    call readnc('s2','s2',s2,k1)

    bf=0.
    eke=0.
    tmp=0.
    do 250 k=1,30
    do 250 j=2,j1
    do 250 i=2,i1
    ub(i,j,k)=ibred(i-1,j-1)*(ub(i,j,k)-u2(i,j,k))
    vb(i,j,k)=ibred(i-1,j-1)*(vb(i,j,k)-v2(i,j,k))
    temp=in(i,j,k)*(ub(i,j,k)*ub(i,j,k)+vb(i,j,k)*vb(i,j,k))
    250  tmp=tmp+temp
    call mpi_allreduce(tmp,temp,1,mpi_real8,mpi_sum,m_cart,ierr)
    bf2=sqrt(temp)
    if (myid .eq. 0) print*,'bred ke2 factor =',bf2,'bred ke2 = ',temp

    do 300 k=1,30
    do 300 j=2,j1
    do 300 i=2,i1
    ub(i,j,k)=ulf(i,j,k)
    300  vb(i,j,k)=vlf(i,j,k)

    call readnc('ul','ulf',ulf,k1)
    call readnc('vl','vlf',vlf,k1)
    call readnc('tl','tlf',tlf,k1)
    call readnc('sl','slf',slf,k1)

    bf=0.
    eke=0.
    tmp=0.
    do 350 k=1,30
    do 350 j=2,j1
    do 350 i=2,i1
    ub(i,j,k)=ibred(i-1,j-1)*(ub(i,j,k)-ulf(i,j,k))
    vb(i,j,k)=ibred(i-1,j-1)*(vb(i,j,k)-vlf(i,j,k))
    temp=in(i,j,k)*(ub(i,j,k)*ub(i,j,k)+vb(i,j,k)*vb(i,j,k))
    350  tmp=tmp+temp
    call mpi_allreduce(tmp,temp,1,mpi_real8,mpi_sum,m_cart,ierr)
    bflf=sqrt(temp)

    if (myid .eq. 0)print*,'bred kelf factor =',bflf,'bred kelf = ',temp
end subroutine


! ----------------------------------------------------------------------
subroutine rescbred
    parameter(nbg0=nb0*ngy0,nbg1=nbg0-1,i01=i0+1,ibir=i2t/ngy0,j01=j0+1)

    character fn*17,filename*30

    real*8 dbf
    dimension dbf(i2*j2)
    dimension rbf(i2*j2*k0),rrbf(i2*j2*12)
    dimension nd(4)

    dimension ub(i0,j0,k1),vb(i0,j0,k1),tb(i0,j0,k1),sb(i0,j0,k1)

    do 100 k=1,30
    do 100 j=2,j1
    do 100 i=2,i1
    ub(i,j,k)=u1(i,j,k)
    vb(i,j,k)=v1(i,j,k)
    tb(i,j,k)=t1(i,j,k)
    100  sb(i,j,k)=s1(i,j,k)

    call readnc('u1','u1',u1,k1)
    call readnc('v1','v1',v1,k1)
    call readnc('t1','t1',t1,k1)
    call readnc('s1','s1',s1,k1)

    tmp=0.

    do 130 k=1,30
    do 130 j=2,j1
    do 130 i=2,i1
    ub(i,j,k)=ibred(i-1,j-1)*(ub(i,j,k)-u1(i,j,k))
    vb(i,j,k)=ibred(i-1,j-1)*(vb(i,j,k)-v1(i,j,k))
    tb(i,j,k)=ibred(i-1,j-1)*(tb(i,j,k)-t1(i,j,k))
    sb(i,j,k)=ibred(i-1,j-1)*(sb(i,j,k)-s1(i,j,k))
    temp=in(i,j,k)*(ub(i,j,k)*ub(i,j,k)+vb(i,j,k)*vb(i,j,k))
    130  tmp=tmp+temp


    call mpi_allreduce(tmp,temp,1,mpi_real8,mpi_sum,m_cart,ierr)

    tp=bf1/sqrt(temp)
    temp=0.
    do 160 k=1,30
    do 160 j=2,j1
    do 160 i=2,i1
    temp=temp+in(i,j,k)*ibred(i-1,j-1)*ub(i,j,k)*ub(i,j,k)
    temp=temp+in(i,j,k)*ibred(i-1,j-1)*vb(i,j,k)*vb(i,j,k)
    u1(i,j,k)=u1(i,j,k)+in(i,j,k)*ub(i,j,k)*tp
    v1(i,j,k)=v1(i,j,k)+in(i,j,k)*vb(i,j,k)*tp
    t1(i,j,k)=t1(i,j,k)+in(i,j,k)*tb(i,j,k)*tp
    160  s1(i,j,k)=s1(i,j,k)+in(i,j,k)*sb(i,j,k)*tp

    call mpi_allreduce(temp,tmp,1,mpi_real8,mpi_sum,m_cart,ierr)
    if (myid .eq. 0) print*,'bred ke1 factor =',tp,'bred ke1 = ',tmp


    do 200 k=1,30
    do 200 j=2,j1
    do 200 i=2,i1
    ub(i,j,k)=u2(i,j,k)
    vb(i,j,k)=v2(i,j,k)
    tb(i,j,k)=t2(i,j,k)
    200  sb(i,j,k)=s2(i,j,k)

    call readnc('u2','u2',u2,k1)
    call readnc('v2','v2',v2,k1)
    call readnc('t2','t2',t2,k1)
    call readnc('s2','s2',s2,k1)

    tmp=0.

    do 230 k=1,30
    do 230 j=2,j1
    do 230 i=2,i1
    ub(i,j,k)=ibred(i-1,j-1)*(ub(i,j,k)-u2(i,j,k))
    vb(i,j,k)=ibred(i-1,j-1)*(vb(i,j,k)-v2(i,j,k))
    tb(i,j,k)=ibred(i-1,j-1)*(tb(i,j,k)-t2(i,j,k))
    sb(i,j,k)=ibred(i-1,j-1)*(sb(i,j,k)-s2(i,j,k))
    temp=in(i,j,k)*(ub(i,j,k)*ub(i,j,k)+vb(i,j,k)*vb(i,j,k))
    230  tmp=tmp+temp

    call mpi_allreduce(tmp,temp,1,mpi_real8,mpi_sum,m_cart,ierr)

    tp=bf2/sqrt(temp)
    temp=0.
    do 260 k=1,30
    do 260 j=2,j1
    do 260 i=2,i1
    temp=temp+in(i,j,k)*ibred(i-1,j-1)*ub(i,j,k)*ub(i,j,k)
    temp=temp+in(i,j,k)*ibred(i-1,j-1)*vb(i,j,k)*vb(i,j,k)
    u2(i,j,k)=u2(i,j,k)+in(i,j,k)*ub(i,j,k)*tp
    v2(i,j,k)=v2(i,j,k)+in(i,j,k)*vb(i,j,k)*tp
    t2(i,j,k)=t2(i,j,k)+in(i,j,k)*tb(i,j,k)*tp
    260  s2(i,j,k)=s2(i,j,k)+in(i,j,k)*sb(i,j,k)*tp

    call mpi_allreduce(temp,tmp,1,mpi_real8,mpi_sum,m_cart,ierr)
    if (myid .eq. 0) print*,'bred ke2 factor =',tp,'bred ke2 = ',tmp

    do 300 k=1,30
    do 300 j=2,j1
    do 300 i=2,i1
    ub(i,j,k)=ulf(i,j,k)
    vb(i,j,k)=vlf(i,j,k)
    tb(i,j,k)=tlf(i,j,k)
    300  sb(i,j,k)=slf(i,j,k)

    call readnc('ul','ulf',ulf,k1)
    call readnc('vl','vlf',vlf,k1)
    call readnc('tl','tlf',tlf,k1)
    call readnc('sl','slf',slf,k1)

    tmp=0.

    do 330 k=1,30
    do 330 j=2,j1
    do 330 i=2,i1
    ub(i,j,k)=ibred(i-1,j-1)*(ub(i,j,k)-ulf(i,j,k))
    vb(i,j,k)=ibred(i-1,j-1)*(vb(i,j,k)-vlf(i,j,k))
    tb(i,j,k)=ibred(i-1,j-1)*(tb(i,j,k)-tlf(i,j,k))
    sb(i,j,k)=ibred(i-1,j-1)*(sb(i,j,k)-slf(i,j,k))
    temp=in(i,j,k)*(ub(i,j,k)*ub(i,j,k)+vb(i,j,k)*vb(i,j,k))
    330  tmp=tmp+temp

    call mpi_allreduce(tmp,temp,1,mpi_real8,mpi_sum,m_cart,ierr)

    tp=bflf/sqrt(temp)
    temp=0.
    do 360 k=1,30
    do 360 j=2,j1
    do 360 i=2,i1
    temp=temp+in(i,j,k)*ibred(i-1,j-1)*ub(i,j,k)*ub(i,j,k)
    temp=temp+in(i,j,k)*ibred(i-1,j-1)*vb(i,j,k)*vb(i,j,k)
    ulf(i,j,k)=ulf(i,j,k)+in(i,j,k)*ub(i,j,k)*tp
    vlf(i,j,k)=vlf(i,j,k)+in(i,j,k)*vb(i,j,k)*tp
    tlf(i,j,k)=tlf(i,j,k)+in(i,j,k)*tb(i,j,k)*tp
    360  slf(i,j,k)=slf(i,j,k)+in(i,j,k)*sb(i,j,k)*tp

    call mpi_allreduce(temp,tmp,1,mpi_real8,mpi_sum,m_cart,ierr)
    if (myid .eq. 0) print*,'bred kel factor =',tp,'bred kel = ',tmp
end subroutine

! ----------------------------------------------------------------------
subroutine write2nc(fn,vn,fld,l0,nl)
    parameter(nbg0=nb0*ngy0,nbg1=nbg0-1,i01=i0+1,ibir=i2t/ngy0,j01=j0+1)

    character fn*(*),vn*(*),filename*10

    dimension fld(i0,j0,l0),wbf(i2*j2*l0),nd(3)

    write(filename,'(a5,a2,a3)'),'data/',fn,'.nc'

    ierr=nfmpi_create(m_cart,filename,nf_64bit_offset,mpi_info_null,ncid)
    if (ierr .ne. 0) print*,fn,nfmpi_strerror(ierr)

    if (nl .eq. 1) then
	ierr=nfmpi_def_dim(ncid, "level", nn(1), idk)
    else
	ierr=nfmpi_def_dim(ncid, "level", nn(nl), idk)
    endif
    ierr=nfmpi_def_dim(ncid, "latitude", nn(2), idj)
    ierr=nfmpi_def_dim(ncid, "longitude", nn(3), idi)
    nd(1)=idk
    nd(2)=idj
    nd(3)=idi
    ierr=nfmpi_def_var(ncid, vn, nf_double, 3, nd, itmp)
    if (ierr .ne. 0) print*,fn,nfmpi_strerror(ierr)

    ierr=nfmpi_enddef(ncid)
    if (ierr .ne. 0) print*,fn,nfmpi_strerror(ierr)

    l=1
    do 100 i=2,i1
    do 100 j=2,j1
    do 100 k=1,l0
    wbf(l)=fld(i,j,k)
    100  l=l+1

    nc_kji(1)=l0
    ierr=nfmpi_put_vara_double_all(ncid, itmp, ns_kji, nc_kji, wbf)

    if (ierr .ne. 0) print*,fn,nfmpi_strerror(ierr)

    ierr=nfmpi_close(ncid)
    if (ierr .ne. 0) print*,fn,nfmpi_strerror(ierr)
end subroutine


! -------------------------------------------------------------
subroutine read_initnc(stm,ttm)
    dimension stm(i0,j0,k1),ttm(i0,j0,k1),rbf(i2*j2*k1),nd(3)

    ierr=nfmpi_open(m_cart,'data/initial.nc',nf_nowrite,mpi_info_null,ncid)
    if(ierr.ne.0)then
	call pnetcdferrck(ierr)
	call mpi_finalize(ierr)
	stop
    endif
    ierr=nfmpi_inq_varid(ncid,'ti',itmp)
    nc_kji(1)=k1
    ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_kji,nc_kji,rbf)
    call pnetcdferrck(ierr)
    l=1
    do 11 i=2,i1
    do 11 j=2,j1
    do 11 k=1,k1
    ttm(i,j,k)=rbf(l)
    11   l=l+1

    ierr=nfmpi_inq_varid(ncid,'si',ismp)
    ierr=nfmpi_get_vara_double_all(ncid,ismp,ns_kji,nc_kji,rbf)
    call pnetcdferrck(ierr)
    l=1
    do 12 i=2,i1
    do 12 j=2,j1
    do 12 k=1,k1
    stm(i,j,k)=rbf(l)
    12   l=l+1
    ierr=nfmpi_close(ncid)
end subroutine


! ----------------------------------------------------------------------
subroutine readnc(fn,vn,fld,l0)
    parameter(nbg0=nb0*ngy0,nbg1=nbg0-1,i01=i0+1,ibir=i2t/ngy0,j01=j0+1)

    character fn*(*),vn*(*),filename*10

    dimension fld(i0,j0,l0),rbf(i2*j2*l0),nd(3)

    write(filename,'(a4,a2,a3)'),'data/',fn,'.nc'
    ierr=nfmpi_open(m_cart,filename,nf_nowrite,mpi_info_null,ncid)
    if (ierr .ne. 0) print*,fn,nfmpi_strerror(ierr)
    ierr=nfmpi_inq_varid(ncid,vn,itmp)
    if (ierr .ne. 0) print*,'nfmpi_inq_var ',fn,nfmpi_strerror(ierr)
    nc_kji(1)=l0
    ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_kji,nc_kji,rbf)
    if (ierr .ne. 0) print*,'nfmpi_get_vara',fn,nfmpi_strerror(ierr)

    ierr=nfmpi_close(ncid)
    if (ierr .ne. 0) print*,fn,nfmpi_strerror(ierr)

    l=1
    do 11 i=2,i1
    do 11 j=2,j1
    do 11 k=1,l0
    fld(i,j,k)=rbf(l)
    11   l=l+1
end subroutine


! ----------------------------------------------------------------------
subroutine timeavg(fd,fld,kl,ct)
    dimension fld(i0,j0,k1),fd(i0,j0,kl)

    do 100 k=1,kl
    do 100 j=2,j1
    do 100 i=2,i1
    100  fld(i,j,k)=fld(i,j,k)+ct*fd(i,j,k)
end subroutine


! ----------------------------------------------------------------------
subroutine timeavgd(fd,fld,kl,ct)
    real*8 fld,fd
    dimension fld(i0,j0,k1),fd(i0,j0,kl)
    do 100 k=1,kl
    do 100 j=2,j1
    do 100 i=2,i1
    100  fld(i,j,k)=fld(i,j,k)+ct*fd(i,j,k)
end subroutine


! ----------------------------------------------------------------------
subroutine mtx2rvec(fd,rbf,in0,jn0,nx,ny,nl,ip,jp)
    dimension fd(in0,jn0,nl),rbf(nx*ny*nl)
    l=1
    ibegin=1+ip
    iend=nx+ibegin-1
    jb=1+jp
    je=ny+jb-1
    do 11 i=ibegin,iend
    do 11 j=jb,je
    do 11 k=1,nl
    rbf(l)=fd(i,j,k)
    11   l=l+1
end subroutine


! ----------------------------------------------------------------------
subroutine mtx2rvec2(fd,rbf,in0,jn0,nx,ny,nl,ip,jp)
    dimension fd(in0,jn0,nl),rbf(nx*ny*nl)
    l=1
    ibegin=1+ip
    iend=nx+ibegin-1
    jb=1+jp
    je=ny+jb-1
    do 11 k=1,nl
    do 11 j=jb,je
    do 11 i=ibegin,iend
    rbf(l)=fd(i,j,k)
    11   l=l+1
end subroutine


! ----------------------------------------------------------------------
subroutine mtx2rvec_m(fd,rbf,in0,jn0,kn1,nx,ny,nk,nl,ip,jp)
    dimension fd(in0,jn0,kn1,nl),rbf(nx*ny*nk*nl)
    l=1
    ibegin=1+ip
    iend=nx+ibegin-1
    jb=1+jp
    je=ny+jb-1
    do 12 m=1,nl
    do 12 k=1,nk
    do 12 j=jb,je
    do 12 i=ibegin,iend
    rbf(l)=fd(i,j,k,m)
    12   l=l+1
end subroutine


! ----------------------------------------------------------------------
subroutine mtx2ivec(fd,rbf,in0,jn0,nx,ny,nl,ip,jp)
    integer*2 fd
    integer rbf
    dimension fd(in0,jn0,nl),rbf(nx*ny*nl)
    l=1
    ibegin=1+ip
    iend=nx+ibegin-1
    jb=1+jp
    je=ny+jb-1
    do 11 k=1,nl
    do 11 j=jb,je
    do 11 i=ibegin,iend
    rbf(l)=int(fd(i,j,k))
    11   l=l+1
end subroutine


! ----------------------------------------------------------------------
subroutine mtx2dvec(fd,dbf)
    parameter(i2j2=i2*j2)
    real*8 fd,dbf
    dimension fd(i0,j0),dbf(i2j2)
    l=1
    do 11 i=2,i1
    do 11 j=2,j1
    dbf(l)=fd(i,j)
    11   l=l+1
end subroutine


! ----------------------------------------------------------------------
subroutine rvec2mtx(fd,rbf,in0,jn0,nx,ny,nl,ip,jp)
    dimension fd(in0,jn0,nl),rbf(nx*ny*nl)
    ibegin=1+ip
    iend=nx+ibegin-1
    jb=1+jp
    je=ny+jb-1
    l=1
    do 11 i=ibegin,iend
    do 11 j=jb,je
    do 11 k=1,nl
    fd(i,j,k)=rbf(l)
    11   l=l+1
end subroutine


! ----------------------------------------------------------------------
subroutine rvec2mtx2(fd,rbf,in0,jn0,nx,ny,nl,ip,jp)
    dimension fd(nx,ny,nl),rbf(nx*ny*nl)
    ibegin=1+ip
    iend=nx+ibegin-1
    jb=1+jp
    je=ny+jb-1
    l=1
    do 11 i=ibegin,iend
    do 11 j=jb,je
    do 11 k=1,nl
    fd(i-1,j-1,k)=rbf(l)
    11   l=l+1
end subroutine


! ----------------------------------------------------------------------
subroutine mtx2vec_c(fd,in,rbf)
    parameter(i2j2k1=i2*j2*k1)
    integer*2 in,nbf
    dimension fd(i0,j0,k1)
    dimension in(i0,j0,k1),rbf(i2j2k1)
    !      rm=rmin+1.e-5*rf
    !      rn=9999./rf
    l=1
    do 11 k=1,k1
    do 11 j=2,j1
    do 11 i=2,i1
    !      fd(i,j,k)=max(min(fd(i,j,k),rmin+rf),rmin)
    !      nbf(l)=-999*(1-in(i,j,k))+in(i,j,k)*rn*(fd(i,j,k)-rm)
    rbf(l)=fd(i,j,k)*in(i,j,k)
    ! nbf(l)=in(i,j,k)*rn*(fd(i,j,k)-rmin)
    11   l=l+1
end subroutine


! ----------------------------------------------------------------------
subroutine mtx2vec_f(fd,iw,rbfw)
    parameter(i2j2k0=i2*j2*k0)
    integer*2 iw
    dimension fd(i0,j0,k0)
    dimension iw(i0,j0,k0),rbfw(i2j2k0)
    !      rm=rmin+1.e-5*rf
    !      rn=9999./rf
    l=1
    do 11 k=1,k0
    do 11 j=2,j1
    do 11 i=2,i1
    !      fd(i,j,k)=max(min(fd(i,j,k),rmin+rf),rmin)
    !      nbf(l)=-999*(1-in(i,j,k))+in(i,j,k)*rn*(fd(i,j,k)-rm)
    rbfw(l)=fd(i,j,k)*iw(i,j,k)
    ! nbf(l)=in(i,j,k)*rn*(fd(i,j,k)-rmin)
    11   l=l+1
end subroutine


! ----------------------------------------------------------------------
subroutine mtx2dec_c(fd,in,rbf)
    parameter(i2j2k1=i2*j2*k1)
    integer*2 in,nbf
    real*8 fd
    dimension fd(i0,j0,k1)
    dimension in(i0,j0,k1)
    real*8 rbf(i2j2k1)
    l=1
    do 11 k=1,k1
    do 11 j=2,j1
    do 11 i=2,i1
    rbf(l)=in(i,j,k)*fd(i,j,k)
    11   l=l+1
end subroutine



! ----------------------------------------------------------------------
subroutine dvec2mtx(fd,dbf)
    parameter(i2j2=i2*j2)
    real*8 fd,dbf
    dimension fd(i0,j0),dbf(i2j2)
    l=1
    do 11 i=2,i1
    do 11 j=2,j1
    fd(i,j)=dbf(l)
    11   l=l+1
end subroutine


! ----------------------------------------------------------------------
subroutine pnetcdferrck(ierr)
    if(ierr.ne.nf_noerr)write(*,'(/2a)')'pnetcdf error: ',nfmpi_strerror(ierr)
end subroutine


subroutine restart
    if (mod(itf,nopt*itfday).eq.0.or.itf.eq.mxit)then
	if (myid.eq.0) print*,'write rerun file'
	if (lbred .eq. 1) call rescbred
	if (lbred .eq. 0) call write_rerun
    endif

    !  nopt: years of sving rerun files
    if(mod(itf,ncopt*360*itfday).eq.0) then
	ifl_sys=1
	nys=itf/(360*itfday)
	if(myid.eq.0) then
	    write(sys1,'(a11,i3.3,a13,i3.3)'),'test -e opt',nys,' || mkdir opt',nys
	    write(sys2,'(a19,i3.3)'),'cp ./data/*.n! ./opt',nys
	    call system(sys1)
	    call system(sys2)
	    print*,'saving rerun files in opt',nys
	    ifl_sys=0
	endif
	call mpi_bcast(ifl_sys,1,mpi_integer,0,m_cart,ierr)
    endif

    if (itf .ge. mxit) then
	call mpi_finalize(ierr)
	stop
    endif

    write(14,405) n360,nyr
    405  format('save at day',i4,', year',i3)
end subroutine


subroutine finalize_io

end subroutine

subroutine rdnc_evp
use comm, only: m_cart,myid,mylon,mylat
use const, only: i2,j2,ngy0,ngx0
implicit none
character :: fn*19
integer :: ncid,ierr,itmp
integer(kind=mpi_offset_kind) :: ns_ij(2),nc_ij(2)
      fn = 'prepglo/data/evp.nc'
      ierr=nfmpi_open(m_cart,fn,nf_nowrite,mpi_info_null,ncid)
      ns_ij(1) = mylon*i2+1
      ns_ij(2) = mylat*j2+1
      nc_ij(1) = i2
      nc_ij(2) = j2
      ierr=nfmpi_inq_varid(ncid,'al',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ij,nc_ij,al)
      ierr=nfmpi_inq_varid(ncid,'ar',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ij,nc_ij,ar)
      ierr=nfmpi_inq_varid(ncid,'ab',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ij,nc_ij,ab)
      ierr=nfmpi_inq_varid(ncid,'ac',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ij,nc_ij,ac)
      ierr=nfmpi_inq_varid(ncid,'cl',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ij,nc_ij,cl)
      ierr=nfmpi_inq_varid(ncid,'cb',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ij,nc_ij,cb)
      ierr=nfmpi_inq_varid(ncid,'cc',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ij,nc_ij,cc)
      ierr=nfmpi_inq_varid(ncid,'cr',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ij,nc_ij,cr)
      ierr=nfmpi_inq_varid(ncid,'ct',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ij,nc_ij,ct)

      ns_ij(1) = mylon*i2+1
      ns_ij(2) = mylat*(j2+1)+1
      nc_ij(1) = i2
      nc_ij(2) = j2+1
      ierr=nfmpi_inq_varid(ncid,'at',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ij,nc_ij,at)

      ierr=nfmpi_close(ncid)
end subroutine rdnc_evp

subroutine rdnc_windmix
use comm, only: m_cart
use const, only: k2
implicit none
character :: fn*23
integer :: ncid,ierr,itmp
integer(kind=mpi_offset_kind) :: ns_i,nc_i
      fn = 'prepglo/data/windmix.nc'
      ierr=nfmpi_open(m_cart,fn,nf_nowrite,mpi_info_null,ncid)
      ns_i = 1
      nc_i = k2
      ierr=nfmpi_inq_varid(ncid,'vbk',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,vbk)
      ierr=nfmpi_inq_varid(ncid,'hbk',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,hbk)
      ierr=nfmpi_close(ncid)
end subroutine rdnc_windmix

subroutine rdnc_winds
use comm, only: m_cart,mylon,mylat
use const, only: i2,j2,ngx0,ngy0
implicit none
character :: fn*21
integer :: ncid,ierr,itmp
integer(kind=mpi_offset_kind) :: ns_ijt(3),nc_ijt(3)
      fn = 'prepglo/data/winds.nc'
      ierr=nfmpi_open(m_cart,fn,nf_nowrite,mpi_info_null,ncid)
      ns_ijt(1) = mylon*i2+1
      ns_ijt(2) = mylat*j2+1
      ns_ijt(3) = 1
      nc_ijt(1) = i2
      nc_ijt(2) = j2
      nc_ijt(3) = 12

!      if (lscowf) then
      ierr=nfmpi_inq_varid(ncid,'tauxs',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ijt,nc_ijt,taux)
      ierr=nfmpi_inq_varid(ncid,'tauys',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ijt,nc_ijt,tauy)
!      else
!      ierr=nfmpi_inq_varid(ncid,'taux_data',itmp)
!      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ijt,nc_ijt,taux)
!      ierr=nfmpi_inq_varid(ncid,'tauy_data',itmp)
!      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ijt,nc_ijt,tauy)
!      endif
      ierr=nfmpi_close(ncid)
end subroutine rdnc_winds

subroutine rdnc_levitus(nm)
use comm, only: m_cart,mylon,mylat
use const, only: i0,j0,ngx0,ngy0,k1
implicit none
character :: fn*28
integer :: ncid,ierr,itmp
integer(kind=mpi_offset_kind) :: ns_ijkt(4),nc_ijkt(4)
integer,intent(in) :: nm
      fn = 'prepglo/data/annualevitus.nc'
      ierr=nfmpi_open(m_cart,fn,nf_nowrite,mpi_info_null,ncid)
      ns_ijkt(1) = mylon*i0+1
      ns_ijkt(2) = mylat*j0+1
      ns_ijkt(3) = 1
      ns_ijkt(4) = nm
      nc_ijkt(1) = i0
      nc_ijkt(2) = j0
      nc_ijkt(3) = k1
      nc_ijkt(4) = 1
      ierr=nfmpi_inq_varid(ncid,'s1_data',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ijkt,nc_ijkt,sclim)
      ierr=nfmpi_inq_varid(ncid,'t1_data',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ijkt,nc_ijkt,tclim)
      ierr=nfmpi_close(ncid)
end subroutine rdnc_levitus

subroutine rdnc_zkb
use comm, only: m_cart,mylon,mylat
use const, only: i0,j0,ngx0,ngy0,k1,k0,i01
implicit none
character :: fn*19
integer :: ncid,ierr,itmp
integer(kind=mpi_offset_kind) :: ns_i,nc_i,ns_ij(2),nc_ij(2)
integer(kind=mpi_offset_kind) :: ns_ijk(3),nc_ijk(3)
      fn = 'prepglo/data/zkb.nc'
      ierr=nfmpi_open(m_cart,fn,nf_nowrite,mpi_info_null,ncid)
      ns_i = 1
      nc_i = 1
      ierr=nfmpi_inq_varid(ncid,'tlz',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,tlz)
      ns_i = 1
      nc_i = k0+k1
      ierr=nfmpi_inq_varid(ncid,'z',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,z)
      ns_i = 1
      nc_i = k1
      ierr=nfmpi_inq_varid(ncid,'odz',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,odz)
      ns_i = 1
      nc_i = k0
      ierr=nfmpi_inq_varid(ncid,'odzw',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,odzw)
      ns_ij(1) = mylon*i0+1
      ns_ij(2) = mylat*j0+1
      nc_ij(1) = i0
      nc_ij(2) = j0
      ierr=nfmpi_inq_varid(ncid,'kb',itmp)
      ierr=nfmpi_get_vara_int2_all(ncid,itmp,ns_ij,nc_ij,kb)
      ns_ij(1) = mylon*i0+1
      ns_ij(2) = mylat*(j0+1)+1
      nc_ij(1) = i0
      nc_ij(2) = j0+1
      ierr=nfmpi_inq_varid(ncid,'iv0',itmp)
      ierr=nfmpi_get_vara_int2_all(ncid,itmp,ns_ij,nc_ij,iv0)
      ns_ij(1) = mylon*(i01+1)+1
      ns_ij(2) = mylat*j0+1
      nc_ij(1) = i01+1
      nc_ij(2) = j0
      ierr=nfmpi_inq_varid(ncid,'iu0',itmp)
      ierr=nfmpi_get_vara_int2_all(ncid,itmp,ns_ij,nc_ij,iu0)
      ns_ijk(1) = mylon*i0+1
      ns_ijk(2) = mylat*j0+1
      ns_ijk(3) = 1
      nc_ijk(1) = i0
      nc_ijk(2) = j0
      nc_ijk(3) = k0
      ierr=nfmpi_inq_varid(ncid,'iw',itmp)
      ierr=nfmpi_get_vara_int2_all(ncid,itmp,ns_ijk,nc_ijk,iw)
      nc_ijk(3) = k1
      ierr=nfmpi_inq_varid(ncid,'in',itmp)
      ierr=nfmpi_get_vara_int2_all(ncid,itmp,ns_ijk,nc_ijk,in)
      ns_ijk(2) = mylat*(j0+1)+1
      nc_ijk(2) = j0+1
      ierr=nfmpi_inq_varid(ncid,'iv',itmp)
      ierr=nfmpi_get_vara_int2_all(ncid,itmp,ns_ijk,nc_ijk,iv)
      ns_ijk(1) = mylon*(i01+1)+1
      ns_ijk(2) = mylat*j0+1
      nc_ijk(1) = i01+1
      nc_ijk(2) = j0
      ierr=nfmpi_inq_varid(ncid,'iu',itmp)
      ierr=nfmpi_get_vara_int2_all(ncid,itmp,ns_ijk,nc_ijk,iu)

      ierr=nfmpi_close(ncid)
end subroutine rdnc_zkb

subroutine rdnc_zkb2
use comm, only: m_cart,mylon,mylat
use const, only: i0,j0
implicit none
character :: fn*19
integer :: ncid,ierr,itmp
integer(kind=mpi_offset_kind) :: ns_ij(2),nc_ij(2)
      fn = 'prepglo/data/zkb.nc'
      ierr=nfmpi_open(m_cart,fn,nf_nowrite,mpi_info_null,ncid)
      ns_ij(1) = mylon*i0+1
      ns_ij(2) = mylat*j0+1
      nc_ij(1) = i0
      nc_ij(2) = j0
      ierr=nfmpi_inq_varid(ncid,'rmets',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_ij,nc_ij,scr(:,:,1))
      ierr=nfmpi_close(ncid)
end subroutine rdnc_zkb2

subroutine rdnc_rundata
use comm, only: m_cart,mylon,mylat
use const, only: i0,j0,j1,j2,ngx0,ngy0
implicit none
character :: fn*23
integer :: ncid,ierr,itmp
integer(kind=mpi_offset_kind) :: ns_i,nc_i
      fn = 'prepglo/data/rundata.nc'
      ierr=nfmpi_open(m_cart,fn,nf_nowrite,mpi_info_null,ncid)
      ns_i = 1
      nc_i = 5
      ierr=nfmpi_inq_varid(ncid,'case',itmp)
      ierr=nfmpi_get_vara_text_all(ncid,itmp,ns_i,nc_i,case)
      nc_i = 63
      ierr=nfmpi_inq_varid(ncid,'describ',itmp)
      ierr=nfmpi_get_vara_text_all(ncid,itmp,ns_i,nc_i,dscrib)
      nc_i = 1
      ierr=nfmpi_inq_varid(ncid,'dt',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,dt)
      ierr=nfmpi_inq_varid(ncid,'tlz',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,tlz)
      ierr=nfmpi_inq_varid(ncid,'b',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,b)
      ierr=nfmpi_inq_varid(ncid,'g',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,g)
      ierr=nfmpi_inq_varid(ncid,'dm0',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,dm0)
      ierr=nfmpi_inq_varid(ncid,'de0',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,de0)
      ierr=nfmpi_inq_varid(ncid,'dmz0',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,dmz0)
      ierr=nfmpi_inq_varid(ncid,'rzmx',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,rzmx)
      ierr=nfmpi_inq_varid(ncid,'drag',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,drag)
      ierr=nfmpi_inq_varid(ncid,'fltw',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,fltw)
      ierr=nfmpi_inq_varid(ncid,'daodt',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,daodt)
      ierr=nfmpi_inq_varid(ncid,'odt',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,odt)
      ierr=nfmpi_inq_varid(ncid,'prn',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,prn)
      ierr=nfmpi_inq_varid(ncid,'orzmx',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,orzmx)
      ierr=nfmpi_inq_varid(ncid,'ofltw',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,ofltw)
      ierr=nfmpi_inq_varid(ncid,'rawf',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,rawf)

      ierr=nfmpi_inq_varid(ncid,'ktrm',itmp)
      ierr=nfmpi_get_vara_int_all(ncid,itmp,ns_i,nc_i,ktrm)
      ierr=nfmpi_inq_varid(ncid,'lrstrt',itmp)
      ierr=nfmpi_get_vara_int_all(ncid,itmp,ns_i,nc_i,lrstrt)
      ierr=nfmpi_inq_varid(ncid,'mxit',itmp)
      ierr=nfmpi_get_vara_int_all(ncid,itmp,ns_i,nc_i,mxit)
      ierr=nfmpi_inq_varid(ncid,'isav',itmp)
      ierr=nfmpi_get_vara_int_all(ncid,itmp,ns_i,nc_i,isav)
      ierr=nfmpi_inq_varid(ncid,'mxsav',itmp)
      ierr=nfmpi_get_vara_int_all(ncid,itmp,ns_i,nc_i,mxsav)
      ierr=nfmpi_inq_varid(ncid,'lopen',itmp)
      ierr=nfmpi_get_vara_int_all(ncid,itmp,ns_i,nc_i,lopen)
      ierr=nfmpi_inq_varid(ncid,'lmovi',itmp)
      ierr=nfmpi_get_vara_int_all(ncid,itmp,ns_i,nc_i,lmovi)
      ierr=nfmpi_inq_varid(ncid,'mvi',itmp)
      ierr=nfmpi_get_vara_int_all(ncid,itmp,ns_i,nc_i,mvi)
      ierr=nfmpi_inq_varid(ncid,'lfsrf',itmp)
      ierr=nfmpi_get_vara_int_all(ncid,itmp,ns_i,nc_i,lfsrf)
      ierr=nfmpi_inq_varid(ncid,'lsolver',itmp)
      ierr=nfmpi_get_vara_int_all(ncid,itmp,ns_i,nc_i,lsolver)
      ierr=nfmpi_inq_varid(ncid,'lprecon',itmp)
      ierr=nfmpi_get_vara_int_all(ncid,itmp,ns_i,nc_i,lprecon)
      ns_i = mylat*j2+1
      nc_i = j2
      ierr=nfmpi_inq_varid(ncid,'f',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,f)
      ierr=nfmpi_inq_varid(ncid,'tanphi',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,tanphi)

      ns_i = mylat*j1+1
      nc_i = j1
      ierr=nfmpi_inq_varid(ncid,'csv',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,csv)
      ierr=nfmpi_inq_varid(ncid,'ocsv',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,ocsv)
      ierr=nfmpi_inq_varid(ncid,'dxv',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,dxv)
      ierr=nfmpi_inq_varid(ncid,'odxv',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,odxv)
      ierr=nfmpi_inq_varid(ncid,'dyv',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,dyv)
      ierr=nfmpi_inq_varid(ncid,'odyv',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,odyv)

      ns_i = mylat*j0+1
      nc_i = j0
      ierr=nfmpi_inq_varid(ncid,'y',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,y)
      ierr=nfmpi_inq_varid(ncid,'ydeg',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,ydeg)
      ierr=nfmpi_inq_varid(ncid,'yv',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,yv)
      ierr=nfmpi_inq_varid(ncid,'yvdeg',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,yvdeg)
      ierr=nfmpi_inq_varid(ncid,'cs',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,cs)
      ierr=nfmpi_inq_varid(ncid,'ocs',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,ocs)
      ierr=nfmpi_inq_varid(ncid,'dx',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,dx)
      ierr=nfmpi_inq_varid(ncid,'odx',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,odx)
      ierr=nfmpi_inq_varid(ncid,'dy',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,dy)
      ierr=nfmpi_inq_varid(ncid,'ody',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,ody)

      ns_i = mylon*i0+1
      nc_i = i0
      ierr=nfmpi_inq_varid(ncid,'xdeg',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,xdeg)


      ierr=nfmpi_close(ncid)
end subroutine rdnc_rundata

end module

module util
    use const
    use var
    use comm
implicit real*8 (a-h,o-z)
contains

subroutine check_blowup
    ! note: diecast has been found to always be stable unless dt is too large
    ! or user-specified i.c.s or b.c.s are unphysical)
    call rangerle(v2,in,i0,j0,2,2,i1,j1,ijlo,ijhi,vlo,vhi)
    call mpi_allreduce(vhi,temp,1,mpi_real8,mpi_max,m_cart,ierr)
    call mpi_allreduce(vlo,tmp,1,mpi_real8,mpi_min,m_cart,ierr)
    tmp=temp-tmp
    
    if (tmp>=1000.) then 
	write(14,107) itf,ijlo(1),ijlo(2),int(vlo),ijhi(1),ijhi(2),int(vhi),vhi-vlo,tmp
	107  format('itf,ilo,jlo,vlo,ihi,jhi,vhi,vmx-vmn|l,vmx-vmn|g=',i8,6i5,2f8.3)
	write(14,109) itf
	109  format('stop. unix-pectedly large velocity at itf=',i7)
	write(*,*) 'unix-pectedly large velocity at itf=',itf,'myid =',myid
	open(1111,file='data/blow_check'//grd,form='unformatted')
	write(1111) u2,v2,t2,s2
	close(1111)
	call mpi_finalize(ierr)
	stop
    endif
end subroutine


! ----------------------------------------------------------------------
subroutine rangerle(fld,in,ir,jr,il,jl,ih,jh,ijlo,ijhi,fmin,fmax)
    integer*2 in(ir,jr)
    real*8 fld(ir,jr)
    integer ijlo(2),ijhi(2)
    ijlo=minloc(fld(il:ih,jl:jh),mask=in(il:ih,jl:jh).eq.1)
    fmin=minval(fld(il:ih,jl:jh),mask=in(il:ih,jl:jh).eq.1)
    if(fmin>1.e20)fmin=0.
    ijhi=maxloc(fld(il:ih,jl:jh),mask=in(il:ih,jl:jh).eq.1)
    fmax=maxval(fld(il:ih,jl:jh),mask=in(il:ih,jl:jh).eq.1)
    if(fmax<-1.e20)fmax=0.
end subroutine


! ----------------------------------------------------------------------
subroutine ranger(fld,in,ir,il,jl,ih,jh,ilo,jlo,ihi,jhi,fmin,fmax)
    integer*2 in(ir,*)
    real*8 fld(ir,*) !dog
    fmin=1.e20
    fmax=-1.e20
    do 10 j=jl,jh
    do 10 i=il,ih
    fmin=(1-in(i,j))*fmin+in(i,j)*min(fmin,fld(i,j))
    10   fmax=(1-in(i,j))*fmax+in(i,j)*max(fmax,fld(i,j))
    do 20 j=jl,jh
    do 20 i=il,ih
    if (fmax.ne.fld(i,j)) go to 15
    ihi=i
    jhi=j
    go to 20
    15   if (fmin.ne.fld(i,j)) go to 20
    ilo=i
    jlo=j
    20   continue
end subroutine

end module

module filter 
    use const
    use var
implicit real*8 (a-h,o-z)
contains


subroutine modified_filter 
    do k=1,k1
	do j=2,j1
	    do i=2,i1
		tmp_u=fltw*(.5*u1(i,j,k)-ulf(i,j,k)+.5*u2(i,j,k))
		u1(i,j,k)=ulf(i,j,k)+rawf*tmp_u
		ulf(i,j,k)=u2(i,j,k)+(rawf-1.)*tmp_u
		tmp_v=fltw*(.5*v1(i,j,k)-vlf(i,j,k)+.5*v2(i,j,k))
		v1(i,j,k)=vlf(i,j,k)+rawf*tmp_v
		vlf(i,j,k)=v2(i,j,k)+(rawf-1.)*tmp_v
		tmp_t=fltw*(.5*t1(i,j,k)-tlf(i,j,k)+.5*t2(i,j,k))
		t1(i,j,k)=tlf(i,j,k)+rawf*tmp_t
		tlf(i,j,k)=t2(i,j,k)+(rawf-1.)*tmp_t
		tmp_s=fltw*(.5*s1(i,j,k)-slf(i,j,k)+.5*s2(i,j,k))
		s1(i,j,k)=slf(i,j,k)+rawf*tmp_s
		slf(i,j,k)=s2(i,j,k)+(rawf-1.)*tmp_s
!yc
                tmp_c=fltw*(.5*c1(i,j,k)-clf(i,j,k)+.5*c2(i,j,k))
                c1(i,j,k)=clf(i,j,k)+rawf*tmp_c
                clf(i,j,k)=c2(i,j,k)+(rawf-1.)*tmp_c
!yc
	    enddo
	enddo
    enddo
end subroutine

end module

module var 
    use const
implicit real*8 (a-h,o-z)

    ! double precision sevp ellipti! solver arrays
    real*8 rinv,rinv1,dum0,dum1,dum2,dumg,x,h,rho
    real*8 cgr,cgrh,cgp,cgv,cgs,cgt,cgph,cgsh
    real*8 a,t1,s1
    ! real*8 al,ar,ab,at,ac,cl,cb,cc,cr,ct,s
    ! lower precision logical depth and masking arrays
    integer*2 kb,iu0,iv0,in,iu,iv,iw
    integer*2 ibred
    
    integer*2 infx,infy
    integer n360,nyr,itf,itff,it0,itfday,nocn
    integer nopt
    integer nld
  
    ! "a" grid arrays
    common/bglo/rho(i0,j0,k1),px(i0,j0),py(i0,j0), &
    u1(i0,j0,k1),u2(i0,j0,k1),v1(i0,j0,k1),v2(i0,j0,k1), &
    s1(i0,j0,k1),s2(i0,j0,k1),t1(i0,j0,k1),t2(i0,j0,k1), &
    p0(i0,j0),p(i0,j0,k1),ulf(i0,j0,k1),vlf(i0,j0,k1),slf(i0,j0,k1), &
    tlf(i0,j0,k1),ev(i2,j2,k2),hv(i2,j2,k2),f(j2), &
    tanphi(j2),sumin(k1),c1(i0,j0,k1),c2(i0,j0,k1),clf(i0,j0,k1)

    real*8 westdeg

    ! logical depth kb and associated masking arrays
    common/bathyglo/kb(i0,j0),iu0(0:i01,j0),iv0(i0,0:j0), &
    in(i0,j0,k1),iu(0:i01,j0,k1),iv(i0,0:j0,k1),iw(i0,j0,k0)

    !c-grid arrays
    common/cgridglo/u(i0,j0,k1),v(i0,j0,k1),w(i0,j0,k0)
    common/tavgglo/pbar(i0,j0),pvar(i0,j0),xbar(i0,j0),sbar(i0,j0,k1), &
    tbar(i0,j0,k1),ucli(i0,j0),vcli(i0,j0),rmsv(i0,j0)
    common/klimatglo/fnew,fold,new,nld
    ! user-defined scalar control parameters
    common/controglo/evap,qsum,olde,oldq, &
    dt,tlz,b,g,dm0,de0,dmz0,rzmx,drag,fltw,av,avn,navg,daodt, &
    taudt,taudtn,ktrm,mvi,mxit,isav, &
    mxsav,lrstrt,lopen,lturb,lwind,lheat,lsol,lmovi,lfsrf,lsolver, &
    rawf,lprecon

    common/metricglo/a(k1),y(j0),yv(j0),yvdeg(j0),ydeg(j0),xdeg(i0), &
    cs(j0),csv(j1),ocs(j0),ocsv(j1),dx(j0),dxv(j1),odx(j0),odxv(j1), &
    dy(j0),dyv(j1),ody(j0),odyv(j1)

    ! derived scalars
    common/scaglo/ odt,prn,days,orzmx,ofltw,watts,n360,nyr,itf,it0,itfday,nocn

    ! scratch arrays
    common/scratchglo/scr(i0,j0,k0+1)

    ! sevp elliptic solver arrays
    ! sevp subregion boundary array "ie" is a user-defined array

    common/sevp/rinv(ibir,i0,nbg0),rinv1(ibir,i0,nbg1),dum0(i0,nb0), &
    dum1(ibir),dum2(i0),dumg(i2t),x(i0,j0),al(i2,j2),ab(i2,j2), &
    ac(i2,j2),ar(i2,j2),at(i2,0:j2),s(i2,j2),ie(nb0), &
    cl(i2,j2),cb(i2,j2),cc(i2,j2),cr(i2,j2),ct(i2,j2)
    common/bicg/cgr(i0,j0),cgrh(i0,j0),cgp(i0,j0),cgv(i0,j0),cgs(i0,j0),cgt(i0,j0),cgph(i0,j0),cgsh(i0,j0)

    ! vertical grid arrays
    ! "z" array contains cell center and interface depths
    common/zfsglo/z(k0+k1),odz(k1),odzw(k0)
    
    common/bred/lbred,ibred(i2,j2),bf1,bf2,bflf

    character grd*7,filename*16
    common/grdglo/grd

    common/fullopt/nopt,wopt

    common/filterglo/ dmx(i0,j0,k1),dmy(i0,j0,k1),infx(i0,j0,k1),infy(i0,j0,k1)

    dimension ule(i0,j0,k1),vle(i0,j0,k1),tle(i0,j0,k1),sle(i0,j0,k1),ple(i0,j0,k1),wle(i0,j0,k1),pot(i0,j0,k1)

    real*8 dtmp,dsum
    real*8 timer
    integer ijlo(2),ijhi(2)
    common/timer/timer(10)

    common/nudging/hmean_nudge(i0,j0,k0),t_nudge(i0,j0),s_nudge(i0,j0)

    character sys1*30,sys2*22

    integer ::   lbred=0

    !climate data for winter
    common/climatglo/tnudge(i2,j2),qavg(i2,j2,12),tclis(i0,j0,k1,12),sclis(i0,j0,k1,12),nsombo(12),tclim(i0,j0,k1),sclim(i0,j0,k1)
    
    character case*5,dscrib*63

    common/title/case,dscrib
    common/windsglo/taux(i2,j2,12),tauy(i2,j2,12)
    common/windmxglo/vbk(k2),hbk(k2)
    common/xymeansglo/sxy(k1),txy(k1),sxycli(k1,12),txycli(k1,12)
    common/tauglo/add(i2,j2,k2)

    common/blank/xp(0:i0,j0),yp(i0,0:j0),pe(2,j0),ype(i0,2),qprof(k1),dhx(i1,j0),dhy(i0,j1),plf(i0,j0,k1)

    common/flxglo/ ux(i1,j2),uy(i2,j1),uz(i2,j2,2),vx(i1,j2),vy(i2,j1),vz(i2,j2,2),sx(i1,j2),sy(i2,j1),sz(i2,j2,2),&
                  tx(i1,j2),ty(i2,j1),tz(i2,j2,2),cfcx(i1,j2),cfcy(i2,j1),cfcz(i2,j2,2)



end module

program preprocess
    implicit real*8 (a-h,o-z)    
    
    call init
    call run 
    call finalize
    
    stop
end program

subroutine init
    use const
    use comm
    use var


    call init_comm
    call mpi_grid2d_gen
end

subroutine run
    use const
    use comm
    use var
    use met
    use interp
    use presolver


    call metgen
    call inmets
    call indata
    call solvergen 
end

subroutine finalize()
    call mpi_finalize(ierr)
end subroutine 

module interp 
    use const
    use comm
    use var
!TS    use io
implicit real*8 (a-h,o-z)
#   include "pnetcdf.inc" !dog
contains

subroutine inmets
    ! ======================================================================
    ! extract regional subset of etopo5 bathymetry
    ! user specified lat-long window and resolution
    ! by david dietrich, may 1, 1995
    !
    ! reads one latitude at a time in a simple do loop.
    ! reads full etopo5 data sets into memory, then extracts desired subset
    ! simple and versatile.
    ! most workstations have the required storage capacity.
    ! etopo5 has 360 x 12 integer*2 data elements per (latitudinal) record.
    !   this gives 8640 bytes or 2160 sgi (or vax) "words". thus, under sun
    !   fortran, recl=8640, while under sgi or vax fortran recl=2160.
    ! ======================================================================
    !nres is the etopo resolution =5 (5min)
    parameter(nres=2)
    parameter(nx=21600/nres,ny=10800/nres,nxpd=nx/360,nypd=ny/180)
    integer*2 meters,in

    ! ========================================================
    ! tlev, slev is levitus climatology data with landfills
    ! t,s is tlev, slev interpolated to model horizontal grid
    ! t1, s1 is t,s vertically interpolated to model z-levels
    ! ========================================================
    dimension rmets(i0,j0),meters(nx,ny),in(i0,j0)
    dimension depth(nx,ny)
    dimension istart(2),icount(2),dt(nx,ny)
    ! read nc data, which is single precision
    real,dimension(nx,ny) :: dep_tmp
    ! ======================================================================
    ! i0= number of grid points in the x-direction including ghost zones
    ! j0= number of grid points in the y-direction including ghost zones
    ! westdeg is western most longitude degrees (west cell face of i=2 zone)
    ! longitude coordinate increases eastward
    ! 0 < westdeg < 360
    ! longitudinal increment in minutes,dxmnut, is read from yzgrid
    ! latitudes are read from yzgrid
    ! ======================================================================

!    open(9,file='data/westdeg'//grd)
!    rewind 9
!    read(9,'(f9.4)') westdeg
!    close(9)
    call rdnc_westdeg !dog
    ! ================
    ! input data files
    ! ================
!    open(10,file='data/yzgrid'//grd,form='unformatted')

    ! new, single record integer*2 data
    ! no record length bullshit!
    if (myid .eq. 0)  then
	if(nres==1)then
	    istatus=nf_open('../worldata/etopo/etopo1/etopo1_bed_c_gmt4.grd',nf_nowrite,ncid)
	    print*,'istatus1',istatus,ncid,nx,ny
	    elseif(nres==2) then
	    istatus=nf_open('../worldata/etopo/etopo2/etopo2v2g_f4.nc',nf_nowrite,ncid)
	    print*,'istatus2',istatus,ncid,nx,ny,NF_STRERROR(istatus)
	    elseif(nres==5) then
	    open(12,file='../worldata/etopo/etopo5/itopo5',form='unformatted')
	endif
    endif
!    rewind 10
    rewind 12
    rewind 35

    ! =================
    ! output data files
    ! =================
!    open(8,file='data/depth'//grd,form='unformatted')
!    open(14,file='data/inview'//grd)
!    rewind 8
!    rewind 14

    ! ==============================================
    ! read metrics data file yzgrid (from metgen.f)
    ! ==============================================
    call rdnc_yzgrid(j,k,dxmnut)  !dog
 !   read(10) j,k
!    if (j0.eq.j.and.k0.eq.k) go to 9
    if (j0.ne.j.and.k0.ne.k) then
    write(*,6)
    6    format('stop due to resolution mismatch. set j0,k0 to values from metgen.f.')
    stop
    endif
!    9    read(10) tlz,z,odz,odzw,dxmnut,xdeg,y,yv,yvdeg,ydeg,cs,csv,ocs,ocsv,dx,dxv,odx,odxv,dy,dyv,ody,odyv
        
    ! new single record input
    if (myid .eq. 0) then
	if(nres.le.2)then
	    istart(1) = 1
	    istart(2) = 1
	    icount(1) = nx
	    icount(2) = ny
	    istatus=nf_get_vara_real(ncid,3,istart,icount,dep_tmp)
            depth = dep_tmp
	    do j=1,ny
		do i=1,nx/2 
		    depth(i,j)=depth(i,j)+depth(i+nx/2,j)
		    depth(i+nx/2,j)=depth(i,j)-depth(i+nx/2,j)
		    depth(i,j)=depth(i,j)-depth(i+nx/2,j)
		enddo
	    enddo
	    print*,'icount,',icount
	    do j=1,ny
		do i=1,nx
		    dt(i,j)=depth(i,ny-j+1)
		enddo
	    enddo
	    do j=1,ny
		do i=1,nx
		    depth(i,j)=dt(i,j)
		enddo
	    enddo
	    !ts   will add this later
	else if(nres.eq.5) then
	    read(12) meters
	    do j=1,ny
		do i=1,nx
		    depth(i,j)=meters(i,j)
		enddo
	    enddo
	endif
    endif

    call mpi_bcast(depth,nx*ny,mpi_real8,0,mpi_comm_world,ierr)

    ! ==============================================================
    ! determine depths at model grid points and store in rmets array
    ! ==============================================================
    ! first element is at 0.0 degrees east (or 360 degrees east).
    ! 
    if(nres.eq.1)then
	xinc=dxmnut/1.
    else if(nres.eq.2)then
	xinc=dxmnut/2.
    else if(nres.eq.5)then
	xinc=dxmnut/5.
    endif

    if(myid.eq.0) print*,'xinc',xinc

    ! xin! is the grid distance of etop2. therefore, for 15' grid size
    ! each grid has 15/2 = 7.5 grid point in etop2 data set.
    do 100 jj=1,j0
	! ylat is measured from north pole.  first point is at pole.
	! xlon is measured units 1/12 deg east, from grenwich, with first point
	! at 1/12 deg east (meters(1,j) is at 1/12 deg east; meters(i,1) is
	! at north pole, or ydeg=90)
	ylat=nypd*(90-ydeg(jj))+1
	! average depths in lat-long window
	j=ylat
	jp=j-1
	xlon=nxpd*westdeg-.5*xinc
	!      print*,'xinc',xinc,xlon,ydeg(524)
      
	do 100 ii=2,i1
	    xlon=xlon+xinc
	    i=xlon
	    tmp1=xlon-i
	    tmp2=1.-tmp1
	    ip=mod(i+1,nx)+1
	    i=mod(i,nx)+1
	    !choke point depths are critical in modeling straits. when they are not
	    ! adequately resolved they are always too shallow when evaluating them from
	    ! world data base. thus, at a given control volume location, it is
	    ! physically better to assign the deepest adjacent point in the control
	    ! volume region than to use the actual local value.

	    ! special for 1/4 deg global grid in critical gom and gibraltar regions
	    if (xdeg(ii).lt.269.625.or.xdeg(ii).gt.359.125) go to 80
	    ! avoid cape hatteras and northern north atlanti! region
	    if (xdeg(ii).lt.299.625.and.ydeg(jj).gt.29.91505) go to 80
	    ! this may make some single-point islands wet, but that's ok!
	    ! note: negative meters values mean positive ocean depths


	    rmets(ii,jj)=min(depth(i,j),depth(ip,j),depth(i,jp),depth(ip,jp))

	    rmets(ii,jj)=-rmets(ii,jj)
	    rmets(ii,jj)=max(0.,rmets(ii,jj))
	    go to 100

80  dsw=depth(i,jp)
    dse=depth(ip,jp)
    dnw=depth(i,j)
    dne=depth(ip,j)
    dn=tmp1*dne+tmp2*dnw
    ds=tmp1*dse+tmp2*dsw
    rmets(ii,jj)=(ylat-j)*ds+(1-ylat+j)*dn
    rmets(ii,jj)=-rmets(ii,jj)
    rmets(ii,jj)=max(0.,rmets(ii,jj))
100 continue

!    open(333,file='data/rmets'//grd,form='unformatted')
!    write(333) rmets
!    close(333)

!    write(8) rmets
    call wr8nc_depth(rmets)  !dog

    m=0
    n=0
    tmp=0.
    temp=.01*tlz
    do j=2,j1
	do i=2,i1
	    m=m+in(i,j)
	    tmp=max(tmp,rmets(i,j))
	    if (rmets(i,j).gt.temp) n=n+1
	enddo  
    enddo  
    write(*,103) m,n,temp,tmp
    103  format(i8,' total wet points,',i6,' deeper than ',f5.0,' m, deepest= ',f6.0,' m')

end subroutine

subroutine indata
! ======================================================================
! read bathymetry file from inmets.f
! read salinity, temperature and wind data sets
! interpolate data to model grid
! ======================================================================
! lscowf: .true.  scow wind climatological forcing
! lscowf: .false. hr   wind climatological forcing
! lclim: 1 levitus 94 climatology
! lclim: 2 phc3 climatology
    parameter(lscowf=.true.,lclim=2)
    parameter(nxscow=1440,nyscow=560,nxhel=360,nyhel=180)
    integer*2 nzdat
!    real*4 slon,slat,ilon,ilat,tlevs,slevs

! real*4 tmp variables for file reading
    real*4,dimension(360,180,33) :: swoa_tmp,twoa_tmp
    real*4,dimension(360,180,33) :: tlevs_tmp,slevs_tmp
    real*4,dimension(nxhel,nyhel) :: tx_tmp,ty_tmp
    real*4,dimension(nxscow,nyscow) :: sctx_tmp,scty_tmp
! ========================================================
! tlev, slev is levitus climatology data with landfills
! t,s is tlev, slev interpolated to model horizontal grid
! t1_data, s1_data is t_data,s_data vertically interpolated to model z-levels
! ========================================================
      dimension tlev(360,180,33),slev(360,180,33),rho_data(360,180,33), &
      t_data(i0,j0,33),s_data(i0,j0,33),t1_data(i0,j0,k1),s1_data(i0,j0,k1),taux_data(i2,j2), &
      tauy_data(i2,j2),tauxs(i2,j2),tauys(i2,j2),nzdat(33)
    
      dimension tlevs(360,180,33),slevs(360,180,33)

      dimension twoa(360,180,33),swoa(360,180,33)
      dimension twoal(0:361,0:181),swoal(0:361,0:181)
      dimension tx_data(nxhel,nyhel),ty_data(nxhel,nyhel)
      dimension scowtx_data(nxscow,nyscow),scowty_data(nxscow,nyscow),istart(2),icount(2)
      
      character*59 txc(12)
      character*59 tyc(12)
      character*59 season(4)
      character*60 twoaf(12),swoaf(12),seasonswoa(4),seasontwoa(4)
      character*80 scowtaux,scowtauy

      integer*2 maxj(i2,j2)
      dimension scr_data(i0,j0,2)
      real*8,dimension(i0,j0,k1,12) :: clidata_t1,clidata_s1
      real*8,dimension(i2,j2,12) :: cli_tauxs,cli_tauys
      real*8,dimension(i2,j2,12) :: clidata_tauy,clidata_taux

      data txc/				    &
       '../worldata/hellerman/tx-jan.dat',  &
       '../worldata/hellerman/tx-feb.dat',  &
       '../worldata/hellerman/tx-mar.dat',  &
       '../worldata/hellerman/tx-apr.dat',  &
       '../worldata/hellerman/tx-may.dat',  &
       '../worldata/hellerman/tx-jun.dat',  &
       '../worldata/hellerman/tx-jul.dat',  &
       '../worldata/hellerman/tx-aug.dat',  &
       '../worldata/hellerman/tx-sep.dat',  &
       '../worldata/hellerman/tx-oct.dat',  &
       '../worldata/hellerman/tx-nov.dat',  &
       '../worldata/hellerman/tx-dec.dat'/
      data tyc/				    &
       '../worldata/hellerman/ty-jan.dat',  &
       '../worldata/hellerman/ty-feb.dat',  &
       '../worldata/hellerman/ty-mar.dat',  &
       '../worldata/hellerman/ty-apr.dat',  &
       '../worldata/hellerman/ty-may.dat',  &
       '../worldata/hellerman/ty-jun.dat',  &
       '../worldata/hellerman/ty-jul.dat',  &
       '../worldata/hellerman/ty-aug.dat',  &
       '../worldata/hellerman/ty-sep.dat',  &
       '../worldata/hellerman/ty-oct.dat',  &
       '../worldata/hellerman/ty-nov.dat',  &
       '../worldata/hellerman/ty-dec.dat'/
      data season/				&
       '../worldata/levitus/modelev_win.dat',   &
       '../worldata/levitus/modelev_spr.dat',   &
       '../worldata/levitus/modelev_sum.dat',   &
       '../worldata/levitus/modelev_aut.dat'/
      data swoaf/			    &
       '../worldata/phc3/salt01_p3',        &
       '../worldata/phc3/salt02_p3',        &
       '../worldata/phc3/salt03_p3',        &
       '../worldata/phc3/salt04_p3',        &
       '../worldata/phc3/salt05_p3',        &
       '../worldata/phc3/salt06_p3',        &
       '../worldata/phc3/salt07_p3',        &
       '../worldata/phc3/salt08_p3',        &
       '../worldata/phc3/salt09_p3',        &
       '../worldata/phc3/salt10_p3',        &
       '../worldata/phc3/salt11_p3',        &
       '../worldata/phc3/salt12_p3'/
      data twoaf/			    &
       '../worldata/phc3/temp01_p3',        &
       '../worldata/phc3/temp02_p3',        &
       '../worldata/phc3/temp03_p3',        &
       '../worldata/phc3/temp04_p3',        &
       '../worldata/phc3/temp05_p3',        &
       '../worldata/phc3/temp06_p3',        &
       '../worldata/phc3/temp07_p3',        &
       '../worldata/phc3/temp08_p3',        &
       '../worldata/phc3/temp09_p3',        &
       '../worldata/phc3/temp10_p3',        &
       '../worldata/phc3/temp11_p3',        &
       '../worldata/phc3/temp12_p3'/

      data seasonswoa/			    & 		
       '../worldata/phc3/salt13_p3',        &
       '../worldata/phc3/salt15_p3',        &
       '../worldata/phc3/salt15_p3',        &
       '../worldata/phc3/salt13_p3'/
      data seasontwoa/			    &
       '../worldata/phc3/temp13_p3',        &
       '../worldata/phc3/temp15_p3',        &
       '../worldata/phc3/temp15_p3',        &
       '../worldata/phc3/temp13_p3'/

      data scowtauy/			    & 
       '../worldata/scow/ws_v.nc'/          
      data scowtaux/                        &
       '../worldata/scow/ws_u.nc'/          

! -------------------------------------
! standard levitus data depths (m)
! -------------------------------------
    data nzdat/   0,  10,  20,  30,  50,  75, 100, 125, 150, 200, 250,  &
      300, 400, 500, 600, 700, 800, 900,1000,1100,1200,1300,1400,1500, &
      1750,2000,2500,3000,3500,4000,4500,5000,5500/
!lat: /lat (degree_north) ordered (89.5s) to (89.5n) by 1.0 n= 180 pts :grid
!lon: /lon (degree_east) periodi! (0.5e) to (0.5w) by 1.0 n= 360 pts :grid
! ======================================================================
! i0= number of grid points in the x-direction including ghost zones
! j0= number of grid points in the y-direction including ghost zones
! westdeg is western most longitude degrees (west cell face of i=2 zone)
! longitude coordinate increases eastward
! 0 < westdeg < 360
! longitudinal increment in minutes,dxmnut, is read from yzgrid
! latitudes are read from yzgrid
! ======================================================================
! ================
! input data files
! ================
!      open(10,file='data/yzgrid'//grd,form='unformatted')
!      open(14,file='data/invu'//grd)

!      rewind 10
!      rewind 14

! =================
! output data files
! =================
      if (myid .eq. 0) open(41,file='data/fixedlev',form='unformatted')

! annual cycle levitus climatology on model grid
!      open(70,file='data/annualevitus'//grd,form='unformatted')

! s,t at surface and lateral boundaries
!      open(72,file='data/winds'//grd,form='unformatted')

      rewind 41
!      rewind 70
!      rewind 72

! ==============================================
! read metrics data file yzgrid (from metrics.f)
! ==============================================
      call rdnc_yzgrid(j,k,dxmnut) !dog
!      read(10) j,k
      if (j0.ne.j.and.k0.ne.k) then
      write(*,6)
 6    format('stop due to resolution mismatch. set j0,k0 to values from metgen.f.')
      stop
      endif
! 9    read(10) tlz,z,odz,odzw,dxmnut,xdeg,y,yv,yvdeg,ydeg,cs,csv,ocs,ocsv,dx,dxv,odx,odxv,dy,dyv,ody,odyv


!     scow wind forcing 
      if (myid.eq.0.and.lscowf.eq..true.)  then
      ist=nf_open(scowtaux,nf_nowrite,nctx)
      ist=nf_open(scowtauy,nf_nowrite,ncty)
      istart(1)=1
      istart(2)=1
      icount(1)=nxscow
      icount(2)=nyscow
      endif
! ==================================================
! prepare monthly winds and seasonal s,t climatology
! ==================================================
      do m=1,12
      if (myid .eq. 0) then

      rewind 41
      write(*,111) m
 111  format(i3)
! hellerman
      open(15,file=txc(m))
      open(16,file=tyc(m))
      rewind 15
      rewind 16
      
      if (mod(m,3).eq.1) then
      nm=(m+2)/3
! ===================================================
! read modelfied (with landfills) levitus climatology
! and fix negative stratification areas
! ===================================================

      open(36,file=season(nm),form='unformatted')
      rewind 36

      if(lclim.ne.1)then
      open(37,file=seasonswoa(nm))
      open(38,file=seasontwoa(nm))
      rewind 37
      rewind 38
      endif
! ===================================================
! read modelfied (with landfills) levitus climatology
! and fix negative stratification areas
! ===================================================
!      read(40)
!     1 ((tlev(i,j,1),i=1,360),j=1,180),((slev(i,j,1),i=1,360),j=1,180)

      print*,'read seasonal data'
      do k=1,33
       read(36) ((tlevs_tmp(i,j,k),i=1,360),j=1,180),((slevs_tmp(i,j,k),i=1,360),j=1,180) 
      enddo
      tlevs = tlevs_tmp     
      slevs = slevs_tmp 

      if(lclim.ne.1)then
      do k=1,33
      do j=1,180
      do i=1,36
       read(37,'(10f8.4)') (swoa_tmp(ii,j,k),ii=(i-1)*10+1,i*10)
       read(38,'(10f8.4)') (twoa_tmp(ii,j,k),ii=(i-1)*10+1,i*10)
      enddo
      enddo
      enddo
      swoa = swoa_tmp
      twoa = twoa_tmp
      endif

      endif

!      read(40)
!     1 ((tlev(i,j,1),i=1,360),j=1,180),((slev(i,j,1),i=1,360),j=1,180)
      if(lclim.ne.1)then
      open(39,file=swoaf(m))
      open(40,file=twoaf(m))
      rewind 39
      rewind 40
! ===================================================
! read modelfied (with landfills) levitus climatology
! and fix negative stratification areas
! ===================================================
      do 124 k=1,24
      do 124 j=1,180
      do 124 i=1,36
      read(40,'(10f8.4)') (twoa_tmp(ii,j,k),ii=(i-1)*10+1,i*10)
 124  read(39,'(10f8.4)') (swoa_tmp(ii,j,k),ii=(i-1)*10+1,i*10)
      swoa = swoa_tmp
      twoa = twoa_tmp
      endif
!      print*,'month twoa',(twoa(180,j,1),j=1,180)

 127  continue

      if(lclim.eq.1)then
      do k=1,33
      do j=1,180 
      do i=1,360
      swoa(i,j,k)=slevs(i,j,k)
      twoa(i,j,k)=tlevs(i,j,k)
      enddo
      enddo
      enddo
      else
      do 128 k=1,33
      do 128 j=1,180 
      do 128 i=1,360
      if (swoa(i,j,k) .le. -10.) swoa(i,j,k)=slevs(i,j,k)
 128  if (twoa(i,j,k) .le. -10.) twoa(i,j,k)=tlevs(i,j,k)
      endif

      write(41) ((twoa(i,j,1),i=1,360),j=1,180),((swoa(i,j,1),i=1,360),j=1,180)


! nzdat are levitus levels
      zlev = dble(nzdat(1))
      do 142 j=1,180
      do 142 i=1,360
      if ((twoa(i,j,1) .lt. -10.0)) twoa(i,j,1) = 0.0
      if ((swoa(i,j,1) .lt. -10.0)) swoa(i,j,1) = 0.0
      twoa(i,j,1)=theta(swoa(i,j,1),twoa(i,j,1),zlev,dble(0.))
 142  rho_data(i,j,1)=r(twoa(i,j,1),swoa(i,j,1),zlev)

! eliminate unstable stratification data

      ssum=0.
      n=0
      lb=1
      lt=2

      do 150 k=2,33

!      read(40)
!     1 ((tlev(i,j,lt),i=1,360),j=1,180),((slev(i,j,lt),i=1,360),j=1,180)
! for density referenced to in situ pressure
      zlev = dble(nzdat(k))
! for density referenced to mean pressure level
!     zlev = float(nzdat(k-1)+nzdat(k))/2.0
!     write(*,*) zlev
      do 145 j=1,180
      do 145 i=1,360
      if ((twoa(i,j,k) .lt. -10.0)) twoa(i,j,k) = 0.0
      if ((swoa(i,j,k) .lt. -10.0)) swoa(i,j,k) = 0.0
      twoa(i,j,k)=theta(swoa(i,j,k),twoa(i,j,k),zlev,dble(0.))
 145  rho_data(i,j,k)=r(twoa(i,j,k),swoa(i,j,k),zlev)
      do 148 j=1,180
      do 148 i=1,360
      rhok=rho_data(i,j,k)
      rhokm=rho_data(i,j,k-1)
      if (rhok.ge.rhokm) go to 148
      n=n+1
      twoa(i,j,k)=twoa(i,j,k-1)
      swoa(i,j,k)=swoa(i,j,k-1)
      rho_data(i,j,k)=rhokm
 148  continue
 150  write(41) ((twoa(i,j,k),i=1,360),j=1,180),((swoa(i,j,k),i=1,360),j=1,180)
      insum=32*180*360

! =================================================
! interpolate levitus data to model horizontal grid
! =================================================
      close(40)
      endif 
      rewind 41     

      do 230 k=1,33
      if (myid .eq. 0) then
      read(41) ((tlev(i,j,1),i=1,360),j=1,180),((slev(i,j,1),i=1,360),j=1,180)
      endif
      call mpi_bcast(tlev,360*180,mpi_real8,0,mpi_comm_world,ierr)
      call mpi_bcast(slev,360*180,mpi_real8,0,mpi_comm_world,ierr)


!      if(k.eq.1.or.k.eq.2) then
!      write(*,'(i2,a6,10f10.7)'),myid,' slev=',slev(340,161:170,1)
!      write(*,'(i2,a6,10f10.7)'),myid,' slev=',slev(320,101:110,1)
!      endif


      slon=.5
      slat=-89.5
      ilon=1.
      ilat=1.


      do 230 jj=1,j0
! xlon is model data point, measured in degrees east of grenwich
! ylat is model data point, measured in degrees north of south pole
! ydeg is measured from -90 at south pole to 90 at north pole
! tlev(1,1) is at 0.5 deg e, -89.5 deg lat
! tlev(360,180,) is at 359.5 deg e, 89.5 deg lat
! allowed model latitudes: -89.5.lt.ydeg.lt.89.5
! allowed model longitudes: 0.le.xlon.le.720

!      ylat=90.+ydeg(jj)
!      j=ylat+0.5
      ylat=(ydeg(jj)-slat)*ilat+1.
      j=ylat
      jp=j+1
      do 230 ii=1,i0
!      xlon=xdeg(ii)
      xlon=(xdeg(ii)-slon)*ilon+1.
      if (xlon.gt.360) xlon=xlon-360. 

! xplus is model data point distance east of 0.5 deg west(!)
! note that xplus is always positive due to xlon restrictions

!      xplus=xlon+0.5
      xplus=xlon
      i=xplus      
      ip=i+1
! tmp1 is weighting of east point
      tmp1=xplus-dble(i)
      tmp2=1.-tmp1
 
! special treatments when 359.5 < xlon < 360 and 0 < xlon < 0.5
      if (ip.eq.361) ip=1
!      if (i.eq.0) i=359
      if (i.eq.0) i=360
 
 
      dnw=tlev(i,jp,1)
      dne=tlev(ip,jp,1)
      dsw=tlev(i,j,1)
      dse=tlev(ip,j,1)

      dn=tmp1*dne+tmp2*dnw
      ds=tmp1*dse+tmp2*dsw
      t_data(ii,jj,k)=(ylat-j)*dn+(jp-ylat)*ds


      dnw=slev(i,jp,1)
      dne=slev(ip,jp,1)
      dsw=slev(i,j,1)
      dse=slev(ip,j,1)
      dn=tmp1*dne+tmp2*dnw
      ds=tmp1*dse+tmp2*dsw
 230  s_data(ii,jj,k)=(ylat-j)*dn+(jp-ylat)*ds
      tmax=-100.
      tmin=100.
      do 240 j=2,j1
      do 240 i=2,i1
      tmax=max(tmax,t_data(i,j,1))
 240  tmin=min(tmin,t_data(i,j,1))
!      write(*,245) m,tmin,tmax
! 245  format('month',i3,' tmin,tmax=',2f6.2)

! ===============================================
! interpolate from levitus levels to model levels
! ===============================================
      z2=100.*nzdat(1)
      k=1
      zc=z(2)
      n=1
 320  continue
      if(n.lt.33) then
      n=n+1
      z1=z2
      z2=100.*nzdat(n)
      endif

      if (z2.lt.zc.and.n.lt.33) go to 320
 322  cc1=(z2-zc)/(z2-z1)
      cc2=(zc-z1)/(z2-z1)
!      write(14,323) k,n
! 323  format('for diecast model level',i3,', lower input level=',i3)
      do 325 j=1,j0
      do 325 i=1,i0
      t1_data(i,j,k)=cc1*t_data(i,j,n-1)+cc2*t_data(i,j,n)
 325  s1_data(i,j,k)=cc1*s_data(i,j,n-1)+cc2*s_data(i,j,n)

      k=k+1
      if (k.eq.k0) go to 390
      zc=z(2*k)
      if (zc.gt.z2) go to 320
      go to 322

! write all seasons or months so we can diagnose annual cycle
! 390  write(70) s1_data,t1_data
      
 390  clidata_t1(:,:,:,m) = t1_data
      clidata_s1(:,:,:,m) = s1_data


! wenien
!      open(777,file='/home/opt/s1t1'//grd,form='unformatted')
!      write(777) s1,t1,s,t,swoa,twoa
!      close(777)
!      call mpi_finalize(ierr)
!      stop 390
      enddo
! increment westdeg by one grid interval, and start at second latitude
! (no ghost zones in winds)
      do m=1,12
      if (myid .eq. 0) then
      open(15,file=txc(m))
      open(16,file=tyc(m))
      read(15,400) i,j,x_tmp,x_tmp,x_tmp,x_tmp,fmt
      read(16,400) i,j,x_tmp,x_tmp,x_tmp,x_tmp,fmt
 400  format(2i4/4(3x,f10.7),a10)

! ================
! read hellerman winds
! ================
      read(15,415) tx_tmp
      read(16,415) ty_tmp
      tx_data = tx_tmp
      ty_data = ty_tmp
 415  format(5e15.7)
      write(*,416)
 416  format('read wind stress')

      endif
 
      call mpi_bcast(tx_data,nxhel*nyhel,mpi_real8,0,mpi_comm_world,ierr)
      call mpi_bcast(ty_data,nxhel*nyhel,mpi_real8,0,mpi_comm_world,ierr)

! xlon is model data point, measured in degrees east of grenwich
! ylat is model data point, measured in degrees north of south pole
! ydeg is measured from -90 at south pole to 90 at north pole
! tlev(1,1) is at 0.5 deg e, -89.5 deg lat
! tlev(360,180,) is at 359.5 deg e, 89.5 deg lat
! allowed model latitudes: -89.5.lt.ydeg.lt.89.5
! allowed model longitudes: 0.le.xlon.le.720

      slon=.5
      slat=-89.5
      ilon=1.
      ilat=1.

      do jj=2,j1
!      ylat=90.+ydeg(jj)
!      j=ylat+0.5
      ylat=(ydeg(jj)-slat)*ilat+1.
      j=ylat
      jp=j+1
      do ii=2,i1
!      xlon=xdeg(ii+1)
      xlon=(xdeg(ii)-slon)*ilon+1.

      if (xlon.gt.dble(nxhel)) xlon=xlon-dble(nxhel)

!      xplus=xlon+0.5
      xplus=xlon
      i=xplus
      ip=i+1
      tmp1=xplus-dble(i)
      tmp2=1.-tmp1
      if (ip.eq.(nxhel+1)) ip=1
!      if (i.eq.0) i=nxhel-1
      if (i.eq.0) i=nxhel
 
      dnw=tx_data(i,jp)
      dne=tx_data(ip,jp)
      dsw=tx_data(i,j)
      dse=tx_data(ip,j)
      dn=tmp1*dne+tmp2*dnw
      ds=tmp1*dse+tmp2*dsw
!      taux(ii-1,jj-1)=(.5+ylat-j)*dn+(.5-ylat+j)*ds
      taux_data(ii-1,jj-1)=(ylat-j)*dn+(jp-ylat)*ds


      dnw=ty_data(i,jp)
      dne=ty_data(ip,jp)
      dsw=ty_data(i,j)
      dse=ty_data(ip,j)
      dn=tmp1*dne+tmp2*dnw
      ds=tmp1*dse+tmp2*dsw
      tauy_data(ii-1,jj-1)=(ylat-j)*dn+(jp-ylat)*ds

      enddo
      enddo


!     
 
      if(lscowf)then
      if (myid .eq. 0) then
! hellerman
      ierr=nf_get_vara_real(nctx,m+2,istart,icount,sctx_tmp)
      ierr=nf_get_vara_real(ncty,m+2,istart,icount,scty_tmp)
      scowtx_data = sctx_tmp
      scowty_data = scty_tmp 
!dog
!      print*,nf_strerror(ierr)
!      write(1233)tx,ty

      do 420 j=1,nyscow
      do 420 i=1,nxscow
      if(abs(scowtx_data(i,j)).lt.10..and.abs(scowty_data(i,j)).lt.10.)go to 420
      scowtx_data(i,j)=0.
      scowty_data(i,j)=0.
 420  continue
      endif

!      stop

      call mpi_bcast(scowtx_data,nxscow*nyscow,mpi_real8,0,mpi_comm_world,ierr)
      call mpi_bcast(scowty_data,nxscow*nyscow,mpi_real8,0,mpi_comm_world,ierr)

! ===================================================
! interpolate scow data to model horizontal grid
! ===================================================
      slon=.125
      slat=-69.875
      ilon=4.
      ilat=4.

      do jj=2,j1
! ============================================================
! tx_data(i,1) is at latitude -69.875; tx_data(i,560) is at latitude 69.875 
! tx_data(1,j) is at longitude 0.125; tx_data(1440,j) is at longitude 359.875
! xlon is measured in degrees east from 0. (xlon=0)
! ydeg is measured in degrees north from -69.875 (ydeg=0)
! ============================================================
! xlon is measured in degrees east from 0 at grenwich
! ydeg is measured from -90 at south pole to 90 at north pole
          
      ylat=(min(ydeg(jj),69.875))*ilat+1.
!      ylat=(ydeg(jj)-slat)*ilat+1.
!      ylat=(70.125+ydeg(jj))*4.
      j=ylat
      if(j.le.0) j=1
      jp=j+1
      do ii=2,i1
      xlon=(xdeg(ii)-slon)*ilon+1.
!      xlon=xdeg(ii)*4.+0.5
!      xlon=xdeg(ii)*4.
      if (xlon.gt.dble(nxscow)) xlon=xlon-dble(nxscow)
! xplus is model data point distance east of 0.5 deg west(!)
! note that xplus is always positive due to xlon restrictions
      xplus=xlon
      i=xplus
      ip=i+1
! tmp1 is weighting of east point
      tmp1=xplus-i
      tmp2=1.-tmp1
 
! special treatments when 359.5 < xlon < 360 and 0 < xlon < 0.5
      if (ip.eq.(nxscow+1)) ip=1
!      if (i.eq.0) i=nxscow-1
      if (i.eq.0) i=nxscow
 
      dnw=scowtx_data(i,jp)
      dne=scowtx_data(ip,jp)
      dsw=scowtx_data(i,j)
      dse=scowtx_data(ip,j)
      dn=tmp1*dne+tmp2*dnw
      ds=tmp1*dse+tmp2*dsw
      tauxs(ii-1,jj-1)=(ylat-j)*dn+(jp-ylat)*ds

      dnw=scowty_data(i,jp)
      dne=scowty_data(ip,jp)
      dsw=scowty_data(i,j)
      dse=scowty_data(ip,j)
      dn=tmp1*dne+tmp2*dnw
      ds=tmp1*dse+tmp2*dsw
      tauys(ii-1,jj-1)=(ylat-j)*dn+(jp-ylat)*ds

      enddo
      enddo
      endif
      
    
      if(lscowf)then

      do i=1,i2
      do j=1,j2
      maxj(i,j)=0
      if(abs(tauxs(i,j)*tauys(i,j)).le.1.e-4)then
      iss=i-1
      iff=i+1
      if(iss.eq.0) iss=1
      if(iff.eq.i1) iff=i2
      jss=j-1
      jff=j+1
      if(jss.eq.0) jss=1
      if(jff.eq.j1) jff=j2
      do ii=iss,iff
      do jj=jss,jff
      maxj(ii,jj)=1
      enddo
      enddo
      tauxs(i,j)=taux_data(i,j)
      tauys(i,j)=tauy_data(i,j)
      endif      
      enddo
      enddo

! lf smoothing !dog ???
      call mpi_type_vector(2*j0,1,i0,mpi_real8,m_vlon3d,ierr)
      call mpi_type_vector(2,i0,i0*j0,mpi_real8,m_vlat3d,ierr)
      call mpi_type_commit(m_vlon3d,ierr)
      call mpi_type_commit(m_vlat3d,ierr)

      js=2
      jf=j1
      if(mylat.eq.0) js=3
      if(mylat.eq.ngy1) jf=j2

      mxpas=10
      do n=1,mxpas

      do i=2,i1
      do j=2,j1
      scr_data(i,j,1)=tauxs(i-1,j-1)
      scr_data(i,j,2)=tauys(i-1,j-1)
      enddo
      enddo
      call mpi_sendrecv(scr_data(2,1,1),1,m_vlon3d,m_w,1,scr_data(i0,1,1),1,m_vlon3d,m_e,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(scr_data(i1,1,1),1,m_vlon3d,m_e,1,scr_data(1,1,1),1,m_vlon3d,m_w,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(scr_data(1,2,1),1,m_vlat3d,m_s,1,scr_data(1,j0,1),1,m_vlat3d,m_n,1,mpi_comm_world,istat,ierr)
      call mpi_sendrecv(scr_data(1,j1,1),1,m_vlat3d,m_n,1,scr_data(1,1,1),1,m_vlat3d,m_s,1,mpi_comm_world,istat,ierr)

      do i=2,i1
      do j=js,jf
      if(maxj(i-1,j-1).eq.1) then
      tauxs(i-1,j-1)=.2*(scr_data(i,j,1)+scr_data(i,j-1,1)+scr_data(i,j+1,1)+scr_data(i-1,j,1)+scr_data(i+1,j,1))
      tauys(i-1,j-1)=.2*(scr_data(i,j,2)+scr_data(i,j-1,2)+scr_data(i,j+1,2)+scr_data(i-1,j,2)+scr_data(i+1,j,2))
      endif
      enddo
      enddo
 
      enddo


!      write(72) tauxs,tauys
      if(myid.eq.0)print*,'scow windstress month:',m


      else
!      write(72) taux_data,tauy_data
      if(myid.eq.0)print*,'hr windstress month:',m
      endif

      cli_tauys(:,:,m) = tauys
      cli_tauxs(:,:,m) = tauxs
      clidata_tauy(:,:,m) = tauy_data
      clidata_taux(:,:,m) = taux_data

      enddo

      call wr8nc_winds(cli_tauxs,cli_tauys,clidata_taux,clidata_tauy) !dog
      call wr8nc_levitus(clidata_s1,clidata_t1) !dog

end subroutine

       
function r(t,s,p)
      p02=1747.4508988+t*(11.51588-0.046331033*t)-s*(3.85429655+0.01353985*t)
      p01=p/10d0+5884.81703666+t*(39.803732+t*(-0.3191477+t*0.0004291133))+2.6126277*s
      r=p01/(p02+0.7028423*p01)
      return
end function


function theta(sal,ts,ps,pr)
    !     ...sal=salinity
    !     ...ts=in situ temp (deg cel)
    !     ...ps=in situ pressure (dbars)
    !     ...pr=reference pressure (dbars)
    delp=pr-ps
    hafp=ps+.5*delp
    delt1=delp*gamma0(sal,ts,ps)
    t1_tmp=ts+.5*delt1
    delt2=delp*gamma0(sal,t1_tmp,hafp)
    t2_tmp=t1_tmp+.2928932*(delt2-delt1)
    delt3=delp*gamma0(sal,t2_tmp,hafp)
    t3_tmp=t2_tmp+1.707107*(delt3-0.5857864*delt2-0.1213203*delt1)
    delt4=delp*gamma0(sal,t3_tmp,pr)
    t4_tmp=t3_tmp+0.16666667*(delt4-6.828427*delt3+4.828427*delt2+delt1)
    theta=t4_tmp
    return
end function


function gamma0(ss,tt,p)
    !     ...adiabati! temperature gradient(deg c/dbar)
    !     ...according to bryden (1973),dsr,20,401-408
    !     ...copied from bio auxilary library
    xx=ss-35
    gamma0=0.35803e-4+0.18932e-5*xx+p*(0.18741e-7- &
         0.11351e-9*xx-0.46206e-12*p) &
         +tt*(0.85258e-5-0.42393e-7*xx+p*(-0.67795e-9+ &
         0.27759e-11*xx+0.18676e-13*p) &
         +tt*(-0.68360e-7+p*(0.87330e-11-0.21687e-15*p) &
         +tt*(0.66228e-9-0.54481e-13*p)))
    return
end function

subroutine wr8nc_depth(rmets)
use const, only: i0,j0,ngx0,ngy0
use comm, only: m_cart,mylat,mylon
implicit none
!declare pnetcdf var
character :: fn*13
integer :: ierr,ncid,nd(2)
integer :: i0id,j0id
integer :: irmt
integer(kind=mpi_offset_kind) :: dim_nn(2)
integer(kind=mpi_offset_kind) :: ns_ij(2),nc_ij(2)
real*8,dimension(i0,j0) :: rmets

      !output file name
      fn = 'data/depth.nc'
      !create ncfile and id
      ierr=nfmpi_create(m_cart,fn,nf_64bit_offset,mpi_info_null,ncid)

      !define dimension and assign dimID
      dim_nn(1) = i0*ngx0
      dim_nn(2) = j0*ngy0
      ierr=nfmpi_def_dim(ncid,"i0_global",dim_nn(1),i0id)
      ierr=nfmpi_def_dim(ncid,"j0_global",dim_nn(2),j0id)

      !define variables and assign varID
      nd(1) = i0id
      nd(2) = j0id
      ierr=nfmpi_def_var(ncid,"rmets",nf_double,2,nd,irmt)
      ierr=nfmpi_enddef(ncid)

      !put variables
      ns_ij(1) = mylon*i0+1
      ns_ij(2) = mylat*j0+1
      nc_ij(1) = i0
      nc_ij(2) = j0
      ierr=nfmpi_put_vara_double_all(ncid,irmt,ns_ij,nc_ij,rmets)

      ierr=nfmpi_close(ncid)

end subroutine wr8nc_depth

subroutine wr8nc_levitus(clidata_s1,clidata_t1)
use const, only: i0,j0,k1,ngx0,ngy0
use comm, only: m_cart,mylat,mylon,myid
implicit none
!declare pnetcdf var
character :: fn*20
integer :: ierr,ncid,nq(4)
integer :: i0id,j0id,k1id,moid
integer :: is1d,it1d,itmp
integer(kind=mpi_offset_kind) :: dim_nn(4)
integer(kind=mpi_offset_kind) :: ns_ijkt(4),nc_ijkt(4)
real*8,dimension(i0,j0,k1,12),intent(in) :: clidata_s1,clidata_t1
      !output file name
      fn = 'data/annualevitus.nc'
      !create ncfile and id
      ierr=nfmpi_create(m_cart,fn,nf_64bit_offset,mpi_info_null,ncid)

      !define dimension and assign dimID
      dim_nn(1) = i0*ngx0
      dim_nn(2) = j0*ngy0
      dim_nn(3) = k1
      dim_nn(4) = 12
      ierr=nfmpi_def_dim(ncid,"i0_global",dim_nn(1),i0id)
      ierr=nfmpi_def_dim(ncid,"j0_global",dim_nn(2),j0id)
      ierr=nfmpi_def_dim(ncid,"k1",dim_nn(3),k1id)
      ierr=nfmpi_def_dim(ncid,"month",dim_nn(4),moid)
      !define variables and assign varID
      nq(1) = i0id
      nq(2) = j0id
      nq(3) = k1id
      nq(4) = moid
      ierr=nfmpi_def_var(ncid,"s1_data",nf_double,4,nq,is1d)
      ierr=nfmpi_def_var(ncid,"t1_data",nf_double,4,nq,it1d)
      ierr=nfmpi_enddef(ncid)

      !put variables
      ns_ijkt(1) = mylon*i0+1
      ns_ijkt(2) = mylat*j0+1
      ns_ijkt(3) = 1
      ns_ijkt(4) = 1
      nc_ijkt(1) = i0
      nc_ijkt(2) = j0
      nc_ijkt(3) = k1
      nc_ijkt(4) = 12
      ierr=nfmpi_put_vara_double_all(ncid,is1d,ns_ijkt,nc_ijkt,clidata_s1)
      ierr=nfmpi_put_vara_double_all(ncid,it1d,ns_ijkt,nc_ijkt,clidata_t1)
      ierr=nfmpi_close(ncid)

end subroutine wr8nc_levitus

subroutine wr8nc_winds(cli_tauxs,cli_tauys,clidata_taux,clidata_tauy)
use const, only: i2,j2,ngy0,ngx0
use comm, only: m_cart
implicit none
!declare pnetcdf var
character :: fn*13
integer :: ierr,ncid,nt(3)
integer :: i2id,j2id,moid
integer :: ixs,iys,ixd,iyd
integer(kind=mpi_offset_kind) :: dim_nn(3)
integer(kind=mpi_offset_kind) :: ns_ijk(3),nc_ijk(3)
real*8,dimension(i2,j2,12),intent(in) :: cli_tauxs,cli_tauys
real*8,dimension(i2,j2,12),intent(in) :: clidata_taux,clidata_tauy

      !output file name
      fn = 'data/winds.nc'
      !create ncfile and id
      ierr=nfmpi_create(m_cart,fn,nf_64bit_offset,mpi_info_null,ncid)

      !define dimension and assign dimID
      dim_nn(1) = i2*ngx0
      dim_nn(2) = j2*ngy0
      dim_nn(3) = 12
      ierr=nfmpi_def_dim(ncid,"i2_global",dim_nn(1),i2id)
      ierr=nfmpi_def_dim(ncid,"j2_global",dim_nn(2),j2id)
      ierr=nfmpi_def_dim(ncid,"month",dim_nn(3),moid)

      !define variables and assign varID
      nt(1) = i2id
      nt(2) = j2id
      nt(3) = moid
      ierr=nfmpi_def_var(ncid,"tauxs",nf_double,3,nt,ixs)
      ierr=nfmpi_def_var(ncid,"tauys",nf_double,3,nt,iys)
      ierr=nfmpi_def_var(ncid,"taux_data",nf_double,3,nt,ixd)
      ierr=nfmpi_def_var(ncid,"tauy_data",nf_double,3,nt,iyd)
      ierr=nfmpi_enddef(ncid)

      !put variables
      ns_ijk(1) = mylon*i2+1
      ns_ijk(2) = mylat*j2+1
      ns_ijk(3) = 1
      nc_ijk(1) = i2
      nc_ijk(2) = j2
      nc_ijk(3) = 12
      ierr=nfmpi_put_vara_double_all(ncid,ixs,ns_ijk,nc_ijk,cli_tauxs)
      ierr=nfmpi_put_vara_double_all(ncid,iys,ns_ijk,nc_ijk,cli_tauys)
      ierr=nfmpi_put_vara_double_all(ncid,ixd,ns_ijk,nc_ijk,clidata_taux)
      ierr=nfmpi_put_vara_double_all(ncid,iyd,ns_ijk,nc_ijk,clidata_tauy)

      ierr=nfmpi_close(ncid)
end subroutine wr8nc_winds

subroutine rdnc_westdeg
use comm, only: m_cart,myid
implicit none
character :: fn*15
integer :: ncid,ierr,itmp
integer(kind=mpi_offset_kind) :: ns_i,nc_i
real :: test
      fn = 'data/westdeg.nc'
      ierr=nfmpi_open(m_cart,fn,nf_nowrite,mpi_info_null,ncid)
      ierr=nfmpi_inq_varid(ncid,'westdeg',itmp)
      ns_i = myid+1
      nc_i = 1
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,westdeg)
      ierr=nfmpi_close(ncid)
end subroutine rdnc_westdeg

subroutine rdnc_yzgrid(j,k,dxmnut)
use comm, only: m_cart,myid,mylat,mylon
use const, only: j0,j1
implicit none
character :: fn*14
integer :: ncid,ierr,itmp
integer(kind=mpi_offset_kind) :: ns_i,nc_i
integer,intent(inout) :: j,k
real*8,intent(inout) :: dxmnut
      fn = 'data/yzgrid.nc'
      ierr=nfmpi_open(m_cart,fn,nf_nowrite,mpi_info_null,ncid)

      ierr=nfmpi_inq_varid(ncid,'j0',itmp)
      ierr=nfmpi_get_var_int_all(ncid,itmp,j)
      ierr=nfmpi_inq_varid(ncid,'k0',itmp)
      ierr=nfmpi_get_var_int_all(ncid,itmp,k)
      ierr=nfmpi_inq_varid(ncid,'dxmnut',itmp)
      ierr=nfmpi_get_var_double_all(ncid,itmp,dxmnut)
      ierr=nfmpi_inq_varid(ncid,'tlz_depth',itmp)
      ierr=nfmpi_get_var_double_all(ncid,itmp,tlz)
      ierr=nfmpi_inq_varid(ncid,'z',itmp)
      ierr=nfmpi_get_var_double_all(ncid,itmp,z)
      ierr=nfmpi_inq_varid(ncid,'odz',itmp)
      ierr=nfmpi_get_var_double_all(ncid,itmp,odz)
      ierr=nfmpi_inq_varid(ncid,'odzw',itmp)
      ierr=nfmpi_get_var_double_all(ncid,itmp,odzw)

      ns_i=mylon*i0+1
      nc_i=i0
      ierr=nfmpi_inq_varid(ncid,'xdeg',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,xdeg)

      ns_i=mylat*j0+1
      nc_i=j0
      ierr=nfmpi_inq_varid(ncid,'y',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,y)
      ierr=nfmpi_inq_varid(ncid,'yv',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,yv)
      ierr=nfmpi_inq_varid(ncid,'yvdeg',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,yvdeg)
      ierr=nfmpi_inq_varid(ncid,'ydeg',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,ydeg)
      ierr=nfmpi_inq_varid(ncid,'cs',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,cs)
      ierr=nfmpi_inq_varid(ncid,'ocs',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,ocs)
      ierr=nfmpi_inq_varid(ncid,'dx',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,dx)
      ierr=nfmpi_inq_varid(ncid,'odx',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,odx)
      ierr=nfmpi_inq_varid(ncid,'dy',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,dy)
      ierr=nfmpi_inq_varid(ncid,'ody',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,ody)

      ns_i=mylat*j1+1
      nc_i=j1
      ierr=nfmpi_inq_varid(ncid,'csv',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,csv)
      ierr=nfmpi_inq_varid(ncid,'ocsv',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,ocsv)
      ierr=nfmpi_inq_varid(ncid,'dxv',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,dxv)
      ierr=nfmpi_inq_varid(ncid,'odxv',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,odxv)
      ierr=nfmpi_inq_varid(ncid,'dyv',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,dyv)
      ierr=nfmpi_inq_varid(ncid,'odyv',itmp)
      ierr=nfmpi_get_vara_double_all(ncid,itmp,ns_i,nc_i,odyv)
      ierr=nfmpi_close(ncid)
end subroutine rdnc_yzgrid



end module

#!/bin/csh 
#BSUB -a mvapich
#BSUB -J mvapich_48c
#BSUB -q test
#BSUB -n 48
#BSUB -W 1:00
#BSUB -o %J.out
#BSUB -e %J.err
#BSUB -R "span[ptile=48]"
#BSUB -R "ipathavail==0"

## Export all my environment variables to the job
source /pkg/local/Modules/3.2.10/init/csh
setenv MODULEPATH "/pkg/local/Modules/modulefiles:/home/j07hsu00/opt/Modules/modulefiles"
module purge
module load compiler/intel/2015 mpi/intel/2015/mvapich2/2.1 netcdf/4.4.0/intel-2015_hdf5-1.8.16 pnetcdf/1.7.0/intel-2015_mvapich2-2.1
module list

limit coredumpsize 1000000
limit datasize  unlimited
limit stacksize unlimited

mpirun ./pre.exe > prep.out

#!/bin/bash
#PBS -V
#PBS -N test24_R8
#PBS -e pdtimcom.err
#PBS -o pdtimcom.out
#PBS -l nodes=2:ppn=12

echo "Working dir: " $PBS_O_WORKDIR
cd $PBS_O_WORKDIR
echo "Nodes used: " `uniq $PBS_NODEFILE`
echo "NOdes count: " $PBS_NP 
NPROCS=`wc -l < $PBS_NODEFILE`
cp $PBS_NODEFILE MPI.nodefile
echo "Cores used: " $NPROCS
echo "Starting at: " `date`

module purge
module load tools 
module load intel-13.1/compiler 
module load intel-13.1/openmpi-1.8.8 
module load intel-13.1/netcdf-4.4.1-nc4 
module list
mpirun -machinefile $PBS_NODEFILE -np $NPROCS ./main.exe
echo "Ending at: " `date`

#source /usr/share/Modules/init/csh

#module purge
module load intel-13.1/compiler intel-13.1/openmpi-1.8.8 intel-13.1/netcdf-4.4.1-nc4
module list
export PNETCDF=/cluster/intel-13.1/pnetcdf-1.3.1-openmpi

#source /usr/share/Modules/init/csh

module purge
module load compiler/intel/2015 mpi/intel/2015/mvapich2/2.1 netcdf/4.4.0/intel-2015_hdf5-1.8.16 pnetcdf/1.7.0/intel-2015_mvapich2-2.1
module list
export PNETCDF=/pkg/user/j07hsu00/opt/pnetcdf/1.7.0/intel-2015_mvapich2-2.1
